#include <Array.au3>
#Include <FileOperations.au3>

$timer = TimerInit()

$aFileList = _FO_FileSearch(@ScriptDir, '*.htm*')

; $ifile = 0
; $s = 0

For $i = 1 To $aFileList[0]
	$sText = FileRead($aFileList[$i])
	$aPNE = _FO_PathSplit($aFileList[$i])
	
	$sText=StringReplace($sText, '</head>', @CRLF & '<link href="../style.css" rel="stylesheet" type="text/css">' & @CRLF & '</head>') ; функции

	; Перемещение пробелов за пределы тегов (если остались по тексту)
	$sText=StringRegExpReplace($sText, '(<font color="#\d{6}">)(\h+)([^,.(){}\[\]&%$#@!+<>;]+?</font>)', '\2\1\3')
	$sText=StringRegExpReplace($sText, '(<font color="#\d{6}">[^,.(){}\[\]&%$#@!+<>;]+?)(\h+)(</font>)', '\1\3\2')

	; Замены цвета на классы

	; ключевые слова сразу на ссылки
	
	_Replace2('ForEach', 'foreach_next')
	_Replace2('NewList', 'newlist')
	_Replace2('NewMap', 'newmap')
	_Replace2('Protected', 'protected')
	_Replace2('Global', 'global')
	_Replace2('Shared', 'shared')
	_Replace2('Static', 'static')
	_Replace2('Define', 'define')
	_Replace2('Runtime', 'runtime')

	_Replace('Break|Continue', 'break_continue')
	_Replace('For|Next|To|Step', 'for_next')
	_Replace('Dim|ReDim', 'dim')
	_Replace('Enumeration|EndEnumeration|EnumerationBinary', 'enumerations')
	_Replace('Debug|CallDebugger', 'debugger')
	_Replace('Gosub|Return', 'gosub_return')
	_Replace('Goto|End|Swap', 'others')
	_Replace('Repeat|Until', 'repeat_until')
	_Replace('Select|EndSelect|Case|Default', 'select_endselect')
	_Replace('Structure|EndStructure|Align|Extends', 'structures')
	_Replace('While|Wend', 'while_wend')
	_Replace('Macro|EndMacro|MacroExpandedCount', 'macros')
	_Replace('With|EndWith', 'with_endwith')
	_Replace('IncludeFile|XIncludeFile|IncludeBinary|IncludePath', 'includes')
	_Replace('If|Else|ElseIf|EndIf', 'if_endif')
	_Replace('Import|EndImport', 'import_endimport')
	_Replace('DeclareModule|EndDeclareModule|Module|EndModule|UseModule|UnuseModule', 'module')
	_Replace('Procedure|EndProcedure|ProcedureReturn', 'procedures')
	_Replace('Not|And|Or|Xor', 'variables')
	_Replace('Interface|EndInterface', 'interfaces')
	_Replace('SizeOf|OffsetOf|TypeOf|Bool|ClearStructure|CopyStructure|InitializeStructure|Defined|Subsystem', 'compilerfunctions')
	_Replace('DataSection|EndDataSection|Data|Restore|Read', 'data')

	
	If StringRight($aPNE[0], 5)='List\' Then
		$sText=StringReplace($sText, '<font color="#006666">List</font>', '<font class="S6">List</font>')
	Else
		$sText=StringReplace($sText, '<font color="#006666">List</font>', '<a class="le" href="../List/index.html"><font class="S6">List</font></a>') ; List
	EndIf
	
	If StringRight($aPNE[0], 6)='Array\' Then
		$sText=StringReplace($sText, '<font color="#006666">Array</font>', '<font class="S6">Array</font>')
	Else
		$sText=StringReplace($sText, '<font color="#006666">Array</font>', '<a class="le" href="../Array/index.html"><font class="S6">Array</font></a>') ; Array
	EndIf
	
	If StringRight($aPNE[0], 4)='Map\' Then
		$sText=StringReplace($sText, '<font color="#006666">Map</font>', '<font class="S6">Map</font>')
	Else
		$sText=StringReplace($sText, '<font color="#006666">Map</font>', '<a class="le" href="../Map/index.html"><font class="S6">Map</font></a>') ; Map
	EndIf


	$sText=StringReplace($sText, '<font color="#006666">;', '<font class="S1">;') ; комментарии
	$sText=StringReplace($sText, '<font color="#006666">', '<font class="S4">') ; функции
	$sText=StringReplace($sText, '<font color="#924B72"', '<font class="S5"') ; константы. Без ">", чтобы захватить список с size=-1
	; $sText=StringRegExpReplace($sText, '([\s\=,\[(])(\w+\$)([\s\=,\])])', '\1<font class="S9">\2</font>\3') ; Переменные с $
	; $sText=StringRegExpReplace($sText, '([\s\=])(\w+\.[abcwulifqds])([\s\=])', '\1<font class="S9">\2</font>\3') ; Переменные с ".x"
	; Замента блока синтаксиса
	$sText=StringRegExpReplace($sText, '(?s)<p><b>Syntax</b></p><blockquote>(.+?)</blockquote>', '<p class="section">Syntax</p>' & @CRLF & '<p class="codeheader">\1</p>')
	; Замента блока кода с примером
	$sText=StringReplace($sText, '<pre><font face="Courier New, Courier, mono"size="2">', '<PRE class="codebox">')
	; Названия секций
	$sText=StringReplace($sText, '<b>Description</b>', '<p class="section">Description</p>')
	$sText=StringReplace($sText, '<p><b>Parameters</b></p>', '<p class="section">Parameters</p>')
	$sText=StringReplace($sText, '<p><b>Example</b></p>', '<p class="section">Example</p>')
	$sText=StringReplace($sText, '<p><b>Comments</b></p>', '<p class="section">Comments</p>')
	$sText=StringReplace($sText, '<p><b>Return value</b></p>', '<p class="section">Return value</p>')
	$sText=StringReplace($sText, '<p><b>See Also</b></p>', '<p class="section">See Also</p>')
	$sText=StringReplace($sText, '<p><b>Supported OS</b>', '<p class="section">Supported OS</p>')
	$sText=StringReplace($sText, '(<p class="section">)(Description|Parameters|Example|Comments|Return value|See Also|Supported OS)(</p>)<br>', '\1\2\3') ; Удалить <br>
	
	; $sText=StringReplace($sText, 'копировать в буфер', 'Copy to clipboard')
	
	; В синтаксическом блоке подсветить переменные типа "xxx.x"
	$sText=StringRegExpReplace($sText, '(codeheader">\h*)(\w+\.[abcwulifqds])(\h*)(=)', '\1<font class="S9">\2</font>\3<span class="S12">=</span>')
	; Константы #File в таблицах
	$sText=StringRegExpReplace($sText, '(><i>)(#\w+)(</i></td>)', '\1<font class="S5">\2</font>\3')
	; Константы #File в тексте без тегов (захватывает в комментариях)
	$sText=StringRegExpReplace($sText, '([^>"\=])(#\w++)([^<>/"])', '\1<font class="S5">\2</font>\3')
	$sText=StringRegExpReplace($sText, '(<span class="S2">[^<]+)<font class="S5">(#\w+)</font>', '\1\2') ; тут же чистка комментариев
	; В синтаксическом блоке функция без тега <b>
	$sText=StringRegExpReplace($sText, '(<font class="S4">)<b>(\w+)</b>(</font>)', '\1\2\3')
	; Переменные file$ в таблицах
	$sText=StringRegExpReplace($sText, '(><i>)(\w+\$)(</i></td>)', '\1<font class="S9">\2</font>\3')
	; Переменные file$ в тексте без тегов
	$sText=StringRegExpReplace($sText, '(?<!>)(\w+\$)(?!<)', '<font class="S9">\1</font>')
	; Переменные file$ в коде
	; $sText=StringRegExpReplace($sText, '<span class="S0">(\w+?)</span><span class="S12">\$</span>', '<span class="S9">\1$</span>')
	; Указатели *MemoryID
	; $sText=StringRegExpReplace($sText, '(<span class="S12">\*</span><span class=")(S0">)(MemoryID|Element|Points|Pointer|ThisData|Buffer|Key|CurrentPoint|Byte|EventGadgets|Parameters|DecipheredString|CipheredString|InitializationVector|MyScreen|NewMemoryID|DynamicPeople|SecondElement|Text|NextWindow|Next)(</span>)', '\1S9">\3\4')
	; Указатели в параметрах функции
	$sText=StringRegExpReplace($sText, '(?i)(<span class="S12">(?:\(\*|,\h?\*)</span><span class=")S0(">[a-z]+)', '\1S9\2')
	$sText=StringReplace($sText, '<PRE id=', '<PRE class="codebox" id=')
	; сменить положение кнопки "копировать"
	$sText=StringReplace($sText, 'style="margin: 18px 0px 0px 4px;" src="copy.gif" border="0" align="left">', 'style="margin: -16px 0px 0px 0px;" src="../copy.gif" border="0" align="right">')
	$sText=StringReplace($sText, '<span class="S5">#CRLF</span><span class="S12">$</span>', '<span class="S5">#CRLF$</span>')
	$sText=StringRegExpReplace($sText, '(<span class="S5">#CRLF)(</span><span class="S12">)(\$)', '\1\3\2')
	$sText=StringReplace($sText, '<a href="http', '<a class="ext" target="_blank" href="http') ; внешние ссылки открывать в браузуре
	$sText=StringReplace($sText, '<body bgcolor="#FFFFDF" link="#009999" vlink="#006666" alink="#006666">', '<body>') ; удалить цвета
	
	$sText=StringReplace($sText, '<style type="text/css">' & @CRLF & 'table.parameters { border-spacing: 0px; border-style: none; border-collapse: collapse; }' & @CRLF & 'table.parameters td { border-width: 1px; padding: 6px; border-style: solid; border-color: gray; vertical-align: top; font-family:Arial; font-size:10pt; }' & @CRLF & '</style>', '') ; удалить стиль таблиц
	
	

; <span class="S12">\*</span><span class="S0">MemoryID</span>
; <span class="S9">*MemoryID</span>

; <PRE id=
; <PRE class="codebox" id=

; style="margin: 18px 0px 0px 4px;" src="../copy.gif"
; style="margin: -16px 0px 0px 0px;" src="../copy.gif"

$char = 2+256 ; сохраняем только в UTF-8
	; If StringInStr($sText, 'charset=utf-8') Then
		; $char = 2+256
	; Else
		; $char = 2
	; EndIf
	; If $s Then ; Если изменения, то сохраняем файл
		; $ifile += 1
		$hFile = FileOpen($aFileList[$i], $char)
		FileWrite($hFile, $sText)
		FileClose($hFile)
	; EndIf
	; $sText=StringRegExpReplace($sText, '(<FONT class="S\d{1,2}">[^,.(){}\[\]&%$#@!+<>]+?</FONT>)', '<a class="le" href="func/MB.htm">\1</a>')
	
Next
$timer = Round(TimerDiff($timer) / 1000, 2) & ' сек'
; MsgBox(0, $timer & ' - ' & $ifile & ' файлов', 'Готово!')
MsgBox(0, $timer & ' - секунд', 'Готово!')



Func _Replace($keyword, $file)
	; If $aPNE[1]=$file Then
		; $sText=StringRegExpReplace($sText, '<span class="S6">(' & $keyword & ')(</span>)', '<span class="S6">\1\2')
	; Else
		; $sText=StringRegExpReplace($sText, '<span class="S6">(' & $keyword & ')(</span>)', '<a class="le" href="../Reference/' & $file & '.html"><span class="S6">\1\2</a>')
	; EndIf
	; Вставка для старых примеров
	If $aPNE[1]=$file Then
		$sText=StringRegExpReplace($sText, '<font color="#006666">(' & $keyword & ')(</font>)', '<font class="S6">\1\2')
	Else
		$sText=StringRegExpReplace($sText, '<font color="#006666">(' & $keyword & ')(</font>)', '<a class="le" href="../Reference/' & $file & '.html"><font class="S6">\1\2</a>')
		$sText=StringRegExpReplace($sText, '<span class="S6">(' & $keyword & ')(</span>)', '<a class="le" href="../Reference/' & $file & '.html"><span class="S6">\1\2</a>')
	EndIf
EndFunc

Func _Replace2($keyword, $file)
	; If $aPNE[1]=$file Then
		; $sText=StringReplace($sText, '<span class="S6">' & $keyword & '</span>', '<span class="S6">' & $keyword & '</span>')
	; Else
		; $sText=StringReplace($sText, '<span class="S6">' & $keyword & '</span>', '<a class="le" href="../Reference/' & $file & '.html"><span class="S6">' & $keyword & '</span></a>')
	; EndIf
	; Вставка для старых примеров
	If $aPNE[1]=$file Then
		$sText=StringReplace($sText, '<font color="#006666">' & $keyword & '</font>', '<font class="S6">' & $keyword & '</font>')
	Else
		$sText=StringReplace($sText, '<font color="#006666">' & $keyword & '</font>', '<a class="le" href="../Reference/' & $file & '.html"><font class="S6">' & $keyword & '</font></a>')
		$sText=StringReplace($sText, '<span class="S6">' & $keyword & '</span>', '<a class="le" href="../Reference/' & $file & '.html"><span class="S6">' & $keyword & '</span></a>')
	EndIf
EndFunc

; Обработка дерева TOC
; ([a-zA-Z]) - ([а-яА-ЯЁё\d])
; \1        \2

; <span class="S5">@</span><span class="S12">\*</span><span class="S9">\w+</span>

; Reference\memory.html
; <span class="S5">@Text</span><span class="S12">$</span>
; <span class="S5">@\w+</span><span class="S12">\$</span>

; MainGuide\history.html
; <font color="red">
; <font class="red">

; <font color="green">
; <font class="green">

; <font color="blue">
; <font class="blue">