﻿
;* %#@2DDrawing\Box.html%#@0 *;
If OpenWindow(0, 0, 0, 200, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 200, 200) And StartDrawing(ImageOutput(0))
    y = 0
    For x = 0 To 95 Step 10
      Box(x, y, 200-2*x, 200-2*y, RGB(Random(255), Random(255), Random(255)))
      y + 10        ; the same as y = y + 10
    Next x
    StopDrawing() 
    ImageGadget(0, 0, 0, 200, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\BoxedGradient.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 400, 200) And StartDrawing(ImageOutput(0))
    Box(0, 0, 400, 200, $FFFFFF)
    
    DrawingMode(#PB_2DDrawing_Gradient)      
    BackColor($00FFFF)
    FrontColor($FF0000)
    
    BoxedGradient(0, 0, 200, 200)      
    Circle(100, 100, 100)
    BoxedGradient(225, -100, 150, 400)
    Circle(300, 100, 100)
    
    StopDrawing() 
    ImageGadget(0, 0, 0, 400, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\Circle.html%#@0 *;
If OpenWindow(0, 0, 0, 200, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 200, 200) And StartDrawing(ImageOutput(0))
    Box(0, 0, 200, 200, RGB(255, 255, 255))
    For Radius = 100 To 10 Step -10
      Circle(100, 100, Radius, RGB(Random(255), Random(255), Random(255)))
    Next
    StopDrawing() 
    ImageGadget(0, 0, 0, 200, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\CircularGradient.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 400, 200) And StartDrawing(ImageOutput(0))
    Box(0, 0, 400, 200, $FFFFFF)
    
    DrawingMode(#PB_2DDrawing_Gradient)      
    BackColor($00FFFF)
    FrontColor($FF0000)
    
    CircularGradient(100, 100, 100)     
    Circle(100, 100, 100)
    CircularGradient(350, 100, 75)
    Circle(300, 100, 100)
    
    StopDrawing() 
    ImageGadget(0, 0, 0, 400, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\ClipOutput.html%#@0 *;
If OpenWindow(0, 0, 0, 200, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 200, 200, 24, $FFFFFF) And StartDrawing(ImageOutput(0))
    
    ClipOutput(50, 50, 100, 100) ; restrict all drawing to this region
    Circle( 50,  50, 50, $0000FF)  
    Circle( 50, 150, 50, $00FF00)  
    Circle(150,  50, 50, $FF0000)  
    Circle(150, 150, 50, $00FFFF)  
    
    DrawingMode(#PB_2DDrawing_Outlined)
    Box(50, 50, 100, 100, $000000)
    
    StopDrawing() 
    ImageGadget(0, 0, 0, 200, 200, ImageID(0))      
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\ConicalGradient.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 400, 200) And StartDrawing(ImageOutput(0))
    Box(0, 0, 400, 200, $FFFFFF)
    
    DrawingMode(#PB_2DDrawing_Gradient)      
    BackColor($00FFFF)
    FrontColor($FF0000)
    
    ConicalGradient(100, 100, 0.0)     
    Circle(100, 100, 100)
    ConicalGradient(300, 0, 90.0)     
    Circle(300, 100, 100)
    
    StopDrawing() 
    ImageGadget(0, 0, 0, 400, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\CustomFilterCallback.html%#@0 *;
Procedure CustomCallback(x, y, SourceColor, TargetColor)
  ;
  ; Calculate ResultColor from the given input
  ;
  ProcedureReturn ResultColor
EndProcedure

;* %#@2DDrawing\CustomFilterCallback.html%#@1 *;
Procedure FilterCallback(x, y, SourceColor, TargetColor)
  ; Take only the Red component from the Source, do not modify the others
  ProcedureReturn RGBA(Red(SourceColor), Green(TargetColor), Blue(TargetColor), Alpha(TargetColor))
EndProcedure

UseJPEGImageDecoder()

If OpenWindow(0, 0, 0, 400, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  LoadImage(1, #PB_Compiler_Home + "examples/3d/Data/Textures/clouds.jpg")
  
  If CreateImage(0, 400, 200) And StartDrawing(ImageOutput(0))
    DrawImage(ImageID(1), 0, 0, 400, 200)
    
    DrawingMode(#PB_2DDrawing_CustomFilter)      
    CustomFilterCallback(@FilterCallback())
    Circle(100, 100, 100, $0000FF)   
    Circle(300, 100, 100, $000000)
    
    StopDrawing() 
    ImageGadget(0, 0, 0, 400, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\CustomGradient.html%#@0 *;
Procedure.f GradientCallback(x, y)
  ;
  ; Return a value between 0.0 and 1.0 to define the gradient for the x/y position.
  ; 
  ProcedureReturn 1.0
EndProcedure

;* %#@2DDrawing\CustomGradient.html%#@1 *;
Procedure.f GradientCallback(x, y)
  ProcedureReturn Sin(x * 0.1) * Sin(y * 0.1) ; will be between 0 and 1
EndProcedure

If OpenWindow(0, 0, 0, 400, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 400, 200) And StartDrawing(ImageOutput(0))
    Box(0, 0, 400, 200, $FFFFFF)
    
    DrawingMode(#PB_2DDrawing_Gradient)      
    BackColor($00FFFF)
    FrontColor($FF0000)
    
    CustomGradient(@GradientCallback())
    Circle(100, 100, 100)   
    Circle(300, 100, 100)
    
    StopDrawing() 
    ImageGadget(0, 0, 0, 400, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\DrawingBufferPixelFormat.html%#@1 *;
If DrawingBufferPixelFormat() = #PB_PixelFormat_32Bits_RGB | #PB_PixelFormat_ReversedY
  ; 32-bit RGB with reversed Y coordinate
EndIf

If DrawingBufferPixelFormat() = #PB_PixelFormat_32Bits_RGB
  ; 32-bit RGB without reversed Y coordinate
EndIf

If DrawingBufferPixelFormat() & #PB_PixelFormat_32Bits_RGB
  ; 32-bit RGB, with or without reversed Y coordinate
EndIf


;* %#@2DDrawing\DrawingMode.html%#@0 *;
DrawingMode(#PB_2DDrawing_Outlined | #PB_2DDrawing_XOr)

;* %#@2DDrawing\DrawRotatedText.html%#@0 *;
If OpenWindow(0, 0, 0, 200, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 200, 200) And StartDrawing(ImageOutput(0))
    Box(0, 0, 200, 200, RGB(255, 255, 255))
    For Angle = 0 To 360 Step 45
      DrawRotatedText(100, 100, "Hello World!", Angle, RGB(0, 0, 0))
    Next Angle
    StopDrawing() 
    ImageGadget(0, 0, 0, 200, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\DrawText.html%#@0 *;
If OpenWindow(0, 0, 0, 200, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 200, 200) And StartDrawing(ImageOutput(0))
    DrawingMode(#PB_2DDrawing_Transparent)
    Box(0, 0, 200, 200, RGB(255, 255, 255))
    For i = 1 To 30
      DrawText(Random(200), Random(200), "Hello World!", RGB(Random(255), Random(255), Random(255)))
    Next i
    StopDrawing() 
    ImageGadget(0, 0, 0, 200, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\Ellipse.html%#@0 *;
If OpenWindow(0, 0, 0, 200, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 200, 200) And StartDrawing(ImageOutput(0))
    Box(0, 0, 200, 200, RGB(255, 255, 255))
    For radius=50 To 10 Step -10
      Ellipse(100, 100, radius*2, radius, RGB(Random(255), Random(255), Random(255)))
    Next radius
    StopDrawing() 
    ImageGadget(0, 0, 0, 200, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\EllipticalGradient.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 400, 200) And StartDrawing(ImageOutput(0))
    Box(0, 0, 400, 200, $FFFFFF)
    
    DrawingMode(#PB_2DDrawing_Gradient)      
    BackColor($00FFFF)
    FrontColor($FF0000)
    
    EllipticalGradient(100, 100, 150, 50)
    Circle(100, 100, 100)   
    EllipticalGradient(300, 100, 50, 150)
    Circle(300, 100, 100)
    
    StopDrawing() 
    ImageGadget(0, 0, 0, 400, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\FillArea.html%#@0 *;
If OpenWindow(0, 0, 0, 300, 300, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 300, 300) And StartDrawing(ImageOutput(0))
    Box(0, 0, 300, 300, RGB(255, 255, 255))
    
    Circle(150, 150, 125 ,$00FF00)
    Circle(150, 150, 120 ,$FF0000)
    LineXY(30, 150, 270, 150, $FFFFFF)
    FillArea(150, 155, -1, $0000FF) ; Replace -1 by $00FF00, and compare the result
    
    StopDrawing() 
    ImageGadget(0, 0, 0, 300, 300, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\GradientColor.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 400, 200) And StartDrawing(ImageOutput(0))
    Box(0, 0, 400, 200, $FFFFFF)
    
    DrawingMode(#PB_2DDrawing_Gradient)      
    BackColor($0000FF)
    GradientColor(0.4, $00FFFF)
    GradientColor(0.6, $FFFF00)
    FrontColor($FF0000)
    
    LinearGradient(0, 0, 200, 200)    
    Circle(100, 100, 100)   
    LinearGradient(350, 100, 250, 100)
    Circle(300, 100, 100)
    
    StopDrawing() 
    ImageGadget(0, 0, 0, 400, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\Line.html%#@0 *;
If OpenWindow(0, 0, 0, 200, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 200, 200) And StartDrawing(ImageOutput(0))
    Box(0, 0, 200, 200, RGB(255, 255, 255))
    For Width = 1 To 180 Step 5
      Line(10, 10, Width, 180, RGB(Random(255), Random(255), Random(255)))
    Next Width
    StopDrawing() 
    ImageGadget(0, 0, 0, 200, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\LinearGradient.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 400, 200) And StartDrawing(ImageOutput(0))
    Box(0, 0, 400, 200, $FFFFFF)
    
    DrawingMode(#PB_2DDrawing_Gradient)      
    BackColor($00FFFF)
    FrontColor($FF0000)
    
    LinearGradient(0, 0, 200, 200)    
    Circle(100, 100, 100)   
    LinearGradient(350, 100, 250, 100)
    Circle(300, 100, 100)
    
    StopDrawing() 
    ImageGadget(0, 0, 0, 400, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\LineXY.html%#@0 *;
If OpenWindow(0, 0, 0, 200, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 200, 200) And StartDrawing(ImageOutput(0))
    Box(0, 0, 200, 200, RGB(255, 255, 255))
    For Angle = 0 To 360 Step 3
      LineXY(100, 100, 100+Cos(Radian(Angle))*90, 100+Sin(Radian(Angle))*90, RGB(Random(255), Random(255), Random(255)))
    Next Angle
    StopDrawing() 
    ImageGadget(0, 0, 0, 200, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\Plot.html%#@0 *;
If OpenWindow(0, 0, 0, 200, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 200, 200) And StartDrawing(ImageOutput(0))
    For x = 0 To 199
      For y = 0 To 199
        Plot(x, y, RGB(Random(255), Random(255), Random(255)))
      Next y
    Next x
    StopDrawing() 
    ImageGadget(0, 0, 0, 200, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\RoundBox.html%#@0 *;
If OpenWindow(0, 0, 0, 200, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 200, 200) And StartDrawing(ImageOutput(0))
    y = 0
    For x = 0 To 95 Step 10
      RoundBox(x, y, 200-2*x, 200-2*y, 20, 20, RGB(Random(255), Random(255), Random(255)))
      y + 10 
    Next x
    StopDrawing() 
    ImageGadget(0, 0, 0, 200, 200, ImageID(0))
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\SetOrigin.html%#@0 *;
If OpenWindow(0, 0, 0, 200, 200, "2DDrawing Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateImage(0, 200, 200, 24, $FFFFFF) And StartDrawing(ImageOutput(0))
    
    ; Draw the same figure at different locations by moving the drawing origin
    For x = 0 To 120 Step 40
      For y = 0 To 120 Step 60
        SetOrigin(x, y)
        Box(0, 0, 30, 30, $FF0000)
        Circle(15, 15, 10, $00FF00)
      Next y
    Next x   
    
    StopDrawing() 
    ImageGadget(0, 0, 0, 200, 200, ImageID(0))      
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@2DDrawing\StopDrawing.html%#@0 *;
If StartDrawing(WindowOutput(0))
  Box(10,10,20,20)
  Line(30,50,100,100)
  ....
  StopDrawing() 
EndIf

;* %#@Array\ArraySize.html%#@0 *;
Dim MyArray.l(10)
Debug ArraySize(MyArray()) ; will print '10'

Dim MultiArray.l(10, 20, 30)
Debug ArraySize(MultiArray(), 2) ; will print '20'

;* %#@Array\ArraySize.html%#@1 *;
Dim Test.q(99999999999999999)

If ArraySize(Test()) <> -1
  Test(12345) = 123  ; everything fine
Else
  Debug "Array 'Test()' couldn't be initialized."
EndIf

;* %#@Array\CopyArray.html%#@0 *;
Dim Numbers(5)
Dim NumbersCopy(10)

Numbers(0) = 128
Numbers(5) = 256

Debug "Array size before copy: "+Str(ArraySize(NumbersCopy())) ; will print 10

CopyArray(Numbers(), NumbersCopy())

Debug "Array size after copy: "+Str(ArraySize(NumbersCopy())) ; will print 5
Debug NumbersCopy(0)
Debug NumbersCopy(5)

;* %#@Camera\CreateCamera.html%#@0 *;
CreateCamera(0, 0, 0, 100, 100) ; Creates a camera which fill the whole screen

CreateCamera(0, 0,  0, 100, 50) ; Creates an horizontal split screen effect, for 2 players
CreateCamera(1, 0, 50, 100, 50) ; mode on the same screen

CreateCamera(0, 0, 0, 100, 100) ; Create a full screen camera
CreateCamera(1, 25, 0, 50, 10)  ; And a rearview mirror effect.
                                ; Note the rearview is last so that it is displayed on top of the full screen camera

;* %#@Camera\CreateCamera.html%#@1 *;
; upper camera
CreateCamera(0, 0, 0, 100, 50)  
MoveCamera(0, 0, 50, 150, #PB_Absolute)
CameraBackColor(0, RGB(215, 225, 255))

; camera below
CreateCamera(1, 0, 50, 100, 50) 
MoveCamera(1, 0, 50, -150, #PB_Absolute)
CameraBackColor(1, RGB(255, 225, 215))
RotateCamera(1, 180, 0, 0)

;* %#@CGI\CGIBuffer.html%#@0 *;
If Not InitCGI()
  End
EndIf

BufferSize = ReadCGI()

WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html", #PB_CGI_LastHeader) ; Write the headers to inform the browser of the content format

WriteCGIString("<html><title>PureBasic - raw buffer</title><body>")  
If CGIBuffer()
  WriteCGIString("Raw buffer content: <br><pre>" + PeekS(CGIBuffer(), BufferSize, #PB_Ascii) + "</pre>")
EndIf

WriteCGIString("</body></html>")

;* %#@CGI\CGICookieName.html%#@0 *;
If Not InitCGI() Or Not ReadCGI()
  End
EndIf

WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html") ; Write the headers to inform the browser of the content format
WriteCGIHeader(#PB_CGI_HeaderSetCookie  , "mycookie=hello", #PB_CGI_LastHeader) ; Write one cookie named 'mycookie'

WriteCGIString("<html><title>PureBasic - cookies</title><body>" +
               "NbCookies: " + CountCGICookies() + "<br><br>")

; List the all cookies and display their name and value
;
For k = 0 To CountCGICookies()-1 
  WriteCGIString(CGICookieName(k)+": " + CGICookieValue(CGICookieName(k)) + "<br>")
Next

WriteCGIString("</body></html>")

;* %#@CGI\CGICookieValue.html%#@0 *;
If Not InitCGI() Or Not ReadCGI()
  End
EndIf

WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html") ; Write the headers to inform the browser of the content format
WriteCGIHeader(#PB_CGI_HeaderSetCookie  , "mycookie=hello", #PB_CGI_LastHeader) ; Write one cookie named 'mycookie'

WriteCGIString("<html><title>PureBasic - cookies</title><body>" +
               "NbCookies: " + CountCGICookies() + "<br><br>")

; List the all cookies and display their name and value
;
For k = 0 To CountCGICookies()-1 
  WriteCGIString(CGICookieName(k)+": " + CGICookieValue(CGICookieName(k)) + "<br>")
Next

WriteCGIString("</body></html>")

;* %#@CGI\CGIParameterData.html%#@0 *;
If Not InitCGI() Or Not ReadCGI()
  End
EndIf

WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html", #PB_CGI_LastHeader) ; Write the headers to inform the browser of the content format

WriteCGIString("<html><title>PureBasic - parameters</title><body>" +
               "NbParameters: " + CountCGIParameters() + "<br><br>")

; List the all parameters and display their name
;
For k = 0 To CountCGIParameters()-1
  If CGIParameterType("", k) = #PB_CGI_File
    WriteCGIString("[File] "+CGIParameterName(k)+" (filename: '"+CGIParameterValue("", k) +
                   "' - size: " + CGIParameterDataSize("", k) + 
                   " bytes - *buffer: " + CGIParameterData("", k) + ")<br>")
  EndIf
Next

WriteCGIString("</body></html>")

;* %#@CGI\CGIParameterDataSize.html%#@0 *;
If Not InitCGI() Or Not ReadCGI()
  End
EndIf

WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html", #PB_CGI_LastHeader) ; Write the headers to inform the browser of the content format

WriteCGIString("<html><title>PureBasic - parameters</title><body>" +
               "NbParameters: " + CountCGIParameters() + "<br><br>")

; List the all parameters and display their name
;
For k = 0 To CountCGIParameters()-1
  If CGIParameterType("", k) = #PB_CGI_File
    WriteCGIString("[File] "+CGIParameterName(k)+" (filename: '"+CGIParameterValue("", k) +
                   "' - size: " + CGIParameterDataSize("", k) + 
                   " bytes - *buffer: " + CGIParameterData("", k) + ")<br>")
  EndIf
Next

WriteCGIString("</body></html>")

;* %#@CGI\CGIParameterName.html%#@0 *;
If Not InitCGI() Or Not ReadCGI()
  End
EndIf

WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html", #PB_CGI_LastHeader) ; Write the headers to inform the browser of the content format

WriteCGIString("<html><title>PureBasic - parameters</title><body>" +
               "NbParameters: " + CountCGIParameters() + "<br><br>")

; List the all parameters and display their name
;
For k = 0 To CountCGIParameters()-1 
  WriteCGIString(CGIParameterName(k)+"<br>")
Next

WriteCGIString("</body></html>")

;* %#@CGI\CGIParameterType.html%#@1 *;
If Not InitCGI() Or Not ReadCGI()
  End
EndIf

WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html", #PB_CGI_LastHeader) ; Write the headers to inform the browser of the content format

WriteCGIString("<html><title>PureBasic - parameters</title><body>" +
               "NbParameters: " + CountCGIParameters() + "<br><br>")

; List the all parameters and display their name
;
For k = 0 To CountCGIParameters()-1
  If CGIParameterType("", k) = #PB_CGI_File
    WriteCGIString("[File] "+CGIParameterName(k)+" (filename: "+CGIParameterValue("", k)+")<br>")
  Else
    WriteCGIString("[String] "+CGIParameterName(k)+" (value: "+CGIParameterValue("", k)+")<br>")
  EndIf
Next

WriteCGIString("</body></html>")

;* %#@CGI\CGIParameterValue.html%#@0 *;
If Not InitCGI() Or Not ReadCGI()
  End
EndIf

WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html", #PB_CGI_LastHeader) ; Write the headers to inform the browser of the content format

WriteCGIString("<html><title>PureBasic - parameters</title><body>" +
               "NbParameters: " + CountCGIParameters() + "<br><br>")

; List the all parameters and display their name and value
;
For k = 0 To CountCGIParameters()-1 
  WriteCGIString(CGIParameterName(k) + ": " + CGIParameterValue("", k) + "<br>")
Next

WriteCGIString("</body></html>")

;* %#@CGI\CGIVariable.html%#@1 *;
If Not InitCGI() Or Not ReadCGI()
  End
EndIf

WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html", #PB_CGI_LastHeader) ; Write the headers to inform the browser of the content format

WriteCGIString("<html><title>PureBasic - variables</title><body>")  

Procedure WriteCGIConstant(Constant$)
  WriteCGIString(Constant$ + ": " + CGIVariable(Constant$)+"<br>")
EndProcedure

WriteCGIConstant(#PB_CGI_AuthType)
WriteCGIConstant(#PB_CGI_ContentLength)
WriteCGIConstant(#PB_CGI_HeaderContentType)
WriteCGIConstant(#PB_CGI_DocumentRoot)
WriteCGIConstant(#PB_CGI_GatewayInterface)
WriteCGIConstant(#PB_CGI_PathInfo)
WriteCGIConstant(#PB_CGI_PathTranslated)
WriteCGIConstant(#PB_CGI_QueryString)
WriteCGIConstant(#PB_CGI_RemoteAddr)
WriteCGIConstant(#PB_CGI_RemoteHost)
WriteCGIConstant(#PB_CGI_RemoteIdent)
WriteCGIConstant(#PB_CGI_RemotePort)
WriteCGIConstant(#PB_CGI_RemoteUser)
WriteCGIConstant(#PB_CGI_RequestURI)
WriteCGIConstant(#PB_CGI_RequestMethod)
WriteCGIConstant(#PB_CGI_ScriptName)
WriteCGIConstant(#PB_CGI_ScriptFilename)
WriteCGIConstant(#PB_CGI_ServerAdmin)
WriteCGIConstant(#PB_CGI_ServerName)
WriteCGIConstant(#PB_CGI_ServerPort)
WriteCGIConstant(#PB_CGI_ServerProtocol)
WriteCGIConstant(#PB_CGI_ServerSignature)
WriteCGIConstant(#PB_CGI_ServerSoftware)
WriteCGIConstant(#PB_CGI_HttpAccept)
WriteCGIConstant(#PB_CGI_HttpAcceptEncoding)
WriteCGIConstant(#PB_CGI_HttpAcceptLanguage)
WriteCGIConstant(#PB_CGI_HttpCookie)
WriteCGIConstant(#PB_CGI_HttpForwarded)
WriteCGIConstant(#PB_CGI_HttpHost)
WriteCGIConstant(#PB_CGI_HttpPragma)
WriteCGIConstant(#PB_CGI_HttpReferer)
WriteCGIConstant(#PB_CGI_HttpUserAgent)

WriteCGIString("</body></html>")

;* %#@CGI\CountCGICookies.html%#@0 *;
If Not InitCGI() Or Not ReadCGI()
  End
EndIf

WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html") ; Write the headers to inform the browser of the content format
WriteCGIHeader(#PB_CGI_HeaderSetCookie  , "mycookie=hello", #PB_CGI_LastHeader) ; Write one cookie named 'mycookie'

WriteCGIString("<html><title>PureBasic - cookies</title><body>" +
               "NbCookies: " + CountCGICookies() + "<br><br>")

WriteCGIString("</body></html>")

;* %#@CGI\CountCGIParameters.html%#@0 *;
If Not InitCGI() Or Not ReadCGI()
  End
EndIf

WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html", #PB_CGI_LastHeader) ; Write the headers to inform the browser of the content format

WriteCGIString("<html><title>PureBasic - parameters</title><body>" +
               "NbParameters: " + CountCGIParameters() + "<br><br>")

WriteCGIString("</body></html>")

;* %#@CGI\FinishFastCGIRequest.html%#@0 *;
If Not InitCGI()
  End
EndIf

If Not InitFastCGI(5600) ; Create the FastCGI program on port 5600
  End
EndIf

While WaitFastCGIRequest()
  
  If ReadCGI()
    WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html", #PB_CGI_LastHeader) ; Write the headers to inform the browser of the content format
    
    WriteCGIString("<html><title>PureBasic - FastCGI</title><body>" +
                   "Hello from PureBasic FastCGI !<br>" +
                   "Actual time: <b>"+FormatDate("%hh:%ii", Date()) + "</b>" +
                   "</body></html>")
    
    FinishFastCGIRequest()
    
    ; Do some processing
    ;
    Delay(1000) ; Simulate large processing
    
  EndIf
Wend

;* %#@CGI\InitCGI.html%#@0 *;
If Not InitCGI() Or Not ReadCGI()
  End
EndIf

WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html", #PB_CGI_LastHeader) ; Write the headers to inform the browser of the content format

WriteCGIString("<html><title>PureBasic - variables</title><body>" +
               "Hello from PureBasic CGI !" +
               "</body></html>")

;* %#@CGI\InitFastCGI.html%#@0 *;
ProxyPass /myfastcgiapp/ fcgi://localhost:5600/

;* %#@CGI\InitFastCGI.html%#@1 *;
If Not InitCGI()
  End
EndIf

If Not InitFastCGI(5600) ; Create the FastCGI program on port 5600
  End
EndIf

While WaitFastCGIRequest()
  
  If ReadCGI()
    WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html", #PB_CGI_LastHeader) ; Write the headers to inform the browser of the content format
    
    WriteCGIString("<html><title>PureBasic - FastCGI</title><body>" +
                   "Hello from PureBasic FastCGI !<br>" +
                   "Actual time: <b>"+FormatDate("%hh:%ii", Date()) + "</b>" +
                   "</body></html>")
  EndIf
  
Wend

;* %#@CGI\ReadCGI.html%#@0 *;
If Not InitCGI() Or Not ReadCGI()
  End
EndIf

WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html", #PB_CGI_LastHeader) ; Write the headers to inform the browser of the content format

WriteCGIString("<html><title>PureBasic - variables</title><body>" +
               "Hello from PureBasic CGI !" +
               "</body></html>")

;* %#@CGI\WaitFastCGIRequest.html%#@0 *;
If Not InitCGI()
  End
EndIf

If Not InitFastCGI(5600) ; Create the FastCGI program on port 5600
  End
EndIf

While WaitFastCGIRequest()
  
  If ReadCGI()
    WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html", #PB_CGI_LastHeader) ; Write the headers to inform the browser of the content format
    
    WriteCGIString("<html><title>PureBasic - FastCGI</title><body>" +
                   "Hello from PureBasic FastCGI !<br>" +
                   "Actual time: <b>"+FormatDate("%hh:%ii", Date()) + "</b>" +
                   "</body></html>")
  EndIf
Wend

;* %#@CGI\WriteCGIHeader.html%#@3 *;
If Not InitCGI() Or Not ReadCGI()
  End
EndIf

WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html", #PB_CGI_LastHeader)

WriteCGIString("<html><title>PureBasic - test</title><body>" +
               "Hello from PureBasic CGI<br>" +
               "</body></html>")

;* %#@CGI\WriteCGIString.html%#@1 *;
If Not InitCGI() Or Not ReadCGI()
  End
EndIf

WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html", #PB_CGI_LastHeader)

WriteCGIString("<html><title>PureBasic - test</title><body>" +
               "Hello from PureBasic CGI<br>" +
               "Actual time: <b>"+FormatDate("%hh:%ii", Date()) + "</b>" +
               "</body></html>")

;* %#@CGI\WriteCGIStringN.html%#@1 *;
If Not InitCGI() Or Not ReadCGI()
  End
EndIf

WriteCGIHeader(#PB_CGI_HeaderContentType, "text/html", #PB_CGI_LastHeader)

; Using cariage return will make the page more readable when using "Show page source" in the browser
;
WriteCGIStringN("<html><title>PureBasic - test</title><body>")
WriteCGIStringN("Hello from PureBasic CGI<br>")
WriteCGIStringN("Actual time: <b>"+FormatDate("%hh:%ii", Date()) + "</b>")
WriteCGIStringN("</body></html>")

;* %#@Cipher\AESEncoder.html%#@1 *;
; Encrypt some string
;
String$ = "Hello this is a test for AES"

StringMemorySize = StringByteLength(String$) + SizeOf(Character) ; Space for the string and its null terminating character
*CipheredString = AllocateMemory(StringMemorySize)   
*DecipheredString = AllocateMemory(StringMemorySize) 

If AESEncoder(@String$, *CipheredString, StringByteLength(String$), ?Key, 128, ?InitializationVector)
  Debug "Ciphered: "+PeekS(*CipheredString) ; warning, it will stop on the first null byte, only for demo purpose
  
  AESDecoder(*CipheredString, *DecipheredString, StringByteLength(String$), ?Key, 128, ?InitializationVector)
  Debug "Deciphered: "+PeekS(*DecipheredString)
EndIf

DataSection
  Key:
  Data.b $06, $a9, $21, $40, $36, $b8, $a1, $5b, $51, $2e, $03, $d5, $34, $12, $00, $06
  
  InitializationVector:
  Data.b $3d, $af, $ba, $42, $9d, $9e, $b4, $30, $b4, $22, $da, $80, $2c, $9f, $ac, $41
EndDataSection


;* %#@Cipher\AESEncoder.html%#@2 *;
; Should be compiled in ascii mode
;
String$ = "Hello this is a test for AES"

*CipheredString   = AllocateMemory(Len(String$)+ SizeOf(Caractere)) ; Space for the string and its
*DecipheredString = AllocateMemory(Len(String$)+ SizeOf(Caractere)) ; null terminating character (ASCII mode)

If AESEncoder(@String$, *CipheredString, Len(String$), ?Key, 128, 0, #PB_Cipher_ECB)
  Debug "Ciphered: "+PeekS(*CipheredString)
  
  AESDecoder(*CipheredString, *DecipheredString, Len(String$), ?Key, 128, 0, #PB_Cipher_ECB)
  Debug "Deciphered: "+PeekS(*DecipheredString)
EndIf

DataSection
  Key:
  Data.b $06, $a9, $21, $40, $36, $b8, $a1, $5b, $51, $2e, $03, $d5, $34, $12, $00, $06
EndDataSection


;* %#@Cipher\Base64Decoder.html%#@0 *;
Example$ = "This is a test string!" 
Decoded$ = Space(1024) 
Encoded$ = Space(1024) 

Debug Base64Encoder(@Example$, StringByteLength(Example$), @Encoded$, 1024)
Debug Encoded$ 

Debug Base64Decoder(@Encoded$, StringByteLength(Encoded$), @Decoded$, 1024)
Debug Decoded$

;* %#@Cipher\Base64Decoder.html%#@1 *;
DataSection
    Test:
    Data.a $00, $01, $02, $03, $04, $05, $06, $07
    Data.a $08, $09, $0A, $0B, $0C, $0D, $0E, $0F
    TestEnd:
EndDataSection

Size = (?TestEnd - ?Test) * 1.35
If Size < 64
    Size = 64
EndIf

*EncodeBuffer = AllocateMemory(Size)
Size = Base64Encoder(?Test, ?TestEnd - ?Test, *EncodeBuffer, MemorySize(*EncodeBuffer))
Encoded$ = PeekS(*EncodeBuffer, Size, #PB_Ascii)
Debug Encoded$

*DecodeBuffer = AllocateMemory(Size)
Size = PokeS(*EncodeBuffer, Encoded$, StringByteLength(Encoded$, #PB_Ascii), #PB_Ascii|#PB_String_NoZero)
Size = Base64Decoder(*EncodeBuffer, Size, *DecodeBuffer, MemorySize(*DecodeBuffer))
ShowMemoryViewer(*DecodeBuffer, Size)

;* %#@Cipher\Base64Encoder.html%#@1 *;
Example$ = "This is a test string!" 
Decoded$ = Space(1024) 
Encoded$ = Space(1024) 

Debug Base64Encoder(@Example$, StringByteLength(Example$), @Encoded$, 1024)
Debug Encoded$ 

Debug Base64Decoder(@Encoded$, StringByteLength(Encoded$), @Decoded$, 1024)
Debug Decoded$

;* %#@Cipher\CryptRandomData.html%#@0 *;
*Key = AllocateMemory(16)

If OpenCryptRandom() And *Key
  CryptRandomData(*Key, 16)
  
  Text$ = "Generated Key:"
  For i = 0 To 15
    Text$ + " " + RSet(Hex(PeekB(*Key+i), #PB_Byte), 2, "0")
  Next i     
  
  CloseCryptRandom()
Else
  Text$ = "Key generation is not available"
EndIf

MessageRequester("Example", Text$)

;* %#@Cipher\DESFingerprint.html%#@0 *;
Debug DESFingerprint("Password", "Key007")
Debug DESFingerprint("NewPass", "Key007")


;* %#@Cipher\Fingerprint.html%#@2 *;
UseMD5Fingerprint()

*Buffer = AllocateMemory(500)    
If *Buffer
  PokeS(*Buffer, "The quick brown fox jumps over the lazy dog.", -1, #PB_Ascii)
  MD5$ = Fingerprint(*Buffer, MemoryStringLength(*Buffer, #PB_Ascii), #PB_Cipher_MD5)
  Debug "MD5 Fingerprint = " + MD5$
  FreeMemory(*Buffer)  ; would also be done automatically at the end of the program
EndIf

;* %#@Cipher\StartFingerprint.html%#@2 *;
UseMD5Fingerprint()

*Buffer = AllocateMemory(200) ; Prepare a buffer with data
If *Buffer
  PokeS(*Buffer, "The quick brown fox jumps over the lazy dog.", -1, #PB_Ascii)
  Length = MemoryStringLength(*Buffer, #PB_Ascii)
  
  If StartFingerprint(0, #PB_Cipher_MD5)          ; start the calculation
    AddFingerprintBuffer(0, *Buffer, Length/2)    ; calculate part 1
    AddFingerprintBuffer(0, *Buffer+Length/2, Length/2) ; calculate part 2
    
    MD5$ = FinishFingerprint(0)                  ; finish calculation
    Debug "MD5 checksum = " + MD5$
    
    MD5$ = Fingerprint(*Buffer, Length, #PB_Cipher_MD5)  ; compare to a calculation in 1 step
    Debug "MD5 checksum = " + MD5$      
  EndIf
  
  FreeMemory(*Buffer)
EndIf

;* %#@Cipher\StringFingerprint.html%#@3 *;
UseMD5Fingerprint()

Debug StringFingerprint("yourpassword", #PB_Cipher_MD5)

;* %#@Cipher\UseCRC32Fingerprint.html%#@0 *;
UseCRC32Fingerprint()

Debug StringFingerprint("any text", #PB_Cipher_CRC32)

;* %#@Cipher\UseMD5Fingerprint.html%#@0 *;
UseMD5Fingerprint()

Debug StringFingerprint("yourpassword", #PB_Cipher_MD5)

;* %#@Cipher\UseSHA1Fingerprint.html%#@0 *;
UseSHA1Fingerprint()

Debug StringFingerprint("yourpassword", #PB_Cipher_SHA1)

;* %#@Cipher\UseSHA2Fingerprint.html%#@0 *;
UseSHA2Fingerprint()

Debug StringFingerprint("yourpassword", #PB_Cipher_SHA2, 512) ; Use SHA2-512 variant

;* %#@Cipher\UseSHA3Fingerprint.html%#@0 *;
UseSHA3Fingerprint()

Debug StringFingerprint("yourpassword", #PB_Cipher_SHA3, 512) ; Use SHA3-512 variant

;* %#@Console\ClearConsole.html%#@0 *;
If OpenConsole()
  EnableGraphicalConsole(1)
  
  PrintN("You will never see me")
  ClearConsole()
  
  PrintN("Press return to exit")
  Input()
EndIf

;* %#@Console\CloseConsole.html%#@0 *;
For i = 0 To 4
  If OpenConsole()
    PrintN("This is console #"+Str(i))
    PrintN("Press return to close console")
    Input()
    CloseConsole()
  EndIf
Next

;* %#@Console\ConsoleCursor.html%#@0 *;
1 : Underline cursor (Default)
5 : Mid-height cursor
10: Full-height cursor

;* %#@Console\ConsoleCursor.html%#@1 *;
If OpenConsole()
  EnableGraphicalConsole(1)
  
  For CursorHeight = 0 To 10
    ConsoleCursor(CursorHeight)
    PrintN("Press return to increase cursor size")
    Input()
  Next
  
  PrintN("Press return to exit")
  Input()
EndIf

;* %#@Console\ConsoleLocate.html%#@0 *;
If OpenConsole()
  EnableGraphicalConsole(1)
  
  For i = 0 To 200
    ConsoleLocate(Random(79), Random(24))
    Print("*")
  Next
  
  ConsoleLocate(30, 10)
  PrintN("Press return to exit")
  Input()
EndIf

;* %#@Console\ConsoleTitle.html%#@0 *;
If OpenConsole()
  ConsoleTitle("The ConsoleTitle example program")
  PrintN("Press return to exit")
  Input()
EndIf

;* %#@Console\EnableGraphicalConsole.html%#@0 *;
If OpenConsole()
  EnableGraphicalConsole(1)
  ConsoleLocate(7, 8)
  PrintN("Press return to exit")
  Input()
EndIf

;* %#@Console\Inkey.html%#@0 *;
If OpenConsole()
  PrintN("Press Escape to exit")
  
  Repeat
    KeyPressed$ = Inkey()
    
    If KeyPressed$ <> ""
      
      PrintN("You pressed: " + KeyPressed$)
      PrintN("It has a raw code of: "+Str(RawKey()))
      
    ElseIf RawKey()
      
      PrintN("You pressed a non ASCII key.")
      PrintN("It has a raw code of: "+Str(RawKey()))
      
    Else
      Delay(20) ; Don't eat all the CPU time, we're on a multitask OS
    EndIf
    
  Until KeyPressed$ = Chr(27) ; Wait until escape is pressed
EndIf

;* %#@Console\Input.html%#@0 *;
If OpenConsole()
  Print("Enter your name and press return: ")
  Name$ = Input()
  
  PrintN("Hello " + Name$ + ", nice to meet you.")
  PrintN("Press return to exit")
  Input()
EndIf

;* %#@Console\OpenConsole.html%#@0 *;
OpenConsole()
PrintN("Waiting 5 secs before quit...")
Delay(5000)

;* %#@Console\Print.html%#@0 *;
If OpenConsole()
  Print("This is quite a long string.")
  Print("You see how this one joins onto the end of the previous one?")
  Print("That is because the cursor moves to the end of the string and not onto a new line.")
  Print("Hopefully the text will also have been wrapped by now.")
  
  PrintN("")
  PrintN("")
  PrintN("Press return to exit")
  Input()
EndIf

;* %#@Console\PrintN.html%#@0 *;
If OpenConsole()
  PrintN("This is quite a long string.")
  PrintN("You see how this one does not join onto the end of the previous one?")
  PrintN("That is because the cursor moves to the start of the next line after the end of the string.")
  
  PrintN("Press return to exit")
  Input()
EndIf

;* %#@Console\RawKey.html%#@0 *;
If OpenConsole()
  PrintN("Press Escape to exit")
  
  Repeat
    KeyPressed$ = Inkey()
    
    If KeyPressed$ <> ""
      
      PrintN("You pressed: " + KeyPressed$)
      PrintN("It has a raw code of: "+Str(RawKey()))
      
    ElseIf RawKey()
      
      PrintN("You pressed a non ASCII key.")
      PrintN("It has a raw code of: "+Str(RawKey()))
      
    Else
      Delay(20) ; Don't eat all the CPU time, we're on a multitask OS
    EndIf
    
  Until KeyPressed$ = Chr(27) ; Wait until escape is pressed
EndIf

;* %#@Console\ReadConsoleData.html%#@0 *;
; This reads a passed image from the console and displays it in a window
; Compile this to an exe and run it like "myexe < image.bmp"
;
; (set "Executable format" To "Console" in the compiler options!)
; (works only with Bitmaps and icons unless you use an Image Decoder)
;
OpenConsole()
TotalSize = 0
BufferFree = 10000
*Buffer = AllocateMemory(BufferFree)

Repeat
  ReadSize = ReadConsoleData(*Buffer+TotalSize, BufferFree) ; read a block of data
  TotalSize + ReadSize
  BufferFree - ReadSize
  If BufferFree < 100  ; resize the buffer if it is not large enough
    BufferFree = 10000
    *Buffer = ReAllocateMemory(*Buffer, TotalSize+10000)
  EndIf
Until ReadSize = 0 ; once 0 is returned, there is nothing else to read

If TotalSize > 0 ; display the image if successful
  If CatchImage(0, *Buffer, TotalSize)
    If OpenWindow(0, 0, 0, ImageWidth(0), ImageHeight(0), "Image", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
      ImageGadget(0, 0, 0, ImageWidth(0), ImageHeight(0), ImageID(0))
      Repeat
      Until WaitWindowEvent() = #PB_Event_CloseWindow
      End
    EndIf
  EndIf
EndIf
MessageRequester("Error", "Not a valid image.")

;* %#@Database\DatabaseError.html%#@0 *;
; First, connect to a database with an employee table
;
If DatabaseQuery(#Database, "SELECT * FROM employee") ; Get all the records in the 'employee' table
                                                      ; ...
  FinishDatabaseQuery(#Database)
Else
  MessageRequester("Error", "Can't execute the query: "+DatabaseError())
EndIf

;* %#@Database\DatabaseQuery.html%#@1 *;
; First, connect to a database with an employee table
;
If DatabaseQuery(#Database, "SELECT * FROM employee") ; Get all the records in the 'employee' table
  
  While NextDatabaseRow(#Database) ; Loop for each records
    Debug GetDatabaseString(#Database, 0) ; Display the content of the first field      
  Wend
  
  FinishDatabaseQuery(#Database)
EndIf

;* %#@Database\DatabaseQuery.html%#@2 *;
; SQLite and ODBC shares the same syntax for bind variables. It is indicated by the '?' character
;
SetDatabaseString(#Database, 0, "test")  
If DatabaseQuery(#Database, "SELECT * FROM employee WHERE id=?")    
  ; ...
EndIf

;* %#@Database\DatabaseQuery.html%#@3 *;
; PostgreSQL uses another syntax: $1, $2.. into the statement to indicate the undefined parameter
;
SetDatabaseString(#Database, 0, "test")  
If DatabaseQuery(#Database, "SELECT * FROM employee WHERE id=$1")    
  ; ...
EndIf

;* %#@Database\DatabaseUpdate.html%#@0 *;
; First, connect to a database with an employee table
;
If DatabaseQuery(#Database, "SELECT * FROM employee") ; Get all the records in the 'employee' table
  
  While NextDatabaseRow(#Database) ; Loop for each records
    
    ; Update the 'checked' field for each records, assuming the 'id' field is 
    ; the first one in the 'employee' table
    ;
    DatabaseUpdate(#Database, "UPDATE employee SET checked=1 WHERE id="+GetDatabaseString(#Database, 0)) 
  Wend
  
  FinishDatabaseQuery(#Database)
EndIf

;* %#@Database\DatabaseUpdate.html%#@1 *;
; SQLite and ODBC shares the same syntax for bind variables. It is indicated by the '?' character
;
SetDatabaseLong(0, 0, 1)
SetDatabaseString(0, 1, "test")
DatabaseUpdate(0, "UPDATE employee SET checked=? WHERE id=?")

;* %#@Database\DatabaseUpdate.html%#@2 *;
; PostgreSQL uses another syntax: $1, $2.. into the statement to indicate the undefined parameter
;
SetDatabaseLong(0, 0, 1)
SetDatabaseString(0, 1, "test")
DatabaseUpdate(0, "UPDATE employee SET checked=$1 WHERE id=$2")

;* %#@Database\FinishDatabaseQuery.html%#@0 *;
; First, connect to a database with an employee table
;
If DatabaseQuery(#Database, "SELECT * FROM employee") ; Get all the records in the 'employee' table
  
  While NextDatabaseRow(#Database) ; Loop for each records
    Debug GetDatabaseString(#Database, 0) ; Display the content of the first field      
  Wend
  
  FinishDatabaseQuery(#Database)
EndIf

;* %#@Database\SetDatabaseBlob.html%#@0 *;
; SQLite and ODBC shares the same syntax to insert blob. It is indicated by the '?' character
;
; The database should be opened and a table PHOTOS with 3 column (BLOB, VARCHAR(255), BLOB)
;
SetDatabaseBlob(0, 0, ?Picture, PictureLength)
SetDatabaseBlob(0, 1, ?SmallPicture, SmallPictureLength)
DatabaseUpdate(0, "INSERT INTO PHOTOS (picture, name, small_picture) values (?, 'my description', ?);")

;* %#@Database\SetDatabaseBlob.html%#@1 *;
; PostgreSQL uses another syntax: $1, $2.. into the statement to indicate the undefined parameter
;
; The database should be opened and a table PHOTOS with 3 column (BYTEA, VARCHAR(255), BYTEA)
;
SetDatabaseBlob(0, 0, ?Picture, PictureLength)
SetDatabaseBlob(0, 1, ?SmallPicture, SmallPictureLength)
DatabaseUpdate(0, "INSERT INTO PHOTOS (picture, name, small_picture) values ($1, 'my description', $2);")

;* %#@Database\UseODBCDatabase.html%#@0 *;
UseODBCDatabase()

If OpenDatabase(0, "MySQL-ODBC", "mysql", "mysql")
  Debug "Connected to MySQL"
Else
  Debug "Connection failed: "+DatabaseError()
EndIf

;* %#@Database\UsePostgreSQLDatabase.html%#@1 *;
UsePostgreSQLDatabase()

; You should have a server running on localhost
;
If OpenDatabase(0, "host=localhost port=5432", "postgres", "postgres")
  Debug "Connected to PostgreSQL"
Else
  Debug "Connection failed: "+DatabaseError()
EndIf

;* %#@Database\UseSQLiteDatabase.html%#@0 *;
UseSQLiteDatabase()

Filename$ = OpenFileRequester("Choose a file name", "PureBasic.sqlite", "*.sqlite|*.sqlite", 0)

If CreateFile(0, Filename$)
  Debug "Database file created"
  CloseFile(0)
EndIf

If OpenDatabase(0, Filename$, "", "")
  Debug "Connected to PureBasic.sqlite"
  If DatabaseUpdate(0, "CREATE TABLE info (test VARCHAR(255));")
    Debug "Table created"
  EndIf
EndIf

;* %#@Date\AddDate.html%#@1 *;

Debug FormatDate("%yyyy/%mm/%dd", AddDate(Date(), #PB_Date_Year, 2)) ; Returns the current date + 2 years

Debug FormatDate("%mm/%dd/%yyyy", AddDate(Date(), #PB_Date_Year, 2)) ; Returns the current date + 2 years


;* %#@Date\Date.html%#@0 *;
Debug Date() / (3600*24*365)  ; will print the number of years since 01/01/1970 and now
Debug Date(1999, 12, 31, 23, 59, 59)  ; will print '946684799' (number of seconds between 01/01/1970 0:00:00 and 12/31/1999 23:59:59)

;* %#@Date\Day.html%#@0 *;
Debug Day(Date(2002, 10, 3, 0, 0, 0))  ; Outputs '3'.

;* %#@Date\DayOfWeek.html%#@1 *;
Debug DayOfWeek(Date(2006, 10, 30, 0, 0, 0))  ; Outputs '1' for Monday.

;* %#@Date\DayOfYear.html%#@0 *;
Debug DayOfYear(Date(2002, 2, 1, 0, 0, 0))  ; Outputs '32'. (31 days for January + 1)

;* %#@Date\FormatDate.html%#@0 *;
%yyyy: Will be replaced by the year value, on 4 digits.
%yy: Will be replaced by the year value, on 2 digits.
%mm: Will be replaced by the month value, on 2 digits.
%dd: Will be replaced by the day value, on 2 digits.
%hh: Will be replaced by the hour value, on 2 digits.
%ii: Will be replaced by the minute value, on 2 digits.
%ss: Will be replaced by the second value, on 2 digits.

;* %#@Date\FormatDate.html%#@1 *;

Debug FormatDate("Y=%yyyy, M= %mm, D=%dd", Date()) ; Will display the actual date with
                                                   ; the form "Y=2010, M=01, D=07"

Debug FormatDate("%mm/%dd/%yyyy", Date()) ; Will display the actual date with
                                          ; the form "01/07/2010"

Debug FormatDate("%hh:%ii:%ss", Date())   ; Will display the time using the 00:00:00 format


;* %#@Date\Hour.html%#@0 *;
Debug Hour(Date(1970, 1, 1, 11, 3, 45))  ; Outputs '11'.

;* %#@Date\Minute.html%#@0 *;
Debug Minute(Date(1970, 1, 1, 11, 3, 45))  ; Outputs '3'.

;* %#@Date\Month.html%#@0 *;
Debug Month(Date(2002, 10, 3, 0, 0, 0))  ; Outputs '10'.

;* %#@Date\ParseDate.html%#@0 *;
%yyyy: Will be replaced by the year value, on 4 digits.
%yy: Will be replaced by the year value, on 2 digits.
%mm: Will be replaced by the month value, on 2 digits.
%dd: Will be replaced by the day value, on 2 digits.
%hh: Will be replaced by the hour value, on 2 digits.
%ii: Will be replaced by the minute value, on 2 digits.
%ss: Will be replaced by the second value, on 2 digits.

;* %#@Date\ParseDate.html%#@1 *;

Debug ParseDate("%yy/%mm/%dd", "10/01/07")     ; Returns the date value of "10/01/07"

Debug ParseDate("%mm/%dd/%yyyy", "01/07/2010") ; Returns the date value of "01/07/2010"


;* %#@Date\Second.html%#@0 *;
Debug Second(Date(1970, 1, 1, 11, 3, 45))  ; Outputs '45'.

;* %#@Date\Year.html%#@0 *;
Debug Year(Date(2002, 10, 3, 0, 0, 0))  ; Outputs '2002'.

;* %#@Debugger\ClearDebugOutput.html%#@0 *;
; Show 10 debug values only, not a continuous list
Repeat
  ClearDebugOutput()
  For i = 1 To 10
    Debug x
    x + 1
  Next i
  
  Delay(500)
ForEver

;* %#@Debugger\PurifierGranularity.html%#@0 *;
; Disable check for string memory and check allocated memory every 10 lines
PurifierGranularity(#PB_Ignore, #PB_Ignore, 0, 10)

;* %#@Debugger\SaveDebugOutput.html%#@0 *;
For i = 1 To 100
  Debug Random(i)
Next i
SaveDebugOutput("C:\log.txt")

;* %#@Debugger\ShowLibraryViewer.html%#@0 *;
If CreateImage(0, 200, 200) And StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_Transparent)
  Box(0, 0, 200, 200, RGB(255, 255, 255))
  For i = 1 To 30
    DrawText(Random(200), Random(200), "Hello World!", RGB(Random(255), Random(255), Random(255)))
  Next i
  StopDrawing() 
  
  ShowLibraryViewer("Image", 0)  ; Show the image
  CallDebugger                   ; Halt the program so it does not end right away
EndIf

;* %#@Debugger\ShowMemoryViewer.html%#@0 *;
*Memory = AllocateMemory(1000)
If *Memory
  RandomData(*Memory, 1000)       ; Fill memory with some data
  
  ShowMemoryViewer(*Memory, 1000) ; Open memory viewer
  CallDebugger                    ; Halt the program, so it does not end right away
EndIf

;* %#@Desktop\DesktopDepth.html%#@0 *;
ExamineDesktops()
MessageRequester("Display Information", "Current resolution = "+Str(DesktopWidth(0))+"x"+Str(DesktopHeight(0))+"x"+Str(DesktopDepth(0)))

;* %#@Desktop\DesktopFrequency.html%#@0 *;
ExamineDesktops()
f = DesktopFrequency(0)
If f = 0
  MessageRequester("Display Information", "There isn't set any desktop frequency, the standard hardware frequency is used.")
Else
  MessageRequester("Display Information", "Frequency of desktop: "+Str(f)+" Hz.")
EndIf

;* %#@Desktop\DesktopHeight.html%#@0 *;
ExamineDesktops()
MessageRequester("Display Information", "Current resolution = "+Str(DesktopWidth(0))+"x"+Str(DesktopHeight(0))+"x"+Str(DesktopDepth(0)))

;* %#@Desktop\DesktopMouseX.html%#@0 *;
If OpenWindow(0, 0, 0, 300, 30, "Desktop mouse monitor", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  TextGadget(0, 10, 6, 200, 20, "")
  
  Repeat
    Event = WindowEvent()
    
    If Event = 0 ; No events are in queue anymore, so halt the process for a few milliseconds for multitasking
      SetGadgetText(0, "Desktop mouse position: "+Str(DesktopMouseX())+","+Str(DesktopMouseY()))
      Delay(20)
    EndIf
    
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Desktop\DesktopMouseY.html%#@0 *;
If OpenWindow(0, 0, 0, 300, 30, "Desktop mouse monitor", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  TextGadget(0, 10, 6, 200, 20, "")
  
  Repeat
    Event = WindowEvent()
    
    If Event = 0 ; No events are in queue anymore, so halt the process for a few milliseconds for multitasking
      SetGadgetText(0, "Desktop mouse position: "+Str(DesktopMouseX())+","+Str(DesktopMouseY()))
      Delay(20)
    EndIf
    
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Desktop\DesktopName.html%#@0 *;
ExamineDesktops()
MessageRequester("Display Information", "Primary desktop name = "+DesktopName(0))

;* %#@Desktop\DesktopWidth.html%#@0 *;
ExamineDesktops()
MessageRequester("Display Information", "Current resolution = "+Str(DesktopWidth(0))+"x"+Str(DesktopHeight(0))+"x"+Str(DesktopDepth(0)))

;* %#@Desktop\ExamineDesktops.html%#@0 *;
MessageRequester("Desktop Information", "You have "+Str(ExamineDesktops())+" desktops")

;* %#@DragDrop\DragOSFormats.html%#@0 *;
Structure DragDataFormat
  Format.i    ; The OS specific ID for the format to drag (see below for more information)
  *Buffer     ; The memory buffer containing the data in this format
  Size.i      ; The size of the data in the buffer
EndStructure

;* %#@DragDrop\SetDragCallback.html%#@0 *;
Procedure DragCallback(Action)
  
  ProcedureReturn #True
EndProcedure

;* %#@DragDrop\SetDragCallback.html%#@2 *;
Procedure DragCallback(*Context.GdkDragContext, isStart)
  
EndProcedure

;* %#@DragDrop\SetDragCallback.html%#@3 *;
Procedure DragCallback(DragReference, isStart)
  
EndProcedure

;* %#@DragDrop\SetDropCallback.html%#@0 *;
Procedure DropCallback(TargetHandle, State, Format, Action, x, y)
  
  ProcedureReturn #True
EndProcedure

;* %#@Engine3D\Add3DArchive.html%#@1 *;
Add3DArchive("MyData.zip", #PB_3DArchive_Zip) ; Add the .zip as a directory in the path
LoadTexture(0, "MyTexture.jpg")               ; load the MyTexture.jpg from the zip
LoadTexture(1, "World/Grass.jpg")             ; load the Grass.jpg from the zip, in the World\ path

;* %#@Engine3D\InputEvent3D.html%#@1 *;
; Here is the classic case to get the events from the mouse
;
InputEvent3D(MouseX(), MouseY(), MouseButton(#PB_MouseButton_Left))

;* %#@Engine3D\SkyBox.html%#@0 *;
TextureName_BK ; BacK face
TextureName_FR ; FRont face
TextureName_DN ; DowN face
TextureName_UP ; UP face
TextureName_LF ; LeFt face
TextureName_RT ; RighT face

;* %#@Entity\ScaleEntity.html%#@1 *;
ScaleEntity(0, 2, 2, 2) ; Double the current size of the entity
ScaleEntity(0, 1, 1, 1) ; Don't change the size of the entity (multiply by 1 don't change anything
ScaleEntity(0, 3, 1, 1) ; Make the width of the entity 3 times larger
ScaleEntity(0, 1, 1, 1, #PB_Absolute) ; Reset the entity size to 1,1,1.

;* %#@File\CreateFile.html%#@2 *;

If CreateFile(0, "Text.txt")         ; we create a new text file...
  For a=1 To 10
    WriteStringN(0, "Line "+Str(a))  ; we write 10 lines (each with 'end of line' character)
  Next
  For a=1 To 10
    WriteString(0, "String"+Str(a))  ; and now we add 10 more strings on the same line (because there is no 'end of line' character)
  Next
  CloseFile(0)                       ; close the previously opened file and store the written data this way
Else
  MessageRequester("Information","may not create the file!")
EndIf


;* %#@File\FileSeek.html%#@1 *;

file$ = OpenFileRequester("Select a file","","Text (.txt)|*.txt|All files (*.*)|*.*",0)
If file$
  If ReadFile(0, file$)
    length = Lof(0)                       ; read length of file
    FileSeek(0, length - 10)              ; set the file pointer 10 chars from end of file
    Debug "Position: " + Str(Loc(0))      ; show actual file pointer position
    *MemoryID = AllocateMemory(10)        ; allocate the needed memory for 10 bytes
    If *MemoryID
      bytes = ReadData(0, *MemoryID, 10)  ; read this last 10 chars in the file
      Debug PeekS(*MemoryID)
    EndIf
    CloseFile(0)
  EndIf
EndIf


;* %#@File\Lof.html%#@0 *;

file$ = OpenFileRequester("Select a file","","Text (.txt)|*.txt|All files (*.*)|*.*",0)
If file$
  If ReadFile(0, file$)
    length = Lof(0)                            ; get the length of opened file
    *MemoryID = AllocateMemory(length)         ; allocate the needed memory
    If *MemoryID
      bytes = ReadData(0, *MemoryID, length)   ; read all data into the memory block
      Debug "Number of bytes read: " + Str(bytes)
    EndIf
    CloseFile(0)
  EndIf
EndIf


;* %#@File\OpenFile.html%#@2 *;

If OpenFile(0, "Test.txt")    ; opens an existing file or creates one, if it does not exist yet
  FileSeek(0, Lof(0))         ; jump to the end of the file (result of Lof() is used)
  WriteStringN(0, "... another line at the end.")
  CloseFile(0)
EndIf


;* %#@File\ReadFile.html%#@2 *;

If ReadFile(0, "Text.txt")   ; if the file could be read, we continue...
  While Eof(0) = 0           ; loop as long the 'end of file' isn't reached
    Debug ReadString(0)      ; display line by line in the debug window
  Wend
  CloseFile(0)               ; close the previously opened file
Else
  MessageRequester("Information","Couldn't open the file!")
EndIf


;* %#@File\WriteData.html%#@0 *;

*MemoryID = AllocateMemory(1000)       ; allocating a memory block
If *MemoryID
  PokeS(*MemoryID, "Store this string in the memory area")   ; we write a string into the memory block
EndIf
If CreateFile(0, GetHomeDirectory()+"Text.txt")           ; we create a new text file...
  WriteData(0, *MemoryID, SizeOf(Character)*Len("Store this string in the memory area"))          ; write the text from the memory block into the file
  CloseFile(0)                                                                                    ; close the previously opened file and so store the written data
Else
  Debug "may not create the file!"
EndIf


;* %#@FileSystem\CopyDirectory.html%#@1 *;
Debug CopyDirectory("D:\Games\MyGame\", "D:\Games\Backup\", "", #PB_FileSystem_Recursive)

;* %#@FileSystem\DirectoryEntryAttributes.html%#@2 *;
[...]

FileAttributes = DirectoryEntryAttributes(#Directory)
If FileAttributes & #PB_FileSystem_Hidden
  Debug "This file is hidden !"
EndIf

;* %#@FileSystem\ExamineDirectory.html%#@0 *;
Directory$ = GetHomeDirectory() ; Lists all files and folder in the home directory
If ExamineDirectory(0, Directory$, "*.*")  
  While NextDirectoryEntry(0)
    If DirectoryEntryType(0) = #PB_DirectoryEntry_File
      Type$ = "[File] "
      Size$ = " (Size: " + DirectoryEntrySize(0) + ")"
    Else
      Type$ = "[Directory] "
      Size$ = "" ; A directory doesn't have a size
    EndIf
    
    Debug Type$ + DirectoryEntryName(0) + Size$
  Wend
  FinishDirectory(0)
EndIf

;* %#@FileSystem\GetFileAttributes.html%#@2 *;
FileAttributes = GetFileAttributes("C:\Text.txt")
If FileAttributes & #PB_FileSystem_Hidden
  Debug "This file is hidden !"
EndIf

;* %#@FileSystem\GetFileAttributes.html%#@3 *;
Value = GetFileAttributes("c:\autoexec.bat") 

If Value = -1 
  Debug "Error reading file attributes!"
Else 
  If Value & #PB_FileSystem_Hidden     : txt$ + "H" : Else : txt$+"-" : EndIf 
  If Value & #PB_FileSystem_Archive    : txt$ + "A" : Else : txt$+"-" : EndIf 
  If Value & #PB_FileSystem_Compressed : txt$ + "C" : Else : txt$+"-" : EndIf 
  If Value & #PB_FileSystem_Normal     : txt$ + "N" : Else : txt$+"-" : EndIf 
  If Value & #PB_FileSystem_ReadOnly   : txt$ + "R" : Else : txt$+"-" : EndIf 
  If Value & #PB_FileSystem_System     : txt$ + "S" : Else : txt$+"-" : EndIf 
  Debug txt$ 
EndIf

;* %#@FileSystem\RenameFile.html%#@0 *;
If RenameFile("C:\test.txt", "D:\temp\test_backup.txt")   
  Debug "Moving and renaming successful."    ; Moving and renaming of the file was successful
Else 
  Debug "Moving and renaming failed."        ; Moving and renaming failed, e.g. because of a not found source file
EndIf

;* %#@FileSystem\SetFileAttributes.html%#@2 *;
SetFileAttributes("C:\Text.txt", #PB_FileSystem_Hidden | #PB_FileSystem_ReadOnly)

;* %#@Font\FontID.html%#@0 *;
If OpenWindow(0, 0, 0, 222, 130, "FontID()", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ButtonGadget(0, 10, 10, 200, 30, "Click to change the font...")
  Font1 = LoadFont(#PB_Any, "Arial"  ,  8, #PB_Font_Bold)
  Font2 = LoadFont(#PB_Any, "Verdana", 12, #PB_Font_StrikeOut)
  UsedFont = 1
EndIf

Repeat
  Event = WaitWindowEvent()
  
  If Event = #PB_Event_Gadget
    If EventGadget() = 0
      If UsedFont = 1
        SetGadgetFont(0, FontID(Font2))
        UsedFont = 2
      Else
        SetGadgetFont(0, FontID(Font1))
        UsedFont = 1
      EndIf
    EndIf
  EndIf
  
Until Event = #PB_Event_CloseWindow

;* %#@Font\LoadFont.html%#@1 *;
If OpenWindow(0, 0, 0, 270, 160, "Loading font...", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If LoadFont(1, "Arial", 24)
    SetGadgetFont(#PB_Default, FontID(1))
    TextGadget(0, 10, 10, 250, 40, "Arial 24")
  EndIf
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Ftp\ExamineFTPDirectory.html%#@0 *;
InitNetwork()

If OpenFTP(0, "ftp.free.fr", "anonymous", "")
  If ExamineFTPDirectory(0)
    While NextFTPDirectoryEntry(0)
      Debug FTPDirectoryEntryName(0)
    Wend
    FinishFTPDirectory(0)
  EndIf
Else
  Debug "Can't connect to ftp.free.fr"
EndIf

;* %#@Ftp\FTPDirectoryEntryAttributes.html%#@1 *;
[...]

FileAttributes = FTPDirectoryEntryAttributes(#Ftp)
If FileAttributes & #PB_FTP_ReadUser
  Debug "This file has the ReadUser flag"
EndIf

;* %#@Ftp\FTPDirectoryEntryRaw.html%#@0 *;
InitNetwork()

If OpenFTP(0, "ftp.free.fr", "anonymous", "")
  If ExamineFTPDirectory(0)
    While NextFTPDirectoryEntry(0)
      Debug FTPDirectoryEntryRaw(0)
    Wend
    FinishFTPDirectory(0)
  EndIf
Else
  Debug "Can't connect to ftp.free.fr"
EndIf

;* %#@Ftp\OpenFTP.html%#@0 *;
InitNetwork()

If OpenFTP(0, "ftp.free.fr", "anonymous", "")
  Debug "Successfully connected"
Else
  Debug "Can't connect to ftp.free.fr"
EndIf

;* %#@Ftp\SetFTPDirectory.html%#@0 *;
InitNetwork()

If OpenFTP(0, "ftp.free.fr", "anonymous", "")
  
  Debug "Successfully connected"
  
  If SetFTPDirectory(0, "pub")
    If SetFTPDirectory(0, "Linux")
      Debug "Cool, changed to '/pub/Linux'"
      Debug GetFTPDirectory(0)
    Else
      Debug "Can't change to '/pub/Linux'"
    EndIf
  Else
    Debug "Can't change to 'pub'"
  EndIf
  
Else
  Debug "Can't connect to ftp.free.fr"
EndIf  

;* %#@Gadget\AddGadgetColumn.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 150, "ListIcon - Add Columns", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ListIconGadget(0, 10, 10, 380, 100, "Standard Column", 150, #PB_ListIcon_GridLines)
  ButtonGadget(1, 10, 120, 150, 20, "Add new column")
  index = 1     ; "Standard column" has already index 0
  Repeat
    Event = WaitWindowEvent()
    If Event = #PB_Event_Gadget
      If EventGadget() = 1
        AddGadgetColumn(0, index, "Column "+Str(index), 80)
        index + 1
      EndIf
    EndIf
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\BindGadgetEvent.html%#@0 *;
Procedure EventHandler()
  ; Code
EndProcedure

;* %#@Gadget\BindGadgetEvent.html%#@1 *;
Procedure ButtonHandler()
  Debug "Button click event on gadget #" + EventGadget()
EndProcedure

OpenWindow(0, 100, 100, 200, 90, "Click test", #PB_Window_SystemMenu)

ButtonGadget(0, 10, 10, 180, 30, "Click me")
BindGadgetEvent(0, @ButtonHandler())

ButtonGadget(1, 10, 50, 180, 30, "Click me")
BindGadgetEvent(1, @ButtonHandler())

Repeat
  Event = WaitWindowEvent()
Until Event = #PB_Event_CloseWindow

;* %#@Gadget\ButtonGadget.html%#@1 *;
; Shows possible flags of ButtonGadget in action...
If OpenWindow(0, 0, 0, 222, 200, "ButtonGadgets", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ButtonGadget(0, 10, 10, 200, 20, "Standard Button")
  ButtonGadget(1, 10, 40, 200, 20, "Left Button", #PB_Button_Left)
  ButtonGadget(2, 10, 70, 200, 20, "Right Button", #PB_Button_Right)
  ButtonGadget(3, 10,100, 200, 60, "Multiline Button  (longer text gets automatically wrapped)", #PB_Button_MultiLine)
  ButtonGadget(4, 10,170, 200, 20, "Toggle Button", #PB_Button_Toggle)
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\ButtonImageGadget.html%#@2 *;
If OpenWindow(0, 0, 0, 120, 100, "ButtonImage", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If LoadImage(0, "map.bmp")    ; change 2nd parameter to the path/filename of your image
    ButtonImageGadget(0, 10, 10, 100, 83, ImageID(0))
  EndIf
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\CalendarGadget.html%#@3 *;
If OpenWindow(0, 0, 0, 250, 200, "CalendarGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CalendarGadget(0, 10, 10, 230, 180)
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\CanvasGadget.html%#@5 *;
If OpenWindow(0, 0, 0, 220, 220, "CanvasGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 10, 10, 200, 200)
  
  Repeat
    Event = WaitWindowEvent()
    
    If Event = #PB_Event_Gadget And EventGadget() = 0 
      If EventType() = #PB_EventType_LeftButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(0, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
        If StartDrawing(CanvasOutput(0))
          x = GetGadgetAttribute(0, #PB_Canvas_MouseX)
          y = GetGadgetAttribute(0, #PB_Canvas_MouseY)
          Circle(x, y, 10, RGB(Random(255), Random(255), Random(255)))
          StopDrawing()
        EndIf
      EndIf
    EndIf    
    
  Until Event = #PB_Event_CloseWindow
EndIf


;* %#@Gadget\CanvasOutput.html%#@0 *;
...
StartDrawing(CanvasOutput(#Gadget))
; do some drawing stuff here...
StopDrawing()

;* %#@Gadget\CanvasVectorOutput.html%#@1 *;
...
StartVectorDrawing(CanvasVectorOutput(#Gadget))
; do some drawing stuff here...
StopVectorDrawing()

;* %#@Gadget\CheckBoxGadget.html%#@1 *;
If OpenWindow(0, 0, 0, 270, 160, "CheckBoxGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CheckBoxGadget(0, 10,  10, 250, 20, "CheckBox standard")
  CheckBoxGadget(1, 10,  40, 250, 20, "CheckBox checked"): SetGadgetState(1, #PB_Checkbox_Checked)
  CheckBoxGadget(2, 10,  70, 250, 20, "CheckBox three state", #PB_CheckBox_ThreeState): SetGadgetState(2, #PB_Checkbox_Inbetween)
  CheckBoxGadget(3, 10, 100, 250, 20, "CheckBox right", #PB_CheckBox_Right)
  CheckBoxGadget(4, 10, 130, 250, 20, "CheckBox center", #PB_CheckBox_Center)
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\ClearGadgetItems.html%#@0 *;
If OpenWindow(0, 0, 0, 220, 150, "ClearGadgetItems", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ListViewGadget(0,10,10,200,100)
  For a = 1 To 10 : AddGadgetItem (0, -1, "Item "+Str(a)) : Next    ; add 10 items
  ButtonGadget(1, 10, 120, 150, 20, "Clear Listview contents")
  Repeat
    Event = WaitWindowEvent()
    If Event = #PB_Event_Gadget
      If EventGadget() = 1
        ClearGadgetItems(0)
      EndIf
    EndIf
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\ComboBoxGadget.html%#@2 *;
UsePNGImageDecoder()
LoadImage(0, #PB_Compiler_Home + "examples/sources/Data/world.png")

If OpenWindow(0, 0, 0, 270, 180, "ComboBoxGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ComboBoxGadget(0, 10, 10, 250, 21, #PB_ComboBox_Editable)
  AddGadgetItem(0, -1, "ComboBox editable...")
  
  ComboBoxGadget(1, 10, 40, 250, 21, #PB_ComboBox_Image)
  AddGadgetItem(1, -1, "ComboBox item with image", ImageID(0))
  
  ComboBoxGadget(2, 10, 70, 250, 21)
  For a = 1 To 5
    AddGadgetItem(2, -1,"ComboBox item " + Str(a))
  Next
  
  SetGadgetState(0, 0)
  SetGadgetState(1, 0)
  SetGadgetState(2, 2)    ; set (beginning with 0) the third item as active one
  
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\ContainerGadget.html%#@1 *;
If OpenWindow(0, 0, 0, 322, 150, "ContainerGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ContainerGadget(0, 8, 8, 306, 133, #PB_Container_Raised)
  ButtonGadget(1, 10, 15, 80, 24, "Button 1")
  ButtonGadget(2, 95, 15, 80, 24, "Button 2")
  CloseGadgetList()
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\DateGadget.html%#@4 *;
If OpenWindow(0, 0, 0, 235, 250, "DateGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  DateGadget(0, 10, 10, 210, 25, "Date: %mm/%dd/%yyyy Time: %hh:%ii")
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\DisableGadget.html%#@0 *;
If OpenWindow(0, 0, 0, 250, 105, "Disable/enable buttons...", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ButtonGadget(0, 10, 15, 230, 30, "Disabled Button") : DisableGadget(0, 1)
  ButtonGadget(1, 10, 60, 230, 30, "Enabled Button") : DisableGadget(1, 0)
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\EditorGadget.html%#@5 *;
If OpenWindow(0, 0, 0, 322, 150, "EditorGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  EditorGadget(0, 8, 8, 306, 133)
  For a = 0 To 5
    AddGadgetItem(0, a, "Line "+Str(a))
  Next
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\ExplorerComboGadget.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 45, "ExplorerComboGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ExplorerComboGadget(0, 10, 10, 380, 25, GetHomeDirectory(), #PB_Explorer_Editable)
  Repeat 
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\ExplorerListGadget.html%#@5 *;
If OpenWindow(0, 0, 0, 400, 200, "ExplorerListGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ExplorerListGadget(0, 10, 10, 380, 180, "*.*", #PB_Explorer_MultiSelect)
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\ExplorerTreeGadget.html%#@3 *;
If OpenWindow(0, 0, 0, 300, 300, "ExplorerTreeGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ExplorerTreeGadget(0, 10, 10, 280, 280, "*.pb;*.pbi")
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\FrameGadget.html%#@1 *;
If OpenWindow(0, 0, 0, 320, 250, "FrameGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  FrameGadget(0, 10,  10, 300, 50, "FrameGadget Standard")
  FrameGadget(1, 10,  70, 300, 50, "", #PB_Frame_Single)
  FrameGadget(2, 10, 130, 300, 50, "", #PB_Frame_Double)
  FrameGadget(3, 10, 190, 300, 50, "", #PB_Frame_Flat)
  
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\GadgetToolTip.html%#@0 *;
If OpenWindow(0, 0, 0, 270, 100, "GadgetTooltip", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ButtonGadget(0, 10, 30, 250, 30, "Button with tooltip")
  GadgetToolTip(0, "Tooltip for Button")
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\GetActiveGadget.html%#@0 *;
If OpenWindow(0, 0, 0, 270, 70, "GetActiveGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  StringGadget  (0, 10, 10, 250, 20, "Press escape...")
  StringGadget  (1, 10, 40, 250, 20, "Press escape...")
  AddKeyboardShortcut(0, #PB_Shortcut_Escape, 1)
  SetActiveGadget(0)
  Repeat
    Event = WaitWindowEvent()
    If Event = #PB_Event_Menu And EventMenu() = 1
      MessageRequester("Test", "Escape pressed in Gadget " + Str(GetActiveGadget()))
    EndIf
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\GetGadgetItemState.html%#@3 *;
If Result & #PB_Tree_Checked
  ; Item is checked
EndIf

;* %#@Gadget\GetGadgetItemState.html%#@4 *;
; ... here a code snippet from a WaitWindowEvent() - event loop:
If GetGadgetItemState(#Listicon, n) & #PB_ListIcon_Checked
  ; Item n is checked (no matter if selected)
EndIf

If GetGadgetItemState(#Listicon, n) & #PB_ListIcon_Selected
  ; Item n is selected (no matter if checked)
EndIf

If GetGadgetItemState(#Listicon, n) = #PB_ListIcon_Checked | #PB_ListIcon_Selected
  ; Item n is checked AND selected
EndIf

If GetGadgetItemState(#Listicon, n) & (#PB_ListIcon_Checked | #PB_ListIcon_Selected)
  ; Item n is checked OR selected OR both
EndIf

;* %#@Gadget\HideGadget.html%#@0 *;
If OpenWindow(0, 0, 0, 180, 120, "HideGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ButtonGadget(0, 10, 10, 160, 50, "Button 1")       : button = #True   ; Button is displayed
  ButtonGadget(1, 10, 80, 160, 30, "Hide Button 1")
  Repeat
    Event = WaitWindowEvent()
    If Event = #PB_Event_Gadget
      If EventGadget() = 1
        If button = #True     ; ButtonGadget is displayed
          HideGadget(0, 1)    ; => hide it
          button = #False
          SetGadgetText(1, "Show Button 1")
        Else                  ; ButtonGadget is hidden
          HideGadget(0, 0)    ; => show it
          button = #True
          SetGadgetText(1, "Hide Button 1")
        EndIf
      EndIf
    EndIf
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\HyperLinkGadget.html%#@1 *;
If OpenWindow(0, 0, 0, 270, 160, "HyperlinkGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  HyperLinkGadget(0, 10, 10, 250,20,"Red HyperLink", RGB(255,0,0))
  HyperLinkGadget(1, 10, 30, 250,20,"Arial Underlined Green HyperLink", RGB(0,255,0), #PB_HyperLink_Underline)
  SetGadgetFont(1, LoadFont(0, "Arial", 12))
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\ImageGadget.html%#@2 *;
If OpenWindow(0, 0, 0, 245, 105, "ImageGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If LoadImage(0, "map.bmp")    ; change 2nd parameter to the path/filename of your image
    ImageGadget(0,  10, 10, 100, 83, ImageID(0))                      ; imagegadget standard
    ImageGadget(1, 130, 10, 100, 83, ImageID(0), #PB_Image_Border)    ; imagegadget with border
  EndIf
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\IPAddressGadget.html%#@0 *;
If OpenWindow(0, 0, 0, 180, 50, "IPAddressGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  IPAddressGadget(0, 10, 15, 160, 20)
  SetGadgetState(0, MakeIPAddress(127, 0, 0, 1))   ; set a valid ip address
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\ListIconGadget.html%#@5 *;
If OpenWindow(0, 100, 100, 300, 100, "ListIcon Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ListIconGadget(0, 5, 5, 290, 90, "Name", 100, #PB_ListIcon_FullRowSelect | #PB_ListIcon_AlwaysShowSelection)
  AddGadgetColumn(0, 1, "Address", 250)
  AddGadgetItem(0, -1, "Harry Rannit"+Chr(10)+"12 Parliament Way, Battle Street, By the Bay")
  AddGadgetItem(0, -1, "Ginger Brokeit"+Chr(10)+"130 PureBasic Road, BigTown, CodeCity")
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\ListIconGadget.html%#@6 *;
; Shows possible flags of ListIconGadget in action...
If OpenWindow(0, 0, 0, 700, 300, "ListIconGadgets", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ; left column
  TextGadget    (6,  10,  10, 330, 20, "ListIcon Standard", #PB_Text_Center)
  ListIconGadget(0,  10,  25, 330, 70, "Column 1", 100)
  TextGadget    (7,  10, 105, 330, 20, "ListIcon with Checkbox", #PB_Text_Center)
  ListIconGadget(1,  10, 120, 330, 70, "Column 1", 100, #PB_ListIcon_CheckBoxes)  ; ListIcon with checkbox
  TextGadget    (8,  10, 200, 330, 20, "ListIcon with Multi-Selection", #PB_Text_Center)
  ListIconGadget(2,  10, 215, 330, 70, "Column 1", 100, #PB_ListIcon_MultiSelect) ; ListIcon with multi-selection
                                                                                  ; right column
  TextGadget    (9, 360,  10, 330, 20, "ListIcon with separator lines",#PB_Text_Center)
  ListIconGadget(3, 360,  25, 330, 70, "Column 1", 100, #PB_ListIcon_GridLines)
  TextGadget   (10, 360, 105, 330, 20, "ListIcon with FullRowSelect and AlwaysShowSelection",#PB_Text_Center)
  ListIconGadget(4, 360, 120, 330, 70, "Column 1", 100, #PB_ListIcon_FullRowSelect | #PB_ListIcon_AlwaysShowSelection)
  TextGadget   (11, 360, 200, 330, 20, "ListIcon Standard with large icons",#PB_Text_Center)
  ListIconGadget(5, 360, 220, 330, 65, "", 200,#PB_ListIcon_GridLines)
  For a = 0 To 4            ; add columns to each of the first 5 listicons
    For b = 2 To 4          ; add 3 more columns to each listicon
      AddGadgetColumn(a, b, "Column " + Str(b), 65)
    Next
    For b = 0 To 2          ; add 4 items to each line of the listicons
      AddGadgetItem(a, b, "Item 1"+Chr(10)+"Item 2"+Chr(10)+"Item 3"+Chr(10)+"Item 4")
    Next
  Next
  ; Here we change the ListIcon display to large icons and show an image
  If LoadImage(0, #PB_Compiler_Home+"Examples\Sources\Data\File.bmp")     ; change path/filename to your own 32x32 pixel image
    SetGadgetAttribute(5, #PB_ListIcon_DisplayMode, #PB_ListIcon_LargeIcon)
    AddGadgetItem(5, 1, "Picture 1", ImageID(0))
    AddGadgetItem(5, 2, "Picture 2", ImageID(0))
  EndIf
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\ListViewGadget.html%#@3 *;
If OpenWindow(0, 0, 0, 270, 140, "ListViewGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ListViewGadget(0, 10, 10, 250, 120)
  For a = 1 To 12
    AddGadgetItem (0, -1, "Item " + Str(a) + " of the Listview") ; define listview content
  Next
  SetGadgetState(0, 9) ; set (beginning with 0) the tenth item as the active one
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\OptionGadget.html%#@0 *;
If OpenWindow(0, 0, 0, 140, 110, "OptionGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  OptionGadget(0, 30, 20, 60, 20, "Option 1")
  OptionGadget(1, 30, 45, 60, 20, "Option 2")
  OptionGadget(2, 30, 70, 60, 20, "Option 3")
  SetGadgetState(1, 1)   ; set second option as active one
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\PanelGadget.html%#@2 *;
; Shows using of several panels...
If OpenWindow(0, 0, 0, 322, 220, "PanelGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  PanelGadget     (0, 8, 8, 306, 203)
  AddGadgetItem (0, -1, "Panel 1")
  PanelGadget (1, 5, 5, 290, 166)
  AddGadgetItem(1, -1, "Sub-Panel 1")
  AddGadgetItem(1, -1, "Sub-Panel 2")
  AddGadgetItem(1, -1, "Sub-Panel 3")
  CloseGadgetList()
  AddGadgetItem (0, -1,"Panel 2")
  ButtonGadget(2, 10, 15, 80, 24,"Button 1")
  ButtonGadget(3, 95, 15, 80, 24,"Button 2")
  CloseGadgetList()
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\ProgressBarGadget.html%#@4 *;
If OpenWindow(0, 0, 0, 320, 160, "ProgressBarGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  TextGadget       (3,  10, 10, 250,  20, "ProgressBar Standard  (50/100)", #PB_Text_Center)
  ProgressBarGadget(0,  10, 30, 250,  30, 0, 100)
  SetGadgetState   (0, 50)   ;  set 1st progressbar (ID = 0) to 50 of 100
  TextGadget       (4,  10, 70, 250,  20, "ProgressBar Smooth  (50/200)", #PB_Text_Center)
  ProgressBarGadget(1,  10, 90, 250,  30, 0, 200, #PB_ProgressBar_Smooth)
  SetGadgetState   (1, 50)   ;  set 2nd progressbar (ID = 1) to 50 of 200
  TextGadget       (5, 100,135, 200,  20, "ProgressBar Vertical  (100/300)", #PB_Text_Right)
  ProgressBarGadget(2, 270, 10,  30, 120, 0, 300, #PB_ProgressBar_Vertical)
  SetGadgetState   (2, 100)   ; set 3rd progressbar (ID = 2) to 100 of 300
  Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow
EndIf

;* %#@Gadget\RemoveGadgetColumn.html%#@0 *;
If OpenWindow(0, 0, 0, 320, 160, "RemoveGadgetColumn", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  
  ListIconGadget(0, 10, 10, 300, 140, "Hello", 100)
  AddGadgetColumn(0, 1, "Column 2", 70)
  AddGadgetColumn(0, 2, "Column 3", 70)
  
  RemoveGadgetColumn(0, 1) ; Remove the 'Column 2'
  
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\ResizeGadget.html%#@0 *;
[...]

ResizeGadget(0, #PB_Ignore, #PB_Ignore, 300, #PB_Ignore) ; Only change the gadget width.

ResizeGadget(0, 150, 100, #PB_Ignore, #PB_Ignore) ; Only move the gadget to a new position.


;* %#@Gadget\ScrollAreaGadget.html%#@3 *;
Procedure BindScrollDatas()
  SetWindowTitle(0, "ScrollAreaGadget " +
                    "(" +
                    GetGadgetAttribute(0, #PB_ScrollArea_X) +
                    "," +                      
                    GetGadgetAttribute(0, #PB_ScrollArea_Y) +
                    ")" )
EndProcedure

If OpenWindow(0, 0, 0, 405, 240, "ScrollAreaGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ScrollAreaGadget(0, 10, 10, 390,220, 575, 555, 30)
  ButtonGadget  (1, 10, 10, 230, 30,"Button 1")
  ButtonGadget  (2, 50, 50, 230, 30,"Button 2")
  ButtonGadget  (3, 90, 90, 230, 30,"Button 3")
  TextGadget    (4,130,130, 230, 20,"This is the content of a ScrollAreaGadget!",#PB_Text_Right)
  CloseGadgetList()
  
  BindGadgetEvent(0, @ BindScrollDatas())
  
  Repeat
    Select WaitWindowEvent()
      Case  #PB_Event_CloseWindow
        End
      Case  #PB_Event_Gadget
        Select EventGadget()
          Case 0
            MessageRequester("Info","A Scroll has been used ! (" +
                                    GetGadgetAttribute(0, #PB_ScrollArea_X) +
                                    "," +                      
                                    GetGadgetAttribute(0, #PB_ScrollArea_Y) +
                                    ")" ,#PB_MessageRequester_Ok)
          Case 1
            MessageRequester("Info","Button 1 was pressed!",#PB_MessageRequester_Ok)
          Case 2
            MessageRequester("Info","Button 2 was pressed!",#PB_MessageRequester_Ok)
          Case 3
            MessageRequester("Info","Button 3 was pressed!",#PB_MessageRequester_Ok)
        EndSelect
    EndSelect
  ForEver
EndIf

;* %#@Gadget\ScrollBarGadget.html%#@3 *;
If OpenWindow(0, 0, 0, 305, 140, "ScrollBarGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  TextGadget       (2,  10, 25, 250,  20, "ScrollBar Standard  (start=50, page=30/100)",#PB_Text_Center)
  ScrollBarGadget  (0,  10, 42, 250,  20, 0, 100, 30)
  SetGadgetState   (0,  50)   ; set 1st scrollbar (ID = 0) to 50 of 100
  TextGadget       (3,  10,115, 250,  20, "ScrollBar Vertical  (start=100, page=50/300)",#PB_Text_Right)
  ScrollBarGadget  (1, 270, 10,  25, 120 ,0, 300, 50, #PB_ScrollBar_Vertical)
  SetGadgetState   (1, 100)   ; set 2nd scrollbar (ID = 1) to 100 of 300
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\ScrollBarGadget.html%#@4 *;
Procedure BindHScrollDatas()
  SetWindowTitle(0, "ScrollBarGadget (" + GetGadgetState(0) + ")" )
EndProcedure

Procedure BindVScrollDatas()
  SetWindowTitle(0, "ScrollBarGadget (" + GetGadgetState(1) + ")" )
EndProcedure


If OpenWindow(0, 0, 0, 400, 400, "ScrollBarGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered) 
  TextGadget       (2,  10, 25, 350,  30, "ScrollBar Standard  (dйbut = 50, page = 30/100)")
  ScrollBarGadget  (0,  10, 50, 350,  20, 0, 100, 30)
  SetGadgetState   (0,  50)   ; set 1st scrollbar (ID = 0) to 50 of 100
  TextGadget       (3,  10, 120, 350,  30, "ScrollBar vertical  (dйbut = 100, page = 50/300)")
  ScrollBarGadget  (1, 175, 160,  25, 120 ,0, 300, 50, #PB_ScrollBar_Vertical)
  SetGadgetState   (1, 100)   ; set 2nd scrollbar (ID = 1) to 100 of 300
  
  BindGadgetEvent(0, @ BindHScrollDatas())
  BindGadgetEvent(1, @ BindVScrollDatas())
  
  Repeat 
    Select WaitWindowEvent() 
      Case  #PB_Event_CloseWindow 
        End 
      Case  #PB_Event_Gadget 
        Select EventGadget()
          Case 0
            MessageRequester("Info","The ScrollBar 0 has been uded ! (" + GetGadgetState(0) +
                                    ")" ,#PB_MessageRequester_Ok)
          Case 1
            MessageRequester("Info","The ScrollBar 1 has been uded ! (" + GetGadgetState(1) +
                                    ")" ,#PB_MessageRequester_Ok) 
            
        EndSelect 
    EndSelect
  ForEver 
EndIf

;* %#@Gadget\SetActiveGadget.html%#@0 *;
If OpenWindow(0, 0, 0, 270, 140, "SetActiveGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  StringGadget  (0, 10, 10, 250, 20, "bla bla...")
  ComboBoxGadget(1, 10, 40, 250, 21)
  For a = 1 To 5 : AddGadgetItem(1, -1, "ComboBox item " + Str(a)) : Next
  SetGadgetState(1, 2)                ; set (beginning with 0) the third item as active one
  ButtonGadget  (2, 10,  90, 250, 20, "Activate StringGadget")
  ButtonGadget  (3, 10, 115, 250, 20, "Activate ComboBox")
  Repeat
    Event = WaitWindowEvent()
    If Event = #PB_Event_Gadget
      Select EventGadget()
        Case 2 : SetActiveGadget(0)   ; Activate StringGadget
        Case 3 : SetActiveGadget(1)   ; Activate ComboBoxGadget
      EndSelect
    EndIf
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\SetGadgetColor.html%#@1 *;
If OpenWindow(0, 0, 0, 200, 170, "SetGadgetColor", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  StringGadget(0, 10, 10, 180, 20, "String...")
  ListViewGadget(1, 10, 40, 180, 60)
  For i = 0 To 4
    AddGadgetItem(1, -1, "Text")
  Next i
  ContainerGadget(2, 10, 110, 180, 50, #PB_Container_Raised)
  
  SetGadgetColor(0, #PB_Gadget_BackColor, $00FFFF)
  SetGadgetColor(1, #PB_Gadget_FrontColor, $FFFFFF)
  SetGadgetColor(1, #PB_Gadget_BackColor, $000000)
  SetGadgetColor(2, #PB_Gadget_BackColor, $0000FF)
  
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\SetGadgetData.html%#@0 *;
; This code uses SetGadgetData to associate an index for the Messages()
; array with each button. This makes the event loop simpler as not every
; gadget needs to he handled separately.
;
Dim Messages.s(2)
Messages(0) = "Good morning"
Messages(1) = "Hello World"
Messages(2) = "Nothing to say"
If OpenWindow(0, 0, 0, 190, 100, "SetGadgetData", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ButtonGadget(0,  10, 10, 80, 20, "Button"): SetGadgetData(0, 1)
  ButtonGadget(1,  10, 40, 80, 20, "Button"): SetGadgetData(1, 2)
  ButtonGadget(2,  10, 70, 80, 20, "Button"): SetGadgetData(2, 1)
  ButtonGadget(3, 100, 10, 80, 20, "Button"): SetGadgetData(3, 2)
  ButtonGadget(4, 100, 40, 80, 20, "Button") ; will have the value 0 because nothing was set yet
  ButtonGadget(5, 100, 70, 80, 20, "Button")
  Repeat
    Event = WaitWindowEvent()
    If Event = #PB_Event_Gadget
      Value = GetGadgetData(EventGadget())
      MessageRequester("Message", Messages(Value))
    EndIf
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\SetGadgetFont.html%#@0 *;
If OpenWindow(0, 0, 0, 222, 130, "SetGadgetFont", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If LoadFont(0, "Arial", 16)
    SetGadgetFont(#PB_Default, FontID(0))   ; Set the loaded Arial 16 font as new standard
  EndIf
  ButtonGadget(0, 10, 10, 200, 30, "Button - Arial 16")
  SetGadgetFont(#PB_Default, #PB_Default)  ; Set the font settings back to original standard font
  ButtonGadget(1, 10, 50, 200, 30, "Button - standard")
  If LoadFont(1,"Courier",10, #PB_Font_Bold | #PB_Font_Underline)
    SetGadgetFont(#PB_Default, FontID(1))   ; Set the loaded Courier 10 font as new standard
  EndIf
  TextGadget(2, 10, 90, 200, 40, "Bold + underlined Courier 10 Text", #PB_Text_Center)
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\SetGadgetItemColor.html%#@1 *;
If OpenWindow(0, 0, 0, 300, 300, "SetGadgetItemColor", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ListIconGadget(0, 10, 10, 280, 280, "Column 0", 100)
  AddGadgetColumn(0, 1, "Column 1", 100)
  For i = 1 To 10
    AddGadgetItem(0, -1, "Text 1"+Chr(10)+"Text 2")
  Next
  
  SetGadgetItemColor(0, #PB_All, #PB_Gadget_FrontColor, $0000FF,  1)
  SetGadgetItemColor(0,  3, #PB_Gadget_BackColor,  $00FFFF, #PB_All)
  SetGadgetItemColor(0,  9, #PB_Gadget_BackColor,  $FFFF00,  1)
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\SetGadgetItemData.html%#@0 *;
; This code uses SetGadgetItemData to store the original position
; of each item to later know it, even if the items index changed.
;
If OpenWindow(0, 0, 0, 280, 250, "SetGadgetItemData", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ButtonGadget(0,  10, 10, 80, 20, "Add")
  ButtonGadget(1, 100, 10, 80, 20, "Remove")
  ButtonGadget(2, 190, 10, 80, 20, "Test")
  ListViewGadget(3, 10, 40, 260, 200)
  For i = 0 To 10
    AddGadgetItem(3, i, "Old Item "+Str(i))
    SetGadgetItemData(3, i, i)
  Next i
  
  Repeat
    Event = WaitWindowEvent()
    If Event = #PB_Event_Gadget
      item = GetGadgetState(3)
      
      Select EventGadget()
        Case 0 ; Add
          AddGadgetItem(3, item, "New Item")
          If item <> -1
            SetGadgetItemData(3, item, -1)
          Else
            SetGadgetItemData(3, CountGadgetItems(3)-1, -1)
          EndIf
          
        Case 1 ; Remove
          If item <> -1
            RemoveGadgetItem(3, item)
          EndIf
          
        Case 2 ; Test
          If item <> -1
            value = GetGadgetItemData(3, item)
            If value = -1
              MessageRequester("", "Its a new item.")
            Else
              MessageRequester("", "It was item number "+Str(value))
            EndIf
          EndIf
          
      EndSelect
    EndIf
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\SetGadgetItemState.html%#@3 *;
SetGadgetItemState(0, 1, #PB_Tree_Expanded | #PB_Tree_Selected) ; The 2nd item is selected and expanded.

;* %#@Gadget\ShortcutGadget.html%#@0 *;
If OpenWindow(0, 0, 0, 240, 70, "ShortcutGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ShortcutGadget(0, 20, 20, 200, 25, #PB_Shortcut_Control | #PB_Shortcut_A)
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\SpinGadget.html%#@5 *;
If OpenWindow(0, 0, 0, 140, 70, "SpinGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  SpinGadget     (0, 20, 20, 100, 25, 0, 1000)
  SetGadgetState (0, 5) : SetGadgetText(0, "5")   ; set initial value
  Repeat
    Event = WaitWindowEvent()
    If Event = #PB_Event_Gadget
      If EventGadget() = 0
        SetGadgetText(0, Str(GetGadgetState(0)))
      EndIf
    EndIf
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\SplitterGadget.html%#@3 *;
If OpenWindow(0, 0, 0, 230, 180, "SplitterGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  #Button1  = 0
  #Button2  = 1
  #Splitter = 2
  
  ButtonGadget(#Button1, 0, 0, 0, 0, "Button 1") ; No need to specify size or coordinates
  ButtonGadget(#Button2, 0, 0, 0, 0, "Button 2") ; as they will be sized automatically
  SplitterGadget(#Splitter, 5, 5, 220, 120, #Button1, #Button2, #PB_Splitter_Separator)
  
  TextGadget(3, 10, 135, 210, 40, "Above GUI part shows two automatically resizing buttons inside the 220x120 SplitterGadget area.",#PB_Text_Center )
  
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\StringGadget.html%#@5 *;
; Shows possible flags of StringGadget in action...
If OpenWindow(0, 0, 0, 322, 205, "StringGadget Flags", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  StringGadget(0, 8,  10, 306, 20, "Normal StringGadget...")
  StringGadget(1, 8,  35, 306, 20, "1234567", #PB_String_Numeric)
  StringGadget(2, 8,  60, 306, 20, "Read-only StringGadget", #PB_String_ReadOnly)
  StringGadget(3, 8,  85, 306, 20, "lowercase...", #PB_String_LowerCase)
  StringGadget(4, 8, 110, 306, 20, "uppercase...", #PB_String_UpperCase)
  StringGadget(5, 8, 140, 306, 20, "Borderless StringGadget", #PB_String_BorderLess)
  StringGadget(6, 8, 170, 306, 20, "Password", #PB_String_Password)
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\TextGadget.html%#@2 *;
If OpenWindow(0, 0, 0, 270, 160, "TextGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  TextGadget(0, 10,  10, 250, 20, "TextGadget Standard (Left)")
  TextGadget(1, 10,  70, 250, 20, "TextGadget Center", #PB_Text_Center)
  TextGadget(2, 10,  40, 250, 20, "TextGadget Right", #PB_Text_Right)
  TextGadget(3, 10, 100, 250, 20, "TextGadget Border", #PB_Text_Border)
  TextGadget(4, 10, 130, 250, 20, "TextGadget Center + Border", #PB_Text_Center | #PB_Text_Border)
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\TrackBarGadget.html%#@3 *;
If OpenWindow(0, 0, 0, 320, 200, "TrackBarGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  TextGadget    (3, 10,  20, 250, 20,"TrackBar Standard", #PB_Text_Center)
  TrackBarGadget(0, 10,  40, 250, 20, 0, 10000)
  SetGadgetState(0, 5000)
  TextGadget    (4, 10, 100, 250, 20, "TrackBar Ticks", #PB_Text_Center)
  TrackBarGadget(1, 10, 120, 250, 20, 0, 30, #PB_TrackBar_Ticks)
  SetGadgetState(1, 3000)
  TextGadget    (5,  90, 180, 200, 20, "TrackBar Vertical", #PB_Text_Right)
  TrackBarGadget(2, 270, 10, 20, 170, 0, 10000, #PB_TrackBar_Vertical)
  SetGadgetState(2, 8000)
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\TreeGadget.html%#@4 *;
If OpenWindow(0, 0, 0, 355, 180, "TreeGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  TreeGadget(0, 10, 10, 160, 160)                                         ; TreeGadget standard
  TreeGadget(1, 180, 10, 160, 160, #PB_Tree_CheckBoxes | #PB_Tree_NoLines); TreeGadget with Checkboxes + NoLines
  For ID = 0 To 1
    For a = 0 To 10
      AddGadgetItem (ID, -1, "Normal Item "+Str(a), 0, 0) ; if you want to add an image, use
      AddGadgetItem (ID, -1, "Node "+Str(a), 0, 0)        ; ImageID(x) as 4th parameter
      AddGadgetItem(ID, -1, "Sub-Item 1", 0, 1)           ; These are on the 1st sublevel
      AddGadgetItem(ID, -1, "Sub-Item 2", 0, 1)
      AddGadgetItem(ID, -1, "Sub-Item 3", 0, 1)
      AddGadgetItem(ID, -1, "Sub-Item 4", 0, 1)
      AddGadgetItem (ID, -1, "File "+Str(a), 0, 0) ; sublevel 0 again
    Next
  Next
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\UnbindGadgetEvent.html%#@0 *;
Procedure ButtonHandler()
  Debug "Button click event on gadget #" + EventGadget()
EndProcedure

OpenWindow(0, 100, 100, 200, 50, "Click test", #PB_Window_SystemMenu)

ButtonGadget(0, 10, 10, 180, 30, "Click me")

BindGadgetEvent(0, @ButtonHandler())
UnbindGadgetEvent(0, @ButtonHandler()) ; Unbind it immediately

Repeat
  Event = WaitWindowEvent()
Until Event = #PB_Event_CloseWindow

;* %#@Gadget\UseGadgetList.html%#@0 *;
If OpenWindow(0, 0, 0, 500, 500, "Main Window", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ButtonGadget(0, 10, 10, 150, 25, "Button 1")
  
  ; Create Window with #PB_Window_NoGadgets to prevent automatic GadgetList creation
  If OpenWindow(1, 0, 0, 300, 200, "Child Window", #PB_Window_TitleBar | #PB_Window_WindowCentered | #PB_Window_NoGadgets, WindowID(0))     
    OldGadgetList = UseGadgetList(WindowID(1)) ; Create GadgetList and store old GadgetList
    
    ButtonGadget(10, 10, 10, 150, 25, "Child Window Button")
    
    UseGadgetList(OldGadgetList)               ; Return to previous GadgetList
  EndIf
  
  ButtonGadget(1, 10, 45, 150, 25, "Button 2") ; This will be on the main window again
  
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\WebGadget.html%#@3 *;
Procedure NavigationCallback(Gadget, Url$)
  ;
  ; Return #True to allow this navigation or #False to deny it.
  ;
  ProcedureReturn #True
EndProcedure

;* %#@Gadget\WebGadget.html%#@6 *;
If OpenWindow(0, 0, 0, 600, 300, "WebGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  WebGadget(0, 10, 10, 580, 280, "http://www.purebasic.com")
  ; Note: if you want to use a local file, change last parameter to "file://" + path + filename
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Gadget\WebGadget.html%#@7 *;
; This example does display the PureBasic.com website. Inside the callback procedure
; the navigation to the 'News' site will be avoided (#False returned), but allowed
; for all other sites (#True returned).

Procedure NavigationCallback(Gadget, Url$) 
  If Url$= "http://www.purebasic.com/news.php" 
    MessageRequester("", "No news today!") 
    ProcedureReturn #False 
  Else 
    ProcedureReturn #True 
  EndIf 
EndProcedure 

If OpenWindow(0, 0, 0, 600, 300, "WebGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered) 
  WebGadget(0, 10, 10, 580, 280, "http://www.purebasic.com") 
  SetGadgetAttribute(0, #PB_Web_NavigationCallback, @NavigationCallback())
  Repeat 
  Until WaitWindowEvent() = #PB_Event_CloseWindow 
EndIf

;* %#@Gadget3D\ResizeGadget3D.html%#@0 *;
[...]

ResizeGadget3D(0, #PB_Ignore, #PB_Ignore, 300, #PB_Ignore) ; Only change the gadget width.


;* %#@Help\OpenHelp.html%#@0 *;
OpenHelp("help.chm", "index.htm")
OpenHelp("help.chm", "print.txt")


;* %#@Http\GetHTTPHeader.html%#@0 *;
InitNetwork()

Header$ = GetHTTPHeader("http://www.purebasic.com/index.php")

Repeat
  Index+1
  Line$ = StringField(Header$, Index, #LF$)
  Debug Line$
Until Line$ = ""

;* %#@Http\GetHTTPHeader.html%#@1 *;
HTTP/1.1 200 OK
Date: Fri, 21 Mar 2008 09:49:30 GMT
Server: Apache/1.3.34 (Debian) mod_vhost_online/1.1 mod_fastcgi/2.4.2 mod_log_online/0.1
X-Powered-By: PHP/4.4.8-1
Content-Type: text/html

;* %#@Http\GetURLPart.html%#@1 *;
URL$ = "http://user:pass@www.purebasic.com:80/index.php3?test=1&ok=2"

Debug GetURLPart(URL$, #PB_URL_Protocol) ; Will print "http"
Debug GetURLPart(URL$, #PB_URL_Site)     ; Will print "www.purebasic.com"
Debug GetURLPart(URL$, #PB_URL_Port)     ; Will print "80"
Debug GetURLPart(URL$, #PB_URL_Parameters) ; Will print "test=1&ok=2"
Debug GetURLPart(URL$, #PB_URL_Path)       ; Will print "index.php3"
Debug GetURLPart(URL$, #PB_URL_User)       ; Will print "user"
Debug GetURLPart(URL$, #PB_URL_Password)   ; Will print "pass"
Debug GetURLPart(URL$, "test")             ; Will print "1"
Debug GetURLPart(URL$, "ok")               ; Will print "2"

;* %#@Http\HTTPProgress.html%#@1 *;
InitNetwork()

Download = ReceiveHTTPMemory("http://www.purebasic.com/download/OgreAssimpConverter.zip", #PB_HTTP_Asynchronous)
If Download
  Repeat
    Progress = HTTPProgress(Download)
    Select Progress
      Case #PB_Http_Success
        *Buffer = FinishHTTP(Download)
        Debug "Download finished (size: " + MemorySize(*Buffer) + ")"
        FreeMemory(*Buffer)
        End
        
      Case #PB_Http_Failed
        Debug "Download failed"
        End
        
      Case #PB_Http_Aborted
        Debug "Download aborted"
        End
        
      Default
        Debug "Current download: " + Progress
        
    EndSelect
    
    Delay(500) ; Don't stole the whole CPU
  ForEver
Else
  Debug "Download error"
EndIf

;* %#@Http\ReceiveHTTPFile.html%#@1 *;
InitNetwork()

Filename$ = SaveFileRequester("Where to save index.php ?", "", "", 0)

If ReceiveHTTPFile("http://www.purebasic.com/index.php", Filename$)
  Debug "Success"
Else
  Debug "Failed"
EndIf

;* %#@Http\ReceiveHTTPMemory.html%#@1 *;
InitNetwork()

*Buffer = ReceiveHTTPMemory("http://www.purebasic.com/index.php")
If *Buffer
  Size = MemorySize(*Buffer)
  Debug "Content: " + PeekS(*Buffer, Size, #PB_UTF8)
  FreeMemory(*Buffer)
Else
  Debug "Failed"
EndIf

;* %#@Http\SetURLPart.html%#@1 *;
URL$ = "http://www.test.com/hello.php3"

URL$ = SetURLPart(URL$, #PB_URL_Protocol, "ftp")
URL$ = SetURLPart(URL$, #PB_URL_Site, "www.purebasic.com")
URL$ = SetURLPart(URL$, #PB_URL_Port, "80")
URL$ = SetURLPart(URL$, #PB_URL_Path, "english/index.php3")
URL$ = SetURLPart(URL$, #PB_URL_User, "user")
URL$ = SetURLPart(URL$, #PB_URL_Password, "pass")
URL$ = SetURLPart(URL$, "test", "1")
URL$ = SetURLPart(URL$, "ok", "2")

Debug URL$ ; Will print "ftp://user:pass@www.purebasic.com:80/english/index.php3?test=1&ok=2"


;* %#@Http\URLDecoder.html%#@1 *;
Debug URLDecoder("http://www.purebasic.com/test%20with%20space.php3")
; Will print "http://www.purebasic.com/test with space.php3"

;* %#@Http\URLEncoder.html%#@1 *;
Debug URLEncoder("http://www.purebasic.com/test with space.php3")
; Will print "http://www.purebasic.com/test%20with%20space.php3"

;* %#@Image\CatchImage.html%#@0 *;
CatchImage(0, ?Logo)
End

DataSection
  Logo: 
  IncludeBinary "Logo.bmp"
EndDataSection

;* %#@Image\ImageOutput.html%#@0 *;
StartDrawing(ImageOutput(#Image))
; do some drawing stuff here...
StopDrawing()

;* %#@Image\ImageVectorOutput.html%#@1 *;
StartVectorDrawing(ImageVectorOutput(#Image, #PB_Unit_Millimeter))
; do some drawing stuff here...
StopVectorDrawing()

;* %#@Joint\SetJointAttribute.html%#@0 *;
0, 1 And 2: translation axis (x, y, z)
3, 4 And 5: rotation axis (x, y, z)

;* %#@Json\AddJSONElement.html%#@0 *;
If CreateJSON(0)
  ArrayValue = SetJSONArray(JSONValue(0))
  
  ; add element at the end
  For i = 1 To 5
    NumValue = AddJSONElement(ArrayValue)
    SetJSONInteger(NumValue, i)
  Next i
  
  ; insert at a specific index
  StrValue = AddJSONElement(ArrayValue, 1)
  SetJSONString(StrValue, "Hello")
  
  Debug ComposeJSON(0)
EndIf

;* %#@Json\AddJSONMember.html%#@0 *;
If CreateJSON(0)
  ObjectValue = SetJSONObject(JSONValue(0))
  
  FirstName = AddJSONMember(ObjectValue, "FirstName")
  SetJSONString(FirstName, "John")
  
  LastName = AddJSONMember(ObjectValue, "LastName")
  SetJSONString(LastName, "Smith")    
  
  Debug ComposeJSON(0)
EndIf

;* %#@Json\ClearJSONElements.html%#@0 *;
ParseJSON(0, "[1, 2, 3, 4]")

; clear the values and add a new string
ClearJSONElements(JSONValue(0))
SetJSONString(AddJSONElement(JSONValue(0)), "Hello")

Debug ComposeJSON(0)

;* %#@Json\ClearJSONMembers.html%#@0 *;
Input$ = "{ " + Chr(34) + "x" + Chr(34) + ": 10, " + Chr(34) + "y" + Chr(34) + ": 20 }"
Debug Input$  
ParseJSON(0, Input$)

; clear the members and add a new one
ClearJSONMembers(JSONValue(0))
SetJSONString(AddJSONMember(JSONValue(0), "Hello"), "World")

Debug ComposeJSON(0)

;* %#@Json\ComposeJSON.html%#@0 *;
If CreateJSON(0)
  Person = SetJSONObject(JSONValue(0))
  SetJSONString(AddJSONMember(Person, "FirstName"), "John")
  SetJSONString(AddJSONMember(Person, "LastName"), "Smith")
  SetJSONInteger(AddJSONMember(Person, "Age"), 42)
  
  Debug ComposeJSON(0, #PB_JSON_PrettyPrint)
EndIf

;* %#@Json\CreateJSON.html%#@0 *;
If CreateJSON(0)
  Person = SetJSONObject(JSONValue(0))
  SetJSONString(AddJSONMember(Person, "FirstName"), "John")
  SetJSONString(AddJSONMember(Person, "LastName"), "Smith")
  SetJSONInteger(AddJSONMember(Person, "Age"), 42)
  
  Debug ComposeJSON(0, #PB_JSON_PrettyPrint)
EndIf

;* %#@Json\ExamineJSONMembers.html%#@0 *;
Input$ = "{ " + Chr(34) + "x" + Chr(34) + ": 10, " + 
         Chr(34) + "y" + Chr(34) + ": 20, " + 
         Chr(34) + "z" + Chr(34) + ": 30 }"

ParseJSON(0, Input$)
ObjectValue = JSONValue(0)

If ExamineJSONMembers(ObjectValue)
  While NextJSONMember(ObjectValue)
    Debug JSONMemberKey(ObjectValue) + " = " + GetJSONInteger(JSONMemberValue(ObjectValue))
  Wend
EndIf

;* %#@Json\ExtractJSONArray.html%#@0 *;
ParseJSON(0, "[1, 3, 5, 7, 9]")

Dim a(0)
ExtractJSONArray(JSONValue(0), a())

For i = 0 To ArraySize(a())
  Debug a(i)
Next i

;* %#@Json\ExtractJSONArray.html%#@1 *;
ParseJSON(0, "[[0, 1, 2], [3, 4, 5], [6, 7, 8]]")

Dim a(0, 0)
ExtractJSONArray(JSONValue(0), a())

For x = 0 To 2
  For y = 0 To 2
    Debug a(x, y)
  Next y
Next x

;* %#@Json\ExtractJSONList.html%#@0 *;
Input$ = "[ {" + Chr(34) + "x" + Chr(34) + ": 10, " + Chr(34) + "y" + Chr(34) + ": 20}, " + 
         "{" + Chr(34) + "x" + Chr(34) + ": 30, " + Chr(34) + "y" + Chr(34) + ": 50}, " + 
         "{" + Chr(34) + "x" + Chr(34) + ": -5, " + Chr(34) + "y" + Chr(34) + ": 100} ]"

Structure Location
  x.l
  y.l
EndStructure

NewList Locations.Location()

ParseJSON(0, Input$)
ExtractJSONList(JSONValue(0), Locations())

ForEach Locations()
  Debug Str(Locations()\x) + ", " + Str(Locations()\y)
Next

;* %#@Json\ExtractJSONMap.html%#@0 *;
Input$ = "{" + Chr(34) + "enabled" + Chr(34) + ": 1, " + 
         Chr(34) + "displayed" + Chr(34) + ": 1, " + 
         Chr(34) + "visible" + Chr(34) + ": 0 }"        
ParseJSON(0, Input$)

NewMap Options()
ExtractJSONMap(JSONValue(0), Options())       

Debug Options("enabled")
Debug Options("visible")

;* %#@Json\ExtractJSONStructure.html%#@0 *;
Structure Person
  Name$
  Age.l
  List Books.s()
EndStructure

Input$ = "{" + Chr(34) + "Name" + Chr(34) + ": " + Chr(34) + "John Smith" + Chr(34) + ", " + 
         Chr(34) + "Age" + Chr(34) + ": 42, " + 
         Chr(34) + "Books" + Chr(34) + ": [" +
         Chr(34) + "Investing For Dummies" + Chr(34) + ", " + 
         Chr(34) + "A Little Bit of Everything For Dummies" + Chr(34) + "] }"

ParseJSON(0, Input$)
ExtractJSONStructure(JSONValue(0), @P.Person, Person)

Debug P\Name$
Debug P\Age
Debug ListSize(P\Books())

;* %#@Json\GetJSONBoolean.html%#@0 *;
ParseJSON(0, "[true, true, false]")

Debug GetJSONBoolean(GetJSONElement(JSONValue(0), 0))
Debug GetJSONBoolean(GetJSONElement(JSONValue(0), 1))
Debug GetJSONBoolean(GetJSONElement(JSONValue(0), 2))

;* %#@Json\GetJSONDouble.html%#@0 *;
ParseJSON(0, "[1, 1.23, 1.23e-3]")

Debug GetJSONDouble(GetJSONElement(JSONValue(0), 0))
Debug GetJSONDouble(GetJSONElement(JSONValue(0), 1))
Debug GetJSONDouble(GetJSONElement(JSONValue(0), 2))

;* %#@Json\GetJSONElement.html%#@0 *;
ParseJSON(0, "[1, 2, 3, 4, 5]")

For i = 0 To JSONArraySize(JSONValue(0)) - 1
  Debug GetJSONInteger(GetJSONElement(JSONValue(0), i))
Next i

;* %#@Json\GetJSONFloat.html%#@0 *;
ParseJSON(0, "[1, 1.23, 1.23e-3]")

Debug GetJSONFloat(GetJSONElement(JSONValue(0), 0))
Debug GetJSONFloat(GetJSONElement(JSONValue(0), 1))
Debug GetJSONFloat(GetJSONElement(JSONValue(0), 2))

;* %#@Json\GetJSONInteger.html%#@0 *;
ParseJSON(0, "[1, 2, 3, 4, 5]")

For i = 0 To JSONArraySize(JSONValue(0)) - 1
  Debug GetJSONInteger(GetJSONElement(JSONValue(0), i))
Next i

;* %#@Json\GetJSONMember.html%#@0 *;
Input$ = "{ " + Chr(34) + "x" + Chr(34) + ": 10, " + 
         Chr(34) + "y" + Chr(34) + ": 20, " + 
         Chr(34) + "z" + Chr(34) + ": 30 }"

ParseJSON(0, Input$)

Debug GetJSONInteger(GetJSONMember(JSONValue(0), "x"))
Debug GetJSONInteger(GetJSONMember(JSONValue(0), "y"))
Debug GetJSONInteger(GetJSONMember(JSONValue(0), "y"))

;* %#@Json\GetJSONQuad.html%#@0 *;
ParseJSON(0, "[1, 2, 3, 4, 5]")

For i = 0 To JSONArraySize(JSONValue(0)) - 1
  Debug GetJSONQuad(GetJSONElement(JSONValue(0), i))
Next i

;* %#@Json\GetJSONString.html%#@0 *;
ParseJSON(0, Chr(34) + "The quick brown fox jumped over the lazy dog" + Chr(34))

Debug GetJSONString(JSONValue(0))  

;* %#@Json\InsertJSONArray.html%#@0 *;
Dim Colors.s(3)
Colors(0) = "red"
Colors(1) = "yellow"
Colors(2) = "green"
Colors(3) = "blue"

If CreateJSON(0)
  InsertJSONArray(JSONValue(0), Colors())
  Debug ComposeJSON(0)
EndIf

;* %#@Json\InsertJSONArray.html%#@1 *;
Dim matrix(2, 2)
matrix(0, 0) = 1
matrix(1, 1) = 1
matrix(2, 2) = 1

If CreateJSON(0)
  InsertJSONArray(JSONValue(0), matrix())
  Debug ComposeJSON(0)
EndIf

;* %#@Json\InsertJSONList.html%#@0 *;
NewList Names.s()
AddElement(Names()): Names() = "John"
AddElement(Names()): Names() = "Jane"
AddElement(Names()): Names() = "Jim"

If CreateJSON(0)
  InsertJSONList(JSONValue(0), Names())
  Debug ComposeJSON(0, #PB_JSON_PrettyPrint)
EndIf

;* %#@Json\InsertJSONMap.html%#@0 *;
NewMap Colors()
Colors("red")   = $0000FF
Colors("green") = $00FF00
Colors("blue")  = $FF0000

If CreateJSON(0)
  InsertJSONMap(JSONValue(0), Colors())
  Debug ComposeJSON(0, #PB_JSON_PrettyPrint)
EndIf

;* %#@Json\InsertJSONStructure.html%#@0 *;
Structure Person
  FirstName$
  LastName$
  Age.l
  List Books.s()
EndStructure

Define P.Person
P\FirstName$ = "John"
P\LastName$  = "Smith"
P\Age        = 42
AddElement(P\Books()): P\Books() = "Investing For Dummies"
AddElement(P\Books()): P\Books() = "English Grammar For Dummies"
AddElement(P\Books()): P\Books() = "A Little Bit of Everything For Dummies"

If CreateJSON(0)
  InsertJSONStructure(JSONValue(0), @P, Person)
  Debug ComposeJSON(0, #PB_JSON_PrettyPrint)
EndIf

;* %#@Json\JSONArraySize.html%#@0 *;
ParseJSON(0, "[1, 2, null, true]")
Debug JSONArraySize(JSONValue(0))

;* %#@Json\JSONErrorMessage.html%#@0 *;
If ParseJSON(0, "[1, 2, 3 4]")
  ; work with the data
Else
  Debug JSONErrorMessage()
EndIf

;* %#@Json\JSONObjectSize.html%#@0 *;
Input$ = "{ " + Chr(34) + "x" + Chr(34) + ": 10, " + 
         Chr(34) + "y" + Chr(34) + ": 20, " + 
         Chr(34) + "z" + Chr(34) + ": 30 }"

ParseJSON(0, Input$)
Debug JSONObjectSize(JSONValue(0))

;* %#@Json\JSONType.html%#@0 *;
; A procedure that accepts any JSON value and returns a string
;
Procedure.s GetAnyValue(Value)
  Select JSONType(Value)
    Case #PB_JSON_Null:    ProcedureReturn "null"
    Case #PB_JSON_String:  ProcedureReturn GetJSONString(Value)
    Case #PB_JSON_Number:  ProcedureReturn StrD(GetJSONDouble(Value))    
    Case #PB_JSON_Boolean: ProcedureReturn Str(GetJSONBoolean(Value))
    Case #PB_JSON_Array:   ProcedureReturn "array"
    Case #PB_JSON_Object:  ProcedureReturn "object"
  EndSelect
EndProcedure

ParseJSON(0, "[1, 2, true, null, " + Chr(34) + "hello" + Chr(34) + "]")
For i = 0 To JSONArraySize(JSONValue(0)) - 1
  Debug GetAnyValue(GetJSONElement(JSONValue(0), i))
Next i

;* %#@Json\JSONValue.html%#@0 *;
ParseJSON(0, Chr(34) + "The quick brown fox jumped over the lazy dog" + Chr(34))

Debug GetJSONString(JSONValue(0))  

;* %#@Json\ParseJSON.html%#@0 *;
If ParseJSON(0, "[1, 2, 3, 4, 5]")    
  For i = 0 To JSONArraySize(JSONValue(0)) - 1
    Debug GetJSONInteger(GetJSONElement(JSONValue(0), i))
  Next i
Else
  JSONErrorMessage()
EndIf

;* %#@Json\RemoveJSONElement.html%#@0 *;
ParseJSON(0, "[1, 2, 3, 4, 5]")
RemoveJSONElement(JSONValue(0), 2)
Debug ComposeJSON(0)

;* %#@Json\RemoveJSONMember.html%#@0 *;
Input$ = "{ " + Chr(34) + "x" + Chr(34) + ": 10, " + 
         Chr(34) + "y" + Chr(34) + ": 20, " + 
         Chr(34) + "z" + Chr(34) + ": 30 }"

ParseJSON(0, Input$)
RemoveJSONMember(JSONValue(0), "x")
Debug ComposeJSON(0, #PB_JSON_PrettyPrint)

;* %#@Json\ResizeJSONElements.html%#@0 *;
ParseJSON(0, "[1, 2, 3, 4, 5]") 

ResizeJSONElements(JSONValue(0), 3)
Debug ComposeJSON(0)

ResizeJSONElements(JSONValue(0), 10)
Debug ComposeJSON(0)

;* %#@Json\SetJSONArray.html%#@0 *;
If CreateJSON(0)
  ArrayValue = SetJSONArray(JSONValue(0))
  SetJSONString(AddJSONElement(ArrayValue), "hello")
  SetJSONString(AddJSONElement(ArrayValue), "world")
  
  Debug ComposeJSON(0)
EndIf

;* %#@Json\SetJSONBoolean.html%#@0 *;
If CreateJSON(0)
  ArrayValue = SetJSONArray(JSONValue(0))
  SetJSONBoolean(AddJSONElement(ArrayValue), #True)
  SetJSONBoolean(AddJSONElement(ArrayValue), #False)
  
  Debug ComposeJSON(0)
EndIf

;* %#@Json\SetJSONDouble.html%#@0 *;
If CreateJSON(0)
  ArrayValue = SetJSONArray(JSONValue(0))
  SetJSONDouble(AddJSONElement(ArrayValue), 1.23)
  SetJSONDouble(AddJSONElement(ArrayValue), 4.56)
  
  Debug ComposeJSON(0)
EndIf

;* %#@Json\SetJSONFloat.html%#@0 *;
If CreateJSON(0)
  ArrayValue = SetJSONArray(JSONValue(0))
  SetJSONFloat(AddJSONElement(ArrayValue), 1.23)
  SetJSONFloat(AddJSONElement(ArrayValue), 4.56)
  
  Debug ComposeJSON(0)
EndIf

;* %#@Json\SetJSONInteger.html%#@0 *;
If CreateJSON(0)
  ArrayValue = SetJSONArray(JSONValue(0))
  SetJSONInteger(AddJSONElement(ArrayValue), 1)
  SetJSONInteger(AddJSONElement(ArrayValue), 2)
  SetJSONInteger(AddJSONElement(ArrayValue), 3)
  
  Debug ComposeJSON(0)
EndIf

;* %#@Json\SetJSONNull.html%#@0 *;
ParseJSON(0, "[1, 2, 3, 4, 5]") 
SetJSONNull(GetJSONElement(JSONValue(0), 2))
SetJSONNull(GetJSONElement(JSONValue(0), 3))
Debug ComposeJSON(0)

;* %#@Json\SetJSONObject.html%#@0 *;
If CreateJSON(0)
  ObjectValue = SetJSONObject(JSONValue(0))
  SetJSONInteger(AddJSONMember(ObjectValue, "x"), 10)
  SetJSONInteger(AddJSONMember(ObjectValue, "y"), 20)
  SetJSONInteger(AddJSONMember(ObjectValue, "z"), 30)
  
  Debug ComposeJSON(0, #PB_JSON_PrettyPrint)
EndIf

;* %#@Json\SetJSONQuad.html%#@0 *;
If CreateJSON(0)
  ArrayValue = SetJSONArray(JSONValue(0))
  SetJSONQuad(AddJSONElement(ArrayValue), 1)
  SetJSONQuad(AddJSONElement(ArrayValue), 2)
  SetJSONQuad(AddJSONElement(ArrayValue), 3)
  
  Debug ComposeJSON(0)
EndIf

;* %#@Json\SetJSONString.html%#@0 *;
If CreateJSON(0)
  ArrayValue = SetJSONArray(JSONValue(0))
  SetJSONString(AddJSONElement(ArrayValue), "with escaped new" + Chr(13) + Chr(10) + "line")
  SetJSONString(AddJSONElement(ArrayValue), "with escaped \ backslash")
  
  Debug ComposeJSON(0)
EndIf

;* %#@Keyboard\KeyboardInkey.html%#@0 *;
If InitSprite() And InitKeyboard() And OpenScreen(800, 600, 32, "")
  Repeat
    FlipBuffers()
    ClearScreen(RGB(0, 0, 0))
    
    ExamineKeyboard()
    
    ; If we press the 'Back' key, we will delete the last character
    ;
    If KeyboardReleased(#PB_Key_Back)
      FullText$ = Left(FullText$, Len(FullText$)-1)
    Else
      result$=KeyboardInkey()
      If FindString("1234567890 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz", result$) ; Or your chosen valid characters
        FullText$ + result$
      EndIf ; Add the new text to the current one (if any)
    EndIf
    
    ; Display the result
    ;
    If StartDrawing(ScreenOutput())
      DrawingMode(1)
      FrontColor(RGB(128, 255, 0))
      DrawText(20, 20, "Just type some text...:")
      DrawText(20, 40, FullText$)
      StopDrawing()
    EndIf
  Until KeyboardPushed(#PB_Key_Escape)
EndIf

;* %#@Keyboard\KeyboardPushed.html%#@1 *;
If InitSprite() And InitKeyboard() And OpenScreen(800,600,16,"")
  Repeat
    FlipBuffers()
    
    If StartDrawing(ScreenOutput())
      DrawText(0, 0, "Press ESC to quit")
      StopDrawing()
    EndIf
    
    ExamineKeyboard()
    If KeyboardPushed(#PB_Key_Escape)   ; press Esc to quit
      End
    EndIf
  ForEver
EndIf

;* %#@Keyboard\KeyboardReleased.html%#@0 *;
If InitSprite() And InitKeyboard() And OpenScreen(800,600,16,"")
  Paused = #False
  Repeat
    FlipBuffers()
    
    If StartDrawing(ScreenOutput())
      
      ExamineKeyboard()
      If KeyboardReleased(#PB_Key_P)
        If Paused = #False
          Paused = #True
        Else
          Paused = #False
        EndIf
      EndIf
      
      DrawingMode(0)
      
      If Paused = #False
        DrawText(20, 20, "Program is running...")
      Else
        DrawText(20, 20, "Program paused...    ")
      EndIf
      
      StopDrawing()
    EndIf
  Until KeyboardPushed(#PB_Key_Escape)
EndIf

;* %#@Light\CreateLight.html%#@1 *;
CreateLight(0, RGB(255,0,0)) ; Creates a red light

CreateLight(1, RGB(0,255,0),  0, 100.7, 50) ; Creates a green light, at the position (0, 100.7, 50)

;* %#@List\AddElement.html%#@0 *;
; The simplest way to use AddElement
NewList simple.w()
AddElement(simple())    ; Creates the first new element in the list
simple() = 23

AddElement(simple())    ; Current position is the first element, so we add one to the second position
simple() = 45


; This shows how to use the return-value of AddElement
NewList advanced.l()
If AddElement(advanced()) <> 0
  advanced() = 12345
Else
  MessageRequester("Error!", "Unable to allocate memory for new element", #PB_MessageRequester_Ok)
EndIf


; A small structure to demonstrate the use of the pointer to the new element
Structure Programmer
  Name.s
  Strength.b
EndStructure

NewList Programmers.Programmer()  ; The list for storing the elements

*Element.Programmer = AddElement(Programmers())
If *Element<>0
  *Element\Name = "Dave"
  *Element\Strength = 3   ; Wow, super-strong geek! ;)
Else
  MessageRequester("Error!", "Unable to allocate memory for new element", #PB_MessageRequester_Ok)
EndIf

;* %#@List\ChangeCurrentElement.html%#@0 *;
*Old_Element = @mylist()   ; Get the address of the current element

ResetList(mylist())        ; Perform a search for all elements named
While NextElement(mylist()); "John" and change them to "J" 
  If mylist()\name = "John"
    mylist()\name = "J"     
  EndIf 
Wend     

ChangeCurrentElement(mylist(), *Old_Element) ; Restore previous current element (from before the search)

;* %#@List\ClearList.html%#@0 *;
NewList Numbers.w()

; A small loop to add many items to the list
For i=1 To 100
  AddElement(Numbers())
  Numbers() = i
Next

; Proof that items have been added to the list
MessageRequester("Information", "There are "+Str(ListSize(Numbers()))+" elements in the list", #PB_MessageRequester_Ok)

; Clear the list and show that the list really is empty
ClearList(Numbers())
MessageRequester("Information", "There are "+Str(ListSize(Numbers()))+" elements in the list", #PB_MessageRequester_Ok)

;* %#@List\CopyList.html%#@0 *;
NewList Friends$()
NewList FriendsCopy$()

AddElement(Friends$())
Friends$() = "John"

AddElement(Friends$())
Friends$() = "Elise"

CopyList(Friends$(), FriendsCopy$())

ForEach FriendsCopy$()
  Debug FriendsCopy$()
Next

;* %#@List\DeleteElement.html%#@0 *;
NewList people.s()

AddElement(people()) : people() = "Tom"
AddElement(people()) : people() = "Dick"
AddElement(people()) : people() = "Harry"
AddElement(people()) : people() = "Bob"

FirstElement(people())
DeleteElement(people(), 1)
MessageRequester("Information", "First person in list is "+people(), #PB_MessageRequester_Ok)

LastElement(people())      ; Moves to "Bob"
PreviousElement(people())  ; Moves to "Harry"
DeleteElement(people())    ; And deletes him. there is an element before Harry, so it becomes the current
MessageRequester("Information", "Current person in list is "+people(), #PB_MessageRequester_Ok)

;* %#@List\FirstElement.html%#@0 *;
; An example of simple usage
NewList Numbers.w()

AddElement(Numbers())
Numbers() = 5
AddElement(Numbers())
Numbers() = 8

FirstElement(Numbers())
MessageRequester("Information", "First element value is "+Str(Numbers()), #PB_MessageRequester_Ok)


; An example which uses the return-value
NewList Numbers.w()

If FirstElement(Numbers()) <> 0
  MessageRequester("Information", "First element value is "+Str(Numbers()), #PB_MessageRequester_Ok)
Else
  MessageRequester("Information", "List is empty", #PB_MessageRequester_Ok)
EndIf

AddElement(Numbers())
Numbers() = 5
AddElement(Numbers())
Numbers() = 8

If FirstElement(Numbers()) <> 0
  MessageRequester("Information", "First element value is "+Str(Numbers()), #PB_MessageRequester_Ok)
Else
  MessageRequester("Information", "List is empty", #PB_MessageRequester_Ok)
EndIf


; An example which is only for advanced users
NewList Numbers.w()

AddElement(Numbers())
Numbers() = 5
AddElement(Numbers())
Numbers() = 8

*Element.Word = FirstElement(Numbers())
If *Element
  MessageRequester("Information", "First element value is "+Str(*Element\w), #PB_MessageRequester_Ok)
Else
  MessageRequester("Information", "List is empty", #PB_MessageRequester_Ok)
EndIf

;* %#@List\InsertElement.html%#@0 *;
; The simplest way to use InsertElement
NewList simple.w()
InsertElement(simple())    ; Creates the first new element in the list
simple() = 23

InsertElement(simple())    ; Current position is the first element, so we add this element to the start of the list
simple() = 45              ; The old first element is now the second element in the list


; This shows how to use the return-value of InsertElement
NewList advanced.l()
If InsertElement(advanced()) <> 0
  advanced() = 12345
Else
  MessageRequester("Error!", "Unable to allocate memory for new element", #PB_MessageRequester_Ok)
EndIf


; A small structure to demonstrate the use of the pointer to the new element
Structure Programmer
  Name.s
  Strength.b
EndStructure

NewList Programmers.Programmer()  ; The list for storing the elements

*Element.Programmer = InsertElement(Programmers())
If *Element<>0
  *Element\Name = "Dave"
  *Element\Strength = 3   ; Wow, super-strong geek! ;)
Else
  MessageRequester("Error!", "Unable to allocate memory for new element", #PB_MessageRequester_Ok)
EndIf

;* %#@List\LastElement.html%#@0 *;
; An example of simple usage
NewList Numbers.w()

AddElement(Numbers())
Numbers() = 5
AddElement(Numbers())
Numbers() = 8

LastElement(Numbers())
MessageRequester("Information", "Last element value is "+Str(Numbers()), #PB_MessageRequester_Ok)


; An example which uses the return-value
NewList Numbers.w()

If LastElement(Numbers()) <> 0
  MessageRequester("Information", "Last element value is "+Str(Numbers()), #PB_MessageRequester_Ok)
Else
  MessageRequester("Information", "List is empty", #PB_MessageRequester_Ok)
EndIf

AddElement(Numbers())
Numbers() = 5
AddElement(Numbers())
Numbers() = 8

If LastElement(Numbers()) <> 0
  MessageRequester("Information", "Last element value is "+Str(Numbers()), #PB_MessageRequester_Ok)
Else
  MessageRequester("Information", "List is empty", #PB_MessageRequester_Ok)
EndIf


; An example which is only for advanced users
NewList Numbers.w()

AddElement(Numbers())
Numbers() = 5
AddElement(Numbers())
Numbers() = 8

*Element.Word = LastElement(Numbers())
If *Element
  MessageRequester("Information", "Last element value is "+Str(*Element\w), #PB_MessageRequester_Ok)
Else
  MessageRequester("Information", "List is empty", #PB_MessageRequester_Ok)
EndIf

;* %#@List\ListIndex.html%#@0 *;
NewList fruit.s()

AddElement(fruit()) : fruit() = "oranges"
AddElement(fruit()) : fruit() = "bananas"
AddElement(fruit()) : fruit() = "apples"
AddElement(fruit()) : fruit() = "pears"

FirstElement(fruit())
MessageRequester("Fruit: "+fruit(), "Now at position "+Str(ListIndex(fruit())),  #PB_MessageRequester_Ok)

NextElement(fruit())
MessageRequester("Fruit: "+fruit(), "Now at position "+Str(ListIndex(fruit())),  #PB_MessageRequester_Ok)

NextElement(fruit())
MessageRequester("Fruit: "+fruit(), "Now at position "+Str(ListIndex(fruit())),  #PB_MessageRequester_Ok)

NextElement(fruit())
MessageRequester("Fruit: "+fruit(), "Now at position "+Str(ListIndex(fruit())),  #PB_MessageRequester_Ok)

;* %#@List\ListSize.html%#@0 *;
NewList countme.w()

; Small loop to add some elements to the list.
For i=0 To 10
  AddElement(countme())
  countme() = i * 23
Next

; Show how many elements there are in the list. I hope you thought
; of the same value as this example ;)
MessageRequester("Information", "There are "+Str(ListSize(countme()))+" elements in the list", #PB_MessageRequester_Ok)

;* %#@List\MergeLists.html%#@1 *;
NewList A.s()
AddElement(A()): A() = "a0"
AddElement(A()): A() = "a1"
AddElement(A()): A() = "a2"
AddElement(A()): A() = "a3"

NewList B.s()
AddElement(B()): B() = "b0"
AddElement(B()): B() = "b1"
AddElement(B()): B() = "b2"
AddElement(B()): B() = "b3"

; Insert the elements of A() before the "b1" element in B()
SelectElement(B(), 1)
MergeLists(A(), B(), #PB_List_Before)

ForEach B()
  Debug B()
Next

;* %#@List\MoveElement.html%#@1 *;
NewList Numbers()

For k=0 To 10
  AddElement(Numbers())
  Numbers() = k
Next

SelectElement(Numbers(), 5) 
*Relative = @Numbers()                             ; get address of element 5

SelectElement(Numbers(), 0)
MoveElement(Numbers(), #PB_List_After, *Relative)  ; move after element 5

SelectElement(Numbers(), 10)
MoveElement(Numbers(), #PB_List_First)             ; move to the beginning

; Result
;
ForEach Numbers()
  Debug Numbers()
Next

;* %#@List\NextElement.html%#@0 *;
NewList Scores.w()

For i=1 To 10
  AddElement(Scores())
  Scores() = 100 - i
Next

ResetList(Scores())
While NextElement(Scores())
  ; This is OK since the first call to NextElement() will move the current element to the first item in the list
  MessageRequester("Score", Str(Scores()), #PB_MessageRequester_Ok)
Wend

;* %#@List\PreviousElement.html%#@0 *;
NewList Numbers.w()

For i=1 To 10
  AddElement(Numbers())
  Numbers() = i
Next

Repeat
  MessageRequester("Number", Str(Numbers()), #PB_MessageRequester_Ok)
Until PreviousElement(Numbers()) = 0

;* %#@List\PushListPosition.html%#@0 *;
NewList Numbers()
AddElement(Numbers()): Numbers() = 1
AddElement(Numbers()): Numbers() = 2
AddElement(Numbers()): Numbers() = 5
AddElement(Numbers()): Numbers() = 3
AddElement(Numbers()): Numbers() = 5
AddElement(Numbers()): Numbers() = 2

; A simple duplicate elimination using a nested iteration
;
ForEach Numbers()
  Value = Numbers()
  PushListPosition(Numbers())
  While NextElement(Numbers())
    If Numbers() = Value 
      DeleteElement(Numbers())
    EndIf
  Wend
  PopListPosition(Numbers())
Next

ForEach Numbers()
  Debug Numbers()
Next

;* %#@List\ResetList.html%#@0 *;
NewList Friends.s()

AddElement(Friends())
Friends() = "Arnaud"

AddElement(Friends())
Friends() = "Seb"

ResetList(Friends())
While NextElement(Friends())
  Debug Friends() ; Display all the list elements
Wend

;* %#@List\SelectElement.html%#@0 *;
NewList mylist.l()

AddElement(mylist()) : mylist() = 23
AddElement(mylist()) : mylist() = 56
AddElement(mylist()) : mylist() = 12
AddElement(mylist()) : mylist() = 73

SelectElement(mylist(), 0)
MessageRequester("Position", "At position 0, the value is "+Str(mylist()),0)

SelectElement(mylist(), 2)
MessageRequester("Position", "At position 2, the value is "+Str(mylist()),0)

SelectElement(mylist(), 1)
MessageRequester("Position", "At position 1, the value is "+Str(mylist()),0)

SelectElement(mylist(), 3)
MessageRequester("Position", "At position 3, the value is "+Str(mylist()),0)

;* %#@List\SplitList.html%#@0 *;
NewList A()
NewList B()

For i = 0 To 10
  AddElement(A())
  A() = i
Next i

; split A() at element 5 and move the remaining elements to B()
SelectElement(A(), 5)
SplitList(A(), B())


Debug " -- A() -- "
ForEach A()
  Debug A()
Next

Debug " -- B() -- "
ForEach B()
  Debug B()
Next

;* %#@List\SwapElements.html%#@0 *;
NewList Numbers()

For k=0 To 10
  AddElement(Numbers())
  Numbers() = k
Next

SelectElement(Numbers(), 3) ; Get the 4th element (first element is 0)
*FirstElement = @Numbers()

SelectElement(Numbers(), 9) ; Get the 10th element
*SecondElement = @Numbers()

; Swap the 3 with the 9
;
SwapElements(Numbers(), *FirstElement, *SecondElement)

; Prove it
;
ForEach Numbers()
  Debug Numbers()
Next

;* %#@Mail\AddMailAttachment.html%#@1 *;
InitNetwork()

If CreateMail(0, "test@purebasic.com", "Hello")
  If AddMailAttachment(0, "Attachment 1", OpenFileRequester("Choose an attachment", "", "", 0))
    Debug "Attachment correctly added"
  Else
    Debug "Attachment failed"
  EndIf
EndIf

;* %#@Mail\AddMailAttachmentData.html%#@0 *;
InitNetwork()

If CreateMail(0, "test@purebasic.com", "Hello")
  
  If AddMailAttachmentData(0, "Attachment 1", ?Hello, 5)
    Debug "Attachment correctly added"
  Else
    Debug "Attachment failed"
  EndIf
EndIf


DataSection
Hello:
Data.b 'H', 'e', 'l', 'l', 'o'

;* %#@Mail\AddMailRecipient.html%#@1 *;
InitNetwork()

If CreateMail(0, "test@purebasic.com", "Hello")
  AddMailRecipient(0, "andre@purebasic.com", #PB_Mail_To) ; Andre is the main recipient
  AddMailRecipient(0, "fred@purebasic.com", #PB_Mail_Cc)  ; Fred is in copy
  AddMailRecipient(0, "timo@purebasic.com", #PB_Mail_Bcc) ; Timo is in copy as well, but Andre and Fred doesn't know it
EndIf

;* %#@Mail\CreateMail.html%#@1 *;
InitNetwork()

If CreateMail(0, "test@purebasic.com", "Hello")
  SetMailBody(0, "This is a body !" + #CRLF$ + "Second line")
  Debug "Mail created"
Else
  Debug "Can't create the mail"
EndIf

;* %#@Mail\GetMailAttribute.html%#@1 *;
InitNetwork()

If CreateMail(0, "test@purebasic.com", "Hello")
  Debug GetMailAttribute(0, #PB_Mail_From)    ; Will print "test@purebasic.com"
  Debug GetMailAttribute(0, #PB_Mail_Subject) ; Will print "Hello"
EndIf

;* %#@Mail\GetMailBody.html%#@0 *;
InitNetwork()

If CreateMail(0, "test@purebasic.com", "Hello")
  SetMailBody(0, "This is the body")
  Debug GetMailBody(0) ; Will print "This is the body"
EndIf

;* %#@Mail\RemoveMailRecipient.html%#@1 *;
InitNetwork()

If CreateMail(0, "test@purebasic.com", "Hello")
  AddMailRecipient(0, "andre@purebasic.com", #PB_Mail_To) ; Andre is the main recipient
  AddMailRecipient(0, "fred@purebasic.com", #PB_Mail_Cc)  ; Fred is in copy
  AddMailRecipient(0, "timo@purebasic.com", #PB_Mail_Bcc) ; Timo is in copy as well, but Andre and Fred are not aware of it
  
  ; Ensure Fred is removed from every destination :-)
  RemoveMailRecipient(0, "fred@purebasic.com")
EndIf

;* %#@Mail\SendMail.html%#@1 *;
InitNetwork()

; Note: change the address and smtp to have a working example
;
If CreateMail(0, "test@youraddress.com", "Hello")
  AddMailRecipient(0, "youraddress@youraddress.com", #PB_Mail_To)
  
  Debug SendMail(0, "smtp.yourfavoritesmtp.com")
EndIf

;* %#@Mail\SendMail.html%#@2 *;
InitNetwork()

; Be sure to use the right login and right password
;
Login$ = "yourlogin"
If CreateMail(0, Login$ + "@gmail.com", "Hello")
  AddMailRecipient(0, "youraddress@youraddress.com", #PB_Mail_To)
  
  Debug SendMail(0, "smtp.gmail.com", 587, #PB_Mail_UseSSL, Login$, "password")
EndIf

;* %#@Mail\SetMailAttribute.html%#@1 *;
InitNetwork()

If CreateMail(0, "test@purebasic.com", "Hello")
  SetMailAttribute(0, #PB_Mail_XMailer, "PureMailer")
  Debug GetMailAttribute(0, #PB_Mail_XMailer) ; Will print "PureMailer"
EndIf

;* %#@Mail\SetMailBody.html%#@0 *;
InitNetwork()

If CreateMail(0, "test@purebasic.com", "Hello")
  SetMailBody(0, "This is the body")
  Debug GetMailBody(0) ; Will print "This is the body"
EndIf

;* %#@Map\AddMapElement.html%#@1 *;
NewMap Country.s()

; Regular way to add an element
Country("US") = "United States"

; The same using AddMapElement()
AddMapElement(Country(), "FR")
Country() = "France"

ForEach Country()
  Debug Country()
Next

;* %#@Map\ClearMap.html%#@0 *;
NewMap Country.s()

Country("FR") = "France"
Country("US") = "United States"

; Proof that items have been added to the map
MessageRequester("Information", "There are "+Str(MapSize(Country()))+" elements in the map")

; Clear the map and show that the map really is empty
ClearMap(Country())
MessageRequester("Information", "There are "+Str(MapSize(Country()))+" element in the map")

;* %#@Map\CopyMap.html%#@0 *;
NewMap Age()
NewMap AgeCopy()

Age("John")  = 15
Age("Elise") = 30

CopyMap(Age(), AgeCopy())

Debug AgeCopy("John")
Debug AgeCopy("Elise")

;* %#@Map\DeleteMapElement.html%#@0 *;
NewMap Country.s()

Country("US") = "United States"
Country("FR") = "France"
Country("GE") = "Germany"

; Delete a country
DeleteMapElement(Country(), "FR")

ForEach Country()
  Debug Country()
Next

;* %#@Map\FindMapElement.html%#@0 *;
NewMap Country.s()

Country("US") = "United States"
Country("FR") = "France"
Country("GE") = "Germany"

If FindMapElement(Country(), "US")
  Debug "'US' is in the country list."    
Else
  Debug "'US' is NOT in the country list !"    
EndIf

If FindMapElement(Country(), "UK")
  Debug "'UK' is in the country list."
Else
  Debug "'UK' is NOT in the country list !"
EndIf

;* %#@Map\MapKey.html%#@0 *;
NewMap Country.s()

Country("US") = "United States"
Country("FR") = "France"
Country("GE") = "Germany"

ForEach Country()
  Debug MapKey(Country())
Next

;* %#@Map\MapSize.html%#@0 *;
NewMap Country.s()

Country("FR") = "France"
Country("US") = "United States"

; Will print '2'
Debug "Size of the map: " + Str(MapSize(Country()))

;* %#@Map\NextMapElement.html%#@0 *;
NewMap Country.s()

Country("US") = "United States"
Country("FR") = "France"
Country("GE") = "Germany"

ResetMap(Country())
While NextMapElement(Country())
  Debug Country()
Wend

;* %#@Map\PushMapPosition.html%#@0 *;
NewMap Numbers()
Numbers("A") = 1
Numbers("B") = 2
Numbers("C") = 5
Numbers("D") = 3
Numbers("E") = 2
Numbers("F") = 5

; A simple duplicate elimination using a nested iteration
;
ForEach Numbers()
  Value = Numbers()
  PushMapPosition(Numbers())
  While NextMapElement(Numbers())
    If Numbers() = Value 
      DeleteMapElement(Numbers())
    EndIf
  Wend
  PopMapPosition(Numbers())
Next

ForEach Numbers()
  Debug Numbers()
Next

;* %#@Map\ResetMap.html%#@0 *;
NewMap Country.s()

Country("US") = "United States"
Country("FR") = "France"
Country("GE") = "Germany"

ResetMap(Country())
While NextMapElement(Country())
  Debug Country()
Wend

;* %#@Math\Abs.html%#@0 *;
Debug Abs(3.14159)  ; Will display '3.14159'
Debug Abs(-3.14159) ; will display '3.14159'

;* %#@Math\ACos.html%#@0 *;
Debug ACos(1)  ; will display '0'
Debug ACos(-1) ; will display 'pi' (approximately 3.14159)

;* %#@Math\ACosH.html%#@0 *;
Debug ACosH(1)                 ; will display '0'
Debug Exp(ACosH(0.5 * Sqr(5))) ; will display '1.618033' (the golden ratio)

;* %#@Math\ASin.html%#@0 *;
Debug ASin(1) ; will display '1.570796' (pi/2)
Debug ASin(0) ; will display '0'

;* %#@Math\ASinH.html%#@0 *;
Debug ASinH(0)        ; will display '0'
Debug Exp(ASinH(0.5)) ; will display '1.618033' (the golden ratio)

;* %#@Math\ATan.html%#@0 *;
Debug ATan(1) ; will display '0.785398' (pi/4)

;* %#@Math\ATan2.html%#@0 *;
Debug ATan2(10, 10) ; will display #PI/4 (45 degrees in radian)

;* %#@Math\ATanH.html%#@0 *;
Debug Exp(ATanH(0.2 * Sqr(5))) ; will display '1.618033' (the golden ratio)

;* %#@Math\Cos.html%#@0 *;
Debug Cos(3.141593) ; will display '-1'

;* %#@Math\CosH.html%#@0 *;
Debug CosH(0)  ; will display 1

;* %#@Math\Degree.html%#@0 *;
Debug Degree(#PI/4) ; will display 45

;* %#@Math\Infinity.html%#@0 *;
Debug IsInfinity(Infinity() / 1000) ; will display 1

;* %#@Math\Int.html%#@0 *;
Debug Int(10.565)  ; will display '10'

;* %#@Math\IntQ.html%#@0 *;
Debug IntQ(12345678901.565)  ; will display '12345678901'

;* %#@Math\IsInfinity.html%#@0 *;
Result = IsInfinity(Infinity())  ; infinity
Result = IsInfinity(Log(0))      ; -infinity
Result = IsInfinity(1234.5)      ; a finite number
Result = IsInfinity(NaN())       ; NaN is not the same as infinity

;* %#@Math\IsNaN.html%#@0 *;
Result = IsNAN(NaN())       ; NaN
Result = IsNAN(Sqr(-1))     ; NaN
Result = IsNAN(1234.5)      ; a normal number
Result = IsNAN(Infinity())  ; infinity is not NaN 

;* %#@Math\NaN.html%#@0 *;
Debug IsNAN(NaN() * 5 + 2) ; will display 1

;* %#@Math\Pow.html%#@0 *;
Debug Pow(2.0, 3.0)  ; will display '8.0'

;* %#@Math\Radian.html%#@0 *;
Debug Radian(90) ; will display #PI/2

;* %#@Math\Random.html%#@0 *;
Repeat
  Dice = Random(6, 1)  ; get a value between 1 and 6, including 1 and 6
  Choice = MessageRequester("Roll the dice", "You got a " + Dice + ", roll again?", #PB_MessageRequester_YesNo)
Until Choice = #PB_MessageRequester_No

;* %#@Math\RandomData.html%#@0 *;
; Create an image with random content
;
CreateImage(0, 200, 200)
If StartDrawing(ImageOutput(0))
  *Buffer = DrawingBuffer()
  Pitch   = DrawingBufferPitch()
  
  RandomData(*Buffer, Pitch*200)    
  
  StopDrawing()
EndIf

OpenWindow(0, 0, 0, 200, 200, "Random Image", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
ImageGadget(0, 0, 0, 200, 200, ImageID(0))

Repeat
Until WaitWindowEvent() = #PB_Event_CloseWindow

;* %#@Math\Round.html%#@1 *;
Debug Round(11.6, #PB_Round_Down)    ; Will print '11'
Debug Round(-3.6, #PB_Round_Down)    ; Will print '-4'

Debug Round(11.6, #PB_Round_Up)      ; Will print '12'
Debug Round(-1.6, #PB_Round_Up)      ; Will print '-1'

Debug Round(11.6, #PB_Round_Nearest) ; Will print '12'
Debug Round(11.4, #PB_Round_Nearest) ; Will print '11'
Debug Round(11.5, #PB_Round_Nearest) ; Will print '12'
Debug Round(-7.5, #PB_Round_Nearest) ; Will print '-8'

;* %#@Math\Sign.html%#@0 *;
Debug Sign(-7)   ; will display -1.0
Debug Sign(0)    ; will display 0.0
Debug Sign(7)    ; will display 1.0

;* %#@Math\Sin.html%#@0 *;
Debug Sin(1.5708) ; will display '1'

;* %#@Math\SinH.html%#@0 *;
Debug SinH(Log(1.618033)) ; Will be approximately 0.5

;* %#@Math\Tan.html%#@0 *;
Debug Tan(0.785398) ; will display '1'

;* %#@Math\TanH.html%#@0 *;
Debug TanH(Log(1.618033)) ; will display '0.447213' (1/5 * Sqr(5))

;* %#@Memory\AllocateMemory.html%#@1 *;
*MemoryID = AllocateMemory(5000)
If *MemoryID
  Debug "Starting address of the 5000 Byte memory area:"
  Debug *MemoryID
  PokeS(*MemoryID, "Store this string in the memory area")
  FreeMemory(*MemoryID)  ; will also be done automatically at the end of program
Else
  Debug "Couldn't allocate the requested memory!"
EndIf

;* %#@Memory\AllocateStructure.html%#@0 *;
Structure People
  Name$
  List Friends$()
EndStructure

*DynamicPeople.People = AllocateStructure(People)
*DynamicPeople\Name$ = "Fred"
AddElement(*DynamicPeople\Friends$())
*DynamicPeople\Friends$() = "Stef"

Debug *DynamicPeople\Name$
Debug *DynamicPeople\Friends$()

FreeStructure(*DynamicPeople)

;* %#@Memory\CopyMemoryString.html%#@0 *;
*Buffer = AllocateMemory(1000)
*Pointer = *Buffer
CopyMemoryString("Hello", @*Pointer)
CopyMemoryString(" World")  ; This one will be put just after "Hello"
*Pointer-4                  ; Come back from 2 characters unicode (on the 'l' of 'World')
CopyMemoryString("LD")      ; Finally the last two letters will be uppercase
Debug PeekS(*Buffer)

;* %#@Memory\FillMemory.html%#@1 *;
*Buffer = AllocateMemory(500)

FillMemory(*Buffer, 500) ; Fill 500 bytes of value 0 (clear the memory area)
FillMemory(*Buffer, 500, $FF) ; Fill 500 bytes of value $FF
FillMemory(*Buffer, 500, $BADF00D, #PB_Long) ; Fill 500 bytes of value $BADF00D

;* %#@Memory\ReAllocateMemory.html%#@1 *;
*MemoryID = AllocateMemory(1000)
PokeS(*MemoryID, "Store this string")
; do something more with it here...
;
*NewMemoryID = ReAllocateMemory(*MemoryID, 2000) ; need more memory
If *NewMemoryID
  ; work with *NewMemoryID now with size 2000
  Debug "The old contents are still here:"
  Debug PeekS(*NewMemoryID)
  ;
  FreeMemory(*NewMemoryID) 
Else
  ; resizing failed, keep working with *MemoryID (size 1000)
  ;
  FreeMemory(*MemoryID)
EndIf

;* %#@Menu\BindMenuEvent.html%#@0 *;
Procedure EventHandler()
  ; Code
EndProcedure

;* %#@Menu\BindMenuEvent.html%#@1 *;
Procedure TestHandler()
  Debug "Test menu event"
EndProcedure

Procedure QuitHandler()
  Debug "Quit menu event"
  End
EndProcedure

OpenWindow(0, 100, 100, 200, 50, "Click test", #PB_Window_SystemMenu)

CreateMenu(0, WindowID(0))
MenuTitle("File")
MenuItem(0, "Test")
MenuItem(1, "Quit")

BindMenuEvent(0, 0, @TestHandler())
BindMenuEvent(0, 1, @QuitHandler())

Repeat
  Event = WaitWindowEvent()
Until Event = #PB_Event_CloseWindow

;* %#@Menu\CreateImageMenu.html%#@1 *;
If LoadImage(0, OpenFileRequester("Choose an icon file", "", "", 0))
  If OpenWindow(0, 200, 200, 200, 100, "Image menu Example")
    If CreateImageMenu(0, WindowID(0))    ; menu creation starts....
      MenuTitle("Project")
      MenuItem(1, "Open"   +Chr(9)+"Ctrl+O", ImageID(0))
      MenuItem(2, "Save"   +Chr(9)+"Ctrl+S")
      MenuItem(3, "Save as"+Chr(9)+"Ctrl+A")
      MenuItem(4, "Close"  +Chr(9)+"Ctrl+C")
    EndIf
    
    Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
  EndIf
EndIf

;* %#@Menu\CreateMenu.html%#@0 *;
If OpenWindow(0, 200, 200, 200, 100, "Menu Example")
  If CreateMenu(0, WindowID(0))    ; menu creation starts....
    MenuTitle("Project")
    MenuItem(1, "Open"   +Chr(9)+"Ctrl+O")
    MenuItem(2, "Save"   +Chr(9)+"Ctrl+S")
    MenuItem(3, "Save as"+Chr(9)+"Ctrl+A")
    MenuItem(4, "Close"  +Chr(9)+"Ctrl+C")
  EndIf
  Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow
EndIf

;* %#@Menu\CreatePopupImageMenu.html%#@1 *;
If OpenWindow(0, 200, 200, 200, 120, "Image Popup-Menu Example")
  
  If CreatePopupImageMenu(0, #PB_Menu_ModernLook)      ; creation of the pop-up menu begins...
    MenuItem(1, "Open")                                ; You can use all commands for creating a menu
    MenuItem(2, "Save")                                ; just like in a normal menu...
    MenuItem(3, "Save as")
    MenuItem(4, "Quit")
    MenuBar()
    OpenSubMenu("Recent files")
    MenuItem(5, "PureBasic.exe")
    MenuItem(6, "Test.txt")
    CloseSubMenu()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()     ; check for window events
    
    Select Event
      Case #PB_Event_RightClick  ; right mouse button was clicked =>
        DisplayPopupMenu(0, WindowID(0))  ; now display the popup-menu
        
      Case #PB_Event_Menu        ; an item of the popup-menu was clicked
        Select EventMenu()       ; get the clicked menu item...
          Case 1 : Debug "Menu: Open"
          Case 2 : Debug "Menu: Save"
          Case 3 : Debug "Menu: Save as"
          Case 4 : End
          Case 5 : Debug "Menu: PureBasic.exe"
          Case 6 : Debug "Menu: Text.txt"
        EndSelect
        
    EndSelect
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Menu\CreatePopupMenu.html%#@0 *;
If OpenWindow(0, 200, 200, 200, 120, "Popup-Menu Example")
  
  If CreatePopupMenu(0)      ; creation of the pop-up menu begins...
    MenuItem(1, "Open")      ; You can use all commands for creating a menu
    MenuItem(2, "Save")      ; just like in a normal menu...
    MenuItem(3, "Save as")
    MenuItem(4, "Quit")
    MenuBar()
    OpenSubMenu("Recent files")
    MenuItem(5, "PureBasic.exe")
    MenuItem(6, "Test.txt")
    CloseSubMenu()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()     ; check for window events
    
    Select Event
      Case #PB_Event_RightClick       ; right mouse button was clicked =>
        DisplayPopupMenu(0, WindowID(0))  ; now display the popup-menu
        
      Case #PB_Event_Menu        ; an item of the popup-menu was clicked
        Select EventMenu()       ; get the clicked menu item...
          Case 1 : Debug "Menu: Open"
          Case 2 : Debug "Menu: Save"
          Case 3 : Debug "Menu: Save as"
          Case 4 : End
          Case 5 : Debug "Menu: PureBasic.exe"
          Case 6 : Debug "Menu: Text.txt"
        EndSelect
        
    EndSelect
    
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Menu\DisableMenuItem.html%#@0 *;
If OpenWindow(0, 200, 200, 200, 100, "DisableMenuItem Example")
  If CreateMenu(0, WindowID(0))
    MenuTitle("Project")
    MenuItem(1, "Open")
    MenuItem(2, "Save")
    DisableMenuItem(0, 2, 1)     ; disable the second menu item (Save)
  EndIf
  
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Menu\GetMenuItemState.html%#@0 *;
If OpenWindow(0, 200, 200, 200, 100, "GetMenuItemState Example")
  If CreateMenu(0, WindowID(0))
    MenuTitle("Project")
    MenuItem(1, "Changed")
    SetMenuItemState(0, 1, 1)        ; set check mark for the previously created menu item
  EndIf
  Repeat
    Event = WaitWindowEvent()          ; wait for an event
    If Event = #PB_Event_Menu          ; a menu event appeared
      If EventMenu() = 1               ; first menu item was clicked
        If GetMenuItemState(0, 1) = 1  ; actual item state = check marked
          SetMenuItemState(0, 1, 0)    ; now remove the check mark
        Else                           ; actual item state = no check mark
          SetMenuItemState(0, 1, 1)    ; now set the check mark
        EndIf
      EndIf
    EndIf
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Menu\MenuBar.html%#@0 *;
If OpenWindow(0, 200, 200, 200, 100, "MenuBar Example")
  If CreateMenu(0, WindowID(0))  ; here the menu creating starts....
    MenuTitle("Project")
    MenuItem(1, "Open")
    MenuBar()                  ; here the separator bar will be inserted
    MenuItem(4, "Close")
  EndIf
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Menu\MenuItem.html%#@0 *;
MenuItem(1, "&Open" + Chr(9) + "Ctrl+O")

;* %#@Menu\MenuItem.html%#@2 *;
If OpenWindow(0, 200, 200, 200, 100, "MenuItem Example")
  If CreateMenu(0, WindowID(0))
    MenuTitle("Project")
    MenuItem(1, "Open")    ; normal item
    MenuItem(2, "&Save")   ; item with underlined character, the underline will only
                           ; be displayed, if menu is called with F10 + arrow keys
    MenuItem(3, "Quit"+Chr(9)+"Esc")   ; item with separate shortcut text
  EndIf
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Menu\MenuTitle.html%#@0 *;
If OpenWindow(0, 200, 200, 200, 100, "MenuTitle Example")
  If CreateMenu(0, WindowID(0))
    MenuTitle("Project")      ; normal menu title with following item
    MenuItem(1, "Open")  
    MenuItem(2, "Close")
    MenuTitle("&Edit")        ; menu title with underlined character, the underline
                              ; will only be displayed, when called with F10 key
    MenuItem(3, "Undo")
    MenuItem(4, "Redo")
    MenuTitle("About")        ; only menu title
  EndIf
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Menu\OpenSubMenu.html%#@0 *;
If OpenWindow(0, 200, 200, 220, 100, "SubMenu Example")
  If CreateMenu(0, WindowID(0))
    MenuTitle("Project") 
    MenuItem(1, "Open")  
    MenuItem(2, "Close")
    MenuBar()
    OpenSubMenu("Recent files")       ; begin submenu
    MenuItem( 3, "C:\Autoexec.bat")
    MenuItem( 4, "D:\Test.txt")
    CloseSubMenu()                    ; end submenu
  EndIf
  Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow
EndIf

;* %#@Menu\SetMenuItemState.html%#@0 *;
If OpenWindow(0, 200, 200, 200, 100, "SetMenuItemState Example")
  If CreateMenu(0, WindowID(0))
    MenuTitle("Project")
    MenuItem(1, "Changed")
    SetMenuItemState(0, 1, 1)    ; set check mark for the previously created menu item
  EndIf
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Menu\UnbindMenuEvent.html%#@0 *;
Procedure TestHandler()
  Debug "Test menu event"
EndProcedure

Procedure QuitHandler()
  Debug "Quit menu event"
  End
EndProcedure

OpenWindow(0, 100, 100, 200, 50, "Click test", #PB_Window_SystemMenu)

CreateMenu(0, WindowID(0))
MenuTitle("File")
MenuItem(0, "Test")
MenuItem(1, "Quit")

BindMenuEvent(0, 0, @TestHandler())
BindMenuEvent(0, 1, @QuitHandler())

UnbindMenuEvent(0, 1, @QuitHandler()) ; Unbind the quit event

Repeat
  Event = WaitWindowEvent()
Until Event = #PB_Event_CloseWindow

;* %#@Mesh\CreateCapsule.html%#@0 *;
InitEngine3D() 
InitSprite() 

OpenWindow(0, 0, 0, 640, 480, "Capsule example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(0), 0, 0, 640, 480, 0, 0, 0)

; Light
CreateLight(#PB_Any, RGB(25, 25, 180), -5, 10, 5, #PB_Light_Point)

; Camera
CreateCamera(0, 0, 0, 100, 100)
MoveCamera(0, 2, 0, 5, #PB_Absolute | #PB_Local)
CameraLookAt(0, 0, 0, 0)

; Create the capsule and attach it to the scene
CreateCapsule(0, 1, 1)
CreateEntity(0, MeshID(0), #PB_Material_None)

Repeat
  RenderWorld()
  FlipBuffers()
Until WaitWindowEvent(1) = #PB_Event_CloseWindow

;* %#@Mesh\CreateCone.html%#@0 *;
InitEngine3D() 
InitSprite() 

OpenWindow(0, 0, 0, 640, 480, "Cone example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(0), 0, 0, 640, 480, 0, 0, 0)

; Light
CreateLight(#PB_Any, RGB(25, 25, 180), -5, 10, 5, #PB_Light_Point)

; Camera
CreateCamera(0, 0, 0, 100, 100)
MoveCamera(0, 2, 1, 3, #PB_Absolute | #PB_Local)
CameraLookAt(0, 0, 0, 0)

; Create the cone and attach it to the scene
CreateCone(0, 0.5, 1)
CreateEntity(0, MeshID(0), #PB_Material_None)

Repeat
  RenderWorld()
  FlipBuffers()
Until WaitWindowEvent(1) = #PB_Event_CloseWindow

;* %#@Mesh\CreateCube.html%#@0 *;
InitEngine3D() 
InitSprite() 

OpenWindow(0, 0, 0, 640, 480, "Cube example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(0), 0, 0, 640, 480, 0, 0, 0)

; Light
CreateLight(#PB_Any, RGB(25, 25, 180), -5, 10, 5, #PB_Light_Point)

; Camera
CreateCamera(0, 0, 0, 100, 100)
MoveCamera(0, 2, 1, 3, #PB_Absolute | #PB_Local)
CameraLookAt(0, 0, 0, 0)

; Create the cube and attach it to the scene
CreateCube(0, 1)
CreateEntity(0, MeshID(0), #PB_Material_None)

Repeat
  RenderWorld()
  FlipBuffers()
Until WaitWindowEvent(1) = #PB_Event_CloseWindow

;* %#@Mesh\CreateCylinder.html%#@0 *;
InitEngine3D() 
InitSprite() 

OpenWindow(0, 0, 0, 640, 480, "Cylinder example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(0), 0, 0, 640, 480, 0, 0, 0)

; Light
CreateLight(#PB_Any, RGB(25, 25, 180), -5, 10, 5, #PB_Light_Point)

; Camera
CreateCamera(0, 0, 0, 100, 100)
MoveCamera(0, 2, 1, 3, #PB_Absolute | #PB_Local)
CameraLookAt(0, 0, 0, 0)

; Create the cylinder and attach it to the scene
CreateCylinder(0, 0.5, 1)
CreateEntity(0, MeshID(0), #PB_Material_None)

Repeat
  RenderWorld()
  FlipBuffers()
Until WaitWindowEvent(1) = #PB_Event_CloseWindow

;* %#@Mesh\CreateIcoSphere.html%#@0 *;
InitEngine3D() 
InitSprite() 

OpenWindow(0, 0, 0, 640, 480, "IcoSphere example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(0), 0, 0, 640, 480, 0, 0, 0)

; Light
CreateLight(#PB_Any, RGB(25, 25, 180), -5, 10, 5, #PB_Light_Point)

; Camera
CreateCamera(0, 0, 0, 100, 100)
MoveCamera(0, 2, 0, 5, #PB_Absolute | #PB_Local)
CameraLookAt(0, 0, 0, 0)

; Create the icosphere and attach it to the scene
CreateIcoSphere(0, 1)
CreateEntity(0, MeshID(0), #PB_Material_None)

Repeat
  RenderWorld()
  FlipBuffers()
Until WaitWindowEvent(1) = #PB_Event_CloseWindow

;* %#@Mesh\CreateLine3D.html%#@0 *;
InitEngine3D() 
InitSprite() 

OpenWindow(0, 0, 0, 640, 480, "Line3D example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(0), 0, 0, 640, 480, 0, 0, 0)

; Light
CreateLight(#PB_Any, RGB(25, 25, 180), -5, 10, 5, #PB_Light_Point)

; Camera
CreateCamera(0, 0, 0, 100, 100)
MoveCamera(0, 2, 1, 3, #PB_Absolute | #PB_Local)
CameraLookAt(0, 0, 0, 0)

; Create the line and attach it to the scene
CreateLine3D(0, 0, 0, 0, RGB(255, 0, 0), 1, 1, 1, RGB(0, 0, 255))
CreateEntity(0, MeshID(0), #PB_Material_None)

Repeat
  RenderWorld()
  FlipBuffers()
Until WaitWindowEvent(1) = #PB_Event_CloseWindow

;* %#@Mesh\CreatePlane.html%#@0 *;
InitEngine3D() 
InitSprite() 

OpenWindow(0, 0, 0, 640, 480, "Plane example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(0), 0, 0, 640, 480, 0, 0, 0)

; Light
CreateLight(#PB_Any, RGB(25, 25, 180), -5, 10, 5, #PB_Light_Point)

; Camera
CreateCamera(0, 0, 0, 100, 100)
MoveCamera(0, 2, 1, 3, #PB_Absolute | #PB_Local)
CameraLookAt(0, 0, 0, 0)

; Create the plane and attach it to the scene
CreatePlane(0, 2, 2, 1, 1, 0, 0)
CreateEntity(0, MeshID(0), #PB_Material_None)

Repeat
  RenderWorld()
  FlipBuffers()
Until WaitWindowEvent(1) = #PB_Event_CloseWindow

;* %#@Mesh\CreateSphere.html%#@0 *;
InitEngine3D() 
InitSprite() 

OpenWindow(0, 0, 0, 640, 480, "Sphere example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(0), 0, 0, 640, 480, 0, 0, 0)

; Light
CreateLight(#PB_Any, RGB(25, 25, 180), -5, 10, 5, #PB_Light_Point)

; Camera
CreateCamera(0, 0, 0, 100, 100)
MoveCamera(0, 2, 1, 3, #PB_Absolute | #PB_Local)
CameraLookAt(0, 0, 0, 0)

; Create the sphere and attach it to the scene
CreateSphere(0, 1)
CreateEntity(0, MeshID(0), #PB_Material_None)

Repeat
  RenderWorld()
  FlipBuffers()
Until WaitWindowEvent(1) = #PB_Event_CloseWindow

;* %#@Mesh\CreateTorus.html%#@0 *;
InitEngine3D() 
InitSprite() 

OpenWindow(0, 0, 0, 640, 480, "Torus example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(0), 0, 0, 640, 480, 0, 0, 0)

; Light
CreateLight(#PB_Any, RGB(25, 25, 180), -5, 10, 5, #PB_Light_Point)

; Camera
CreateCamera(0, 0, 0, 100, 100)
MoveCamera(0, 2, 4, 3, #PB_Absolute | #PB_Local)
CameraLookAt(0, 0, 0, 0)

; Create the torus and attach it to the scene
CreateTorus(0, 1, 0.3)
CreateEntity(0, MeshID(0), #PB_Material_None)

Repeat
  RenderWorld()
  FlipBuffers()
Until WaitWindowEvent(1) = #PB_Event_CloseWindow

;* %#@Mesh\CreateTube.html%#@0 *;
InitEngine3D() 
InitSprite() 

OpenWindow(0, 0, 0, 640, 480, "Tube example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(0), 0, 0, 640, 480, 0, 0, 0)

; Light
CreateLight(#PB_Any, RGB(25, 25, 180), -5, 10, 5, #PB_Light_Point)

; Camera
CreateCamera(0, 0, 0, 100, 100)
MoveCamera(0, 2, 4, 3, #PB_Absolute | #PB_Local)
CameraLookAt(0, 0, 0, 0)

; Create the tube and attach it to the scene
CreateTube(0, 0.5, 0.4, 2)
CreateEntity(0, MeshID(0), #PB_Material_None)

Repeat
  RenderWorld()
  FlipBuffers()
Until WaitWindowEvent(1) = #PB_Event_CloseWindow

;* %#@Mesh\GetMeshData.html%#@2 *;
Structure PB_MeshVertex
  x.f
  y.f
  z.f
  NormalX.f ; only used if #PB_Mesh_Normal flag is set
  NormalY.f ;
  NormalZ.f ;
  TangentX.f
  TangentY.f
  TangentZ.f
  u.f       ; only used if #PB_Mesh_UVCoordinate flag is set
  v.f       ;
  Color.l   ; only used if #PB_Mesh_Color flag is set
EndStructure    

Structure PB_MeshFace
  Index.l
EndStructure   

;* %#@Mesh\SetMeshData.html%#@2 *;
Structure PB_MeshVertex
  x.f
  y.f
  z.f
  NormalX.f ; only used if #PB_Mesh_Normal flag is set
  NormalY.f ;
  NormalZ.f ;
  TangentX.f
  TangentY.f
  TangentZ.f
  u.f       ; only used if #PB_Mesh_UVCoordinate flag is set
  v.f       ;
  Color.l   ; only used if #PB_Mesh_Color flag is set
EndStructure    

Structure PB_MeshFace
  Index.l
EndStructure   

;* %#@Music\CatchMusic.html%#@0 *;
CatchMusic(0, ?Music, ?MusicEnd-?Music)
End

DataSection
  Music: 
  IncludeBinary "Music.xm"
  MusicEnd:
EndDataSection

;* %#@Network\ExamineIPAddresses.html%#@1 *;
InitNetwork()
If ExamineIPAddresses()
  Repeat
    IP = NextIPAddress()
    If IP
      Debug "IPv4: " + IPString(IP) 
    EndIf
  Until IP = 0
EndIf

;* %#@Network\ExamineIPAddresses.html%#@2 *;
InitNetwork()
If ExamineIPAddresses(#PB_Network_IPv6)
  Repeat
    IP = NextIPAddress()
    If IP
      Debug "IPv6: " + IPString(IP, #PB_Network_IPv6) 
      FreeIP(IP)                                     
    EndIf
  Until IP = 0
EndIf

;* %#@Network\NextIPAddress.html%#@0 *;
InitNetwork()
If ExamineIPAddresses()
  Repeat
    IP = NextIPAddress()
    If IP
      Debug "IPv4: " + IPString(IP) 
    EndIf
  Until IP = 0
EndIf

;* %#@Network\NextIPAddress.html%#@1 *;
InitNetwork()
If ExamineIPAddresses(#PB_Network_IPv6)
  Repeat
    IP = NextIPAddress()
    If IP
      Debug "IPv6: " + IPString(IP, #PB_Network_IPv6) 
      FreeIP(IP)                                     
    EndIf
  Until IP = 0
EndIf

;* %#@OnError\ExamineAssembly.html%#@0 *;
DisableDebugger ; do not disassemble any debugger related instructions

Code_Start:
; Place code to be disassembled here
a = (Random(100) * 5) + 2000
Code_End:

Text$ = "Disassembled code: " + Chr(13)  
If ExamineAssembly(?Code_Start, ?Code_End)
  While NextInstruction()
    Text$ + RSet(Hex(InstructionAddress()), SizeOf(Integer)*2, "0")
    Text$ + " " + InstructionString() + Chr(13)
  Wend
EndIf

MessageRequester("Result", Text$)

;* %#@OnError\OnErrorCall.html%#@0 *;
Procedure ErrorHandler()
  ; Your code here
EndProcedure

;* %#@OnError\OnErrorCall.html%#@1 *;
Procedure ErrorHandler()
  MessageRequester("OnError test", "The following error happened: " + ErrorMessage())
EndProcedure

MessageRequester("OnError test", "Test start")

OnErrorCall(@ErrorHandler())
PokeS(10, "Hello World") ; Cause a #PB_OnError_InvalidMemory error

MessageRequester("OnError test", "This should never be displayed")

;* %#@OnError\OnErrorDefault.html%#@0 *;
Procedure ErrorHandler()
  MessageRequester("OnError test", "The following error happened: " + ErrorMessage())
EndProcedure

MessageRequester("OnError test", "Test start")

OnErrorCall(@ErrorHandler())
OnErrorDefault()         ; Comment this to get the handler call instead of the system error handling
PokeS(10, "Hello World") ; Cause a #PB_OnError_InvalidMemory error

MessageRequester("OnError test", "This should never be displayed")

;* %#@OnError\OnErrorExit.html%#@0 *;
MessageRequester("OnError test", "Test start")

OnErrorExit()
PokeS(10, "Hello World") ; Cause a #PB_OnError_InvalidMemory error

MessageRequester("OnError test", "This should never be displayed")

;* %#@OnError\OnErrorGoto.html%#@0 *;
MessageRequester("OnError test", "Test start")

OnErrorGoto(?ErrorHandler)
PokeS(10, "Hello World") ; Cause a #PB_OnError_InvalidMemory error

MessageRequester("OnError test", "This should never be displayed")
End

ErrorHandler:
MessageRequester("OnError test", "The following error happened: " + ErrorMessage())
End

;* %#@OnError\RaiseError.html%#@1 *;
Procedure ErrorHandler()
  MessageRequester("OnError test", "The following error happened: " + ErrorMessage())
EndProcedure

MessageRequester("OnError test", "Test start")

OnErrorCall(@ErrorHandler())
RaiseError(#PB_OnError_InvalidMemory)

MessageRequester("OnError test", "This should never be displayed")

;* %#@Packer\CreatePack.html%#@1 *;
UseZipPacker()

; Create the packed file
If CreatePack(0, "mycompressedfiles.zip") 
  
  ; add your files 
  AddPackFile(0, "Image1.bmp", "Image1.bmp")  
  AddPackFile(0, "Image2.bmp", "Image2.bmp") 
  AddPackFile(0, "mywave1.wav", "mywave1.wav") 
  AddPackFile(0, "mywave2.wav", "mywave2.wav") 
  ClosePack(0) 
EndIf

;* %#@Packer\ExaminePack.html%#@0 *;
UseZipPacker()

; Open the packed file
If OpenPack(0, "mycompressedfiles.zip") 
  
  ; List all the entries
  If ExaminePack(0)
    While NextPackEntry(0)
      Debug "Name: " + PackEntryName(0) + ", Size: " + PackEntrySize(0)
    Wend
  EndIf
  
  ClosePack(0)
EndIf

;* %#@Packer\OpenPack.html%#@1 *;
UseZipPacker()

; Open the packed file
If OpenPack(0, "mycompressedfiles.zip") 
  
  ; List all the entries
  If ExaminePack(0)
    While NextPackEntry(0)
      Debug "Name: " + PackEntryName(0) + ", Size: " + PackEntrySize(0)
    Wend
  EndIf
  
  ClosePack(0)
EndIf

;* %#@Preference\ClosePreferences.html%#@0 *;
; Open a preference file
OpenPreferences(#PB_Compiler_Home +"Examples\Sources\Data\test.pref")

; Choose the group "window"
PreferenceGroup("window")

; Display the "w" key of this group
MessageRequester("Info", "w = " + ReadPreferenceLong ("w", 0))

; Close the preference file
ClosePreferences()

;* %#@Preference\CreatePreferences.html%#@1 *;
; Create a preference file nammed Setup.ini
CreatePreferences(GetTemporaryDirectory()+"Setup.ini")

; Create a group named "Window"
PreferenceGroup("Window")
WritePreferenceLong ("X", 10)     ; X = 10
WritePreferenceLong ("Y", 10)     ; Y = 10
WritePreferenceLong("W", 800)     ; W = 800
WritePreferenceLong("H", 600)     ; H = 600
WritePreferenceFloat("%", 20)     ; % = 20.000000
WritePreferenceString("Title", "PureNote") ; Title = "PureNote"

; Close the preference file
ClosePreferences()

;* %#@Preference\ExaminePreferenceGroups.html%#@0 *;
; Open a preference file
OpenPreferences(#PB_Compiler_Home +"Examples\Sources\Data\test.pref")

; Examine groups
ExaminePreferenceGroups()
While NextPreferenceGroup() ; While group exists
  MessageRequester("Groups", PreferenceGroupName())  ; Display this group
Wend

; Close the preference file
ClosePreferences() 

;* %#@Preference\ExaminePreferenceKeys.html%#@0 *;
; Open a preference file
OpenPreferences(#PB_Compiler_Home +"Examples\Sources\Data\test.pref")

; Select a group
PreferenceGroup("window")

; Examine keys in the group 'window'  
ExaminePreferenceKeys()
While  NextPreferenceKey() ; While a key exists
  MessageRequester("Key group 'window'", PreferenceKeyName() + " = " + PreferenceKeyValue())  ; Display the key with its data
Wend

; Close the preference file
ClosePreferences()  

;* %#@Preference\NextPreferenceGroup.html%#@0 *;
; Open a preference file
OpenPreferences(#PB_Compiler_Home +"Examples\Sources\Data\test.pref")

; Examine groups
ExaminePreferenceGroups()
While NextPreferenceGroup() ; While group exists
  MessageRequester("Groups", PreferenceGroupName())  ; Display this group
Wend

; Close the preference file
ClosePreferences() 

;* %#@Preference\NextPreferenceKey.html%#@0 *;
; Open a preference file
OpenPreferences(#PB_Compiler_Home +"Examples\Sources\Data\test.pref")

; Select a group
PreferenceGroup("window")

; Examine keys in the group 'window'  
ExaminePreferenceKeys()
While  NextPreferenceKey() ; While a key exists
  MessageRequester("Key group 'window'", PreferenceKeyName() + " = " + PreferenceKeyValue())  ; Display the key with its data
Wend

; Close the preference file
ClosePreferences()  

;* %#@Preference\OpenPreferences.html%#@1 *;
; Open a preference file
OpenPreferences(#PB_Compiler_Home +"Examples\Sources\Data\test.pref")

; Examine Groups
ExaminePreferenceGroups()
; For each group
While NextPreferenceGroup()
  texte$ = texte$ + PreferenceGroupName() + #LF$ ; its name
                                                 ; Examine keys for the current group  
  ExaminePreferenceKeys()
  ; For each key  
  While  NextPreferenceKey()                          
    texte$ = texte$ + PreferenceKeyName() + " = " + PreferenceKeyValue() + #LF$ ; its name and its data
  Wend
  texte$ = texte$ +  #LF$
Wend

; Display all groups and all keys with datas
MessageRequester("test.pref",texte$)

; Close the preference file
ClosePreferences()    

;* %#@Preference\PreferenceComment.html%#@0 *;
; Crйation du fichier prefs.txt
If CreatePreferences(GetTemporaryDirectory()+"Prefs.txt")
  
  PreferenceComment("The coordinates of the window.") ; Write a comment
  PreferenceComment("")                               ; Write a comment (empty line)
  
  PreferenceGroup("Window")
  WritePreferenceLong ("X", 100)
  WritePreferenceLong ("Y", 125)
  
  ClosePreferences()
  
  RunProgram(GetTemporaryDirectory()+"Prefs.txt")
EndIf

;* %#@Preference\PreferenceGroup.html%#@0 *;
; Open a preference file
OpenPreferences(#PB_Compiler_Home +"Examples\Sources\Data\test.pref")

; Select a group
PreferenceGroup("window")

; Examine keys in the group 'window'  
ExaminePreferenceKeys()
While  NextPreferenceKey() ; While a key exists
  MessageRequester("Keys from the 'window' group", PreferenceKeyName() + " = " + PreferenceKeyValue())  ; Display the key with its data
Wend

; Close the preference file
ClosePreferences()  

;* %#@Preference\PreferenceGroupName.html%#@0 *;
; Open a preference file
OpenPreferences(#PB_Compiler_Home +"Examples\Sources\Data\test.pref")

; Examine groups
ExaminePreferenceGroups()
While NextPreferenceGroup() ; While group exists
  MessageRequester("Groups", PreferenceGroupName())  ; Display this group
Wend

; Close the preference file
ClosePreferences() 

;* %#@Preference\PreferenceKeyName.html%#@0 *;
; Open a preference file
OpenPreferences(#PB_Compiler_Home +"Examples\Sources\Data\test.pref")

; Select a group
PreferenceGroup("window")

; Examine keys in the group 'window'  
ExaminePreferenceKeys()
While  NextPreferenceKey() ; While a key exists
  MessageRequester("Key group 'window'", PreferenceKeyName() + " = " + PreferenceKeyValue())  ; Display the key with its data
Wend

; Close the preference file
ClosePreferences()  

;* %#@Preference\PreferenceKeyValue.html%#@0 *;
; Open a preference file
OpenPreferences(#PB_Compiler_Home +"Examples\Sources\Data\test.pref")

; Select a group
PreferenceGroup("window")

; Examine keys in the group 'window'  
ExaminePreferenceKeys()
While  NextPreferenceKey() ; While a key exists
  MessageRequester("Key group 'window'", PreferenceKeyName() + " = " + PreferenceKeyValue())  ; Display the key with its data
Wend

; Close the preference file
ClosePreferences()  

;* %#@Preference\ReadPreferenceDouble.html%#@0 *;
; Open a preference file
OpenPreferences(#PB_Compiler_Home +"Examples\Sources\Data\test.pref")

; Open the group 'window'
PreferenceGroup("window")

; Examine keys until w = 800
NextPreferenceKey() ; x = 0
NextPreferenceKey() ; y = 0
NextPreferenceKey() ; w = 800

; Read the key
cle$= PreferenceKeyName()

; Display the key and its data with different format
MessageRequester("Clй Integer", Str(ReadPreferenceInteger(cle$,0)))
MessageRequester("Clй Float", StrF(ReadPreferenceFloat(cle$,0),6))
MessageRequester("Clй Double", StrD(ReadPreferenceDouble(cle$,0),15))
MessageRequester("Clй Long", Str(ReadPreferenceLong(cle$,0)))
MessageRequester("Clй Quad", Str(ReadPreferenceQuad(cle$,0)))
MessageRequester("Clй String", ReadPreferenceString(cle$,"0"))

; Close the preference file
ClosePreferences() 

;* %#@Preference\RemovePreferenceGroup.html%#@0 *;
; Create the preference file prefs.txt
If CreatePreferences(GetTemporaryDirectory()+"Prefs.txt", #PB_Preference_GroupSeparator)
  
  PreferenceGroup("Window")
  WritePreferenceLong ("X", 100)
  WritePreferenceLong ("Y", 125)
  WritePreferenceString("Title", "PureNote")
  
  PreferenceGroup("event")
  WritePreferenceString("percentage", "percentage")
  WritePreferenceFloat("%", 100)
  
  ClosePreferences()
  
  RunProgram(GetTemporaryDirectory()+"Prefs.txt")
EndIf  

MessageRequester("Info", "Delete the group 'event' ")

; Open a preference file
OpenPreferences(GetTemporaryDirectory()+"Prefs.txt")

; Delete the group 'event'  
RemovePreferenceGroup("event")

ClosePreferences()

RunProgram(GetTemporaryDirectory()+"Prefs.txt")

;* %#@Preference\RemovePreferenceKey.html%#@0 *;
If CreatePreferences(GetTemporaryDirectory()+"Prefs.txt", #PB_Preference_GroupSeparator)
  PreferenceGroup("Window")
  WritePreferenceLong ("X", 100)
  WritePreferenceLong ("Y", 125)
  WritePreferenceString("Title", "PureNote")    
  ClosePreferences()   
  RunProgram(GetTemporaryDirectory()+"Prefs.txt")
EndIf  

MessageRequester("Info", "Delete the key 'Title' ")

; Open the preference file
OpenPreferences(GetTemporaryDirectory()+"Prefs.txt")
PreferenceGroup("Window")

; Delete the key 'Title'  
RemovePreferenceKey("Title")

ClosePreferences()      
RunProgram(GetTemporaryDirectory()+"Prefs.txt")

;* %#@Preference\WritePreferenceFloat.html%#@0 *;
; Create the preference file prefs.txt
If CreatePreferences(GetTemporaryDirectory()+"Prefs.txt", #PB_Preference_GroupSeparator)
  PreferenceGroup("Window")
  WritePreferenceString("Title", "PureNote") 
  WritePreferenceLong ("X", 100)
  WritePreferenceLong ("Y", 125)
  WritePreferenceInteger("I", 1024) 
  WritePreferenceQuad("Q", 9223372036854775807)
  WritePreferenceFloat("%", 20.10)
  WritePreferenceDouble("D", 0.0123456789 )
  ClosePreferences()   
  RunProgram(GetTemporaryDirectory()+"Prefs.txt")
EndIf

;* %#@Printer\NewPrinterPage.html%#@0 *;
If PrintRequester()
  If StartPrinting("Two sheets")
    If StartDrawing(PrinterOutput())
      DrawingMode(#PB_2DDrawing_Transparent)
      DrawText(10, 10, "First page !", RGB(0, 0, 0))
      
      ; Tell the printer to start a new page
      NewPrinterPage()
      
      DrawText(10, 10, "Second page !", RGB(0, 0, 0))
      
      StopDrawing()
    EndIf
    
    StopPrinting()
  EndIf
EndIf

;* %#@Printer\PrinterOutput.html%#@0 *;
StartDrawing(PrinterOutput())
; do some drawing stuff here...
StopDrawing()

;* %#@Printer\PrinterVectorOutput.html%#@1 *;
StartVectorDrawing(PrinterVectorOutput(#PB_Unit_Point))
; do some drawing stuff here...
StopVectorDrawing()

;* %#@Process\ExamineEnvironmentVariables.html%#@0 *;
; Will output all environment variables of the program
;
OpenConsole()
If ExamineEnvironmentVariables()
  While NextEnvironmentVariable()
    PrintN(EnvironmentVariableName() + " = " + EnvironmentVariableValue())
  Wend
EndIf
PrintN("")
PrintN("Press Enter to quit.")
Input()

;* %#@Process\GetEnvironmentVariable.html%#@0 *;
; Display the content of the "PATH" environment variable
;
Debug GetEnvironmentVariable("PATH")

;* %#@Process\ProgramExitCode.html%#@0 *;
End 1   ; returns the exitcode 1

;* %#@Process\ProgramParameter.html%#@0 *;
MyProgram.exe MyText.txt /FAST "Special Mode"

;* %#@Process\RunProgram.html%#@1 *;
; Executes the PB compiler with the /? option and displays the output (windows version)
; For Linux/MacOS change the "/?" to "-h".
;
Compiler = RunProgram(#PB_Compiler_Home+"/Compilers/pbcompiler", "/?", "", #PB_Program_Open | #PB_Program_Read)
Output$ = ""
If Compiler
  While ProgramRunning(Compiler)
    If AvailableProgramOutput(Compiler)
      Output$ + ReadProgramString(Compiler) + Chr(13)
    EndIf
  Wend
  Output$ + Chr(13) + Chr(13)
  Output$ + "Exitcode: " + Str(ProgramExitCode(Compiler))
  
  CloseProgram(Compiler) ; Close the connection to the program
EndIf

MessageRequester("Output", Output$)

;* %#@Reference\break_continue.html%#@1 *;
For k=0 To 10
  If k=5
    Break  ; Will exit directly from the For/Next loop
  EndIf
  Debug k
Next

;* %#@Reference\break_continue.html%#@2 *;
For k=0 To 10
  Counter = 0
  Repeat
    If k=5
      Break 2 ; Will exit directly from the Repeat/Until and For/Next loops
    EndIf
    Counter+1
  Until Counter > 1
  Debug k
Next

;* %#@Reference\break_continue.html%#@4 *;
For k=0 To 10
  If k=5
    Continue  ; Will skip the 'Debug 5' and go directly to the next iteration
  EndIf
  Debug k
Next

;* %#@Reference\cli_compiler.html%#@0 *;
CLI> pbcompiler sourcecode.pb

;* %#@Reference\cli_compiler.html%#@1 *;
CLI> pbcompiler sourcecode.pb --debugger

;* %#@Reference\cli_compiler.html%#@2 *;
CLI> pbcompiler "C:\Project\Source\DLLSource.pb" /EXE "C:\Project\project.dll" /DLL

;* %#@Reference\colortable.html%#@0 *;
Plot(0, 0, RGB($00,$00,$FF))

;* %#@Reference\colortable.html%#@1 *;
Plot(0, 0, $FF0000))

;* %#@Reference\compilerdirectives.html%#@1 *;
CompilerIf #PB_Compiler_OS = #PB_OS_Linux And #PB_Compiler_Processor = #PB_Processor_x86
  ; some Linux and x86 specific code.
CompilerEndIf

;* %#@Reference\compilerdirectives.html%#@3 *;
CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_MacOS
    ; some Mac OS X specific code
  CompilerCase #PB_OS_Linux
    ; some Linux specific code
CompilerEndSelect

;* %#@Reference\compilerdirectives.html%#@5 *;
CompilerIf #PB_Compiler_OS = #PB_OS_Linux
  CompilerError "Linux isn't supported, sorry."
CompilerElse
  CompilerError "OS supported, you can now comment me."
CompilerEndIf


;* %#@Reference\compilerdirectives.html%#@7 *;
EnableExplicit

Define a

a = 20 ; Ok, as declared with 'Define'
b = 10 ; Will raise an error here

;* %#@Reference\compilerdirectives.html%#@9 *;
; x86 assembly example
;
Test = 10

EnableASM
MOV dword [v_Test],20
DisableASM

Debug Test ; Will be 20

;* %#@Reference\compilerfunctions.html%#@0 *;

Size = SizeOf(Type)

;* %#@Reference\compilerfunctions.html%#@1 *;
char.c='!'
Debug SizeOf(char); display 2

ascii.a='!'
Debug SizeOf(ascii); display 1

;* %#@Reference\compilerfunctions.html%#@2 *;
Structure Person
  Name.s
  ForName.s 
  Age.w 
EndStructure

Debug "The size of my friend is "+Str(SizeOf(Person))+" bytes" ; will be 10 (4+4+2)

John.Person\Name = "John"

Debug SizeOf(John) ; will be also 10 

;* %#@Reference\compilerfunctions.html%#@4 *;
Structure Person
  Name.s
  ForName.s 
  Age.w 
EndStructure

Debug OffsetOf(Person\Age) ; will be 8 as a string is 4 byte in memory
                           ; (16 with the 64-bit compiler, as a string is 8 bytes there)


Interface ITest
  Create()
  Destroy(Flags) 
EndInterface

Debug OffsetOf(ITest\Destroy()) ; will be 4

;* %#@Reference\compilerfunctions.html%#@7 *;
Structure Person
  Name.s
  ForName.s 
  Age.w 
EndStructure

If TypeOf(Person\Age) = #PB_Word
  Debug "Age is a 'Word'"
EndIf

Surface.f                 
If TypeOf(Surface) = #PB_Float
  Debug "Surface is a 'Float'"
EndIf

;* %#@Reference\compilerfunctions.html%#@9 *;
CompilerIf Subsystem("OpenGL")
  Debug "Compiling with the OpenGL subsystem"
CompilerEndIf

;* %#@Reference\compilerfunctions.html%#@14 *;
Structure People
  Name$
  Age.l
  List Friends.s()
EndStructure

*Student.People = AllocateMemory(SizeOf(People))
InitializeStructure(*Student, People)

; Now the list is ready to use
;
AddElement(*Student\Friends())
*Student\Friends() = "John"

AddElement(*Student\Friends())
*Student\Friends() = "Yann"

; Print out the list content
;
ForEach *Student\Friends()
  Debug *Student\Friends()
Next

;* %#@Reference\compilerfunctions.html%#@16 *;
Structure People
  Name$
  LastName$
  Map Friends$()
  Age.l
EndStructure

Student.People\Name$ = "Paul"
Student\LastName$ = "Morito"
Student\Friends$("Tom") = "Jones"
Student\Friends$("Jim") = "Doe"

CopyStructure(@Student, @StudentCopy.People, People)

Debug StudentCopy\Name$
Debug StudentCopy\LastName$
Debug StudentCopy\Friends$("Tom")
Debug StudentCopy\Friends$("Jim")

;* %#@Reference\compilerfunctions.html%#@18 *;
Structure People
  Name$
  LastName$
  Age.l
EndStructure

Student.People\Name$ = "Paul"
Student\LastName$ = "Morito"
Student\Age = 10

ClearStructure(@Student, People)

; Will print empty strings as the whole structure has been cleared. All other fields have been reset to zero.
;
Debug Student\Name$
Debug Student\LastName$
Debug Student\Age

;* %#@Reference\compilerfunctions.html%#@20 *;
Structure Person
  Map Friends.s()
EndStructure

Henry.Person\Friends("1") = "Paul"

ResetStructure(@Henry, Person)

; Will print an empty string as the whole structure has been reseted. The map is still usable but empty.
;
Debug Henry\Friends("1")

;* %#@Reference\compilerfunctions.html%#@22 *;
Hello$ = "Hello"
World$ = "World"

Debug Bool(Hello$ = "Hello")  ; will print 1
Debug Bool(Hello$ <> "Hello" Or World$ = "World") ; will print 1

;* %#@Reference\data.html%#@3 *;
Data.l 100, 200, -250, -452, 145
Data.s "Hello", "This", "is ", "What ?"

;* %#@Reference\data.html%#@4 *;
Procedure Max(Number, Number2)
EndProcedure

Label:

DataSection
  Data.i ?Label, @Max()
EndDataSection

;* %#@Reference\data.html%#@5 *;
Interface MyObject
  DoThis()
  DoThat()
EndInterface

Procedure This(*Self)
  MessageRequester("MyObject", "This")
EndProcedure

Procedure That(*Self)
  MessageRequester("MyObject", "That")
EndProcedure

m.MyObject = ?VTable

m\DoThis()
m\DoThat()


DataSection
  VTable:
  Data.i ?Procedures
  Procedures:
  Data.i @This(), @That()
EndDataSection

;* %#@Reference\data.html%#@7 *;
Restore StringData
Read.s MyFirstData$
Read.s MySecondData$

Restore NumericalData
Read.l a
Read.l b

Debug MyFirstData$
Debug a

End  

DataSection
  NumericalData:    
  Data.l 100, 200, -250, -452, 145
  
  StringData:
  Data.s "Hello", "This", "is ", "What ?"
EndDataSection

;* %#@Reference\debugger.html%#@1 *;
Debug <expression> [, DebugLevel]

;* %#@Reference\debugger.html%#@2 *;

DebugLevel <constant expression>

;* %#@Reference\define.html%#@1 *;
d = e + f
Define.w
a = b + c 

;* %#@Reference\define.html%#@2 *;
Define.b a, b = 10, c = b*2, d ; these 4 variables will be byte typed (.b)

;* %#@Reference\define.html%#@4 *;
Define MyChar.c 
Define MyLong.l 
Define MyWord.w 

Debug SizeOf(MyChar)   ; will print 2
Debug SizeOf(MyLong)   ; will print 4
Debug SizeOf(MyWord)   ; will print 2

;* %#@Reference\dim.html%#@1 *;
Dim MyArray(41)
MyArray(0) = 1
MyArray(1) = 2 

;* %#@Reference\dim.html%#@2 *;
Dim MultiArray.b(NbColumns, NbLines)
MultiArray(10, 20) = 10
MultiArray(20, 30) = 20

;* %#@Reference\dim.html%#@3 *;
Procedure fill(Array Numbers(1), Length)  ; the 1 stays for the number of dimensions in the array
  For i = 0 To Length
    Numbers(i) = i
  Next
EndProcedure

Dim Numbers(10)
fill(Numbers(), 10)  ; the array Numbers() will be passed as parameter here

Debug Numbers(5)
Debug Numbers(10)

;* %#@Reference\dim.html%#@5 *;
Dim MyArray.l(1) ; We have 2 elements
MyArray(0) = 1
MyArray(1) = 2

ReDim MyArray(4) ; Now we want 5 elements
MyArray(2) = 3

For k = 0 To 2
  Debug MyArray(k)
Next

;* %#@Reference\dll.html%#@0 *;
ProcedureDLL MyFunction()
  MessageRequester("Hello", "This is a PureBasic DLL !", 0)
EndProcedure

; Now the client program, which use the DLL
;
If OpenLibrary(0, "PureBasic.dll")
  CallFunction(0, "MyFunction")
  CloseLibrary(0)
EndIf

;* %#@Reference\dll.html%#@1 *;
Global ReturnString$

ProcedureDLL.s MyFunction(var.s)
  ReturnString$ = var + " test"
  ProcedureReturn ReturnString$
EndProcedure

;* %#@Reference\dll.html%#@2 *;
String.s = PeekS(CallFunction(0, "FunctionName", Parameter1, Parameter2))

;* %#@Reference\enumerations.html%#@1 *;
Enumeration
  #GadgetInfo ; will be 0
  #GadgetText ; will be 1
  #GadgetOK   ; will be 2
EndEnumeration

;* %#@Reference\enumerations.html%#@2 *;
Enumeration 20 Step 3
  #GadgetInfo ; will be 20
  #GadgetText ; will be 23
  #GadgetOK   ; will be 26
EndEnumeration

;* %#@Reference\enumerations.html%#@3 *;
Enumeration
  #GadgetInfo      ; will be 0
  #GadgetText = 15 ; will be 15
  #GadgetOK        ; will be 16
EndEnumeration

;* %#@Reference\enumerations.html%#@4 *;
Enumeration Gadget
  #GadgetInfo ; will be 0
  #GadgetText ; will be 1
  #GadgetOK   ; will be 2
EndEnumeration

Enumeration Window
  #FirstWindow  ; will be 0
  #SecondWindow ; will be 1
EndEnumeration

Enumeration Gadget
  #GadgetCancel ; will be 3
  #GadgetImage  ; will be 4
  #GadgetSound  ; will be 5
EndEnumeration

;* %#@Reference\enumerations.html%#@5 *;
Enumeration
  #GadgetInfo ; will be 0
  #GadgetText ; will be 1
  #GadgetOK   ; will be 2
EndEnumeration

Debug "Next enumeration value: " + #PB_Compiler_EnumerationValue ; will print 3

;* %#@Reference\enumerations.html%#@6 *;
EnumerationBinary
  #Flags1 ; will be 1
  #Flags2 ; will be 2
  #Flags3 ; will be 4
  #Flags4 ; will be 8
  #Flags5 ; will be 16
EndEnumeration

;* %#@Reference\foreach_next.html%#@1 *;
NewList Number()

AddElement(Number())
Number() = 10

AddElement(Number())
Number() = 20

AddElement(Number())
Number() = 30

ForEach Number()
  Debug Number() ; Will output 10, 20 and 30
Next

;* %#@Reference\foreach_next.html%#@2 *;
NewMap Country.s()

Country("US") = "United States"
Country("FR") = "France"
Country("GE") = "Germany"

ForEach Country()
  Debug Country()
Next

;* %#@Reference\for_next.html%#@1 *;
For k = 0 To 10 
  Debug k
Next

;* %#@Reference\for_next.html%#@2 *;
For k = 10 To 1 Step -1
  Debug k
Next

;* %#@Reference\for_next.html%#@3 *;
a = 2
b = 3 
For k = a+2 To b+7 Step 2
  Debug k
Next k  

;* %#@Reference\for_next.html%#@4 *;
For x=0 To 10 
  For y=0 To 5
    Debug "x: " + x + " y: " + y
  Next y
Next x

;* %#@Reference\general_rules.html%#@0 *;
If a = 10 ; This is a comment to indicate something.

;* %#@Reference\general_rules.html%#@1 *;
If a = 1      ; If, Else and EndIf are keywords; while 'a = 1'
  ...         ; is a variable used inside an expression.
Else
  ...
EndIf

;* %#@Reference\general_rules.html%#@2 *;
EventWindow() ; it is a function.
EventWindow   ; it is a variable.

;* %#@Reference\general_rules.html%#@6 *;
a$ =  "Hello world"  ; standard string
b$ = ~"Escape\nMe !" ; string with escape sequences

;* %#@Reference\general_rules.html%#@8 *;
a = a + 1 + (12 * 3)

a = a + WindowHeight(#Window) + b/2 + #MyConstant

If a <> 12 + 2
  b + 2 >= c + 3
EndIf

a$ = b$ + "this is a string value" + c$

Foo = Foo + $69 / %1001  ; Hexadecimal and binary number usage

;* %#@Reference\general_rules.html%#@9 *;
If IsCrazy = 0 : MessageRequester("Info", "Not Crazy") : Else : MessageRequester("Info", "Crazy") : EndIf

;* %#@Reference\general_rules.html%#@10 *;
Text$ = "Very very very very long text" + #LF$ +
        "another long text" + #LF$ +
        " and the end of the long text"

MessageRequester("Hello this is a very long title",
                 "And a very long message, so we can use the multiline" + #LF$ + Text$,
                 #PB_MessageRequester_Ok)

;* %#@Reference\global.html%#@1 *;
Global a.l, b.b, c, d = 20

Procedure Change()
  Debug a  ; Will be 10 as the variable is global
EndProcedure

a = 10
Change()

;* %#@Reference\global.html%#@2 *;
Global Dim Array(2)

Procedure Change()
  Debug Array(0)  ; Will be 10 as the array is global
EndProcedure

Array(0) = 10
Change()

;* %#@Reference\global.html%#@3 *;
; 'Angle' and 'Position' will be a float, as they didn't have a specified type
;
Global.f Angle, Length.b, Position


;* %#@Reference\gosub_return.html%#@1 *;
a = 1
b = 2
Gosub ComplexOperation 
Debug a 
End 

ComplexOperation: 
a = b*2+a*3+(a+b) 
a = a+a*a 
Return 

;* %#@Reference\gosub_return.html%#@3 *;
Gosub SubRoutine1

SubRoutine1:
...
If a = 10
  FakeReturn 
  Goto Main_Loop 
EndIf 
Return

;* %#@Reference\handles.html%#@0 *;
EventGadget()
EventMenu()
EventWindow()

;* %#@Reference\handles.html%#@1 *;
ImageGadget(#Gadget, x, y, Width, Height, ImageID [, Flags])
; #Gadget needs to be the number you want to assign to the Gadget
; ImageID needs to a handle to the image.

;* %#@Reference\handles.html%#@2 *;
FontID()
GadgetID()
ImageID()
ThreadID()
WindowID()

;* %#@Reference\handles.html%#@3 *;
GadgetHandle = ImageGadget(...)

;* %#@Reference\ide_debugger.html%#@0 *;
MyVariable$ <> "Hello" Or Counter < 0  ; halt if MyVariable$ changes from "Hello" or if the Counter falls below zero
PeekL(*SomeAddress+500) <> 0           ; halt if the long value at the given memory location is not equal to zero

;* %#@Reference\ide_form.html%#@0 *;
Main.pb        ; The main PureBasic file, which will includes the two forms file, and defines the events
MainWindow.pbf ; The main window
DateWindow.pbf ; Another window

;* %#@Reference\ide_form.html%#@1 *;
XIncludeFile "MainWindow.pbf" ; Include the first window definition
XIncludeFile "DateWindow.pbf" ; Include the second window definition

OpenMainWindow() ; Open the first window. This procedure name is always 'Open' followed by the window name
OpenDateWindow() ; Open the second window

; The event procedures, as specified in the 'event procedure' property of each gadget
Procedure OkButtonEvent(EventType)
  Debug "OkButton event"
EndProcedure

Procedure CancelButtonEvent(EventType)
  Debug "CancelButton event"
EndProcedure

Procedure TrainCalendarEvent(EventType)
  Debug "TrainCalendar event"
EndProcedure

; The main event loop as usual, the only change is to call the automatically
; generated event procedure for each window.
Repeat
  Event = WaitWindowEvent()
  
  Select EventWindow()
    Case MainWindow
      MainWindow_Events(Event) ; This procedure name is always window name followed by '_Events'
      
    Case DateWindow
      DateWindow_Events(Event)
      
  EndSelect
  
Until Event = #PB_Event_CloseWindow ; Quit on any window close

;* %#@Reference\if_endif.html%#@1 *;
a = 5
If a = 10 
  Debug "a = 10"
Else
  Debug "a <> 10"
EndIf    

;* %#@Reference\if_endif.html%#@2 *;
b = 15
If a = 10 And b >= 10 Or c = 20     
  If b = 15
    Debug "b = 15"
  Else       
    Debug "Other possibility"
  EndIf   
Else     
  Debug "Test failure"
EndIf  

;* %#@Reference\if_endif.html%#@3 *;
Procedure DisplayHello()
  Debug "Hello"
  ProcedureReturn 1
EndProcedure

a = 10
If a = 10 Or DisplayHello() = 1 ; a is equal to 10, so the second test is fully ignored
  Debug "Test success"
Else     
  Debug "Test failure"
EndIf  

;* %#@Reference\import_endimport.html%#@1 *;
Import "User32.lib"
  
  ; No need to use 'As' as PureBasic decorates the function correctly
  ; We also define the 'Flags' as optional, with a default value of 0 (when omitted)
  ;
  MessageBoxA(Window.i, Body$, Title$, Flags.i = 0)
  
  ; This time PureBasic can't find it alone as the function 
  ; name isn't the same than the one used by the symbol
  ;
  MsgBox(Window.i, Body$, Title$, Flags.i) As "_MessageBoxA@16"
  
EndImport

MessageBoxA(0, "Hello", "World") ; We don't specify the flags
MsgBox(0, "Hello", "World 2", 0)


;* %#@Reference\import_endimport.html%#@2 *;
Import "User32.lib"
  
  ; We use the 'p-unicode' pseudotype for the string parameters, as
  ; MessageBoxW() is an unicode only function. The compiler will 
  ; automatically converts the strings to unicode when needed.
  ;
  MessageBoxW(Window.l, Body.p-unicode, Title.p-unicode, Flags.l = 0)
  
EndImport

;
MessageBoxW(0, "Hello", "World")


;* %#@Reference\includes.html%#@1 *;
IncludeFile "Sources\myfile.pb" ; This file will be inserted in the current code.

;* %#@Reference\includes.html%#@3 *;
XIncludeFile "Sources\myfile.pb" ; This file will be inserted.
XIncludeFile "Sources\myfile.pb" ; This file will be ignored along with all subsequent calls. 

;* %#@Reference\includes.html%#@5 *;
DataSection
  MapLabel:
  IncludeBinary "Data\map.data"
EndDataSection 

;* %#@Reference\includes.html%#@7 *;
IncludePath  "Sources\Data"
IncludeFile  "Sprite.pb"
XIncludeFile "Music.pb"

;* %#@Reference\inlinedasm.html%#@0 *;
MOV ebx, ll_mylabel
...
MyLabel:

;* %#@Reference\inlinedasm.html%#@1 *;
Procedure.l MyTest()
  MOV eax, 45
  ProcedureReturn  ; The returned value will be 45
EndProcedure

;* %#@Reference\inlinedasm.html%#@2 *;
Procedure Test(*Pointer, Variable)
  ! MOV dword [p.p_Pointer], 20
  ! MOV dword [p.v_Variable], 30
  Debug *Pointer
  Debug Variable
EndProcedure

Test(0, 0)

;* %#@Reference\interfaces.html%#@1 *;
; In order to access an external object (within a DLL for example),
; the objects' interface must first be declared:

Interface MyObject
  Move(x,y)
  MoveF(x.f,y.f)
  Destroy()
EndInterface

; CreateObject is the function which creates the object, from the DLL,
; whose interface has just been defined.
; Create the first object...
;
Object1.MyObject = MyCreateObject()

; And the second one.
;
Object2.MyObject = MyCreateObject()

; Then the functions which have just been defined, may 
; be used, in order to act upon the desired object.
;
Object1\Move(10, 20)
Object1\Destroy()

Object2\MoveF(10.5, 20.1)
Object2\Destroy()

;* %#@Reference\interfaces.html%#@2 *;
; Define a basic Cube interface object.
;
Interface Cube
  GetPosition()
  SetPosition(x)
  GetWidth()
  SetWidth(Width)
EndInterface

Interface ColoredCube Extends Cube
  GetColor()
  SetColor(Color)
EndInterface

Interface TexturedCube Extends Cube
  GetTexture()
  SetTexture(TextureID)
EndInterface

; The interfaces for 3 different objects have now been defined, these objects include:
;
; - 'Cube' which has the: Get/SetPosition() and Get/SetWidth() functions.
; - 'ColoredCube' which has the: Get/SetPosition(), Get/SetWidth() and Get/SetColor() functions.
; - 'TexturedCube' which has the: Get/SetPosition(), Get/SetWidth() and Get/SetTexture() functions.
;

;* %#@Reference\macros.html%#@1 *;
Macro MyNot
  Not
EndMacro

a = 0
If MyNot a   ; Here the line will be expanded to : 'If Not a'
  Debug "Ok"
EndIf


;* %#@Reference\macros.html%#@2 *;
Macro UMsgBox(Title, Body)
  MessageRequester(Title, UCase(Body), 0)
EndMacro

Text$ = "World"
UMsgBox("Hello", "-"+Text$+"-") ; Here the line will be expanded like that:
                                ; 'MessageRequester("Hello", UCase("-"+Text$+"-"), 0)'

;* %#@Reference\macros.html%#@3 *;
Macro UMsgBox(Title, Body = "Ha, no body specified")
  MessageRequester(Title, UCase(Body), 0)
EndMacro

UMsgBox("Hello") ; Here the line will be expanded like that:
                 ; 'MessageRequester("Hello", UCase("Ha, no body specified"), 0)'

;* %#@Reference\macros.html%#@4 *;
Macro XCase(Type, Text)
  Type#Case(Text)
EndMacro

Debug XCase(U, "Hello")
Debug XCase(L, "Hello")


;* %#@Reference\macros.html%#@5 *;
Macro DoubleQuote
  "
EndMacro

Macro Assert(Expression)
  CompilerIf #PB_Compiler_Debugger  ; Only enable assert in debug mode
    If Expression
      Debug "Assert (Line " + #PB_Compiler_Line + "): " + DoubleQuote#Expression#DoubleQuote
    EndIf
  CompilerEndIf
EndMacro

Assert(10 <> 10) ; Will display nothing
Assert(10 <> 15) ; Should display the assert


;* %#@Reference\macros.html%#@7 *;
Macro Test
  Debug "1"
EndMacro

Test ; Call the macro

UndefineMacro Test ; Undefine the macro, it no more exists

Macro Test ; Now we can redefine the macro
  Debug "2"
EndMacro

Test ; Call the macro


;* %#@Reference\macros.html%#@9 *;
Macro Test
  Debug MacroExpandedCount
EndMacro

Test ; Call the macro
Test ; Call the macro
Test ; Call the macro


;* %#@Reference\memory.html%#@0 *;
*MyScreen.Screen = OpenScreen(0, 320, 200, 8, 0)
mouseX = *MyScreen\MouseX  ; Assuming the Screen structure contains a MouseX field

;* %#@Reference\memory.html%#@1 *;
Define Point1.Point, Point2.Point
*CurrentPoint.Point = @Point1  ; Pointer declaration, associated to a structure and initialized with Point1's address
*CurrentPoint \x = 10          ; Assign value 10 to Point1\x
*CurrentPoint.Point = @Point2  ; move to Point2's address
*CurrentPoint \x = 20          ; Assign value 20 to Point2\x
Debug Point1\x
Debug Point2\x

;* %#@Reference\memory.html%#@2 *;
Define Point1.Point, Point2.Point
Dim *Points.Point(1) ; 2 slots array
*Points(0) = @Point1 ; Assign the first point variable to the first array slot
*Points(1) = @Point2 ; Same for second

*Points(0)\x = 10 ; Modify the variables trough the pointers
*Points(1)\x = 20 ;

Debug Point1\x
Debug Point2\x

;* %#@Reference\memory.html%#@3 *;
Text$ = "Hello"
*Text = @Text$            ; *Text store the address of the string in memory
*Pointer.String = @*Text  ; *Pointer points on *Text
Debug *Pointer\s          ; Display the string living at the address stored in *Pointer (i.e. @Text$)

;* %#@Reference\memory.html%#@4 *;
Dim Array.Point(1)         ; Array of points 

*Pointer.Point = @Array()  ; Store the array address
*Pointer\x = 10            ; Change the first array element values
*Pointer\y = 15   

*Pointer + SizeOf(Point)   ; Move to the next array element 

*Pointer\x = 7             ; Change the second array element values
*Pointer\y = 9

; Display results
For i = 0 To 1
  Debug Array(i)\x
  Debug Array(i)\y
Next i

;* %#@Reference\memory.html%#@5 *;
Structure astruct
  a.w
  b.l
  c.w
EndStructure

Procedure SetB(*myptr.astruct)
  *myptr\b = 69
EndProcedure

Define.astruct myvar

SetB(@myvar)

Debug myvar\b

;* %#@Reference\memory.html%#@6 *;
*String = @"Test"
Debug PeekC(*String) ; Will display 84, which is the value of 'T'

;* %#@Reference\memory.html%#@7 *;
Procedure WindowCB(WindowID.i, Message.l, wParam.l, lParam.l)
  ; This is where the processing of your callback procedure would be performed
EndProcedure

; A special callback for the Windows OS allowing you to process window events
SetWindowCallback( @WindowCB() )

;* %#@Reference\memory.html%#@8 *;
Debug "Size of data file = " + Str(?endofmydata - ?mydata)

DataSection
  mydata:
  IncludeBinary "somefile.bin"
  endofmydata:
EndDataSection

;* %#@Reference\migration_520_540.html%#@0 *;
; Old
AddBillboard(Billboard, BillboardGroup, x, y, z)

; New
Billboard = AddBillboard(BillboardGroup, x, y, z)

;* %#@Reference\migration_520_540.html%#@1 *;
; Old
ExamineMD5Fingerprint(#FingerPrint)

; New
UseMD5Fingerprint()  
StartFingerprint(#FingerPrint, #PB_Cipher_MD5)

;* %#@Reference\migration_520_540.html%#@2 *;
; Old
ExamineSHA1Fingerprint(#FingerPrint)

; New
UseSHA1Fingerprint()
StartFingerprint(#FingerPrint, #PB_Cipher_SHA1)

;* %#@Reference\migration_520_540.html%#@3 *;
; Old
Result$ = MD5FileFingerprint(Filename$)

; New
UseMD5Fingerprint()
Result$ = FileFingerprint(Filename$, #PB_Cipher_MD5)

;* %#@Reference\migration_520_540.html%#@4 *;
; Old
Result$ = MD5Fingerprint(*Buffer, Size)

; New
UseMD5Fingerprint()
Result$ = Fingerprint(*Buffer, Size, #PB_Cipher_MD5)

;* %#@Reference\migration_520_540.html%#@5 *;
; Old
Result$ = SHA1FileFingerprint(Filename$)

; New
UseSHA1Fingerprint()
Result$ = FileFingerprint(Filename$, #PB_Cipher_SHA1)

;* %#@Reference\migration_520_540.html%#@6 *;
; Old
Result$ = SHA1Fingerprint(*Buffer, Size)

; New
UseSHA1Fingerprint()
Result$ = Fingerprint(*Buffer, Size, #PB_Cipher_SHA1)

;* %#@Reference\migration_520_540.html%#@7 *;
; Old
Result = CRC32FileFingerprint(Filename$)

; New
UseCR32FingerPrint()
Result.l = Val("$"+FileFingerprint(Filename$, #PB_Cipher_CRC32))

;* %#@Reference\migration_520_540.html%#@8 *;
; Old
Result = CRC32Fingerprint(*Buffer, Size)

; New
UseCR32FingerPrint()
Result.l = Val("$"+Fingerprint(*Buffer, Size, #PB_Cipher_CRC32))

;* %#@Reference\migration_520_540.html%#@9 *;
; Old
NextFingerprint(#FingerPrint, *Buffer, Size)

; New
AddFingerprintBuffer(#FingerPrint, *Buffer, Size)

;* %#@Reference\migration_520_540.html%#@10 *;
; Old
SendMail(#Mail, Smtp$, Port, 1)

; New
SendMail(#Mail, Smtp$, Port, #PB_Mail_Asynchronous)

;* %#@Reference\migration_520_540.html%#@11 *;
; Old
Node = CreateXMLNode(ParentNode)
SetXMLNodeName(Node, "Name")

; New
Node = CreateXMLNode(ParentNode, "Name")

;* %#@Reference\migration_530_540.html%#@0 *;
; Old
ExamineMD5Fingerprint(#FingerPrint)

; New
UseMD5Fingerprint()  
StartFingerprint(#FingerPrint, #PB_Cipher_MD5)

;* %#@Reference\migration_530_540.html%#@1 *;
; Old
ExamineSHA1Fingerprint(#FingerPrint)

; New
UseSHA1Fingerprint()
StartFingerprint(#FingerPrint, #PB_Cipher_SHA1)

;* %#@Reference\migration_530_540.html%#@2 *;
; Old
Result$ = MD5FileFingerprint(Filename$)

; New
UseMD5Fingerprint()
Result$ = FileFingerprint(Filename$, #PB_Cipher_MD5)

;* %#@Reference\migration_530_540.html%#@3 *;
; Old
Result$ = MD5Fingerprint(*Buffer, Size)

; New
UseMD5Fingerprint()
Result$ = Fingerprint(*Buffer, Size, #PB_Cipher_MD5)

;* %#@Reference\migration_530_540.html%#@4 *;
; Old
Result$ = SHA1FileFingerprint(Filename$)

; New
UseSHA1Fingerprint()
Result$ = FileFingerprint(Filename$, #PB_Cipher_SHA1)

;* %#@Reference\migration_530_540.html%#@5 *;
; Old
Result$ = SHA1Fingerprint(*Buffer, Size)

; New
UseSHA1Fingerprint()
Result$ = Fingerprint(*Buffer, Size, #PB_Cipher_SHA1)

;* %#@Reference\migration_530_540.html%#@6 *;
; Old
Result = CRC32FileFingerprint(Filename$)

; New
UseCR32FingerPrint()
Result.l = Val("$"+FileFingerprint(Filename$, #PB_Cipher_CRC32))

;* %#@Reference\migration_530_540.html%#@7 *;
; Old
Result = CRC32Fingerprint(*Buffer, Size)

; New
UseCR32FingerPrint()
Result.l = Val("$"+Fingerprint(*Buffer, Size, #PB_Cipher_CRC32))

;* %#@Reference\migration_530_540.html%#@8 *;
; Old
NextFingerprint(#FingerPrint, *Buffer, Size)

; New
AddFingerprintBuffer(#FingerPrint, *Buffer, Size)

;* %#@Reference\migration_530_540.html%#@9 *;
; Old
SendMail(#Mail, Smtp$, Port, 1)

; New
SendMail(#Mail, Smtp$, Port, #PB_Mail_Asynchronous)

;* %#@Reference\module.html%#@2 *;

; The common module, which will be used by others to share data
;
DeclareModule Cars
  Global NbCars = 0
EndDeclareModule

Module Cars 
EndModule

; First car module
;
DeclareModule Ferrari
EndDeclareModule

Module Ferrari
  UseModule Cars
  
  NbCars+1
EndModule

; Second car module
;
DeclareModule Porche
EndDeclareModule

Module Porche
  UseModule Cars
  
  NbCars+1
EndModule

Debug Cars::NbCars


;* %#@Reference\newlist.html%#@1 *;
NewList MyList()

AddElement(MyList())
MyList() = 10

AddElement(MyList())
MyList() = 20

AddElement(MyList())
MyList() = 30

ForEach MyList()
  Debug MyList()
Next

;* %#@Reference\newlist.html%#@2 *;
NewList Test()

AddElement(Test())
Test() = 1
AddElement(Test())
Test() = 2

Procedure DebugList(c, List ParameterList())
  
  AddElement(ParameterList())
  ParameterList() = 3
  
  ForEach ParameterList()
    MessageRequester("List", Str(ParameterList()))
  Next
  
EndProcedure

DebugList(10, Test())

;* %#@Reference\newmap.html%#@1 *;
NewMap Country.s()

Country("GE") = "Germany"
Country("FR") = "France"
Country("UK") = "United Kingdom"

Debug Country("FR")

ForEach Country()
  Debug Country()
Next

;* %#@Reference\newmap.html%#@2 *;
NewMap Country.s()

Country("GE") = "Germany"
Country("FR") = "France"
Country("UK") = "United Kingdom"

Procedure DebugMap(Map ParameterMap.s())
  
  ParameterMap("US") = "United States"
  
  ForEach ParameterMap()
    Debug ParameterMap()
  Next
  
EndProcedure

DebugMap(Country())

;* %#@Reference\newmap.html%#@3 *;
Structure Car
  Weight.l
  Speed.l
  Price.l
EndStructure

NewMap Cars.Car()

; Here we use the current element after the new insertion
;
Cars("Ferrari F40")\Weight = 1000
Cars()\Speed = 320
Cars()\Price = 500000

Cars("Lamborghini Gallardo")\Weight = 1200
Cars()\Speed = 340
Cars()\Price = 700000

ForEach Cars()
  Debug "Car name: "+MapKey(Cars())
  Debug "Weight: "+Str(Cars()\Weight)
Next


;* %#@Reference\others.html%#@0 *;

Goto <label>

;* %#@Reference\others.html%#@1 *;

End [ExitCode]

;* %#@Reference\others.html%#@2 *;

Swap <expression>, <expression>

;* %#@Reference\others.html%#@3 *;
Hello$ = "Hello"
World$ = "World"

Swap Hello$, World$

Debug Hello$+" "+World$

;* %#@Reference\others.html%#@4 *;
Dim Array1(5,5) 
Dim Array2(5,5) 
Array1(2,2) = 10     ; set initial contents
Array2(3,3) = 20

Debug Array1(2,2) ; will print 10
Debug Array2(3,3) ; will print 20

Swap Array1(2,2) , Array2(3,3)  ; swap 2 arrays elements

Debug "Array contents after swapping:"
Debug Array1(2,2)    ; will print 20
Debug Array2(3,3)    ; will print 10

;* %#@Reference\procedures.html%#@1 *;
Procedure Maximum(nb1, nb2)
  If nb1 > nb2
    Result = nb1
  Else
    Result = nb2
  EndIf
  
  ProcedureReturn Result
EndProcedure 

Result = Maximum(15, 30)
Debug Result

;* %#@Reference\procedures.html%#@2 *;
Procedure.s Attach(String1$, String2$)
  ProcedureReturn String1$+" "+String2$
EndProcedure 

Result$ = Attach("PureBasic", "Coder")
Debug Result$

;* %#@Reference\procedures.html%#@3 *;
Procedure a(a, b, c=2)
  Debug c
EndProcedure

a(10, 12)      ; 2 will be used as default value for 3rd parameter
a(10, 12, 15) 

;* %#@Reference\procedures.html%#@4 *;
NewList Test.Point()

AddElement(Test())
Test()\x = 1
AddElement(Test())
Test()\x = 2

Procedure DebugList(c.l, List ParameterList.Point())
  
  AddElement(ParameterList())
  ParameterList()\x = 3
  
  ForEach ParameterList()
    MessageRequester("List", Str(ParameterList()\x))
  Next
  
EndProcedure

DebugList(10, Test())

;* %#@Reference\procedures.html%#@5 *;
Dim Table.Point(10, 15)

Table(0,0)\x = 1
Table(1,0)\x = 2

Procedure TestIt(c.l, Array ParameterTable.Point(2))  ; The table support 2 dimensions
  
  ParameterTable(1, 2)\x = 3
  ParameterTable(2, 2)\x = 4
  
EndProcedure

TestIt(10, Table())

MessageRequester("Table", Str(Table(1, 2)\x))

;* %#@Reference\procedures.html%#@7 *;
Declare Maximum(Value1, Value2)

Procedure Operate(Value)
  Maximum(10, 2)      ; At this time, Maximum() is unknown.
EndProcedure

Procedure Maximum(Value1, Value2)
  ProcedureReturn 0
EndProcedure

;* %#@Reference\protected.html%#@1 *;
Global a
a = 10

Procedure Change()
  Protected a
  a = 20 
EndProcedure 

Change()
Debug a ; Will print 10, as the variable has been protected.

;* %#@Reference\protected.html%#@2 *;
Global Dim Array(2)
Array(0) = 10

Procedure Change()
  Protected Dim Array(2) ; This array is protected, it will be local.
  Array(0) = 20 
EndProcedure 

Change()
Debug Array(0) ; Will print 10, as the array has been protected.

;* %#@Reference\prototypes.html%#@1 *;

Prototype.i ProtoMessageBox(Window.i, Body$, Title$, Flags.i = 0)

If OpenLibrary(0, "User32.dll")
  
  ; 'MsgBox' is a variable with a 'ProtoMessageBox' type
  ;
  MsgBox.ProtoMessageBox = GetFunction(0, "MessageBoxA")
  
  MsgBox(0, "Hello", "World") ; We don't specify the flags
EndIf


;* %#@Reference\prototypes.html%#@2 *;
; We use the 'p-unicode' pseudotype for the string parameters, as
; MessageBoxW() is an unicode only function. The compiler will 
; automatically converts the strings to unicode when needed.
;
Prototype.i ProtoMessageBoxW(Window.i, Body.p-unicode, Title.p-unicode, Flags.i = 0)

If OpenLibrary(0, "User32.dll")
  
  ; 'MsgBox' is a variable with a 'ProtoMessageBoxW' type
  ;
  MsgBox.ProtoMessageBoxW = GetFunction(0, "MessageBoxW")
  
  MsgBox(0, "Hello", "World") ; We don't specify the flags
EndIf


;* %#@Reference\pseudotypes.html%#@1 *;
Import "User32.lib"
  
  ; We use the 'p-unicode' pseudotype for the string parameters, as
  ; MessageBoxW() is an unicode only function. The compiler will 
  ; automatically converts the strings to unicode when needed.
  ;
  MessageBoxW(Window.i, Body.p-unicode, Title.p-unicode, Flags.i = 0)
  
EndImport

; It will work correctly in ascii and in unicode mode, even if the API is unicode
; only as the compiler will take care of the conversion itself.
;
MessageBoxW(0, "Hello", "World")


;* %#@Reference\purebasic_objects.html%#@0 *;
CreateImage(0, 640, 480) ; Create an image, the n°0
ResizeImage(0, 320, 240) ; Resize the n°0 image

;* %#@Reference\purebasic_objects.html%#@1 *;
CreateImage(2, 640, 480) ; Create an image, the n°2
ResizeImage(2, 320, 240) ; Resize the n°2 image
CreateImage(2, 800, 800) ; Create a new image in the n°2 index, the old one is automatically free'ed

;* %#@Reference\purebasic_objects.html%#@2 *;
For k = 0 To 9
  CreateImage(k, 640, 480) ; Create 10 different images, numbered from 0 to 9
  ResizeImage(k, 320, 240) ; Create a new image in the n°2 index, the old one is automatically free'ed
Next

;* %#@Reference\purebasic_objects.html%#@4 *;
DynamicImage1 = CreateImage(#PB_Any, 640, 480) ; Create a dynamic image
ResizeImage(DynamicImage1, 320, 240)           ; Resize the DynamicImage1

;* %#@Reference\repeat_until.html%#@1 *;
a=0
Repeat 
  a=a+1
Until a>100 

;* %#@Reference\runtime.html%#@1 *;
Runtime Procedure OnEvent()
  Debug "OnEvent"
EndProcedure 

Debug GetRuntimeInteger("OnEvent()") ; Will display the procedure address

;* %#@Reference\runtime.html%#@2 *;
Runtime Enumeration
  #Constant1 = 10
  #Constant2
  #Constant3
EndEnumeration

Debug GetRuntimeInteger("#Constant1")
Debug GetRuntimeInteger("#Constant2")
Debug GetRuntimeInteger("#Constant3")

;* %#@Reference\runtime.html%#@3 *;
Define a = 20
Runtime a

Debug GetRuntimeInteger("a")
SetRuntimeInteger("a", 30)

Debug a ; the variable has been modified

;* %#@Reference\select_endselect.html%#@1 *;
Value = 2

Select Value
  Case 1
    Debug "Value = 1"
    
  Case 2 
    Debug "Value = 2"
    
  Case 20 
    Debug "Value = 20"
    
  Default
    Debug "I don't know"
EndSelect

;* %#@Reference\select_endselect.html%#@2 *;
Value = 2

Select Value
  Case 1, 2, 3
    Debug "Value is 1, 2 or 3"
    
  Case 10 To 20, 30, 40 To 50
    Debug "Value is between 10 and 20, equal to 30 or between 40 and 50"
    
  Default
    Debug "I don't know"
    
EndSelect

;* %#@Reference\shared.html%#@1 *;
a = 10

Procedure Change()
  Shared a
  a = 20 
EndProcedure 

Change()
Debug a   ; Will print 20, as the variable has been shared.

;* %#@Reference\shared.html%#@2 *;
Dim Array(2)
NewList List()
AddElement(List())

Procedure Change()
  Shared Array(), List()
  Array(0) = 1
  List() = 2
EndProcedure 

Change()
Debug Array(0)  ; Will print 1, as the array has been shared.
Debug List()    ; Will print 2, as the list has been shared.

;* %#@Reference\static.html%#@1 *;
Global a
a = 10

Procedure Change()
  Static a
  a+1
  Debug "In Procedure: "+Str(a) ; Will print 1, 2, 3 as the variable increments at each procedure call.
EndProcedure 

Change()
Change()
Change()
Debug a ; Will print 10, as the static variable doesn't affect global one.

;* %#@Reference\static.html%#@2 *;
Global Dim Array(2)
Array(0) = 10

Procedure Change()
  Static Dim Array(2)
  Array(0)+1
  Debug "In Procedure: "+Str(Array(0)) ; Will print 1, 2, 3 as the value of the array field increments at each procedure call.
EndProcedure 

Change()
Change()
Change()
Debug Array(0) ; Will print 10, as the static array doesn't affect global one.

;* %#@Reference\static.html%#@3 *;
Procedure Foo()
  Static x = 100  ; the declaration and the assignment is done only once at program start.
  
  Debug x
  x + 1
EndProcedure

Foo() ; Display 100
Foo() ; Display 101
Foo() ; Display 102

Debug "---"

Procedure Bar()
  Static x  ; the declaration is done only once at program start.  
  x = 100   ; the assignment is done on every Procedure call.
  
  Debug x
  x + 1
EndProcedure

Bar() ; Display 100
Bar() ; Display 100
Bar() ; Display 100


;* %#@Reference\structures.html%#@1 *;
Structure Person
  Name.s
  ForName.s 
  Age.w 
EndStructure

Dim MyFriends.Person(100)

; Here the position '0' of the array MyFriend()
; will contain one person and it's own information

MyFriends(0)\Name = "Andersson"
MyFriends(0)\Forname = "Richard" 
MyFriends(0)\Age = 32

;* %#@Reference\structures.html%#@2 *;
Structure Window
  *NextWindow.Window  ; Points to another window object
  x.w 
  y.w
  Name.s[10]  ; 10 Names available (from 0 to 9)
EndStructure

;* %#@Reference\structures.html%#@3 *;
Structure MyPoint
  x.l 
  y.l
EndStructure

Structure MyColoredPoint Extends MyPoint
  color.l 
EndStructure

ColoredPoint.MyColoredPoint\x = 10
ColoredPoint.MyColoredPoint\y = 20
ColoredPoint.MyColoredPoint\color = RGB(255, 0, 0)

;* %#@Reference\structures.html%#@4 *;
Structure MyPoint
  x.l 
  y.l
EndStructure

LeftPoint.MyPoint\x = 10
LeftPoint\y = 20

RightPoint.MyPoint = LeftPoint

Debug RightPoint\x
Debug RightPoint\y

;* %#@Reference\structures.html%#@5 *;
Structure Person
  Name$
  Age.l
  List Friends$()
EndStructure

John.Person
John\Name$ = "John"
John\Age   = 23

; Now, add some friends to John
;
AddElement(John\Friends$())
John\Friends$() = "Jim"

AddElement(John\Friends$())
John\Friends$() = "Monica"

ForEach John\Friends$()
  Debug John\Friends$()
Next

;* %#@Reference\structures.html%#@7 *;
Structure Type
  Name$
  StructureUnion
    Long.l      ; Each field (Long, Float and Byte) resides at the
    Float.f     ; same address in memory.
    Byte.b      ;
  EndStructureUnion
EndStructure

;* %#@Reference\structures.html%#@8 *;
Structure date
  day.s{2}
  pk1.s{1}
  month.s{2}
  pk2.s{1}
  year.s{4}
EndStructure

Structure date2
  StructureUnion
    s.s{10}
    d.date
  EndStructureUnion
EndStructure

Dim d1.date2(5)

d1(0)\s = "05.04.2008"
d1(1)\s = "07.05.2009"

Debug d1(0)\d\day
Debug d1(0)\d\month
Debug d1(0)\d\year

Debug d1(1)\d\day
Debug d1(1)\d\month
Debug d1(1)\d\year

d2.date2\s = "15.11.2010"

Debug d2\d\day
Debug d2\d\month
Debug d2\d\year

;* %#@Reference\structures.html%#@9 *;
Structure Type Align 4
  Byte.b
  Word.w
  Long.l
  Float.f
EndStructure

Debug OffsetOf(Type\Byte)   ; will print 0
Debug OffsetOf(Type\Word)   ; will print 4
Debug OffsetOf(Type\Long)   ; will print 8
Debug OffsetOf(Type\Float)  ; will print 12

;* %#@Reference\structures.html%#@10 *;
Structure Person
  *Next.Person ; Here the '*' is mandatory to declare a pointer
  Name$
  Age.b
EndStructure

Timo.Person\Name$ = "Timo"
Timo\Age = 25

Fred.Person\Name$ = "Fred"
Fred\Age = 25

Timo\Next = @Fred ; When using the pointer, the '*' is omitted

Debug Timo\Next\Name$ ; Will print 'Fred'

;* %#@Reference\threaded.html%#@1 *;
Threaded Counter

Counter = 128

Procedure Thread(Parameter)
  
  Debug Counter ; Will display zero as this thread doesn't have used this variable for now
  Counter = 256
  Debug Counter ; Will display 256
  
EndProcedure

Thread = CreateThread(@Thread(), 0)
WaitThread(Thread) ; Wait for thread ending

Debug Counter ; Will display 128, even if Counter has been changed in the thread

;* %#@Reference\threaded.html%#@2 *;
Threaded Counter = 128 ; Defined for all threads

Procedure Thread(Parameter)
  
  Debug Counter ; Will display 128 because a programme started, starts a thread too
  Counter = 256
  Debug Counter ; Will display 256
  
EndProcedure

Thread = CreateThread(@Thread(), 0)
WaitThread(Thread) ; Wait for thread ending

Debug Counter ; Will display 128, even if Counter has been changed in the thread

;* %#@Reference\ug_constants.html%#@1 *;
Enumeration
    #MyConstantA
    #MyConstantB
    #MyConstantC
EndEnumeration

Enumeration 10 Step 5
    #MyConstantD
    #MyConstantE
    #MyConstantF
EndEnumeration

Debug #MyConstantA
Debug #MyConstantB
Debug #MyConstantC

Debug #MyConstantD   ; will be 10
Debug #MyConstantE   ; will be 15
Debug #MyConstantF   ; will be 20

;* %#@Reference\ug_data.html%#@0 *;
; This section describes the fields of a structure or record, mostly integers in this case,
; but notice the string for the file name and the quad for the file size.
Structure FILEITEM
  Name.s
  Attributes.i
  Size.q
  DateCreated.i
  DateAccessed.i
  DateModified.i
EndStructure

; Now we define a new list of files using the structure previously specified 
; and some other working variables we'll use later on.
NewList Files.FILEITEM()
Define.s Folder
Define.l Result

; This function gets the home directory for the logged on user.
Folder = GetHomeDirectory()

; Open the directory to enumerate all its contents.
Result = ExamineDirectory(0, Folder, "*.*")  

; If this is ok, begin enumeration of entries.
If Result
  ; Loop through until NextDirectoryEntry(0) becomes zero - indicating that there are no more entries.
  While NextDirectoryEntry(0)
    ; If the directory entry is a file, not a folder.
    If DirectoryEntryType(0) = #PB_DirectoryEntry_File
      ; Add a new element to the list.
      AddElement(Files())
      ; And populate it with the properties of the file.
      Files()\Name = DirectoryEntryName(0)
      Files()\Size = DirectoryEntrySize(0)
      Files()\Attributes = DirectoryEntryAttributes(0)
      Files()\DateCreated = DirectoryEntryDate(0, #PB_Date_Created)
      Files()\DateAccessed = DirectoryEntryDate(0, #PB_Date_Accessed)
      Files()\DateModified = DirectoryEntryDate(0, #PB_Date_Modified)
    EndIf
  Wend
  ; Close the directory.
  FinishDirectory(0)
EndIf

; Shows the results in the debug window (if there is no entry, nothing will be displayed)
ForEach Files()
  Debug "Filename = " + Files()\Name
  Debug "Size = " + Str(Files()\Size)
  Debug "Attributes = " + StrU(Files()\Attributes)
  Debug "Created = " + StrU(Files()\DateCreated)
  Debug "Accessed = " + StrU(Files()\DateAccessed)
  Debug "Modified = " + StrU(Files()\DateModified)
Next Files()

;* %#@Reference\ug_data.html%#@1 *;
...
Debug "Created = " + FormatDate("%dd/%mm/%yyyy", Files()\DateCreated)
Debug "Accessed = " + FormatDate("%dd/%mm/%yyyy", Files()\DateAccessed)
Debug "Modified = " + FormatDate("%dd/%mm/%yyyy", Files()\DateModified)

;* %#@Reference\ug_data.html%#@2 *;
...

; Sort the list into ascending alphabetical order of file name.
SortStructuredList(Files(), #PB_Sort_Ascending, OffsetOf(FILEITEM\Name), #PB_String)

; If there are some entries in the list, show the results in the debug window.
...

;* %#@Reference\ug_decisions.html%#@0 *;
Define.l Items = 10, Filter = 6
Define.s Message

If Items = 0 
  Message = "List is empty."
  
ElseIf Items = 1 And Filter = 0
  Message = "One item. Not shown by filter."
  
ElseIf Items > 1 And Filter = 0
  Message = StrU(Items) + " items. All filtered."
  
ElseIf Items > 1 And Filter = 1
  Message = StrU(Items) + " items. One shown by filter."
  
ElseIf Items = Filter
  Message = StrU(Items) + " items. None filtered."
  
Else
  ; None of the other conditions were met.
  Message = StrU(Items) + " items. " + StrU(Filter) +" shown by filter."
  
EndIf

Debug Message

;* %#@Reference\ug_decisions.html%#@1 *;
Define.c Char
Define.s Message

For Char = 0 To 130
  
  Select Char
      
    Case 0 To 8, 10 To 31, 127
      Message = StrU(Char) + " is a non-printing control code."
      
    Case 9
      Message = StrU(Char) + " is a tab."
      
    Case 32
      Message = StrU(Char) + " is a space."
      
    Case 36, 128   
      Message = StrU(Char) + " is a currency symbol. (" + Chr(Char) + ")"
      
    Case 33 To 35, 37 To 47, 58 To 64, 91 To 96
      Message = StrU(Char) + " is a punctuation mark or math symbol. (" + Chr(Char) + ")"
      
    Case 48 To 57
      Message = StrU(Char) + " is a numeral. (" + Chr(Char) + ")"
      
    Case 65 To 90
      Message = StrU(Char) + " is an upper case letter. (" + Chr(Char) + ")"
      
    Case 97 To 122
      Message = StrU(Char) + " is a lower case letter. (" + Chr(Char) + ")"
      
    Default
      ; If none of the preceding Case conditions are met.
      Message = "Sorry, I don't know what " + StrU(Char) + " is!"
      
  EndSelect
  
  Debug Message
  
Next Char

;* %#@Reference\ug_directives.html%#@0 *;
Declare.s AttributeString(Attributes.l)

;* %#@Reference\ug_directives.html%#@1 *;
Procedure.s AttributeString(Attributes.l)
  ; Converts an integer attributes value into a string description.
  ; Supports Linux, Mac and Windows system's attributes.
  
  Protected.s Result
  
  Result = ""
  
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
        
        ; These are the attributes for Windows systems.
        ; A logical-and of the attribute with each constant filters out that bit and can then be used for comparison.
    
        If Attributes & #PB_FileSystem_Archive
            Result + "A"
        Else
            Result + " "
        EndIf
        
        If Attributes & #PB_FileSystem_Compressed
            Result + "C"
        Else
            Result + " "
        EndIf
        
        If Attributes & #PB_FileSystem_Hidden
            Result + "H"
        Else
            Result + " "
        EndIf
        
        If Attributes & #PB_FileSystem_ReadOnly
            Result + "R"
        Else
            Result + " "
        EndIf
        
        If Attributes & #PB_FileSystem_System
            Result + "S"
        Else
            Result + " "
        EndIf
        
  CompilerElse
    
    ; These are the attributes for Mac and Linux systems.
    
    If Attributes & #PB_FileSystem_Link
      Result + "L "
    Else
      Result + "  "
    EndIf
    
    ; User attributes.
    If Attributes & #PB_FileSystem_ReadUser
      Result + "R"
    Else
      Result + " "
    EndIf
    
    If Attributes & #PB_FileSystem_WriteUser
      Result + "W"
    Else
      Result + " "
    EndIf
    
    If Attributes & #PB_FileSystem_ExecUser
      Result + "X "
    Else
      Result + "  "
    EndIf
    
    ; Group attributes.
    If Attributes & #PB_FileSystem_ReadGroup
      Result + "R"
    Else
      Result + " "
    EndIf
    
    If Attributes & #PB_FileSystem_WriteGroup
      Result + "W"
    Else
      Result + " "
    EndIf
    
    If Attributes & #PB_FileSystem_ExecGroup
      Result + "X "
    Else
      Result + "  "
    EndIf
    
    ; All attributes.
    If Attributes & #PB_FileSystem_ReadAll
      Result + "R"
    Else
      Result + " "
    EndIf
    
    If Attributes & #PB_FileSystem_WriteAll
      Result + "W"
    Else
      Result + " "
    EndIf
    
    If Attributes & #PB_FileSystem_ExecAll
      Result + "X"
    Else
      Result + " "
    EndIf
    
  CompilerEndIf
  
  ; Return the result.
  ProcedureReturn Result
  
EndProcedure

;* %#@Reference\ug_directives.html%#@2 *;
; Convert the attributes to a string, for now.
Attrib = StrU(Files()\Attributes)

;* %#@Reference\ug_directives.html%#@3 *;
; Call AttributeString to convert the attributes to a string representation.
Attrib = AttributeString(Files()\Attributes)

;* %#@Reference\ug_directives.html%#@6 *;
CompilerIf #PB_Compiler_OS = #PB_OS_Windows

;* %#@Reference\ug_directives.html%#@8 *;
CompilerSelect #PB_Compiler_OS
    
  CompilerCase #PB_OS_Linux
    ; Code for Linux systems.
    
    
  CompilerCase #PB_OS_MacOS
    ; Code for Mac systems.
    
  CompilerCase #PB_OS_Windows
    ; Code for Windows systems.
    
CompilerEndSelect

;* %#@Reference\ug_directives.html%#@9 *;
EnableExplicit

Define.l Field, FieldMax

; ...

If Field < FieldMax
  ; If EnableExplicit is omitted this section of code may not execute when intended because FieldMax will be zero.
EndIf

;* %#@Reference\ug_firststeps.html%#@0 *;
Debug "Hello World!"

;* %#@Reference\ug_firststeps.html%#@1 *;
MessageRequester("", "Hello World!")

;* %#@Reference\ug_firststeps.html%#@2 *;
a = 5
b = 7
c = 3

d = a + b  ; we use the values stored in variables 'a' and 'b' and save the sum of them in 'd'
d / c      ; we directly use the value of 'd' (= 12) divided by the value of 'c' (= 3) and save the result in 'd'

Debug d   ; will output 4

;* %#@Reference\ug_graphics.html%#@0 *;
; Window
Enumeration
  #WinHarmonic
EndEnumeration

; Gadgets
Enumeration
  #txtPlot1
  #cboPlot1
  #txtPlot2
  #cboPlot2
  #imgPlot
EndEnumeration

; Image
Enumeration
  #drgPlot
EndEnumeration

; Image dimensions are used in several places so define constants.
#imgPlotX = 8
#imgPlotY = 40
#imgPlotW = 745
#imgPlotH = 645

; Event variables
Define.l Event, EventWindow, EventGadget, EventType, EventMenu

; Implementation
Procedure CreateWindow()
  ; Creates the window and gadgets.  
  
  If OpenWindow(#WinHarmonic, 30, 30, #imgPlotW + 20, #imgPlotH + 55, "Harmonics", #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_TitleBar)
    
    ; This is a non-visual gadget used to draw the image, later its contents will be displayed in #imgPlot.
    CreateImage(#drgPlot, #imgPlotW - 5, #imgPlotH - 5, 24)
    
    ; Label for the Plot 1 combo.
    TextGadget(#txtPlot1, 2, 5, 50, 25, "Plot 1:")
    
    ; The Plot 1 combo.
    ComboBoxGadget(#cboPlot1, 55, 5, 150, 25)
    AddGadgetItem(#cboPlot1, 0, "Sin(X)")
    AddGadgetItem(#cboPlot1, 1, "Sin(X * 2)")
    AddGadgetItem(#cboPlot1, 2, "Sin(X * 3)")
    AddGadgetItem(#cboPlot1, 3, "Sin(X * 4)")
    AddGadgetItem(#cboPlot1, 4, "Sin(X * 5)")
    AddGadgetItem(#cboPlot1, 5, "Sin(X * 6)")
    
    ; Select Sin(X)
    SetGadgetState(#cboPlot1, 0)
    
    ; Label for the Plot 2 combo.
    TextGadget(#txtPlot2, 230, 5, 50, 25, "Plot 2:")
    
    ; The Plot 2 combo.
    ComboBoxGadget(#cboPlot2, 280, 5, 150, 25)
    AddGadgetItem(#cboPlot2, 0, "Sin(X)")
    AddGadgetItem(#cboPlot2, 1, "Sin(X * 2)")
    AddGadgetItem(#cboPlot2, 2, "Sin(X * 3)")
    AddGadgetItem(#cboPlot2, 3, "Sin(X * 4)")
    AddGadgetItem(#cboPlot2, 4, "Sin(X * 5)")
    AddGadgetItem(#cboPlot2, 5, "Sin(X * 6)")
    
    ; Select Sin(X * 2), otherwise the initial display is a bit uninteresting.
    SetGadgetState(#cboPlot2, 1)
    
    ; The visual image gadget on the window.
    ImageGadget(#imgPlot, #imgPlotX, #imgPlotY, #imgPlotW, #imgPlotH, 0, #PB_Image_Border)
    
  EndIf
  
EndProcedure

Procedure PlotAxes()
  ; Draws the axes on the image #drgPlot.
  
  ; Send drawing commands to #drgPlot.
  StartDrawing(ImageOutput(#drgPlot))
  
  ; Draw a white background.
  Box(0, 0, ImageWidth(#drgPlot), ImageHeight(#drgPlot), RGB(255, 255, 255))
  
  ; Draw the axes in black.
  Line(1, 1, 1, ImageHeight(#drgPlot) - 2, RGB(0, 0, 0))
  Line(1, (ImageHeight(#drgPlot) - 2) /2, ImageWidth(#drgPlot) -2, 1, RGB(0, 0, 0))
  
  ; Finished drawing.
  StopDrawing()
EndProcedure

Procedure PlotLegend(alngPlot1, alngPlot2)
  ; Draws the legend on the image #drgPlot.
  
  Protected.s strFunc1, strFunc2, strLabel1, strLabel2, strLabel3
  
  ; Set label text 1.
  If alngPlot1 = 0 
    strFunc1 = "Sin(X)"
  Else
    strFunc1 = "Sin(X * " + StrU(alngPlot1 + 1) + ")"
  EndIf
  
  ; Set label text 2.
  If alngPlot2 = 0 
    strFunc2 = "Sin(X)"
  Else
    strFunc2 = "Sin(X * " + StrU(alngPlot2 + 1) + ")"
  EndIf
  
  ; Set label text.
  strLabel1 = "Y = " + strFunc1
  strLabel2 = "Y = " + strFunc2
  strLabel3 = "Y = " + strFunc1 + " + " + strFunc2 
  
  ; Draw legend.
  StartDrawing(ImageOutput(#drgPlot))
  
  ; Box.
  DrawingMode(#PB_2DDrawing_Outlined)
  Box(20, 10, TextWidth(strLabel3) + 85, 80, RGB(0, 0, 0))
  
  ; Label 1.
  Line(30, 30, 50, 1, RGB(0, 0, 255))
  DrawText(95, 22, strLabel1, RGB(0, 0, 0), RGB(255, 255, 255))
  
  ; Label 2.
  Line(30, 50, 50, 1, RGB(0, 255, 200))
  DrawText(95, 42, strLabel2, RGB(0, 0, 0), RGB(255, 255, 255))
  
  ; Label 3.
  Line(30, 70, 50, 1, RGB(255, 0, 0))
  DrawText(95, 62, strLabel3, RGB(0, 0, 0), RGB(255, 255, 255))
  
  StopDrawing()
  
EndProcedure

Procedure PlotFunction(alngPlot1, alngPlot2)
  ; Draws the waveforms on the image #drgPlot.
  
  Protected.l lngSX, lngEX
  Protected.f fltRad1, fltRad2, fltSY1, fltEY1, fltSY2, fltEY2, fltSY3, fltEY3
  
  StartDrawing(ImageOutput(#drgPlot))
  
  ; Set initial start points for each wave.
  lngSX = 1
  fltSY1 = ImageHeight(#drgPlot) / 2
  fltSY2 = fltSY1
  fltSY3 = fltSY1
  
  ; Plot wave forms.
  For lngEX = 1 To 720
    ; Sine function works in radians, so convert from degrees and calculate sine.
    
    ; Function 1
    If alngPlot1 = 0 
      fltRad1 = Sin(Radian(lngEX))
    Else
      ; If the function should have a multiplier, account for this.
      fltRad1 = Sin(Radian(lngEX) * (alngPlot1 + 1))
    EndIf
    
    ; Function 2
    If alngPlot2 = 0 
      fltRad2 = Sin(Radian(lngEX))
    Else
      fltRad2 = Sin(Radian(lngEX) * (alngPlot2 + 1))
    EndIf
    
    ; Plot function 1 in blue.
    ; Calculate end Y point.
    fltEY1 = (ImageHeight(#drgPlot) / 2) + (fltRad1 * 100)
    ; Draw a line from the start point to the end point.
    LineXY(lngSX, fltSY1, lngEX, fltEY1, RGB(0, 0, 255))
    ; Update the next start Y point to be the current end Y point.
    fltSY1 = fltEY1
    
    ; Plot function 2 in green.
    fltEY2 = (ImageHeight(#drgPlot) / 2) + (fltRad2 * 100)
    LineXY(lngSX, fltSY2, lngEX, fltEY2, RGB(0, 255, 200))
    fltSY2 = fltEY2
    
    ; Plot harmonic in red.
    fltEY3 = (ImageHeight(#drgPlot) / 2) + ((fltRad1 + fltRad2) * 100)
    LineXY(lngSX, fltSY3, lngEX, fltEY3, RGB(255, 0, 0))
    fltSY3 = fltEY3
    
    ; Update the start X point to be the current end X point.
    lngSX = lngEX
  Next lngEX
  
  StopDrawing()
  
EndProcedure

;- Main
CreateWindow()
PlotAxes()
PlotLegend(GetGadgetState(#cboPlot1), GetGadgetState(#cboPlot2))
PlotFunction(GetGadgetState(#cboPlot1), GetGadgetState(#cboPlot2))

; Reload the image gadget now drawing is complete.
ImageGadget(#imgPlot, #imgPlotX, #imgPlotY, #imgPlotW, #imgPlotH, ImageID(#drgPlot), #PB_Image_Border)

;- Event loop
Repeat
  Event = WaitWindowEvent()
  EventWindow = EventWindow()
  EventGadget = EventGadget()
  EventType = EventType()
  
  Select Event
    Case #PB_Event_Gadget
      If EventGadget = #txtPlot1 Or EventGadget = #txtPlot2
        ; Do nothing.
      ElseIf EventGadget = #imgPlot
        ; Do nothing.
      ElseIf EventGadget = #cboPlot1 Or EventGadget = #cboPlot2
        ; If one of the combo boxes changed, redraw the image.
        PlotAxes()
        PlotLegend(GetGadgetState(#cboPlot1), GetGadgetState(#cboPlot2))
        PlotFunction(GetGadgetState(#cboPlot1), GetGadgetState(#cboPlot2))
        ImageGadget(#imgPlot, #imgPlotX, #imgPlotY, #imgPlotW, #imgPlotH, ImageID(#drgPlot), #PB_Image_Border)
      EndIf
    Case #PB_Event_CloseWindow
      If EventWindow = #WinHarmonic
        CloseWindow(#WinHarmonic)
        Break
      EndIf
  EndSelect
ForEver

;* %#@Reference\ug_gui.html%#@0 *;
; The structure for file information as before.
Structure FILEITEM
  Name.s
  Attributes.i
  Size.q
  DateCreated.i
  DateAccessed.i
  DateModified.i
EndStructure

; This is a constant to identify the window.
Enumeration
  #WindowFiles
EndEnumeration

; This is an enumeration to identify controls which will appear on the window.
Enumeration
  #Folder
  #Files
EndEnumeration

; Now we define a list of files using the structure previously specified.
NewList Files.FILEITEM()

; And some working variables to make things happen.
Define.s Access, Attrib, Create, Folder, Modify, Msg, Num, Size
Define.l Result, Flags

; These variables will receive details of GUI events as they occur in the program.
Define.l Event, EventWindow, EventGadget, EventType, EventMenu

; This function gets the home directory for the logged on user.
Folder = GetHomeDirectory()

; Open the directory to enumerate its contents.
Result = ExamineDirectory(0, Folder, "*.*")

; If this is ok, begin enumeration of entries.
If Result
  ; Loop through until NextDirectoryEntry(0) becomes zero - indicating that there are no more entries.
  While NextDirectoryEntry(0)
    ; If the directory entry is a file, not a folder.
    If DirectoryEntryType(0) = #PB_DirectoryEntry_File
      
      ; Add a new element to the list.
      AddElement(Files())
      ; And populate it with the properties of the file.
      Files()\Name = DirectoryEntryName(0)
      Files()\Size = DirectoryEntrySize(0)
      Files()\Attributes = DirectoryEntryAttributes(0)
      Files()\DateCreated = DirectoryEntryDate(0, #PB_Date_Created)
      Files()\DateAccessed = DirectoryEntryDate(0, #PB_Date_Accessed)
      Files()\DateModified = DirectoryEntryDate(0, #PB_Date_Modified)
    EndIf
  Wend
  ; Close the directory.
  FinishDirectory(0)
EndIf

; Sort the list into ascending alphabetical order of file name.
SortStructuredList(Files(), #PB_Sort_Ascending, OffsetOf(FILEITEM\Name), #PB_String)

; The interesting stuff starts to happen here...

; This line defines a flag for the window attributes by OR-ing together the desired attribute constants.
Flags = #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_TitleBar

; Open a GUI window.
OpenWindow(#WindowFiles, 50, 50, 450, 400, "File Properties", Flags)
; A text gadget to show the name of the folder.
TextGadget(#Folder, 5, 40, 440, 25, Folder)
; A list icon gadget to hold the file list and properties.
ListIconGadget(#Files, 5, 70, 440, 326, "#", 35)
; Add columns to the ListIconGadget to hold each property.
AddGadgetColumn(#Files, 1, "Name", 200)
AddGadgetColumn(#Files, 2, "Created", 100)
AddGadgetColumn(#Files, 3, "Accessed", 100)
AddGadgetColumn(#Files, 4, "Modified", 100)
AddGadgetColumn(#Files, 5, "Attributes", 150)
AddGadgetColumn(#Files, 6, "Size", 100)

; Load the files into the list view.
ForEach Files()
  ; Display the item number and file name.
  Num = StrU(ListIndex(Files()) + 1)
  
  ; These lines convert the three date values to something more familiar.
  Create = FormatDate("%dd/%mm/%yyyy", Files()\DateCreated)
  Access = FormatDate("%dd/%mm/%yyyy", Files()\DateAccessed)
  Modify = FormatDate("%dd/%mm/%yyyy", Files()\DateModified)
  
  ; Convert the file size to a padded string the same as with the index value above,
  ; but allow space for the maximum size of a quad.
  Size = StrU(Files()\Size)
  
  ; Convert the attributes to a string, for now.
  Attrib = StrU(Files()\Attributes)
  
  ; Build a row string.  
  ; The Line Feed character 'Chr(10)' tells the gadget to move to the next column.
  Msg = Num + Chr(10) + Files()\Name + Chr(10) + Create + Chr(10) + Access + Chr(10) + Modify + Chr(10) + Attrib + Chr(10) + Size
  
  ; Add the row to the list view gadget.
  AddGadgetItem(#Files, -1, Msg)
Next Files()

; This is the event loop for the window.  
; It will deal with all the user interaction events that we wish to use. 

Repeat
  ; Wait until a new window or gadget event occurs.
  Event = WaitWindowEvent()
  ; In programs with more than one form, which window did the event occur on.
  EventWindow = EventWindow()
  ; Which gadget did the event occur on.
  EventGadget = EventGadget()
  ; What sort of event occurred.
  EventType = EventType()
  
  ; Take some action.
  Select Event
      
    Case #PB_Event_Gadget
      ; A gadget event occurred.
      If EventGadget = #Folder
      ElseIf EventGadget = #Files
      EndIf
      
    Case #PB_Event_CloseWindow
      ; The window was closed.
      If EventWindow = #WindowFiles
        CloseWindow(#WindowFiles)
        Break
      EndIf
      
  EndSelect
  
  ; Go round and do it again.
  ; In practice the loop isn't infinite because it can be stopped by clicking the window's Close button.
ForEver

;* %#@Reference\ug_loops.html%#@0 *;
Define.i A
For A = 0 To 10 Step 2
    Debug A
Next A

;* %#@Reference\ug_loops.html%#@1 *;
Define.i B
; B = 100
While B < 100
      B + Random(20)
      Debug B
Wend

;* %#@Reference\ug_loops.html%#@2 *;
Define.i C
; C = 100
Repeat
      C + Random(20)
      Debug C
Until C > 99

;* %#@Reference\ug_loops.html%#@3 *;
Define.i D
Repeat
      Debug D
ForEver

;* %#@Reference\ug_loops.html%#@4 *;
NewList Fruit.s()

AddElement(Fruit())
Fruit() = "Banana"

AddElement(Fruit())
Fruit() = "Apple"

AddElement(Fruit())
Fruit() = "Pear"

AddElement(Fruit())
Fruit() = "Orange"

ForEach Fruit()
      Debug Fruit()
Next Fruit()

;* %#@Reference\ug_memory.html%#@0 *;
;- Compiler Directives
EnableExplicit

;- Constants
; Window
Enumeration
  #WindowHex
EndEnumeration

; Gadgets
Enumeration
  #GadgetFiles
  #GadgetOpen
  #GadgetClose
  #GadgetHex
EndEnumeration

;- Variables
Define.l Event, EventWindow, EventGadget, EventType, EventMenu
Define.l Length
Define.s File
Define *Buffer

;- Declarations
Declare WindowCreate()
Declare WindowResize()
Declare FileClose()
Declare FileDisplay()
Declare FileRead()

;- Implementation
Procedure WindowCreate()  
  ; Create the window.
  
  Protected.l Col
  Protected.s Label
  
  If OpenWindow(#WindowHex, 50, 50, 500, 400, "Hex View", #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_MinimizeGadget | #PB_Window_TitleBar)
    
    ; Set minimum window size.
    WindowBounds(#WindowHex, 175, 175, #PB_Ignore, #PB_Ignore)
    
    ; Create Explorer List and set to user's home directory.
    ExplorerListGadget(#GadgetFiles, 5, 5, 490, 175, GetHomeDirectory())
    
    ; Buttons.
    ButtonGadget(#GadgetOpen, 5, 185, 80, 25, "Open")
    ButtonGadget(#GadgetClose, 100, 185, 80, 25, "Close")
    
    ; List Icon Gadget.
    ListIconGadget(#GadgetHex, 5, 215, 490, 180, "Offset", 80, #PB_ListIcon_AlwaysShowSelection | #PB_ListIcon_GridLines | #PB_ListIcon_FullRowSelect)
    
    ; Column Headings.
    For Col = 0 To 7
      Label = RSet(Hex(Col, #PB_Byte), 2, "0")
      AddGadgetColumn(#GadgetHex, Col + 1, Label, 38)
    Next Col
    AddGadgetColumn(#GadgetHex, 9, "Text", 80)
    
  EndIf
  
EndProcedure

Procedure WindowResize()
  ; Resize gadgets to new window size.
  
  Protected.l X, Y, W, H
  
  ; Explorer List
  W = WindowWidth(#WindowHex) - 10
  H = (WindowHeight(#WindowHex) - 35) / 2
  ResizeGadget(#GadgetFiles, #PB_Ignore, #PB_Ignore, W, H)
  
  ; Buttons
  Y = GadgetHeight(#GadgetFiles) + 10
  ResizeGadget(#GadgetOpen, #PB_Ignore, Y, #PB_Ignore, #PB_Ignore)
  ResizeGadget(#GadgetClose, #PB_Ignore, Y, #PB_Ignore, #PB_Ignore)
  
  ; List Icon View
  Y = (WindowHeight(#WindowHex) / 2) + 23
  W = WindowWidth(#WindowHex) - 10
  H = WindowHeight(#WindowHex) - (Y + 5)
  ResizeGadget(#GadgetHex, #PB_Ignore, Y, W, H)
  
EndProcedure

Procedure FileClose()
  ; Clear the list view and release the memory buffer.
  
  Shared Length, *Buffer
  
  ClearGadgetItems(#GadgetHex)
  FillMemory(*Buffer, Length)
  FreeMemory(*Buffer)
  
EndProcedure

Procedure FileDisplay()
  ; Display the file buffer in the list view.
  
  Shared Length, *Buffer
  
  Protected *Byte
  Protected Peek
  Protected.l Rows, Cols, Offset
  Protected.s OffsetString, Row, String
  
  ; Clear current contents.
  ClearGadgetItems(#GadgetHex)
  
  ; Loop through rows.
  For Rows = 0 To Length - 1 Step 8
    
    ; Clear the text value for each row.
    String = ""
    
    ; Convert the offset value to a fixed length string.
    Row = RSet(Hex(Rows, #PB_Long), 6, "0") + Chr(10)
    
    ; Loop through columns.
    For Cols = 0 To 7
      
      ; Calculate the offset for the current column.
      Offset = Rows + Cols
      
      ; Compare the offset with the file length.
      If Offset < Length
        ; The offset is less than the length of the file.
        
        ; Obtain the byte from the buffer.
        *Byte = *Buffer + Offset
        Peek = PeekB(*Byte)
        
        ; Convert the byte to text.
        Row + RSet(Hex(Peek, #PB_Byte), 2, "0") + Chr(10)
        
        ; Add the character to the text version.
        Select Peek
            
          Case 0 To 31, 127
            ; Unprintable characters.
            String + Chr(129)   
            
          Default
            ; Printable characters.
            String + Chr(Peek)
            
        EndSelect
        
      Else
        ; The offset is greater than the length of the file.
        
        ; Add an empty column.
        Row + Chr(10)
        
      EndIf
      
    Next Cols
    
    ; Add the text version at the end of the hex columns.
    Row + String
    
    ; Add the completed row to the list view.
    AddGadgetItem(#GadgetHex, -1, Row)
    
  Next Rows
  
EndProcedure

Procedure FileRead()
  ; Read the file into the memory buffer.
  
  Shared Length, File, *Buffer
  
  Protected.b ReadByte
  Protected.l FileNumber, ReadLong, Size
  
  ; Stop if file is empty.
  If File = ""
    ProcedureReturn
  EndIf
  
  ; Stop if file size is invalid.
  Size = FileSize(File)
  If Size < 1
    ProcedureReturn 
  EndIf
  
  ; Open the file.
  FileNumber = OpenFile(#PB_Any, File)
  Length = Lof(FileNumber)
  
  If File And Length
    
    ; Allocate a memory buffer to hold the file.
    *Buffer = AllocateMemory(Length)
    
    ; Read the file into the buffer.
    Length = ReadData(FileNumber, *Buffer, Length)
    
  EndIf
  
  ; Close the file.
  CloseFile(FileNumber)
  
EndProcedure

;- Main
WindowCreate()

;- Event Loop
Repeat
  
  ; Obtain event parameters.
  Event = WaitWindowEvent()
  EventGadget = EventGadget()
  EventType = EventType()
  EventWindow = EventWindow()
  
  ; Handle events.
  Select Event
      
    Case #PB_Event_Gadget
      If EventGadget = #GadgetFiles
        ; Do nothing.
        
      ElseIf EventGadget = #GadgetOpen
        File = GetGadgetText(#GadgetFiles) + GetGadgetItemText(#GadgetFiles, GetGadgetState(#GadgetFiles))
        If FileSize(File) > 0
          FileRead()  
          FileDisplay()
        EndIf
        
      ElseIf EventGadget = #GadgetClose
        FileClose()
        
      ElseIf EventGadget = #GadgetHex
        ; Do nothing.
        
      EndIf
      
    Case #PB_Event_CloseWindow
      If EventWindow = #WindowHex
        CloseWindow(#WindowHex)
        Break
      EndIf
      
    Case #PB_Event_SizeWindow
      WindowResize()
      
  EndSelect
  
ForEver

;* %#@Reference\ug_pb_any1.html%#@0 *;
; Compiler Directives
EnableExplicit

; Constants
CompilerIf Defined(Blue, #PB_Constant) = #False
  #Blue = 16711680
  #Gray = 8421504
  #White = 16777215
CompilerEndIf

;- Enumerations
; The menu commands will be the same on all the windows.
Enumeration
  #MenuNew
  #MenuClose
EndEnumeration

;- Structures
; This structure will hold references to the unique elements of a window.
Structure POLYGONWINDOW
  Menu.i
  LabelSides.i
  ComboSides.i
  ImagePlot.i
EndStructure

;- Variables

; This map uses the previously defined structure to hold references for all the open windows.
NewMap ActiveWindows.POLYGONWINDOW()

; Event variables.
Define.i Event, EventWindow, EventGadget, EventType, EventMenu, EventQuit
Define.s EventWindowKey

; Implementation.
Procedure.i CreatePolygonWindow()
  ; Creates a new window and gadgets, adding it and its child gadgets to the tracking map.
  Shared ActiveWindows()
  Protected.i ThisWindow
  Protected.s ThisKey
  
  ThisWindow = OpenWindow(#PB_Any, 50, 50, 300, 300, "Polygon", #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_MinimizeGadget | #PB_Window_TitleBar)  
  
  WindowBounds(ThisWindow, 250, 250, #PB_Ignore, #PB_Ignore)
  
  If ThisWindow
    ; Maps take a string value as key so convert the integer ThisWindow to a string.
    ThisKey = StrU(ThisWindow)
    
    ; Add a map element to hold the new gadget references.
    AddMapElement(ActiveWindows(), ThisKey)
    
    ; Create the menu bar.
    ActiveWindows(ThisKey)\Menu = CreateMenu(#PB_Any, WindowID(ThisWindow))
    MenuTitle("Window")
    MenuItem(#MenuNew, "New Window")
    MenuItem(#MenuClose, "Close Window")
    
    ; Create the child gadgets and store their references in the map.
    With ActiveWindows()
      ; A label for the combo.
      \LabelSides = TextGadget(#PB_Any, 5, 5, 150, 20, "Number of Sides:")
      
      ; The Sides combo.
      \ComboSides = ComboBoxGadget(#PB_Any, 160, 5, 100, 25)
      AddGadgetItem(\ComboSides, 0, "Triangle")
      AddGadgetItem(\ComboSides, 1, "Diamond")
      AddGadgetItem(\ComboSides, 2, "Pentagon")
      AddGadgetItem(\ComboSides, 3, "Hexagon")
      AddGadgetItem(\ComboSides, 4, "Heptagon")
      AddGadgetItem(\ComboSides, 5, "Octagon")
      AddGadgetItem(\ComboSides, 6, "Nonagon")
      AddGadgetItem(\ComboSides, 7, "Decagon")
      
      ; Select Triangle.
      SetGadgetState(\ComboSides, 0)
      
      ; The visual image gadget on the window.
      \ImagePlot = ImageGadget(#PB_Any, 5, 35, 290, 240, 0, #PB_Image_Border)
    EndWith
  EndIf
  
  ; Return the reference to the new window.
  ProcedureReturn ThisWindow
EndProcedure

Procedure DestroyPolygonWindow(Window.i)
  ; Remove Window from the ActiveWindows map, close the window and set the quit flag, if appropriate.
  Shared EventQuit, ActiveWindows()
  Protected.s ThisKey
  
  ; Convert the integer Window to a string.
  ThisKey = StrU(Window)
  
  ; Delete the map entry.
  DeleteMapElement(ActiveWindows(), ThisKey)
  
  ; Close the window.
  CloseWindow(Window)
  
  ; Check if there are still open windows.
  If MapSize(ActiveWindows()) = 0
    EventQuit = #True
  EndIf
EndProcedure

Procedure.i ResizePolygonWindow(Window.i)
  ; Resize the child gadgets on Window.
  ; In practice only the ImageGadget needs to be resized in this example.
  Shared ActiveWindows()
  Protected.i ThisImage
  Protected.i X, Y, W, H
  Protected.s ThisKey
  
  ; Obtain references to the affected gadgets from the map.
  ThisKey = StrU(Window)
  ThisImage = ActiveWindows(ThisKey)\ImagePlot
  
  ; Resize gadgets.
  W = WindowWidth(Window) - 15
  H = WindowHeight(Window) - 70
  ResizeGadget(ThisImage, #PB_Ignore, #PB_Ignore, W, H)
EndProcedure

Procedure PlotPolygon(Window.i)
  ; Draw the polygon image and transfer it to the image gadget.
  Shared ActiveWindows()
  Protected.f Radius, OriginX, OriginY, StartX, StartY, EndX, EndY
  Protected.i Sides, Vertex, Width, Height, ThisCombo, ThisImage, ThisPlot
  Protected.s ThisKey
  
  ; Check if the event is for the right window.
  If Not IsWindow(Window) : ProcedureReturn : EndIf
  
  ; Obtain references to the affected gadgets from the map.
  ThisKey = StrU(Window)
  ThisCombo = ActiveWindows(ThisKey)\ComboSides
  ThisImage = ActiveWindows(ThisKey)\ImagePlot
  
  ; Calculate dimensions and origin.
  Sides = GetGadgetState(ThisCombo) + 3
  Width = GadgetWidth(ThisImage) - 4
  Height = GadgetHeight(ThisImage) - 4
  OriginX = Width/2
  OriginY = Height/2
  If Width < Height
    Radius = OriginX - 50
  Else
    Radius = OriginY - 50
  EndIf
  
  ; Create a new image.
  ThisPlot = CreateImage(#PB_Any, Width, Height)
  StartDrawing(ImageOutput(ThisPlot))
  
  ; Draw a white background.
  Box(0, 0, Width, Height, #White)
  
  ; Draw a gray circumscribing circle.
  Circle(OriginX, OriginY, Radius, #Gray)
  
  ; Draw the polygon.
  For Vertex = 0 To Sides
    
    ; Calculate side start point.
    StartX =  OriginX + (Radius * Cos(2 * #PI * Vertex/Sides))
    StartY = OriginY + (Radius * Sin(2 * #PI * Vertex/Sides)) 
    
    ; and end point.
    EndX = OriginX + (Radius * Cos(2 * #PI * (Vertex + 1)/Sides))
    EndY = OriginY + (Radius * Sin(2 * #PI * (Vertex + 1)/Sides))
    
    ; Draw the side in blue.
    LineXY(StartX, StartY, EndX, EndY, #Blue)
    
  Next Vertex
  
  ; Fill the polygon in blue
  FillArea(OriginX, OriginY, #Blue, #Blue)
  
  StopDrawing()
  
  ; Transfer the image contents to the visible gadget.
  SetGadgetState(ThisImage, ImageID(ThisPlot))
  
  ; Destroy the temporary image.
  FreeImage(ThisPlot)
EndProcedure

;- Main

; Create the first window.
EventWindow = CreatePolygonWindow()
ResizePolygonWindow(EventWindow)
PlotPolygon(EventWindow)

;- Event loop
Repeat
  Event = WaitWindowEvent()
  EventWindow = EventWindow()
  EventWindowKey = StrU(EventWindow)
  EventGadget = EventGadget()
  EventType = EventType()
  EventMenu = EventMenu()
  
  Select Event
    Case #PB_Event_Gadget
      ; A gadget event has occurred.
      If EventGadget = ActiveWindows(EventWindowKey)\LabelSides
        ; Do nothing.
        
      ElseIf EventGadget = ActiveWindows(EventWindowKey)\ComboSides
        ; If the combo box changes, redraw the image.
        PlotPolygon(EventWindow)
        
        ; Update the windows title to reflect the new shape.
        SetWindowTitle(EventWindow, GetGadgetText(ActiveWindows(EventWindowKey)\ComboSides))
        
      ElseIf EventGadget = ActiveWindows(EventWindowKey)\ImagePlot
        ; Do nothing.
        
      EndIf
      
    Case #PB_Event_Menu
      ; A menu event has occurred.
      If EventMenu = #MenuNew
        EventWindow = CreatePolygonWindow()
        ResizePolygonWindow(EventWindow)
        PlotPolygon(EventWindow)
        
      ElseIf EventMenu = #MenuClose
        DestroyPolygonWindow(EventWindow)
        
      EndIf
      
    Case #PB_Event_Repaint
      ; A window's content has been invalidated.
      PlotPolygon(EventWindow)
      
    Case #PB_Event_SizeWindow
      ; A window has been resized.
      ResizePolygonWindow(EventWindow)
      PlotPolygon(EventWindow)
      
    Case #PB_Event_CloseWindow
      ; A window has been closed.
      DestroyPolygonWindow(EventWindow)
      
  EndSelect
  
Until EventQuit = #True

;* %#@Reference\ug_pb_any2.html%#@0 *;
*ThisData = ActiveWindows(ThisKey)
*ThisData\ListView ...

;* %#@Reference\ug_pb_any2.html%#@1 *;
If *ThisData\WindowClass <> #WindowClassButton

;* %#@Reference\ug_pb_any2.html%#@2 *;
; Use *EventGadgets\WindowClass to call the correct resize window procedure.
Select *EventGadgets\WindowClass ...

;* %#@Reference\ug_pb_any2.html%#@3 *;
;- Constants
#DateFormat = "%dd/%mm/%yyyy"

;- Enumerations
Enumeration 
  #WindowClassButton = 1
  #WindowClassDate
  #WindowClassTrack
EndEnumeration

; The menu commands will be the same on all the windows.
Enumeration
  #MenuNewButton
  #MenuNewDate
  #MenuNewTrack
  #MenuClose
EndEnumeration

;- Structures
Structure BASEWINDOW
  WindowClass.i 
  Menu.i  
EndStructure

Structure BUTTONWINDOW Extends BASEWINDOW
  ListView.i
  AddButton.i
  RemoveButton.i  
EndStructure

Structure DATEWINDOW Extends BASEWINDOW
  Calendar.i
  AddButton.i
  RemoveButton.i
  ListView.i
EndStructure

Structure TRACKWINDOW Extends BASEWINDOW
  TrackBar1.i
  TrackBar2.i
  Label.i
  Difference.i
EndStructure

;- Variables
; This map will track all the active windows as before, however as the structure for each window class
; differs we will be storing pointers to structures in the map not the gadget references directly.
NewMap ActiveWindows.i()

; These values will be used to give new windows a unique label.
Define.i Buttons, Dates, Tracks

; Event variables.
; Notice the type of *EventGadgets.
Define.i Event, EventWindow, EventGadget, EventType, EventMenu, EventQuit
Define.s EventWindowKey
Define *EventGadgets.BASEWINDOW  

;- Button Window
Procedure.i CreateButtonWindow()
  ; Creates a new Button window and adds it to the tracking map, 
  ; allocates memory for gadget references, creates the gadgets 
  ; and stores these references in the memory structure.
  Shared Buttons, ActiveWindows()
  Protected *ThisData.BUTTONWINDOW
  Protected.i ThisWindow
  Protected.s ThisKey, ThisTitle
  
  ; Set the window caption.
  Buttons + 1
  ThisTitle = "Button Window " + StrU(Buttons)
  
  ; Open the window.
  ThisWindow = OpenWindow(#PB_Any, 30, 30, 225, 300, ThisTitle, #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_MinimizeGadget | #PB_Window_TitleBar)
  
  ; Check that the OpenWindow command worked.
  If ThisWindow
    ; Set minimum window dimensions.
    WindowBounds(ThisWindow, 220, 100, #PB_Ignore, #PB_Ignore)
    
    ; Convert the window reference to a string to use as the map key value.
    ThisKey = StrU(ThisWindow)
    
    ; Allocate memory to store the gadget references in.
    *ThisData = AllocateMemory(SizeOf(BUTTONWINDOW))
  EndIf
  
  ; Check that the memory allocation worked.
  If *ThisData
    ; Store the window reference and memory pointer values in the map.
    ActiveWindows(ThisKey) = *ThisData
    
    ; Set the window class.
    *ThisData\WindowClass = #WindowClassButton
    
    ; Create the menu bar.
    *ThisData\Menu = CreateMenu(#PB_Any, WindowID(ThisWindow))
    
    ; If the menu creation worked, create the menu items.
    If *ThisData\Menu
      MenuTitle("Window")
      MenuItem(#MenuNewButton, "New Button Window")
      MenuItem(#MenuNewDate, "New Date Window")
      MenuItem(#MenuNewTrack, "New Track Window")
      MenuItem(#MenuClose, "Close Window")
    EndIf
    
    ; Create the window gadgets.
    *ThisData\ListView = ListViewGadget(#PB_Any, 10, 10, 200, 225)
    *ThisData\AddButton = ButtonGadget(#PB_Any, 15, 245, 90, 30, "Add")
    *ThisData\RemoveButton = ButtonGadget(#PB_Any, 115, 245, 90, 30, "Remove")
  Else
    ; Memory allocation failed.
    CloseWindow(ThisWindow)
  EndIf
  
  ; Set the return value.
  If ThisWindow > 0 And *ThisData > 0
    ; Return the reference to the new window.
    ProcedureReturn ThisWindow
  Else
    ; Return 0
    ProcedureReturn 0
  EndIf
EndProcedure

Procedure.i DestroyButtonWindow(Window.i)
  ; Remove Window from the ActiveWindows map, release the allocated memory,
  ; close the window and set the quit flag, if appropriate.
  Shared EventQuit, ActiveWindows()
  Protected *ThisData.BUTTONWINDOW
  Protected.s ThisKey
  
  ; Convert the integer Window to a string.
  ThisKey = StrU(Window)
  
  ; Obtain the reference structure pointer.
  *ThisData = ActiveWindows(ThisKey)
  
  ; Check that a valid pointer was obtained, if not stop.
  If *ThisData = 0
    ProcedureReturn #False
  EndIf
  
  ; Check that it is the correct window type, if not stop.
  If *ThisData\WindowClass <> #WindowClassButton
    ProcedureReturn #False
  EndIf
  
  ; Release the memory allocation.
  FreeMemory(*ThisData)
  
  ; Delete the map entry.
  DeleteMapElement(ActiveWindows(), ThisKey)
  
  ; Close the window.
  CloseWindow(Window)
  
  ; Check if there are still open windows.
  If MapSize(ActiveWindows()) = 0
    EventQuit = #True
  EndIf
  
  ; Set the successful return value.
  ProcedureReturn #True
EndProcedure

Procedure.i ResizeButtonWindow(Window.i)
  ; Resize the child gadgets on Window.
  Shared ActiveWindows()
  Protected *ThisData.BUTTONWINDOW
  Protected.i X, Y, W, H
  Protected.s ThisKey
  
  ; Obtain the reference structure pointer.
  ThisKey = StrU(Window)
  *ThisData = ActiveWindows(ThisKey)
  
  ; Check that a valid pointer was obtained, if not stop.
  If *ThisData = 0
    ProcedureReturn #False
  EndIf
  
  ; Check that it is the correct window type, if not stop.
  If *ThisData\WindowClass <> #WindowClassButton
    ProcedureReturn #False
  EndIf
  
  ; Resize list view.
  W = WindowWidth(Window) - 25
  H = WindowHeight(Window) - 85
  ResizeGadget(*ThisData\ListView, #PB_Ignore, #PB_Ignore, W, H)
  
  ; Recenter buttons.
  X = WindowWidth(Window)/2 - 95
  Y = WindowHeight(Window) - 65
  ResizeGadget(*ThisData\AddButton, X, Y, #PB_Ignore, #PB_Ignore)
  
  X = WindowWidth(Window)/2 + 5
  ResizeGadget(*ThisData\RemoveButton, X, Y, #PB_Ignore, #PB_Ignore)
  
  ProcedureReturn #True
EndProcedure

Procedure.i EventsButtonWindow(Window, Gadget, Type)
  ; Handle events for a button window.
  Shared Buttons, ActiveWindows()
  Protected *ThisData.BUTTONWINDOW
  Protected.i NewValue, Index
  Protected.s ThisKey
  
  ; Convert the integer Window to a string.
  ThisKey = StrU(Window)
  
  ; Obtain the reference structure pointer.
  *ThisData = ActiveWindows(ThisKey)
  
  ; Check that a valid pointer was obtained, if not stop.
  If *ThisData = 0
    ProcedureReturn #False
  EndIf
  
  ; Check that it is the correct window type, if not stop.
  If *ThisData\WindowClass <> #WindowClassButton
    ProcedureReturn #False
  EndIf
  
  Select Gadget
    Case *ThisData\AddButton
      NewValue = Random(2147483647)
      AddGadgetItem(*ThisData\ListView, -1, StrU(NewValue))
      
    Case *ThisData\RemoveButton
      Index = GetGadgetState(*ThisData\ListView)
      If Index >= 0 And Index <= CountGadgetItems(*ThisData\ListView)
        RemoveGadgetItem(*ThisData\ListView, Index)
      EndIf
      
    Case *ThisData\ListView
      ; Do nothing.
  EndSelect
EndProcedure

;- Date Window
Procedure.i CreateDateWindow()
  ; Creates a new Date window and adds it to the tracking map, 
  ; allocates memory for gadget references, creates the gadgets 
  ; and stores these references in the memory Structure.
  Shared Dates, ActiveWindows()
  Protected *ThisData.DATEWINDOW
  Protected.i ThisWindow
  Protected.s ThisKey, ThisTitle
  
  Dates + 1
  ThisTitle = "Date Window " + StrU(Dates)
  ThisWindow = OpenWindow(#PB_Any, 30, 30, 310, 420, ThisTitle , #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_MinimizeGadget | #PB_Window_TitleBar)
  
  ; Check that the OpenWindow command worked.
  If ThisWindow
    ; Set minimum window dimensions.
    WindowBounds(ThisWindow, 310, 245, #PB_Ignore, #PB_Ignore)
    
    ; Convert the window reference to a string to use as the map key value.
    ThisKey = StrU(ThisWindow)
    
    ; Allocate memory to store the gadget references in.
    *ThisData = AllocateMemory(SizeOf(DATEWINDOW))
  EndIf
  
  ; Check that the memory allocation worked.
  If *ThisData
    ; Store the window reference and memory pointer values in the map.
    ActiveWindows(ThisKey) = *ThisData
    
    ; Set the window class.
    *ThisData\WindowClass = #WindowClassDate
    
    ; Create the menu bar.
    *ThisData\Menu = CreateMenu(#PB_Any, WindowID(ThisWindow))
    
    ; If the menu creation worked, create the menu items.
    If *ThisData\Menu
      MenuTitle("Window")
      MenuItem(#MenuNewButton, "New Button Window")
      MenuItem(#MenuNewDate, "New Date Window")
      MenuItem(#MenuNewTrack, "New Track Window")
      MenuItem(#MenuClose, "Close Window")
    EndIf
    
    ; Create the window gadgets.
    *ThisData\Calendar = CalendarGadget(#PB_Any, 10, 10, 182, 162)
    *ThisData\AddButton = ButtonGadget(#PB_Any, 210, 10, 90, 30, "Add")
    *ThisData\RemoveButton = ButtonGadget(#PB_Any, 210, 45, 90, 30, "Remove")
    *ThisData\ListView = ListViewGadget(#PB_Any, 10, 187, 290, 200)
  Else
    ; Memory allocation failed.
    CloseWindow(ThisWindow)
  EndIf
  
  ; Set the return value.
  If ThisWindow > 0 And *ThisData > 0 
    ; Return the reference to the new window.
    ProcedureReturn ThisWindow
  Else
    ; Return 0
    ProcedureReturn 0
  EndIf
  
EndProcedure

Procedure.i DestroyDateWindow(Window.i)
  ; Remove Window from the ActiveWindows map, release the allocated memory,
  ; close the window and set the quit flag, if appropriate.
  Shared EventQuit, ActiveWindows()
  Protected *ThisData.DATEWINDOW
  Protected.s ThisKey
  
  ; Convert the integer Window to a string.
  ThisKey = StrU(Window)
  
  ; Obtain the reference structure pointer.
  *ThisData = ActiveWindows(ThisKey)
  
  ; Check that a valid pointer was obtained.
  If *ThisData = 0
    ProcedureReturn #False
  EndIf
  
  ; Check that it is the correct window type, if not stop as this procedure can't destroy this window.
  If *ThisData\WindowClass <> #WindowClassDate
    ProcedureReturn #False
  EndIf
  
  ; Release the memory allocation.
  FreeMemory(*ThisData)
  
  ; Delete the map entry.
  DeleteMapElement(ActiveWindows(), ThisKey)
  
  ; Close the window.
  CloseWindow(Window)
  
  ; Check if there are still open windows.
  If MapSize(ActiveWindows()) = 0
    EventQuit = #True
  EndIf
  
  ; Set the successful return value.
  ProcedureReturn #True
EndProcedure

Procedure.i ResizeDateWindow(Window.i)
  ; Resize the child gadgets on Window.
  Shared ActiveWindows()
  Protected *ThisData.DATEWINDOW
  Protected.i X, Y, W, H
  Protected.s ThisKey
  
  ; Obtain the reference structure pointer.
  ThisKey = StrU(Window)
  *ThisData = ActiveWindows(ThisKey)
  
  ; Check that a valid pointer was obtained, if not stop.
  If *ThisData = 0
    ProcedureReturn #False
  EndIf
  
  ; Check that it is the correct window type, if not stop.
  If *ThisData\WindowClass <> #WindowClassDate
    ProcedureReturn #False
  EndIf
  
  ; Resize list view.
  W = WindowWidth(Window) - 20
  H = WindowHeight(Window) - 220
  ResizeGadget(*ThisData\ListView, #PB_Ignore, #PB_Ignore, W, H)
  
  ProcedureReturn #True
EndProcedure

Procedure.i EventsDateWindow(Window, Gadget, Type)
  ; Handle events for a Date window.
  Shared Buttons, ActiveWindows()
  Protected *ThisData.DATEWINDOW
  Protected.i NewValue, Index
  Protected.s ThisKey
  
  ; Convert the integer Window to a string.
  ThisKey = StrU(Window)
  
  ; Obtain the reference structure pointer.
  *ThisData = ActiveWindows(ThisKey)
  
  ; Check that a valid pointer was obtained, if not stop.
  If *ThisData = 0
    ProcedureReturn #False
  EndIf
  
  ; Check that it is the correct window type, if not stop.
  If *ThisData\WindowClass <> #WindowClassDate
    ProcedureReturn #False
  EndIf
  
  Select Gadget
    Case *ThisData\AddButton
      NewValue = GetGadgetState(*ThisData\Calendar)
      AddGadgetItem(*ThisData\ListView, -1, FormatDate(#DateFormat, NewValue))
      
    Case *ThisData\RemoveButton
      Index = GetGadgetState(*ThisData\ListView)
      If Index >= 0 And Index <= CountGadgetItems(*ThisData\ListView)
        RemoveGadgetItem(*ThisData\ListView, Index)
      EndIf
      
    Case *ThisData\Calendar, *ThisData\ListView
      ; Do nothing.
  EndSelect
EndProcedure

;- Track Window
Procedure.i CreateTrackWindow()
  ; Creates a new Track window and adds it to the tracking map, 
  ; allocates memory for gadget references, creates the gadgets 
  ; and stores these references in the memory Structure.
  Shared Tracks, ActiveWindows()
  Protected *ThisData.TRACKWINDOW
  Protected.i ThisWindow, ThisSum
  Protected.s ThisKey, ThisTitle
  
  Tracks + 1
  ThisTitle = "Track Bar Window " + StrU(Tracks)
  ThisWindow = OpenWindow(#PB_Any, 30, 30, 398, 130, ThisTitle, #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_MinimizeGadget | #PB_Window_TitleBar)
  
  ; Check that the OpenWindow command worked.
  If ThisWindow
    ; Set minimum window dimensions.
    WindowBounds(ThisWindow, 135, 130, #PB_Ignore, 130)
    
    ; Convert the window reference to a string to use as the map key value.
    ThisKey = StrU(ThisWindow)
    
    ; Allocate memory to store the gadget references in.
    *ThisData = AllocateMemory(SizeOf(TRACKWINDOW))
  EndIf
  
  ; Check that the memory allocation worked.
  If *ThisData
    ; Store the window reference and memory pointer values in the map.
    ActiveWindows(ThisKey) = *ThisData
    
    ; Set the window class.
    *ThisData\WindowClass = #WindowClassTrack
    
    ; Create the menu bar.
    *ThisData\Menu = CreateMenu(#PB_Any, WindowID(ThisWindow))
    
    ; If the menu creation worked, create the menu items.
    If *ThisData\Menu
      MenuTitle("Window")
      MenuItem(#MenuNewButton, "New Button Window")
      MenuItem(#MenuNewDate, "New Date Window")
      MenuItem(#MenuNewTrack, "New Track Window")
      MenuItem(#MenuClose, "Close Window")
    EndIf
    
    ; Create the window gadgets.
    *ThisData\TrackBar1 = TrackBarGadget(#PB_Any, 10, 10, 375, 25, 0, 100, #PB_TrackBar_Ticks)
    *ThisData\TrackBar2 = TrackBarGadget(#PB_Any, 10, 40, 375, 25, 0, 100, #PB_TrackBar_Ticks)
    *ThisData\Label = TextGadget(#PB_Any, 10, 75, 80, 25, "Difference:")
    *ThisData\Difference = StringGadget(#PB_Any, 90, 75, 290, 25, "0", #PB_String_ReadOnly)
  Else
    ; Memory allocation failed.
    CloseWindow(ThisWindow)
  EndIf
  
  ; Set the return value.
  If ThisWindow > 0 And *ThisData > 0
    ; Return the reference to the new window.
    ProcedureReturn ThisWindow
  Else
    ; Return 0
    ProcedureReturn 0
  EndIf
EndProcedure

Procedure.i DestroyTrackWindow(Window.i)
  ; Remove Window from the ActiveWindows map, release the allocated memory,
  ; close the window and set the quit flag, if appropriate.
  Shared EventQuit, ActiveWindows()
  Protected *ThisData.DATEWINDOW
  Protected.s ThisKey
  
  ; Convert the integer Window to a string.
  ThisKey = StrU(Window)
  
  ; Obtain the reference structure pointer.
  *ThisData = ActiveWindows(ThisKey)
  
  ; Check that a valid pointer was obtained.
  If *ThisData = 0
    ProcedureReturn #False
  EndIf
  
  ; Check that it is the correct window type, if not stop as this procedure can't destroy this window.
  If *ThisData\WindowClass <> #WindowClassTrack
    ProcedureReturn #False
  EndIf
  
  ; Release the memory allocation.
  FreeMemory(*ThisData)
  
  ; Delete the map entry.
  DeleteMapElement(ActiveWindows(), ThisKey)
  
  ; Close the window.
  CloseWindow(Window)
  
  ; Check if there are still open windows.
  If MapSize(ActiveWindows()) = 0
    EventQuit = #True
  EndIf
  
  ; Set the successful return value.
  ProcedureReturn #True
EndProcedure

Procedure.i ResizeTrackWindow(Window.i)
  ; Resize the child gadgets on Window.
  Shared ActiveWindows()
  Protected *ThisData.TRACKWINDOW
  Protected.i X, Y, W, H
  Protected.s ThisKey
  
  ; Obtain the reference structure pointer.
  ThisKey = StrU(Window)
  *ThisData = ActiveWindows(ThisKey)
  
  ; Check that a valid pointer was obtained, if not stop.
  If *ThisData = 0
    ProcedureReturn #False
  EndIf
  
  ; Check that it is the correct window type, if not stop.
  If *ThisData\WindowClass <> #WindowClassTrack
    ProcedureReturn #False
  EndIf
  
  ; Resize track bars.
  W = WindowWidth(Window) - 20
  ResizeGadget(*ThisData\TrackBar1, #PB_Ignore, #PB_Ignore, W, #PB_Ignore)
  ResizeGadget(*ThisData\TrackBar2, #PB_Ignore, #PB_Ignore, W, #PB_Ignore)
  
  ; Resize string.
  W = WindowWidth(Window) - 110
  ResizeGadget(*ThisData\Difference, #PB_Ignore, #PB_Ignore, W, #PB_Ignore)
  
  ProcedureReturn #True
EndProcedure

Procedure.i EventsTrackWindow(Window, Gadget, Type)
  ; Handle events for a Track window.
  Shared Buttons, ActiveWindows()
  Protected *ThisData.TRACKWINDOW
  Protected.i NewValue
  Protected.s ThisKey
  
  ; Convert the integer Window to a string.
  ThisKey = StrU(Window)
  
  ; Obtain the reference structure pointer.
  *ThisData = ActiveWindows(ThisKey)
  
  ; Check that a valid pointer was obtained, if not stop.
  If *ThisData = 0
    ProcedureReturn #False
  EndIf
  
  ; Check that it is the correct window type, if not stop.
  If *ThisData\WindowClass <> #WindowClassTrack
    ProcedureReturn #False
  EndIf
  
  Select Gadget
    Case *ThisData\TrackBar1, *ThisData\TrackBar2
      NewValue = GetGadgetState(*ThisData\TrackBar1) - GetGadgetState(*ThisData\TrackBar2)
      SetGadgetText(*ThisData\Difference, Str(NewValue))
      
    Case *ThisData\Label, *ThisData\Difference
      ; Do nothing.
  EndSelect
EndProcedure

;- Main

; Create the first window.
EventWindow = CreateButtonWindow()
ResizeButtonWindow(EventWindow)

;- Event loop
Repeat
  Event = WaitWindowEvent()
  EventWindow = EventWindow()
  EventWindowKey = StrU(EventWindow)
  EventGadget = EventGadget()
  EventType = EventType()
  EventMenu = EventMenu()
  *EventGadgets = ActiveWindows(EventWindowKey)
  
  Select Event
    Case #PB_Event_Gadget
      ; Check that a valid pointer was obtained.
      If *EventGadgets > 0
        ; Use *EventGadgets\WindowClass to despatch events to the correct event procedure.
        Select *EventGadgets\WindowClass
          Case #WindowClassButton
            EventsButtonWindow(EventWindow, EventGadget, EventType)
            
          Case #WindowClassDate
            EventsDateWindow(EventWindow, EventGadget, EventType)
            
          Case #WindowClassTrack
            EventsTrackWindow(EventWindow, EventGadget, EventType)
            
          Default
            ; Do nothing
        EndSelect
      EndIf
      
    Case #PB_Event_Menu
      Select EventMenu
        Case #MenuNewButton
          EventWindow = CreateButtonWindow()
          If EventWindow > 0
            ResizeButtonWindow(EventWindow)
          EndIf
          
        Case #MenuNewDate
          EventWindow = CreateDateWindow()
          If EventWindow > 0
            ResizeDateWindow(EventWindow)
          EndIf
          
        Case #MenuNewTrack
          EventWindow = CreateTrackWindow()
          If EventWindow > 0
            ResizeTrackWindow(EventWindow)
          EndIf
          
        Case #MenuClose
          ; Check that a valid pointer was obtained.
          If *EventGadgets > 0
            ; Use *EventGadgets\WindowClass to call the correct destroy window procedure.    
            Select *EventGadgets\WindowClass
              Case #WindowClassButton
                DestroyButtonWindow(EventWindow)
                
              Case #WindowClassDate
                DestroyDateWindow(EventWindow)
                
              Case #WindowClassTrack
                DestroyTrackWindow(EventWindow)
                
              Default
                ; Do nothing
            EndSelect
          EndIf
      EndSelect
      
    Case #PB_Event_CloseWindow
      ; Check that a valid pointer was obtained.
      If *EventGadgets > 0
        ; Use *EventGadgets\WindowClass to call the correct destroy window procedure.
        Select *EventGadgets\WindowClass
          Case #WindowClassButton
            DestroyButtonWindow(EventWindow)
            
          Case #WindowClassDate
            DestroyDateWindow(EventWindow)
            
          Case #WindowClassTrack
            DestroyTrackWindow(EventWindow)
            
          Default
            ; Do nothing
        EndSelect
      EndIf
      
    Case #PB_Event_SizeWindow     
      If *EventGadgets > 0
        ; Use *EventGadgets\WindowClass to call the correct resize window procedure.
        Select *EventGadgets\WindowClass
          Case #WindowClassButton
            ResizeButtonWindow(EventWindow)
            
          Case #WindowClassDate
            ResizeDateWindow(EventWindow)
            
          Case #WindowClassTrack
            ResizeTrackWindow(EventWindow)
            
          Default
            ; Do nothing
        EndSelect
      EndIf
      
  EndSelect
  
Until EventQuit = #True

;* %#@Reference\ug_procedures.html%#@0 *;
; The structure for file information as before.
Structure FILEITEM
  Name.s
  Attributes.i
  Size.q
  DateCreated.i
  DateAccessed.i
  DateModified.i
EndStructure

; This is a constant to identify the window.
Enumeration
  #WindowFiles
EndEnumeration

; This is an enumeration to identify controls that will appear on the window.
Enumeration
  #FolderButton
  #UpdateButton
  #FolderText
  #FilesList
EndEnumeration

Procedure FilesExamine(Folder.s, List Files.FILEITEM())
  ; Obtains file properties from Folder into Files.
  
  Protected.l Result
  
  ; Clear current contents.
  ClearList(Files())
  
  ; Open the directory to enumerate its contents.
  Result = ExamineDirectory(0, Folder, "*.*")  
  
  ; If this is ok, begin enumeration of entries.
  If Result
    ; Loop through until NextDirectoryEntry(0) becomes zero - indicating that there are no more entries.
    While NextDirectoryEntry(0)
      ; If the directory entry is a file, not a folder.
      If DirectoryEntryType(0) = #PB_DirectoryEntry_File
        ; Add a new element to the list.
        AddElement(Files())
        ; And populate it with the properties of the file.
        Files()\Name = DirectoryEntryName(0)
        Files()\Size = DirectoryEntrySize(0)
        Files()\Attributes = DirectoryEntryAttributes(0)
        Files()\DateCreated = DirectoryEntryDate(0, #PB_Date_Created)
        Files()\DateAccessed = DirectoryEntryDate(0, #PB_Date_Accessed)
        Files()\DateModified = DirectoryEntryDate(0, #PB_Date_Modified)
      EndIf
    Wend
    
    ; Close the directory.
    FinishDirectory(0)
  EndIf
  
  ; Sort the list into ascending alphabetical order of file name.
  SortStructuredList(Files(), #PB_Sort_Ascending, OffsetOf(FILEITEM\Name), #PB_String)
EndProcedure

Procedure.s FolderSelect(Folder.s)
  ; Displays a path requester and returns the new path, or the old one if the requester is cancelled.
  Protected.s SelectedPath
  
  SelectedPath = PathRequester("Choose a folder.", Folder)
  
  If SelectedPath = ""
    SelectedPath = Folder
  EndIf
  
  ProcedureReturn SelectedPath
EndProcedure

Procedure LabelUpdate(Folder.s)
  ; Updates the folder label.
  SetGadgetText(#FolderText, Folder)
EndProcedure

Procedure ListLoad(ListView.l, List Files.FILEITEM())
  ; Load the files properties from list Files() into the list view #FilesList.
  Protected.s Access, Attrib, Create, Folder, Modify, Msg, Num, Size
  
  ; Remove previous contents.
  ClearGadgetItems(ListView)
  
  ForEach Files()
    ; Display the item number and file name.
    Num = StrU(ListIndex(Files()) + 1)
    
    ; These lines convert the three date values to something more familiar.
    Create = FormatDate("%dd/%mm/%yyyy", Files()\DateCreated)
    Access = FormatDate("%dd/%mm/%yyyy", Files()\DateAccessed)
    Modify = FormatDate("%dd/%mm/%yyyy", Files()\DateModified)
    
    ; Convert the file size to a padded string the same as with the index value above,
    ; but allow space for the maximum size of a quad.
    Size = StrU(Files()\Size)
    
    ; Convert the attributes to a string, for now.
    Attrib = StrU(Files()\Attributes)
    
    ; Build a row string.  
    ; The Line Feed character 'Chr(10)' tells the gadget to move to the next column.
    Msg = Num + Chr(10) + Files()\Name + Chr(10) + Create + Chr(10) + Access + Chr(10) + Modify + Chr(10) + Attrib + Chr(10) + Size
    
    ; Add the row to the list view gadget.
    AddGadgetItem(#FilesList, -1, Msg)
  Next Files()
EndProcedure

Procedure WindowCreate()
  ; Creates the wdwFiles window.
  Protected Flags
  
  ; This line defines a flag for the window attributes by OR-ing together the desired attribute constants.
  Flags = #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget| #PB_Window_TitleBar
  
  ; Open a window.
  OpenWindow(#WindowFiles, 50, 50, 450, 400, "File Properties", Flags)
  ; A button to choose a folder.
  ButtonGadget(#FolderButton, 5, 5, 100, 30, "Select Folder")
  ; A button to update the list.
  ButtonGadget(#UpdateButton, 112, 5, 100, 30, "Update List")
  ; A text gadget to show the name of the folder.
  TextGadget(#FolderText, 5, 40, 400, 25, "")
  ; A list icon gadget to hold the file list and properties.
  ListIconGadget(#FilesList, 5, 70, 400, 326, "#", 35)
  ; Add columns to the ListIconGadget to hold each property.
  AddGadgetColumn(#FilesList, 1, "Name", 200)
  AddGadgetColumn(#FilesList, 2, "Created", 100)
  AddGadgetColumn(#FilesList, 3, "Accessed", 100)
  AddGadgetColumn(#FilesList, 4, "Modified", 100)
  AddGadgetColumn(#FilesList, 5, "Attributes", 150)
  AddGadgetColumn(#FilesList, 6, "Size", 100)
EndProcedure

Procedure WindowDestroy()
  ; Closes the window.
  ; If necessary, you could do other tidying up jobs here too.
  CloseWindow(#WindowFiles)
EndProcedure

Procedure WindowResize()
  ; Resizes window gadgets to match the window size.
  ResizeGadget(#FolderText, #PB_Ignore, #PB_Ignore, WindowWidth(#WindowFiles) - 10, #PB_Ignore)
  ResizeGadget(#FilesList, #PB_Ignore, #PB_Ignore, WindowWidth(#WindowFiles) - 10, WindowHeight(#WindowFiles) - 74)
EndProcedure

;- Main
; Now we define a list of files using the structure previously specified.
NewList Files.FILEITEM()

; And some working variables to make things happen.
Define.s Folder
Define.l Event, EventWindow, EventGadget, EventType, EventMenu

; This function gets the home directory for the logged on user.
Folder = GetHomeDirectory()

; Create the window and set the initial contents.
WindowCreate()
WindowResize()
LabelUpdate(Folder)
FilesExamine(Folder, Files())
ListLoad(#FilesList, Files())

;- Event Loop
Repeat
  ; Wait until a new window or gadget event occurs.
  Event = WaitWindowEvent()
  EventWindow = EventWindow()
  EventGadget = EventGadget()
  EventType = EventType()
  
  ; Take some action.
  Select Event
    Case #PB_Event_Gadget
      ; A gadget event occurred.
      If EventGadget = #FolderButton
        ; The folder button was clicked.
        Folder = FolderSelect(Folder)
        LabelUpdate(Folder)
        FilesExamine(Folder, Files())
        ListLoad(#FilesList, Files())
        
      ElseIf EventGadget = #UpdateButton
        ; The update button was clicked.
        FilesExamine(Folder, Files())
        ListLoad(#FilesList, Files())
        
      ElseIf EventGadget = #FolderText
        ; Do nothing here.
        
      ElseIf EventGadget = #FilesList
        ; Do nothing here.
        
      EndIf
      
    Case #PB_Event_SizeWindow
      ; The window was moved or resized.
      If EventWindow = #WindowFiles
        WindowResize()  
      EndIf
      
    Case #PB_Event_CloseWindow
      ; The window was closed.
      If EventWindow = #WindowFiles
        WindowDestroy()
        Break
        
      EndIf
  EndSelect
ForEver

;* %#@Reference\ug_string.html%#@0 *;
Define.s String1, String2, String3

String1 = "The quick brown fox jumps over the lazy dog."

; Left returns a number of characters from the left hand end of a string.
; Mid returns a number of characters from the given start location in the middle of a string.
; Right returns a number of characters from the right hand end of a string.
; Space returns the specified number of space characters as a string.
; Shows "The brown dog."
Debug "* Left, Mid and Right"
String2 = Left(String1, 3) + Space(1) + Mid(String1, 11, 5) + Space(1) + Right(String1, 4)
Debug String2

; CountString returns the number of instances of the second string in the first string, it is case sensitive.
; Shows 1.
Debug "* CountString"
Debug CountString(String1, "the")

; However the LCase (and UCase) functions can be used to switch a string to all lower (or upper) case
; Shows 2
Debug "* CountString and LCase"
String2 = LCase(String1)
Debug CountString(String2, "the")

; FindString can be used to find the location of one string within another.
; Shows 17.
Debug "* FindString"
Debug FindString(String1, "fox")

; RemoveString can be used to remove one string from within another.
; Shows The quick fox jumps over the lazy dog.
Debug "* RemoveString"
String2 = RemoveString(String1, " brown")
Debug String2

; ReplaceString can be used to change the occurrence of a substring within another string.
; Shows The quick brown fox jumps over the sleeping dog.
Debug "* ReplaceString"
String2 = ReplaceString(String1, "lazy", "sleeping")
Debug String2

; StringByteLength returns the length of a string in bytes in the specified format, or the current default
; if one is not specified (excluding the terminating null).
Debug "* StringByteLength"
; Shows 44.
Debug StringByteLength(String1, #PB_Ascii)
; Shows 88.
Debug StringByteLength(String1, #PB_Unicode)

; StringField can be used to obtain an indexed substring from a target string. 
; Useful for converting strings to lists for example.
; StringField will work with space as a delimiter too 
; but hopefully this example makes the functions behaviour more apparent.
; Shows jumps.
Debug "* StringField"
String2 = ReplaceString(String1, " ", "\")
Debug String2
String3 = StringField(String2, 5, "\")
Debug String3

; Trim removes white space characters from the start and end of a given string.
; Similarly, LTrim acts on the left hand end (start) of a string and RTrim the right hand end.
Debug "* Trim, LTrim and RTrim"
String2 = Space(10) + String1 + Space(8)
Debug #DQUOTE$ + String2 + #DQUOTE$
String3 = Trim(String2)
Debug #DQUOTE$ + String3 + #DQUOTE$
String3 = LTrim(String2)
Debug #DQUOTE$ + String3 + #DQUOTE$
String3 = RTrim(String2)
Debug #DQUOTE$ + String3 + #DQUOTE$

; LSet sets a string to be a specific length from the left hand end, padding with spaces, 
; or other specified character, as necessary.
; If the string is already longer than the specified length it will be truncated.
Debug "*LSet"
Debug LSet("Abc", 10, "*")
Debug LSet("Abcd", 10, "*")
Debug LSet("Abcde", 10, "*")

; Similarly RSet pads a string from its right hand end.
Debug "* RSet"
Debug RSet("1.23", 10, "0")
Debug RSet("10.23", 10, "0")
Debug RSet("100.23", 10, "0")

; Str converts a signed quad value to a string, similarly StrF converts floats, 
; StrD converts doubles and StrU converts unsigned values, these two function have an optional 
; parameter to specify the number of decimal places to show.
Debug "* Str, StrF and StrD"
Debug Str(100)
Debug StrF(1.234, 3)
Debug StrD(123456.789, 3)

; Val will convert a string value into its numeric (quad) equivalent.
; ValD and ValF perform the same function for floats and doubles.
Debug "* Val"
Debug Val("123")

; Bin will convert a numeric value into its binary equivalent.
; Hex will convert one into its hexadecimal equivalent.
Debug "* Bin and Hex"
Debug Bin(19)
Debug Hex(19)

;* %#@Reference\ug_textoutput.html%#@0 *;
...

; Now we define a new list of files using the structure previously specified 
NewList Files.FILEITEM()
Define.s Access, Attrib, Create, Folder, Modify, Msg, Num, Size
Define.l Result

...

;* %#@Reference\ug_textoutput.html%#@1 *;
; If there are some entries in the list, show the results in the debug window.
...

;* %#@Reference\ug_tips.html%#@0 *;
EnableExplicit

; A book catalog structure.
Structure BOOK
  Title.s
  Author.s
  ISBN13.s
  Price.d
EndStructure

; Create a list to hold the catalog entries.
NewList Catalog.BOOK()
; Create a map to hold the ISBN index.
NewMap ISBN13.l()
; Working variables.
Define.l Count, Index
Define.s ISBN

; Add an empty element at the top of the list.
; The first element in a list is numbered zero, however the map will return zero if a requested entry isn't present.
; This empty element avoids a potential problem with an incorrect reference to the first catalog item being returned.
AddElement(Catalog())

For Count = 1 To 5
  
  ; Read the data from the table into the list.
  AddElement(Catalog())
  Read.s Catalog()\Title
  Read.s Catalog()\Author
  Read.s Catalog()\ISBN13
  Read.d Catalog()\Price
  
  ; Index the ISBN to the map.
  ISBN13(Catalog()\ISBN13) = ListIndex(Catalog())
  
Next Count

; Find an entry.
ISBN = "978-0340896983"
Index = ISBN13(ISBN)

If Index > 0
  Debug "Book with ISBN13 " + ISBN + " is at list index " + StrU(Index) + "."
  Debug ""
  
  ; We can now directly select the right list element without having to perform a search.
  SelectElement(Catalog(), Index)
  Debug "'" + Catalog()\Title + "' by " + Catalog()\Author
  Debug "ISBN: " + Catalog()\ISBN13
  Debug "Price: " + StrD(Catalog()\Price, 2)
  
Else
  Debug "No book with that ISBN in the catalog."
  
EndIf

End

; Some test data.
DataSection
  
  BookData:
  
  Data.s "Carte Blanche", "Jeffery Deaver", "978-1444716474"
  Data.d 19.99
  
  Data.s "One Day", "David Nicholls", "978-0340896983"
  Data.d 7.99
  
  Data.s "Madeleine", "Kate McCann", "978-0593067918"
  Data.d 20.00
  
  Data.s "The Dukan Diet", "Dr Pierre Dukan", "978-1444710335"
  Data.d 8.99
  
  Data.s "A Game of Thrones", "George R. R. Martin", "978-0006479888"
  Data.d 9.99
  
  Data.s "The Help", "Kathryn Stockett", "978-0141039282"
  Data.d 8.99
  
EndDataSection

;* %#@Reference\ug_variables.html%#@0 *;
A = 0

;* %#@Reference\ug_variables.html%#@1 *;
Define B.l, C.f

;* %#@Reference\ug_variables.html%#@2 *;
Define.l D = 10, E = 20

;* %#@Reference\ug_variables.html%#@3 *;
Define.s F

;* %#@Reference\ug_variables.html%#@4 *;
G$ = "Hello, "

;* %#@Reference\ug_variables.html%#@5 *;
G = "Goodbye, World!"

;* %#@Reference\ug_variables.html%#@6 *;
Dim H.s(19)

;* %#@Reference\ug_variables.html%#@7 *;
ReDim H.s(24)

;* %#@Reference\ug_variables.html%#@8 *;
Global.i J

;* %#@Reference\ug_variables.html%#@9 *;
NewList K.s()

;* %#@Reference\ug_variables.html%#@10 *;
NewMap M.s()

;* %#@Reference\ug_variables.html%#@11 *;
Procedure TestVariables()
    
    ; N and P will be local.
    Define.l N
    Protected.l P
    
    ; Q will be a static local.
    Static.l Q
    
    ; The main scope variable F and the string list K will be available within this procedure.
    Shared F, K()
    
    ; The global scope variable J will be available here implicitly.
    
EndProcedure

;* %#@Reference\ug_variables.html%#@12 *;
; Add two to A.
A + 2

; Bitwise Or with 21 (A will become 23)
A | 21

; Bitwise And with 1 (A will become 1)
A & 1

; Arithmetic shift left (A will become 2, that is 10 in binary).
A << 1

;* %#@Reference\ug_variables.html%#@13 *;
G$ + "World!"

;* %#@Reference\ug_variables.html%#@14 *;
AddElement(K())
K() = "List element one"

;* %#@Reference\ug_variables.html%#@15 *;
M("one") = "Map element one"

;* %#@Reference\variables.html%#@0 *;
a.b         ; Declare a variable called 'a' from byte (.b) type.
c.l = a*d.w ; 'd' is declared here within the expression and it's an integer !

;* %#@Reference\variables.html%#@1 *;
a.s = "One string"
a$ = "Another string"
Debug a   ; will give "One string"
Debug a$  ; will give "Another string"

;* %#@Reference\variables.html%#@2 *;
value.d = 123.5e-20
Debug value   ; will give 0.000000000000000001235

;* %#@Reference\variables.html%#@11 *;
Value + 1  ; The same as: Value = Value + 1
Value * 2  ; The same as: Value = Value * 2
Value << 1 ; The same as: Value = Value << 1

;* %#@Reference\variables.html%#@12 *;
Dim MyArray(10)
MyArray(Random(10)) + 1 ; The same as: MyArray(Random(10)) = MyArray(Random(10)) + 1, but here Random() won't return the same value for each call.

;* %#@Reference\while_wend.html%#@1 *;
b = 0
a = 10
While a = 10 
  b = b+1 
  If b=10 
    a=11 
  EndIf 
Wend 

;* %#@Reference\winmessages.html%#@0 *;
While WindowEvent() : Wend

;* %#@Reference\winmessages.html%#@1 *;
WindowEvent()

;* %#@Reference\winmessages.html%#@2 *;
While WindowEvent() : Wend

;* %#@Reference\winmessages.html%#@3 *;
Repeat : Until WindowEvent() = 0

;* %#@Reference\with_endwith.html%#@1 *;
Structure Person
  Name$
  Age.l
  Size.l
EndStructure

Friend.Person

With Friend
  \Name$ = "Yann"
  \Age   = 30
  \Size  = 196
  
  Debug \Size+\Size
EndWith


;* %#@Reference\with_endwith.html%#@2 *;
Structure Body
  Weight.l
  Color.l
  Texture.l
EndStructure

Structure Person
  Name$
  Age.l
  Body.Body[10]
EndStructure

Friend.Person

For k = 0 To 9
  With Friend\Body[k]
    \Weight = 50
    \Color  = 30
    \Texture = \Color*k
    
    Debug \Texture
  EndWith
Next


;* %#@RegularExpression\CreateRegularExpression.html%#@1 *;
; This expression will match every word of 3 letter which begin by a lower case letter,
; followed with the character 'b' and which ends with an uppercase letter. ex: abC
;    
If CreateRegularExpression(0, "[a-z]b[A-Z]")
  Debug MatchRegularExpression(0, "abC") ; Will print 1
  Debug MatchRegularExpression(0, "abc") ; Will print 0
Else
  Debug RegularExpressionError()
EndIf


;* %#@RegularExpression\ExamineRegularExpression.html%#@0 *;
; This expression will match every word of 3 letter which begin by a lower case letter,
; followed with the character 'b' and which ends with an uppercase letter. ex: abC
; Each match is printed with its position in the original string.
;    
If CreateRegularExpression(0, "[a-z]b[A-Z]")
  If ExamineRegularExpression(0, "abC ABc zbA abc")
    While NextRegularExpressionMatch(0)
      Debug "Match: " + RegularExpressionMatchString(0)
      Debug "    Position: " + Str(RegularExpressionMatchPosition(0))
      Debug "    Length: " + Str(RegularExpressionMatchLength(0))
    Wend
  EndIf
Else
  Debug RegularExpressionError()
EndIf

;* %#@RegularExpression\ExtractRegularExpression.html%#@0 *;
; This expression will match every word of 3 letter which begin by a lower case letter,
; followed with the character 'b' and which ends with an uppercase letter. ex: abC
;    
If CreateRegularExpression(0, "[a-z]b[A-Z]")
  Dim Result$(0)
  NbFound = ExtractRegularExpression(0, "abC ABc zbA abc", Result$())
  For k = 0 To NbFound-1
    Debug Result$(k)
  Next
Else
  Debug RegularExpressionError()
EndIf

;* %#@RegularExpression\MatchRegularExpression.html%#@0 *;
; This expression will match every word of 3 letter which begin by a lower case letter,
; followed with the character 'b' and which ends with an uppercase letter. ex: abC
;    
If CreateRegularExpression(0, "[a-z]b[A-Z]")
  If MatchRegularExpression(0, "abC ABc zbA abc")
    Debug "The string match !"
  Else
    Debug "No pattern found in the string"
  EndIf
Else
  Debug RegularExpressionError()
EndIf

;* %#@RegularExpression\RegularExpressionError.html%#@0 *;
; Here we put an extra bracket '[', so there is a syntax error in the regular expression
;    
If CreateRegularExpression(0, "[a-z]b[[A-Z][]")
  Debug "Success"
Else
  Debug RegularExpressionError()
EndIf

;* %#@RegularExpression\RegularExpressionGroup.html%#@0 *;
; This expression matches a color setting string (with value red, green or blue)
; The colors are grouped with () and the color value is extracted in case of a match
;  
If CreateRegularExpression(0, "color=(red|green|blue)")
  If ExamineRegularExpression(0, "stype=bold, color=blue, margin=50")
    While NextRegularExpressionMatch(0)
      Debug "The color is " + RegularExpressionGroup(0, 1)
    Wend
  EndIf
Else
  Debug RegularExpressionError()
EndIf

;* %#@RegularExpression\RegularExpressionNamedGroup.html%#@0 *;
; This expression matches a color setting string (with value red, green or blue)
; The colors are grouped with () which has the name "col" assigned to it.
; This color name is then extracted
;  
If CreateRegularExpression(0, "color=(?<col>red|green|blue)")
  If ExamineRegularExpression(0, "stype=bold, color=blue, margin=50")
    While NextRegularExpressionMatch(0)
      Debug "The color is " + RegularExpressionNamedGroup(0, "col")
    Wend
  EndIf
Else
  Debug RegularExpressionError()
EndIf

;* %#@Requester\ColorRequester.html%#@0 *;
Color = ColorRequester()
If Color > -1
  a$ = "You have selected following color value:" + Chr(10)  ; Chr(10) only needed
  a$ + "24 Bit value: " + Str(Color)              + Chr(10)  ; for line-feed
  a$ + "Red value:    " + Str(Red(Color))         + Chr(10)
  a$ + "Green value:  " + Str(Green(Color))       + Chr(10)
  a$ + "Blue value:   " + Str(Blue(Color))
Else  
  a$ = "The requester was canceled."
EndIf
MessageRequester("Information", a$, 0)
End

;* %#@Requester\FontRequester.html%#@1 *;
FontName$ = "Arial"   ; set initial font  (could also be blank)
FontSize  = 14        ; set initial size  (could also be null)
Result = FontRequester(FontName$, FontSize, #PB_FontRequester_Effects)
If Result
  Message$ = "You have selected following font:"  + #LF$ 
  Message$ + "Name:  " + SelectedFontName()       + #LF$
  Message$ + "Size:  " + Str(SelectedFontSize())  + #LF$
  Message$ + "Color: " + Str(SelectedFontColor()) + #LF$
  If SelectedFontStyle() & #PB_Font_Bold
    Message$ + "Bold" + #LF$
  EndIf
  If SelectedFontStyle() & #PB_Font_StrikeOut
    Message$ + "StrikeOut" + #LF$
  EndIf
  If SelectedFontStyle() & #PB_Font_Underline
    Message$ + "Underline" + #LF$
  EndIf
Else 
  Message$ = "The requester was canceled."
EndIf

MessageRequester("FontRequester", Message$, #PB_MessageRequester_Ok) 

;* %#@Requester\InputRequester.html%#@1 *;
Input$ = InputRequester("Title", "Please make your input:", "I'm the default input.")

If Input$ > ""
  a$ = "You entered in the requester:" + Chr(10)  ; Chr(10) only needed
  a$ + Input$                                     ; for line-feed
Else  
  a$ = "The requester was canceled or there was nothing entered."
EndIf
MessageRequester("Information", a$, 0)

;* %#@Requester\MessageRequester.html%#@3 *;
; Simple MessageRequester  (normally used for information purposes only)
; (result will be always the same, so we don't check it here)
MessageRequester("Information", "Just a short information text.", #PB_MessageRequester_Ok | #PB_MessageRequester_Info)

; MessageRequester with Yes / No buttons  (normally used for questions)
; (result will be shown in the following information requester)
Result = MessageRequester("Title", "Please make your input:", #PB_MessageRequester_YesNo)
a$ = "Result of the previously requester was: "
If Result = #PB_MessageRequester_Yes    ; pressed Yes button (Result = 6)
  a$ + "Yes"
Else                                    ; pressed No button (Result = 7)
  a$ + "No"
EndIf
MessageRequester("Information", a$, #PB_MessageRequester_Ok)

; MessageRequester with Yes / No / Cancel buttons  (normally used for questions)
; (result will be shown in the following information requester)
Result = MessageRequester("Title", "Please make your input:", #PB_MessageRequester_YesNoCancel) 
a$ = "Result of the previously requester was: "
If Result = #PB_MessageRequester_Yes       ; pressed Yes button
  a$ + "Yes"
ElseIf Result = #PB_MessageRequester_No    ; pressed No button
  a$ + "No"
Else                                       ; pressed Cancel button or Esc
  a$ + "Cancel"
EndIf
MessageRequester("Information", a$, #PB_MessageRequester_Ok)

;* %#@Requester\NextSelectedFilename.html%#@0 *;
Filename$ = OpenFileRequester("Choose some files","","",0, #PB_Requester_MultiSelection)

While Filename$ 
  Debug Filename$ 
  Filename$ = NextSelectedFileName() 
Wend 

;* %#@Requester\OpenFileRequester.html%#@1 *;
StandardFile$ = "C:\autoexec.bat"   ; set initial file+path to display
                                    ; With next string we will set the search patterns ("|" as separator) for file displaying:
                                    ;  1st: "Text (*.txt)" as name, ".txt" and ".bat" as allowed extension
                                    ;  2nd: "PureBasic (*.pb)" as name, ".pb" as allowed extension
                                    ;  3rd: "All files (*.*) as name, "*.*" as allowed extension, valid for all files
Pattern$ = "Text (*.txt)|*.txt;*.bat|PureBasic (*.pb)|*.pb|All files (*.*)|*.*"
Pattern = 0    ; use the first of the three possible patterns as standard
File$ = OpenFileRequester("Please choose file to load", StandardFile$, Pattern$, Pattern)
If File$
  MessageRequester("Information", "You have selected following file:" + Chr(10) + File$, 0)
Else
  MessageRequester("Information", "The requester was canceled.", 0) 
EndIf

;* %#@Requester\PathRequester.html%#@0 *;
InitialPath$ = "C:\"   ; set initial path to display (could also be blank)
Path$ = PathRequester("Please choose your path", InitialPath$)
If Path$
  MessageRequester("Information", "You have selected following path:"+Chr(10)+Path$, 0)
Else
  MessageRequester("Information", "The requester was canceled.", 0) 
EndIf

;* %#@Requester\SaveFileRequester.html%#@0 *;
StandardFile$ = "C:\autoexec.bat"   ; set initial file+path to display
                                    ; With next string we will set the search patterns ("|" as separator) for file displaying:
                                    ;  1st: "Text (*.txt)" as name, ".txt" and ".bat" as allowed extension
                                    ;  2nd: "PureBasic (*.pb)" as name, ".pb" as allowed extension
                                    ;  3rd: "All files (*.*) as name, "*.*" as allowed extension, valid for all files
Pattern$ = "Text (*.txt)|*.txt;*.bat|PureBasic (*.pb)|*.pb|All files (*.*)|*.*"
Pattern = 0    ; use the first of the three possible patterns as standard
File$ = SaveFileRequester("Please choose file to save", StandardFile$, Pattern$, Pattern)
If File$
  MessageRequester("Information", "You have selected following file:"+Chr(10)+File$, 0)
Else
  MessageRequester("Information", "The requester was canceled.", 0) 
EndIf

;* %#@Requester\SelectedFilePattern.html%#@0 *;
StandardFile$ = "C:\autoexec.bat"        ; initial path + file
Pattern$ = "Text (*.txt)|*.txt;*.bat|"   ; set first pattern  (index = 0)
Pattern$ + "PureBasic (*.pb)|*.pb|"      ; set second pattern (index = 1)
Pattern$ + "Bmp (*.bmp)|*.bmp|"          ; set third pattern  (index = 2)
Pattern$ + "Jpeg (*.jpg)|*.jpg|"         ; set fourth pattern (index = 3)
Pattern$ + "All files (*.*)|*.*"         ; set fifth pattern  (index = 4)
Pattern = 1                              ; use the second of the five possible patterns as standard

; Now we open a filerequester, you can change the pattern and will get the index after closing
File$ = OpenFileRequester("Please choose file to load", StandardFile$, Pattern$, Pattern)
Index = SelectedFilePattern()
If Index > -1
  MessageRequester("Information", "Following pattern index was selected: "+Str(Index), 0)
Else
  MessageRequester("Information", "The requester was canceled.", 0)
EndIf

;* %#@Requester\SelectedFontStyle.html%#@1 *;
If SelectedFontStyle() & #PB_Font_Bold
  ; The font is bold
EndIf

;* %#@Scintilla\ScintillaGadget.html%#@0 *;

Procedure ScintillaCallBack(Gadget, *scinotify.SCNotification)
  ; You code here
EndProcedure


;* %#@Scintilla\ScintillaGadget.html%#@2 *;
If OpenWindow(0, 0, 0, 330, 90, "ScintillaGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  
  If InitScintilla()
    ScintillaGadget(0, 10, 10, 320, 70, 0)
    
    ; Output set to red color
    ScintillaSendMessage(0, #SCI_STYLESETFORE, 0, RGB(255, 0, 0))
    
    ; Set the initial text to the ScintillaGadget
    ScintillaSendMessage(0, #SCI_SETTEXT, 0, UTF8("This is a simple ScintillaGadget with text..."))
    
    ; Adding a second line of text with linebreak before
    Text$ = Chr(10) + "Second line"
    ScintillaSendMessage(0, #SCI_APPENDTEXT, Len(Text$), UTF8(Text$))
  EndIf
  
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Screen\ChangeGamma.html%#@0 *;
ChangeGamma(255, 255, 0)   ; Will remove completely the blue channel from the screen

;* %#@Screen\NextScreenMode.html%#@0 *;
InitSprite()

If ExamineScreenModes()
  While NextScreenMode()
    Debug Str(ScreenModeWidth())+"x"+Str(ScreenModeHeight())+"x"+Str(ScreenModeDepth())+"@"+Str(ScreenModeRefreshRate())+"Hz"
  Wend
EndIf

;* %#@Screen\OpenScreen.html%#@0 *;
16: 65000 colors, fixed palette
24: 16 Mo colors, fixed palette
32: 16 Mo colors, faster than 24-bit mode, allows alpha blending

;* %#@Screen\OpenWindowedScreen.html%#@1 *;
If InitSprite() = 0
  MessageRequester("Error", "Can't open screen & sprite environment!", 0)
  End
EndIf

If OpenWindow(0, 0, 0, 220, 160, "A screen in a window...", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ButtonGadget(0, 170, 135, 45, 20, "Quit")
  
  If OpenWindowedScreen(WindowID(0), 0, 0, 160, 160)
    CreateSprite(0, 20, 20)
    If StartDrawing(SpriteOutput(0))
      Box(0, 0, 20, 20, RGB(255, 0, 155))
      Box(5, 5, 10, 10, RGB(155, 0, 255))
      StopDrawing()
    EndIf
  Else
    MessageRequester("Error", "Can't open windowed screen!", 0)
    End
  EndIf
EndIf

direction = 2
Repeat
  ; It's very important to process all the events remaining in the queue at each frame
  ;
  Repeat
    Event = WindowEvent()
    
    Select Event 
      Case #PB_Event_Gadget
        If EventGadget() = 0
          End
        EndIf
        
      Case #PB_Event_CloseWindow
        End 
    EndSelect
  Until Event = 0
  
  FlipBuffers() 
  ClearScreen(RGB(0, 0, 0))
  DisplaySprite(0, x, x)
  x + direction
  If x > 140 : direction = -2 : EndIf
  If x < 0   : direction =  2 : EndIf
  Delay(1)
ForEver

;* %#@Screen\OpenWindowedScreen.html%#@2 *;
If InitSprite() = 0
  MessageRequester("Error", "Can't open screen & sprite environment!", 0)
  End
EndIf

If OpenWindow(0, 0, 0, 420, 200, "A screen in a window...", #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_ScreenCentered)
  CreateStatusBar(0, WindowID(0))
  AddStatusBarField(420)
  
  StatusBarText(0, 0, "Automatically zoomed screen area when changing window size...")
  
  If OpenWindowedScreen(WindowID(0), 0, 0, 420, 200, #True, 0, 20)
    
    CreateSprite(0, 50, 50) ; Create an empty sprite, will be whole black
    
    Repeat
      ; It's very important to process all the events remaining in the queue at each frame
      ;
      Repeat
        Event = WaitWindowEvent(10)
        
        If Event = #PB_Event_CloseWindow
          End
        EndIf
      Until Event = 0
      
      FlipBuffers()
      ClearScreen(RGB(0, 0, 200)) ; A blue background
      
      DisplaySprite(0, 10, 10)  ; Display our black box at the left-top corner
      DisplaySprite(0, 260, 10) ; Display our black box at the right-top corner
    ForEver
    
  Else
    MessageRequester("Error", "Can't open windowed screen!", 0)
  EndIf
EndIf

;* %#@Screen\ScreenOutput.html%#@0 *;
StartDrawing(ScreenOutput())
; do some drawing stuff here...
StopDrawing()

;* %#@SerialPort\OpenSerialPort.html%#@0 *;
50, 75, 110, 150, 300, 600, 1200, 1800, 2400
4800, 9600, 19200, 38400, 57600 Or 115200

;* %#@SerialPort\OpenSerialPort.html%#@3 *;
If OpenSerialPort(0, "COM1", 300, #PB_SerialPort_NoParity, 8, 1, #PB_SerialPort_NoHandshake, 1024, 1024)
  Debug "Success"
Else
  Debug "Failed"
EndIf

;* %#@SerialPort\SetSerialPortStatus.html%#@1 *;
If OpenSerialPort(0, "COM1", 300, #PB_SerialPort_NoParity, 8, 1, #PB_SerialPort_XonXoffHandshake, 1024, 1024)
  SetSerialPortStatus(0, #PB_SerialPort_XonCharacter, 8)
  SetSerialPortStatus(0, #PB_SerialPort_XoffCharacter, 9)
  Debug "Success"
Else
  Debug "Failed"
EndIf

;* %#@Sort\SortStructuredArray.html%#@2 *;

Structure Animal
  Name$
  Speed.l
EndStructure

Dim Animals.Animal(2)

Animals(0)\Name$ = "Tiger"
Animals(0)\Speed = 10

Animals(1)\Name$ = "Jaguar"
Animals(1)\Speed = 40

Animals(2)\Name$ = "Zebra"
Animals(2)\Speed = 30

SortStructuredArray(Animals(), 0, OffsetOf(Animal\Name$), TypeOf(Animal\Name$))

For k=0 To 2
  Debug Animals(k)\Name$+" - Speed: "+Str(Animals(k)\Speed)
Next

SortStructuredArray(Animals(), 0, OffsetOf(Animal\Speed), TypeOf(Animal\Speed))

For k=0 To 2
  Debug Animals(k)\Name$+" - Speed: "+Str(Animals(k)\Speed)
Next


;* %#@Sort\SortStructuredList.html%#@2 *;

Structure Animal
  Name$
  Speed.l
EndStructure

NewList Animals.Animal()

AddElement(Animals())
Animals()\Name$ = "Tiger"
Animals()\Speed = 10

AddElement(Animals())
Animals()\Name$ = "Jaguar"
Animals()\Speed = 40

AddElement(Animals())
Animals()\Name$ = "Zebra"
Animals()\Speed = 30

SortStructuredList(Animals(), 0, OffsetOf(Animal\Name$), TypeOf(Animal\Name$))

ForEach Animals()
  Debug Animals()\Name$+" - Speed: "+Str(Animals()\Speed)
Next

SortStructuredList(Animals(), 0, OffsetOf(Animal\Speed), TypeOf(Animal\Speed))

ForEach Animals()
  Debug Animals()\Name$+" - Speed: "+Str(Animals()\Speed)
Next


;* %#@Sound\CatchSound.html%#@1 *;
CatchSound(0, ?Music)
End

DataSection
Music: 
IncludeBinary "Sound.wav"

;* %#@Sound\FreeSound.html%#@0 *;
InitSound()           ; Initialize Sound system
UseOGGSoundDecoder()  ; Use ogg files

; Loads a sound from a file
LoadSound(0, #PB_Compiler_Home +"Examples\3D\Data\Siren.ogg")
; The sound is playing 
PlaySound(0, #PB_Sound_Loop)

MessageRequester("Info", "Ok to stop.")

FreeSound(0) ; The sound is freed
End

;* %#@Sound\GetSoundFrequency.html%#@0 *;
InitSound()           ; Initialize Sound system
UseOGGSoundDecoder()  ; Use ogg files

; Loads a sound from a file
LoadSound(0, #PB_Compiler_Home +"Examples\3D\Data\Siren.ogg")
; The sound is playing
PlaySound(0, #PB_Sound_Loop, 20)

MessageRequester("Info", "The average frequency is " + Str(GetSoundFrequency(0))+" Hz")

MessageRequester("Info", "Ok to stop.")

FreeSound(0) ; The sound is freed
End

;* %#@Sound\GetSoundPosition.html%#@1 *;
InitSound()           ; Initialize Sound system
UseOGGSoundDecoder()  ; Use ogg files

; Loads 2 sounds
LoadSound(0, #PB_Compiler_Home +"Examples\3D\Data\Siren.ogg")
LoadSound(1, #PB_Compiler_Home +"Examples\3D\Data\Roar.ogg")

; The siren is playing 
PlaySound(0)

; Display the position
Repeat
  Pos=GetSoundPosition(0, #PB_Sound_Millisecond)
  Delay(100)   ; Wait 100 ms
  Debug Pos    ; Display the position
  If Pos>1000  ; Stop after 1 second
    Break
  EndIf
ForEver

; Then 2 sounds are playing together
PlaySound(1)

MessageRequester("Info", "Ok to stop.") 
End 

;* %#@Sound\IsSound.html%#@0 *;
If IsSound(0) = 0
  MessageRequester("Info", "The sound is not valid.") 
EndIf

;* %#@Sound\LoadSound.html%#@1 *;
InitSound()           ; Initialize Sound system
UseOGGSoundDecoder()  ; Use ogg files

; Loads a sound from a file
LoadSound(0, #PB_Compiler_Home +"Examples\3D\Data\Siren.ogg")
; The sound is playing
PlaySound(0, #PB_Sound_Loop)

MessageRequester("Info", "Ok to stop.")

FreeSound(0) ; The sound is freed
End

;* %#@Sound\PauseSound.html%#@0 *;
InitSound()           ; Initialize Sound system
UseOGGSoundDecoder()  ; Use ogg files

; Loads a sound from a file
LoadSound(0, #PB_Compiler_Home +"Examples\3D\Data\Siren.ogg")
; The sound is playing
PlaySound(0, #PB_Sound_Loop)

MessageRequester("Info", "Ok to pause.")
PauseSound(0)  ; Pause

MessageRequester("Info", "Ok to resume.")
ResumeSound(0)  ; Resume

MessageRequester("Info", "Ok to stop.")

FreeSound(0) ; The sound is freed
End

;* %#@Sound\PlaySound.html%#@1 *;
InitSound()           ; Initialize Sound system
UseOGGSoundDecoder()  ; Use ogg files

; Loads a sound from a file
LoadSound(0, #PB_Compiler_Home +"Examples\3D\Data\Siren.ogg")
; The sound is playing
PlaySound(0, #PB_Sound_Loop, 20)

MessageRequester("Info", "Ok to stop.")

FreeSound(0) ; The sound is freed
End

;* %#@Sound\ResumeSound.html%#@0 *;
InitSound()           ; Initialize Sound system
UseOGGSoundDecoder()  ; Use ogg files

; Loads a sound from a file
LoadSound(0, #PB_Compiler_Home +"Examples\3D\Data\Siren.ogg")
; The sound is playing
PlaySound(0, #PB_Sound_Loop)

MessageRequester("Info", "Ok to pause.")
PauseSound(0)  ; Pause

MessageRequester("Info", "Ok to resume.")
ResumeSound(0)  ; Resume

MessageRequester("Info", "Ok to stop.")

FreeSound(0) ; The sound is freed
End

;* %#@Sound\SetSoundFrequency.html%#@0 *;
InitSound()           ; Initialize Sound system
UseOGGSoundDecoder()  ; Use ogg files

; Loads a sound from a file
LoadSound(0, #PB_Compiler_Home +"Examples\3D\Data\Siren.ogg")
; The sound is playing
PlaySound(0, #PB_Sound_Loop, 20)

MessageRequester("Info", "The average frequency is " + Str(GetSoundFrequency(0))+" Hz")
PauseSound(0)

SetSoundFrequency(0,16000)

ResumeSound(0)

MessageRequester("Info", "The average frequency is " + Str(GetSoundFrequency(0))+" Hz")

FreeSound(0) ; The sound is freed
End

;* %#@Sound\SetSoundPosition.html%#@1 *;
InitSound()           ; Initialize Sound system
UseOGGSoundDecoder()  ; Use ogg files

; Loads a sound from a file
LoadSound(0, #PB_Compiler_Home +"Examples\3D\Data\Siren.ogg")

; The is playing
PlaySound(0)

; Change the position at 2 seconds
SetSoundPosition(0, 2000, #PB_Sound_Millisecond)

MessageRequester("Info", "Ok to stop.") 
End 

;* %#@Sound\SoundLength.html%#@1 *;
InitSound()           ; Initialize Sound system
UseOGGSoundDecoder()  ; Use ogg files

; Loads a sound from a file
LoadSound(0, #PB_Compiler_Home +"Examples\3D\Data\Siren.ogg")
; The sound is playing
PlaySound(0, #PB_Sound_Loop, 20)

MessageRequester("Info", "The length of the sound is "+ Str(SoundLength(0)) + " frames.")

MessageRequester("Info", "The length of the sound is "+ Str(SoundLength(0, #PB_Sound_Millisecond)) + " ms.")

FreeSound(0) ; The sound is freed
End

;* %#@Sound\SoundPan.html%#@0 *;
InitSound()           ; Initialize Sound system
UseOGGSoundDecoder()  ; Use ogg files

; Loads a sound from a file
LoadSound(0, #PB_Compiler_Home +"Examples\3D\Data\Siren.ogg")
; The sound is playing
PlaySound(0, #PB_Sound_Loop, 20)

MessageRequester("Info", "The sound is playing in stereo.")

SoundPan(0, -100)
MessageRequester("Info", "The sound is playing only on the left channel.")

SoundPan(0, 100)
MessageRequester("Info", "The sound is playing only on the right channel.")

SoundPan(0, 0)
MessageRequester("Info", "The sound is playing in stereo.")

FreeSound(0) ; The sound is freed
End

;* %#@Sound\SoundStatus.html%#@1 *;
Procedure SelectStatus(Status)
  Select Status
    Case #PB_Sound_Stopped
      MessageRequester("Info", "The sound is stopped.")
      
    Case #PB_Sound_Playing
      MessageRequester("Info", "The sound is playing.")
      
    Case  #PB_Sound_Paused
      MessageRequester("Info", "The sound is paused.")
      
    Case #PB_Sound_Unknown
      MessageRequester("Info", "Status unknown.")
      
    Default
      MessageRequester("Info", "Status unknown.")
      
  EndSelect
EndProcedure

InitSound()           ; Initialize Sound system
UseOGGSoundDecoder()  ; Use ogg files

; Loads a sound from a file
LoadSound(0, #PB_Compiler_Home +"Examples\3D\Data\Siren.ogg")
; The sound is playing
PlaySound(0, #PB_Sound_Loop, 20)
SelectStatus(SoundStatus(0))

PauseSound(0)
SelectStatus(SoundStatus(0))

ResumeSound(0)
SelectStatus(SoundStatus(0))

StopSound(0)
SelectStatus(SoundStatus(0))

FreeSound(0) ; The sound is freed
End

;* %#@Sound\SoundVolume.html%#@0 *;
InitSound()           ; Initialize Sound system
UseOGGSoundDecoder()  ; Use ogg files

; Loads a sound from a file
LoadSound(0, #PB_Compiler_Home +"Examples\3D\Data\Siren.ogg")
; The sound is playing
PlaySound(0, #PB_Sound_Loop, 20)

MessageRequester("Info", "The sound volume is at 20%")

SoundVolume(0, 80)
MessageRequester("Info", "The sound volume is at 80%")

FreeSound(0) ; The sound is freed
End

;* %#@Sound\StopSound.html%#@0 *;
InitSound()           ; Initialize Sound system
UseOGGSoundDecoder()  ; Use ogg files

; Loads a sound from a file
LoadSound(0, #PB_Compiler_Home +"Examples\3D\Data\Siren.ogg")
; The sound is playing
PlaySound(0, #PB_Sound_Loop, 20)

MessageRequester("Info", "Ok to stop.")

StopSound(0)
MessageRequester("Info", "Sound stopped")

FreeSound(0) ; The sound is freed
End

;* %#@Sprite\CatchSprite.html%#@1 *;
Debug CatchSprite(0, ?Pic)

DataSection
  Pic: 
  IncludeBinary "Sprite.bmp"
EndDataSection

;* %#@Sprite\SpriteOutput.html%#@0 *;
StartDrawing(SpriteOutput(#Sprite))
; do some drawing stuff here...
StopDrawing()

;* %#@StatusBar\CreateStatusBar.html%#@0 *;
If OpenWindow(0, 0, 0, 440, 50, "StatusBar", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_SizeGadget)
  If CreateStatusBar(0, WindowID(0))
    AddStatusBarField(90)
    AddStatusBarField(100)
    AddStatusBarField(#PB_Ignore) ; automatically resize this field
    AddStatusBarField(100)
  EndIf
  
  StatusBarText(0, 0, "Area normal")
  StatusBarText(0, 1, "Area borderless", #PB_StatusBar_BorderLess)
  StatusBarText(0, 2, "Area right & raised", #PB_StatusBar_Right | #PB_StatusBar_Raised) 
  StatusBarText(0, 3, "Area centered", #PB_StatusBar_Center)
  
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@StatusBar\StatusBarImage.html%#@1 *;
If OpenWindow(0, 0, 0, 340, 50, "StatusBarImage", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_SizeGadget)
  If CreateStatusBar(0, WindowID(0))
    AddStatusBarField(120)
    AddStatusBarField(170)
  EndIf
  
  If LoadImage(0, "cube16.ico")     ; change path/filename to your own image (or icon)
    StatusBarImage(0, 0, ImageID(0))
    StatusBarImage(0, 1, ImageID(0), #PB_StatusBar_Right | #PB_StatusBar_Raised) 
  EndIf  
  
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf 

;* %#@StatusBar\StatusBarProgress.html%#@1 *;
If OpenWindow(0, 0, 0, 340, 50, "StatusBarProgress", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_SizeGadget)
  If CreateStatusBar(0, WindowID(0))
    AddStatusBarField(120)
    AddStatusBarField(170)
  EndIf
  
  StatusBarText(0, 0, "ProgressBar !")
  StatusBarProgress(0, 1, 25)
  
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@String\Asc.html%#@0 *;
Debug Asc("!") ; will print '33'

;* %#@String\Asc.html%#@1 *;
Debug '!'      ; will print '33'
Debug Asc("!") ; will print '33'
Debug Asc("Ђ") ; will print '8364' = 20AC in hexadecimal

unicode$="ЂЂ "
Debug Asc(unicode$) ; will print '8364'
ShowMemoryViewer(@unicode$,8)


;* %#@String\Ascii.html%#@0 *;
*Ascii = Ascii("Hйlй")
ShowMemoryViewer(*Ascii, 4)

;* %#@String\Bin.html%#@1 *;
Debug Bin(32) ; Will display "100000"
Debug Bin(1024*1024*1024*1024) ; Will display "10000000000000000000000000000000000000000"

;* %#@String\Bin.html%#@2 *;
Debug RSet(Bin(32), 16, "0") ; Will display "0000000000100000"

;* %#@String\Chr.html%#@0 *;
Debug Chr(33) ; Will display "!"

;* %#@String\Chr.html%#@1 *;
Debug Chr(401) ; will display "?"
Debug Chr(956) ; will display "ј"

;* %#@String\CountString.html%#@0 *;
Debug CountString("How many 'ow' contains Bow ?", "ow") ; will display 3

;* %#@String\EscapeString.html%#@1 *;
Debug EscapeString("Test="+Chr(34)+"Hello"+Chr(34)+".") ; Will display "Test=\"Hello\"."
Debug EscapeString("<item>Hello</item>", #PB_String_EscapeXML) ; Will display "<item>Hello</item>"

;* %#@String\FindString.html%#@1 *;
Debug FindString("PureBasic", "Bas") ; will display 5

;* %#@String\FormatNumber.html%#@0 *;
Debug FormatNumber(125400.25) ; Will display: 125,000.25

;* %#@String\Hex.html%#@1 *;
Debug Hex(12) ; Will display "C"
Debug Hex(1234567890) ; Will display "499602D2"

;* %#@String\Hex.html%#@2 *;
Debug RSet(Hex(12), 4, "0") ; Will display "000C"

;* %#@String\Hex.html%#@3 *;
Debug Hex(-1)
Debug Hex(-1, #PB_Byte)
Debug Hex(-1, #PB_Word)
Debug Hex(-1, #PB_Long)
Debug Hex(-1, #PB_Quad)    ; quad value is the default

;* %#@String\InsertString.html%#@0 *;
Debug InsertString("Hello !", "World", 7)  ; Will display "Hello World!"
Debug InsertString("Hello !", "World", 1)  ; Will display "WorldHello !"

;* %#@String\LCase.html%#@0 *;
Debug LCase("This is Art") ; Will display "this is art"

;* %#@String\Left.html%#@0 *;
Debug Left("This is Art",4) ; Will display "This"

;* %#@String\Len.html%#@0 *;
Debug Len("This is Art") ; will display 11

;* %#@String\LTrim.html%#@0 *;
Debug LTrim("     This is Art")  ; Will display "This is Art"
Debug LTrim("!!Hello Word", "!") ; Will display "Hello World"

;* %#@String\Mid.html%#@0 *;
Debug Mid("Hello", 2) ; Will display "ello"
Debug Mid("Hello", 2, 1) ; Will display "e"

;* %#@String\RemoveString.html%#@1 *;
Debug RemoveString("This is Art", "is") ; Will display "Th  Art"
Debug RemoveString("This is Art", "is", #PB_String_CaseSensitive, 1, 1) ; Will display "Th is Art"

;* %#@String\ReplaceString.html%#@1 *;
Debug ReplaceString("This is Art", " is", " was") ; Will display "This was Art"
Debug ReplaceString("Hello again, hello again", "HELLO", "oh no...", 1, 10) ; Will display "Hello again, oh no... again"

test$ = "Bundy, Barbie, Buddy"
ReplaceString(test$, "B", "Z", 2, 1)  ; all B gets changed to Z  (directly in memory, no valid return-value here)
Debug test$                           ; Output of the changed string

;* %#@String\ReverseString.html%#@0 *;
Debug ReverseString("Hello")  ; Will display "olleH"

;* %#@String\Right.html%#@0 *;
Debug Right("This is Art", 3) ; Will display "Art"

;* %#@String\RTrim.html%#@0 *;
Debug RTrim("This is Art     ") ; Will display "This is Art"
Debug RTrim("Hello Word!!", "!"); Will display "Hello World"

;* %#@String\Space.html%#@0 *;
Debug "-" + Space(5) + "-" ; Will display "-     -"

;* %#@String\Str.html%#@0 *;
Value.q = 100000000000000001
Debug "Result: " + Str(Value)

;* %#@String\StrD.html%#@0 *;
Value.d = 10.54
Debug "Result: " + StrD(Value)     ; we do not use the 2nd parameter, so we get a float number rounded to 10 decimal places
Debug "Result: " + Value           ; same as previous line
Debug "Result: " + StrD(Value, 2)  ; we want a result with two decimal places, no rounding needed as we have only two
Debug "Result: " + StrD(Value, 0)  ; we want a result with no decimal places, so the value is rounded

;* %#@String\StrF.html%#@0 *;
value.f = 10.54
Debug "Result: " + StrF(value)    ; we do not use the 2nd parameter, so we get a float number rounded to 10 decimal places
Debug "Result: " + value          ; same as previous line
Debug "Result: " + StrF(value,2)  ; we want a result with two decimal places, no rounding needed as we have only two
Debug "Result: " + StrF(value,0)  ; we want a result with no decimal places, so the value is rounded

;* %#@String\StringByteLength.html%#@1 *;
Debug StringByteLength("д", #PB_UTF8) ; will display 2

;* %#@String\StringField.html%#@0 *;
For k = 1 To 6
  Debug StringField("Hello I am a splitted string", k, " ")
Next

;* %#@String\StrU.html%#@1 *;
byte.b = 255
Debug Str(byte) ; Will display -1
Debug StrU(byte, #PB_Byte) ; Will display 255

;* %#@String\Trim.html%#@0 *;
Debug Trim("   Hello     ")  ; Will display "Hello"
Debug Trim("!!Hello!!", "!") ; Will display "Hello"

;* %#@String\UCase.html%#@0 *;
Debug UCase("This is Art") ; Will display "THIS IS ART"

;* %#@String\UnescapeString.html%#@1 *;
Debug UnescapeString(~"Test=\"Hello\".") ; Will display "Test="Hello"."
Debug UnescapeString("<item>Hello</item>", #PB_String_EscapeXML) ; Will display "<item>Hello</item>"

;* %#@String\UTF8.html%#@0 *;
*UTF8 = UTF8("Hйlй")
ShowMemoryViewer(*UTF8, 6)

;* %#@String\Val.html%#@0 *;
Debug Val("1024102410241024") ; will print '1024102410241024'.
Debug Val("$10FFFFFFFF")      ; will print '73014444031'.
Debug Val("%1000")            ; will print '8'.

;* %#@String\ValD.html%#@0 *;
Debug ValD("10.000024") ; will display 10.000024
Debug ValD("1.2345e-2") ; will display  0.012345

;* %#@String\ValF.html%#@0 *;
Debug ValF("10.24")     ; will display 10.24
Debug ValF("1.2345e+3") ; will display 1234.5

;* %#@System\CocoaMessage.html%#@0 *;
; Objective-C: 
;   ColorList = [NSColorList colorListNamed:@"Crayons"];
;
ColorList = CocoaMessage(0, 0, "NSColorList colorListNamed:$", @"Crayons") ; Will create an NSString for "Crayons" under the hood (respecting ascii/unicode mode of the program)

;* %#@System\CocoaMessage.html%#@1 *;
; Objective-C: 
;   Transform = [NSAffineTransform transform];
;
Transform = CocoaMessage(0, 0, "NSAffineTransform transform") ; Get an identity transform

; Objective-C: 
;   [TransForm scaleXBy:sx yBy:sy];
;
sx.CGFloat = 5.5
sy.CGFloat = 20
CocoaMessage(0, TransForm, "scaleXBy:@", @sx, "yBy:@", @sy) ; Scale x by 5.5, y by 20. As sx is not an integer, '@' needs to be specified

; Objective-C: 
;   NSAffineTransform TransformStruct = [TransForm transformStruct];
;
CocoaMessage(@TransformStruct.NSAffineTransform, TransForm, "transformStruct") ; Get the transform structure

Debug TransformStruct\m11 ; debug outputs 5.5

;* %#@System\ComputerName.html%#@0 *;
Debug "Computer name: "+ComputerName()

;* %#@System\CPUName.html%#@0 *;
Debug CPUName() ; Could print: "Intel(R) Core(TM) i7 CPU         860  @ 2.80GHz"

;* %#@System\ElapsedMilliseconds.html%#@0 *;
StartTime = ElapsedMilliseconds()             ; Get the actual value
Delay(1000)                                   ; Wait 1000 milliseconds
ElapsedTime = ElapsedMilliseconds()-StartTime ; 'ElapsedTime' value should be about 1000 milliseconds

;* %#@System\OSVersion.html%#@3 *;
Select OSVersion()
  Case #PB_OS_Windows_98
    MessageRequester("Info", "Windows 98")
    
  Case #PB_OS_Windows_2000
    MessageRequester("Info", "Windows 2000")
    
  Case #PB_OS_Windows_XP
    MessageRequester("Info", "Windows XP")
    
  Default
    MessageRequester("Info", "Unsupported Windows version")
EndSelect

;* %#@System\OSVersion.html%#@4 *;
If OSVersion() < #PB_OS_Windows_2000
  ;
  ; All versions older than Windows 2000
  ;
EndIf

;* %#@System\UserName.html%#@0 *;
Debug "Currently logged user: "+UserName()

;* %#@Texture\CreateCubeMapTexture.html%#@0 *;
material CubeMapMaterial
{
technique
{
pass
{
texture_unit
{
cubic_texture CubeMapTexture combinedUVW
tex_address_mode clamp
env_map cubic_reflection
}
}
}
}

;* %#@Texture\CreateTexture.html%#@0 *;
CreateTexture(0, 256, 256) ; Creates a new 256x256 texture

;* %#@Texture\TextureOutput.html%#@0 *;
...
StartDrawing(TextureOutput(#Texture))
; do some drawing stuff here...
StopDrawing()

;* %#@Thread\CreateMutex.html%#@0 *;
; Run this code once as it is. You will see that the lines printed are
; mixed from between the threads. Now uncomment the Mutex functions and
; the strings are printed in order, because only one thread at a time
; has the right to execute the printing functions.
;
Procedure WithoutMutex(*Number)     
  Shared Mutex
  
  For a = 1 To 5      
    ;LockMutex(Mutex)    ; uncomment this to see the difference
    
    PrintN("Thread "+Str(*Number)+": Trying to print 5x in a row:")
    For b = 1 To 5
      Delay(50)
      PrintN("Thread "+Str(*Number)+" Line "+Str(b))
    Next b          
    
    ;UnlockMutex(Mutex) ; uncomment this to see the difference
  Next a    
EndProcedure

OpenConsole()
Mutex = CreateMutex()

thread1 = CreateThread(@WithoutMutex(), 1)
Delay(25)
thread2 = CreateThread(@WithoutMutex(), 2)
Delay(25)
thread3 = CreateThread(@WithoutMutex(), 3)

WaitThread(thread1)
WaitThread(thread2)
WaitThread(thread3)

Input()

;* %#@Thread\CreateThread.html%#@0 *;
Procedure YourProcedure(*Value)
  ; The variable '*Value' will contain 23
EndProcedure

CreateThread(@YourProcedure(), 23)

;* %#@Thread\CreateThread.html%#@1 *;
Structure Person
  Name$
  Age.b
  Phone.l
EndStructure

Procedure Thread(*Parameters.Person)
  
  ; Display the parameters
  ;
  Debug *Parameters\Name$
  Debug *Parameters\Age
  Debug *Parameters\Phone
  
  ; Once we don't need them anymore, use ClearStructure() to ensure dynamic 
  ; objects (if any) are correctly cleared, and release the dynamic memory block
  ClearStructure(*Parameters, Person)
  FreeMemory(*Parameters)
  
EndProcedure

; We use a dynamically allocated block, so even if we call it from a procedure, it will
; still work. The memory block will be freed by the thread, when 
;
*Parameters.Person = AllocateMemory(SizeOf(Person))
*Parameters\Name$ = "John"
*Parameters\Age   = 30
*Parameters\Phone = 10203040

CreateThread(@Thread(), *Parameters) ; Send the thread a pointer to our structure

Delay(2000)

;* %#@Thread\KillThread.html%#@0 *;
; A procedure/thread which will never exit. Not good, but it
; shows how KillThread works 
Procedure PrintStuff(*Interval)
  Repeat
    PrintN(".")
    Delay(*Interval)
  ForEver
EndProcedure

If OpenConsole()
  thread = CreateThread(@PrintStuff(), 500)
  If thread
    For i=0 To 10
      PrintN("A")
      Delay(999)
      
      If i=5
        KillThread(thread)
      EndIf
    Next
  EndIf
EndIf

;* %#@Thread\PauseThread.html%#@0 *;
Procedure PrintStuff(*Dummy)
  For i = 0 To 10
    PrintN(".")
    Delay(200)
  Next
EndProcedure

If OpenConsole()
  thread = CreateThread(@PrintStuff(), 0)
  If thread
    Delay(100)
    PauseThread(thread)
    For i = 0 To 10
      PrintN("A")
      Delay(50)
    Next
    
    ; Resume thread and give it enough time to complete
    ResumeThread(thread)
    Delay(3000)
  EndIf
EndIf

;* %#@Thread\ThreadPriority.html%#@1 *;
; Procedure which always runs (note, no Delay function as
; this would cause the thread to stop running while it was
; being delayed
Procedure PrintStuff(*Interval)
  For i = 0 To 1000000000
    ; Nasty busy wait
  Next
EndProcedure

If OpenConsole()
  thread = CreateThread(@PrintStuff(), 500)
  If thread
    ; Increase the priority above the main thread
    ; You should notice a delay before the print function
    ; is executed. Now change the 17 to 15 (lower than normal priority)
    ; and see that the print executes immediately
    ThreadPriority(thread, 17)
    PrintN("Waits for higher priority thread to finish")
  EndIf
  
  PrintN("Press return to exit")
  Input()
EndIf

;* %#@Thread\TryLockMutex.html%#@0 *;
Procedure ThreadProcedure(*Value)
  Shared Mutex
  
  Repeat
    If TryLockMutex(Mutex)
      PrintN("Mutex successfully locked.")
      
      UnlockMutex(Mutex)
      Break ; quit the loop and thread
    Else
      PrintN("Still waiting for mutex access...")
      Delay(200)
    EndIf
  ForEver  
EndProcedure

OpenConsole()

Mutex = CreateMutex()
LockMutex(Mutex) ; main program has the mutex locked at first
Thread = CreateThread(@ThreadProcedure(), 0)

Delay(4000)
UnlockMutex(Mutex) ; now release the mutex, so the thread can get it

Input()

;* %#@Thread\WaitThread.html%#@0 *;
Procedure PrintStuff(*Interval)
  For i = 0 To 10
    PrintN(".")
    Delay(*Interval)
  Next
EndProcedure

If OpenConsole()
  thread = CreateThread(@PrintStuff(), 500)
  If thread
    ; Wait for thread to finish before we continue
    ; Try commenting the WaitThread function out and seeing what happens
    WaitThread(thread)
    
    For i = 0 To 10
      PrintN("A")
      Delay(1000)
    Next
  EndIf
EndIf

;* %#@ToolBar\CreateToolBar.html%#@0 *;
If OpenWindow(0, 0, 0, 150, 25, "ToolBar", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateToolBar(0, WindowID(0))
    ToolBarStandardButton(0, #PB_ToolBarIcon_New)
    ToolBarStandardButton(1, #PB_ToolBarIcon_Open)
    ToolBarStandardButton(2, #PB_ToolBarIcon_Save)
  EndIf
  Repeat
    Event = WaitWindowEvent()
    If Event = #PB_Event_Menu
      Debug "ToolBar ID: "+Str(EventMenu())
    EndIf
  Until Event = #PB_Event_CloseWindow 
EndIf

;* %#@ToolBar\DisableToolBarButton.html%#@0 *;
If OpenWindow(0, 0, 0, 150, 60, "ToolBar", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateToolBar(0, WindowID(0))
    ToolBarStandardButton(0, #PB_ToolBarIcon_New)
    ToolBarStandardButton(1, #PB_ToolBarIcon_Open)
    ToolBarStandardButton(2, #PB_ToolBarIcon_Save)
    DisableToolBarButton(0, 1, 1) : Disabled = #True
  EndIf
  
  ButtonGadget(0, 20, 30, 110, 20, "Enable OpenFile")
  
  Repeat
    Event = WaitWindowEvent()
    If Event = #PB_Event_Gadget
      If EventGadget() = 0
        If Disabled = #True
          DisableToolBarButton(0, 1, 0)
          SetGadgetText(0,"Disable OpenFile")
          Disabled = #False
        Else
          DisableToolBarButton(0, 1, 1)
          SetGadgetText(0,"Enable OpenFile")
          Disabled = #True
        EndIf
      EndIf
    EndIf
  Until Event = #PB_Event_CloseWindow 
EndIf

;* %#@ToolBar\ToolBarImageButton.html%#@1 *;
If OpenWindow(0, 0, 0, 150, 25, "ToolBar", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CreateImage(0,16,16)
  StartDrawing(ImageOutput(0))
  Box(0,0,16,16,RGB(255,255,255))
  Box(4,4,8,8,RGB(255,0,0))
  StopDrawing()
  CreateImage(1,16,16)
  StartDrawing(ImageOutput(1))
  Box(0,0,16,16,RGB(255,0,0))
  Box(4,4,8,8,RGB(255,255,255))
  StopDrawing()
  If CreateToolBar(0, WindowID(0))
    ToolBarImageButton(0,ImageID(0))
    ToolBarImageButton(1,ImageID(1))
  EndIf
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow 
EndIf

;* %#@ToolBar\ToolBarSeparator.html%#@0 *;
If OpenWindow(0, 0, 0, 150, 25, "ToolBar", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateToolBar(0, WindowID(0))
    ToolBarStandardButton(0, #PB_ToolBarIcon_New)
    ToolBarSeparator()
    ToolBarStandardButton(1, #PB_ToolBarIcon_Open)
    ToolBarSeparator()
    ToolBarStandardButton(2, #PB_ToolBarIcon_Save)
    ToolBarSeparator()
    ToolBarSeparator()
  EndIf
  Repeat
    Event = WaitWindowEvent()
    If Event = #PB_Event_Menu
      Debug "ToolBar ID: "+Str(EventMenu())
    EndIf
  Until Event = #PB_Event_CloseWindow 
EndIf

;* %#@ToolBar\ToolBarStandardButton.html%#@2 *;
If OpenWindow(0, 0, 0, 150, 25, "ToolBar", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateToolBar(0, WindowID(0))
    ToolBarStandardButton(0, #PB_ToolBarIcon_New)
    ToolBarStandardButton(1, #PB_ToolBarIcon_Open)
    ToolBarStandardButton(2, #PB_ToolBarIcon_Save)
  EndIf
  Repeat
    Event = WaitWindowEvent()
    If Event = #PB_Event_Menu
      Debug "ToolBar ID: "+Str(EventMenu())
    EndIf
  Until Event = #PB_Event_CloseWindow 
EndIf

;* %#@ToolBar\ToolBarToolTip.html%#@0 *;
If OpenWindow(0, 0, 0, 150, 60, "ToolBar", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateToolBar(0, WindowID(0))
    ToolBarStandardButton(0, #PB_ToolBarIcon_New)
    ToolBarStandardButton(1, #PB_ToolBarIcon_Open)
    ToolBarStandardButton(2, #PB_ToolBarIcon_Save)
    ToolBarToolTip(0, 0, "New document")
    ToolBarToolTip(0, 1, "Open file")
    ToolBarToolTip(0, 2, "Save file")
  EndIf
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow 
EndIf

;* %#@VectorDrawing\AddPathArc.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    MovePathCursor(40, 60)
    AddPathArc(100, 140, 160, 20, 20)
    AddPathArc(160, 20, 220, 180, 20)
    AddPathArc(220, 180, 280, 80, 20)
    AddPathArc(280, 80, 340, 120, 20)
    AddPathLine(340, 120)
    
    VectorSourceColor(RGBA(255, 0, 0, 255))
    StrokePath(10)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\AddPathBox.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    AddPathBox(50, 50, 200, 50)
    AddPathBox(150, 75, 200, 50)
    VectorSourceColor(RGBA(255, 0, 0, 255))
    StrokePath(10)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\AddPathCircle.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    ; partial circle
    AddPathCircle(100, 100, 75, 0, 235)
    
    ; partial circle with lines to the center
    MovePathCursor(300, 100)
    AddPathCircle(300, 100, 75, 0, 235, #PB_Path_Connected)
    ClosePath()
    
    VectorSourceColor(RGBA(255, 0, 0, 255))
    StrokePath(10)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\AddPathCurve.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    MovePathCursor(50, 100)
    AddPathCurve(90, 30, 250, 180, 350, 100)
    VectorSourceColor(RGBA(255, 0, 0, 255))
    StrokePath(10)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\AddPathEllipse.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    ; regular ellipse
    AddPathEllipse(100, 100, 80, 30)
    
    ; rotated ellipse
    SaveVectorState()
    RotateCoordinates(300, 100, 45)
    AddPathEllipse(300, 100, 80, 30)
    RestoreVectorState()
    
    VectorSourceColor(RGBA(255, 0, 0, 255))
    StrokePath(10)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\AddPathLine.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    MovePathCursor(40, 20)
    For i = 1 To 4
      AddPathLine(80, 0, #PB_Path_Relative)
      AddPathLine(0, 40, #PB_Path_Relative)
    Next i
    
    VectorSourceColor(RGBA(255, 0, 0, 255))
    StrokePath(10, #PB_Path_RoundCorner)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\AddPathSegments.html%#@2 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    AddPathSegments("M 40 20 L 120 20 L 120 60 L 200 60 L 200 100 L 280 100 L 280 140 L 360 140 L 360 180")
    VectorSourceColor(RGBA(255, 0, 0, 255))
    StrokePath(10, #PB_Path_RoundCorner)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\AddPathText.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  LoadFont(0, "Times New Roman", 20, #PB_Font_Bold)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    VectorFont(FontID(0), 150)
    
    MovePathCursor(50, 25)
    AddPathText("Text")
    
    VectorSourceColor(RGBA(255, 0, 0, 255))
    DashPath(3, 6)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\BeginVectorLayer.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    ; Semi-transparent drawing on the base layer
    AddPathCircle(75, 100, 60)      
    VectorSourceColor(RGBA(255, 0, 0, 127))
    FillPath()      
    AddPathCircle(125, 100, 60)
    VectorSourceColor(RGBA(0, 0, 255, 127))
    FillPath()    
    
    ; Opaque drawing on a semi-transparent layer
    BeginVectorLayer(127)
    AddPathCircle(275, 100, 60)    
    VectorSourceColor(RGBA(255, 0, 0, 255))
    FillPath()        
    AddPathCircle(325, 100, 60)
    VectorSourceColor(RGBA(0, 0, 255, 255))
    FillPath()    
    EndVectorLayer()
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\ClipPath.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  LoadFont(0, "Times New Roman", 20, #PB_Font_Bold)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    ; Setup a complex clipping path with nested ellipses (every second one will be clipped)
    For i = 10 To 150 Step 5
      AddPathEllipse(200, 100, 2*i, i)
    Next i
    ClipPath()
    
    ; Draw some text with this clipping
    VectorFont(FontID(0), 150)      
    VectorSourceColor(RGBA(255, 0, 0, 255))
    
    MovePathCursor(50, 25)
    DrawVectorText("Text")
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\ClosePath.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    ; Create a path with two closed triangles
    MovePathCursor(20, 160)
    AddPathLine(100, 20)
    AddPathLine(180, 160)
    ClosePath()
    
    MovePathCursor(220, 160)
    AddPathLine(300, 20)
    AddPathLine(380, 160)
    ClosePath()      
    
    ; fill the path
    VectorSourceColor(RGBA(0, 0, 255, 255))
    FillPath()
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\ConvertCoordinateX.html%#@1 *;
; This example draws a dot at the mouse location even in a modified coordinate system
; by mapping the coordinates from the device system (pixels) to the user system (points)
;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)   
  
  Repeat
    Event = WaitWindowEvent()
    
    If Event = #PB_Event_Gadget And EventGadget() = 0 And EventType() = #PB_EventType_LeftButtonDown
      
      If StartVectorDrawing(CanvasVectorOutput(0, #PB_Unit_Point))
        RotateCoordinates(0, 0, 30)
        
        CanvasX = GetGadgetAttribute(0, #PB_Canvas_MouseX)
        CanvasY = GetGadgetAttribute(0, #PB_Canvas_MouseY)
        
        DrawingX = ConvertCoordinateX(CanvasX, CanvasY, #PB_Coordinate_Device, #PB_Coordinate_User)
        DrawingY = ConvertCoordinateY(CanvasX, CanvasY, #PB_Coordinate_Device, #PB_Coordinate_User)
        
        AddPathCircle(DrawingX, DrawingY, 10)
        VectorSourceColor(RGBA(Random(255), Random(255), Random(255), 255))
        FillPath()
        
        StopVectorDrawing()
      EndIf
      
    EndIf
    
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\CustomDashPath.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    MovePathCursor(40, 20)
    For i = 1 To 4
      AddPathLine(80, 0, #PB_Path_Relative)
      AddPathLine(0, 40, #PB_Path_Relative)
    Next i
    
    VectorSourceColor(RGBA(255, 0, 0, 255))
    
    Dim dashes.d(7)
    dashes(0) = 20
    dashes(1) = 10
    dashes(2) = 0 ; draw a dot
    dashes(3) = 10
    dashes(4) = 0
    dashes(5) = 10
    dashes(6) = 20
    dashes(7) = 10
    CustomDashPath(5, dashes())
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\DashPath.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    MovePathCursor(40, 20)
    For i = 1 To 4
      AddPathLine(80, 0, #PB_Path_Relative)
      AddPathLine(0, 40, #PB_Path_Relative)
    Next i
    
    VectorSourceColor(RGBA(255, 0, 0, 255))
    DashPath(5, 15)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\DotPath.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    MovePathCursor(40, 20)
    For i = 1 To 4
      AddPathLine(80, 0, #PB_Path_Relative)
      AddPathLine(0, 40, #PB_Path_Relative)
    Next i
    
    VectorSourceColor(RGBA(255, 0, 0, 255))
    DotPath(5, 10, #PB_Path_RoundEnd)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\DrawVectorImage.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  LoadImage(0, #PB_Compiler_Home + "examples/Sources/Data/PureBasicLogo.bmp")
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    MovePathCursor(50, 50)
    DrawVectorImage(ImageID(0), 127)
    
    MovePathCursor(75, 75)
    DrawVectorImage(ImageID(0), 127, ImageWidth(0) / 2, ImageHeight(0))
    
    MovePathCursor(120, 0)
    RotateCoordinates(120, 0, 35)
    DrawVectorImage(ImageID(0), 127)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\DrawVectorParagraph.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 250, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 250)
  LoadFont(0, "Times New Roman", 20)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    Text$ = "Every drawing output has a default unit of measurement. The default unit is pixels " +
            "for screen or raster image outputs and points for printer or vector image outputs. " +
            "It is however possible to select a different unit of measurement for the output when " +
            "creating it with the ImageVectorOutput(), PrinterVectorOutput() or similar function."
    
    VectorFont(FontID(0), 18)
    
    MovePathCursor(25, 25)
    DrawVectorParagraph(Text$, 350, 200)
    
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\DrawVectorText.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  LoadFont(0, "Impact", 20, #PB_Font_Bold)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    VectorFont(FontID(0), 25)
    VectorSourceColor(RGBA(0, 0, 0, 80))
    Text$ = "The quick brown fox jumped over the lazy doc"
    
    For i = 1 To 6
      MovePathCursor(200 - VectorTextWidth(Text$)/2, 100 - VectorTextHeight(Text$)/2)
      DrawVectorText(Text$)
      RotateCoordinates(200, 100, 30)
    Next i
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\FillPath.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    AddPathBox(50, 50, 200, 50)
    AddPathBox(150, 75, 200, 50)
    VectorSourceColor(RGBA(0, 0, 255, 255))
    FillPath()
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\FillVectorOutput.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    ; make the entire output red
    VectorSourceColor(RGBA(255, 0, 0, 255))
    FillVectorOutput()
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\FlipCoordinatesX.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)    
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    VectorFont(LoadFont(0, "Times New Roman", 60, #PB_Font_Bold))
    
    VectorSourceColor(RGBA(0, 0, 255, 128))
    MovePathCursor(50, 50)
    DrawVectorText("Test")
    
    FlipCoordinatesX(200)
    
    VectorSourceColor(RGBA(255, 0, 0, 128))
    MovePathCursor(50, 50)
    DrawVectorText("Test")    
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\FlipCoordinatesY.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)    
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    VectorFont(LoadFont(0, "Times New Roman", 60, #PB_Font_Bold))
    
    VectorSourceColor(RGBA(0, 0, 255, 128))
    MovePathCursor(50, 50)
    DrawVectorText("Test")
    
    FlipCoordinatesY(120)
    
    VectorSourceColor(RGBA(255, 0, 0, 128))
    MovePathCursor(50, 50)
    DrawVectorText("Test")    
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\IsInsidePath.html%#@1 *;

; This example uses the IsInsidePath() function to color the figure in green
; while the mouse is inside of it and blue otherwise
;
Procedure Draw()    
  x = GetGadgetAttribute(0, #PB_Canvas_MouseX)
  y = GetGadgetAttribute(0, #PB_Canvas_MouseY)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    VectorSourceColor(RGBA(255, 255, 255, 255))   ; erase previous content
    FillVectorOutput()
    
    AddPathEllipse(200, 100, 150, 75)             ; prepare path
    
    If IsInsidePath(x, y, #PB_Coordinate_Device)  ; check if the mouse is inside
      VectorSourceColor(RGBA(0, 255, 0, 255))
    Else
      VectorSourceColor(RGBA(0, 0, 255, 255))
    EndIf
    
    FillPath()                                    ; fill path
    StopVectorDrawing()
  EndIf      
EndProcedure

If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  LoadFont(0, "Times New Roman", 20, #PB_Font_Bold)
  Draw()
  
  Repeat
    Event = WaitWindowEvent()
    
    If Event = #PB_Event_Gadget And EventGadget() = 0 And EventType() = #PB_EventType_MouseMove
      Draw()
    EndIf
    
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\IsInsideStroke.html%#@1 *;
; This example uses the IsInsideStroke() function to color the figure in green
; while the mouse on its outline and blue otherwise
;
Procedure Draw()    
  x = GetGadgetAttribute(0, #PB_Canvas_MouseX)
  y = GetGadgetAttribute(0, #PB_Canvas_MouseY)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    VectorSourceColor(RGBA(255, 255, 255, 255))         ; erase previous content
    FillVectorOutput()
    
    AddPathEllipse(200, 100, 150, 75)                   ; prepare path
    
    If IsInsideStroke(x, y, 20, #PB_Path_Default, #PB_Coordinate_Device)  ; check if the mouse is inside
      VectorSourceColor(RGBA(0, 255, 0, 255))
    Else
      VectorSourceColor(RGBA(0, 0, 255, 255))
    EndIf
    
    StrokePath(20)                                      ; stroke path
    StopVectorDrawing()
  EndIf      
EndProcedure

If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  LoadFont(0, "Times New Roman", 20, #PB_Font_Bold)
  Draw()
  
  Repeat
    Event = WaitWindowEvent()
    
    If Event = #PB_Event_Gadget And EventGadget() = 0 And EventType() = #PB_EventType_MouseMove
      Draw()
    EndIf
    
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\MovePathCursor.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    MovePathCursor(40, 40)
    For i = 1 To 4
      AddPathLine(80, 0, #PB_Path_Relative)
      MovePathCursor(0, 40, #PB_Path_Relative)
    Next i
    
    VectorSourceColor(RGBA(255, 0, 0, 255))
    StrokePath(10)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\PathBoundsX.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    ; construct path
    MovePathCursor(150, 125)
    AddPathCurve(0, 270, 0, -150, 350, 180)
    
    ; get path bounds
    x = PathBoundsX()
    y = PathBoundsY()
    w = PathBoundsWidth()
    h = PathBoundsHeight()
    
    ; stroke the path
    VectorSourceColor($FF0000FF)
    StrokePath(5)
    
    ; draw bounding box
    AddPathBox(x, y, w, h)
    VectorSourceColor($FF000000)
    DashPath(2, 5)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\PathLength.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    ; construct path
    MovePathCursor(150, 125)
    AddPathCurve(0, 270, 0, -150, 350, 180)
    
    ; get length
    Debug "Path length: " + PathLength()
    
    ; stroke the path
    VectorSourceColor($FF0000FF)
    StrokePath(5)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\PathPointX.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    ; construct path
    MovePathCursor(150, 125)
    AddPathCurve(0, 270, 0, -150, 350, 180)
    
    ; get location & angle of point on the path
    x = PathPointX(200)
    y = PathPointY(200)
    a = PathPointAngle(200)
    
    ; stroke the path
    VectorSourceColor($FF0000FF)
    StrokePath(5)
    
    ; draw a marker at the path point
    AddPathCircle(x, y, 10)
    VectorSourceColor($FFFF0000)
    FillPath()
    
    MovePathCursor(x, y)
    AddPathLine(30*Cos(Radian(a)), 30*Sin(Radian(a)), #PB_Path_Relative)
    StrokePath(5)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\PathSegments.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    MovePathCursor(40, 20)
    For i = 1 To 4
      AddPathLine(80, 0, #PB_Path_Relative)
      AddPathLine(0, 40, #PB_Path_Relative)
    Next i
    
    ; Show the path segments
    Debug PathSegments()
    
    VectorSourceColor(RGBA(255, 0, 0, 255))
    StrokePath(10, #PB_Path_RoundCorner)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\PdfVectorOutput.html%#@1 *;
LoadFont(0, "Times New Roman", 20)

If StartVectorDrawing(PdfVectorOutput("test.pdf", 595, 842))  
  VectorFont(FontID(0), 25)
  
  MovePathCursor(20, 20)
  DrawVectorText("This is page 1...")
  
  NewVectorPage()
  
  MovePathCursor(20, 20)
  DrawVectorText("This is page 2...")      
  
  StopVectorDrawing()
EndIf

;* %#@VectorDrawing\RotateCoordinates.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)    
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    VectorFont(LoadFont(0, "Times New Roman", 60, #PB_Font_Bold))
    
    VectorSourceColor(RGBA(0, 0, 255, 128))
    MovePathCursor(50, 50)
    DrawVectorText("Test")
    
    RotateCoordinates(50, 50, -20) ; rotate by -20 degrees around the (50, 50) point
    
    VectorSourceColor(RGBA(255, 0, 0, 128))
    MovePathCursor(50, 50)
    DrawVectorText("Test")    
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\SaveVectorState.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  LoadFont(0, "Times New Roman", 20, #PB_Font_Bold)    
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    VectorSourceColor(RGBA(255, 0, 0, 255))
    VectorFont(FontID(0))
    
    MovePathCursor(20, 20)
    DrawVectorText("Normal text")
    
    ; Changes made to the drawing state within this block do not affect the other commands
    SaveVectorState()
    MovePathCursor(120, 160)
    RotateCoordinates(120, 160, -50)
    VectorSourceColor(RGBA(0, 0, 255, 255))
    DrawVectorText("Rotated text")
    RestoreVectorState()
    
    MovePathCursor(220, 140)
    DrawVectorText("Normal text")
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\ScaleCoordinates.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)    
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    VectorFont(LoadFont(0, "Times New Roman", 60, #PB_Font_Bold))
    
    VectorSourceColor(RGBA(0, 0, 255, 128))
    MovePathCursor(50, 50)
    DrawVectorText("Test")
    
    ScaleCoordinates(0.7, 0.9)
    
    VectorSourceColor(RGBA(255, 0, 0, 128))
    MovePathCursor(50, 50)
    DrawVectorText("Test")    
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\SkewCoordinates.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)    
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    VectorFont(LoadFont(0, "Times New Roman", 60, #PB_Font_Bold))
    
    VectorSourceColor(RGBA(0, 0, 255, 128))
    MovePathCursor(50, 50)
    DrawVectorText("Test")
    
    SkewCoordinates(45, 0)
    
    VectorSourceColor(RGBA(255, 0, 0, 128))
    MovePathCursor(50, 50)
    DrawVectorText("Test")    
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\StrokePath.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    MovePathCursor(40, 20)
    For i = 1 To 4
      AddPathLine(80, 0, #PB_Path_Relative)
      AddPathLine(0, 40, #PB_Path_Relative)
    Next i
    
    VectorSourceColor(RGBA(255, 0, 0, 255))
    StrokePath(20, #PB_Path_RoundCorner|#PB_Path_RoundEnd)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\SvgVectorOutput.html%#@1 *;
If StartVectorDrawing(SvgVectorOutput("test.svg", 400, 200))
  
  AddPathBox(50, 50, 200, 50)
  AddPathBox(150, 75, 200, 50)
  VectorSourceColor(RGBA(255, 0, 0, 255))
  StrokePath(10)
  
  StopVectorDrawing()
EndIf

;* %#@VectorDrawing\TranslateCoordinates.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)    
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    VectorFont(LoadFont(0, "Times New Roman", 60, #PB_Font_Bold))
    
    VectorSourceColor(RGBA(0, 0, 255, 128))
    MovePathCursor(50, 50)
    DrawVectorText("Test")
    
    TranslateCoordinates(30, 30) ; all coordinates are moved 30 pixels in each direction
    
    VectorSourceColor(RGBA(255, 0, 0, 128))
    MovePathCursor(50, 50)
    DrawVectorText("Test")    
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\VectorSourceCircularGradient.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    VectorSourceCircularGradient(200, 100, 150, -50, -50)
    VectorSourceGradientColor(RGBA(255, 255, 255, 255), 0.0)
    VectorSourceGradientColor(RGBA(0, 0, 0, 255), 1.0)
    
    FillVectorOutput()
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\VectorSourceImage.html%#@1 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  LoadImage(0, #PB_Compiler_Home + "examples/Sources/Data/PureBasicLogo.bmp")
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    AddPathBox(50, 50, 200, 50)
    AddPathBox(150, 75, 200, 50)
    
    VectorSourceImage(ImageID(0), 255, ImageWidth(0), ImageHeight(0), #PB_VectorImage_Repeat)
    StrokePath(20)
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\VectorSourceImage.html%#@2 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  LoadImage(0, #PB_Compiler_Home + "examples/Sources/Data/PureBasicLogo.bmp")
  LoadFont(0, "Impact", 20, #PB_Font_Bold)    
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    FlipCoordinatesY(50, #PB_Coordinate_Source)
    RotateCoordinates(50, 50, -45, #PB_Coordinate_Source)      
    VectorSourceImage(ImageID(0), 255, ImageWidth(0), ImageHeight(0), #PB_VectorImage_Repeat)
    
    VectorFont(FontID(0), 150)
    MovePathCursor(20, 20)      
    DrawVectorText("TEXT")
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\VectorSourceLinearGradient.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 200, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 400, 200)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    VectorSourceLinearGradient(50, 0, 350, 0)
    VectorSourceGradientColor(RGBA(255, 0, 0, 255), 0.0)
    VectorSourceGradientColor(RGBA(0, 255, 0, 255), 0.5)
    VectorSourceGradientColor(RGBA(0, 0, 255, 255), 1.0)
    
    AddPathBox(50, 25, 300, 150)
    FillPath()
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\VectorTextHeight.html%#@1 *;
If OpenWindow(0, 0, 0, 500, 250, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 500, 250)
  LoadFont(0, "Monotype Corsiva", 20, #PB_Font_Italic)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    VectorFont(FontID(0), 125)
    Text$ = "Sample"
    
    ; draw text
    MovePathCursor(25, 25)
    DrawVectorText(Text$)
    
    ; draw logical bounding box
    AddPathBox(25, 25, VectorTextWidth(Text$), VectorTextHeight(Text$))
    VectorSourceColor(RGBA(0, 0, 255, 255))
    DashPath(2, 10)
    
    ; draw visible bounding box
    AddPathBox(25 + VectorTextWidth(Text$, #PB_VectorText_Visible|#PB_VectorText_Offset), 
               25 + VectorTextHeight(Text$, #PB_VectorText_Visible|#PB_VectorText_Offset), 
               VectorTextWidth(Text$, #PB_VectorText_Visible), 
               VectorTextHeight(Text$, #PB_VectorText_Visible))
    VectorSourceColor(RGBA(255, 0, 0, 255))
    DashPath(2, 10)        
    
    ; draw baseline
    MovePathCursor(25, 25 + VectorTextHeight(Text$, #PB_VectorText_Baseline))
    AddPathLine(VectorTextWidth(Text$), 0, #PB_Path_Relative)
    VectorSourceColor(RGBA(0, 255, 0, 255))
    DashPath(2, 10)                    
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@VectorDrawing\VectorTextWidth.html%#@1 *;
If OpenWindow(0, 0, 0, 500, 250, "VectorDrawing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 500, 250)
  LoadFont(0, "Monotype Corsiva", 20, #PB_Font_Italic)
  
  If StartVectorDrawing(CanvasVectorOutput(0))
    
    VectorFont(FontID(0), 125)
    Text$ = "Sample"
    
    ; draw text
    MovePathCursor(25, 25)
    DrawVectorText(Text$)
    
    ; draw logical bounding box
    AddPathBox(25, 25, VectorTextWidth(Text$), VectorTextHeight(Text$))
    VectorSourceColor(RGBA(0, 0, 255, 255))
    DashPath(2, 10)
    
    ; draw visible bounding box
    AddPathBox(25 + VectorTextWidth(Text$, #PB_VectorText_Visible|#PB_VectorText_Offset), 
               25 + VectorTextHeight(Text$, #PB_VectorText_Visible|#PB_VectorText_Offset), 
               VectorTextWidth(Text$, #PB_VectorText_Visible), 
               VectorTextHeight(Text$, #PB_VectorText_Visible))
    VectorSourceColor(RGBA(255, 0, 0, 255))
    DashPath(2, 10)        
    
    ; draw baseline
    MovePathCursor(25, 25 + VectorTextHeight(Text$, #PB_VectorText_Baseline))
    AddPathLine(VectorTextWidth(Text$), 0, #PB_Path_Relative)
    VectorSourceColor(RGBA(0, 255, 0, 255))
    DashPath(2, 10)                    
    
    StopVectorDrawing()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Vehicle\CreateVehicleBody.html%#@0 *;
value = 0: undamped & bouncy
value = 1: critical damping

;* %#@Window\AddKeyboardShortcut.html%#@2 *;
AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_F, 15) ; Will create a keyboard shortcut CTRL+F on the window 0
                                                                  ; which will fires a menu event '15'

;* %#@Window\AddWindowTimer.html%#@0 *;
If OpenWindow(0, 0, 0, 400, 100, "Timer Example", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ProgressBarGadget(0, 10, 10, 380, 20, 0, 100)
  AddWindowTimer(0, 123, 250)
  
  Value = 0
  Repeat
    Event = WaitWindowEvent()
    
    If Event = #PB_Event_Timer And EventTimer() = 123
      Value = (Value + 5) % 100
      SetGadgetState(0, Value)
    EndIf    
    
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Window\AddWindowTimer.html%#@1 *;
RemoveWindowTimer(#Window, Timer)
AddWindowTimer(#Window, Timer, Timeout)

;* %#@Window\BindEvent.html%#@0 *;
Procedure EventHandler()
  ; Code
EndProcedure

;* %#@Window\BindEvent.html%#@1 *;
Procedure SizeWindowHandler()
  Debug "Size event on window #" + EventWindow()
  
  ; Resize the gadget to fit the new window dimensions
  ;
  ResizeGadget(0, #PB_Ignore, #PB_Ignore, WindowWidth(EventWindow())-20, WindowHeight(EventWindow())-20)
EndProcedure

OpenWindow(0, 100, 100, 200, 200, "Live resize test", #PB_Window_SizeGadget | #PB_Window_SystemMenu)
EditorGadget(0, 10, 10, 180, 180)

BindEvent(#PB_Event_SizeWindow, @SizeWindowHandler())

Repeat
  Event = WaitWindowEvent()
Until Event = #PB_Event_CloseWindow

;* %#@Window\EventType.html%#@1 *;
If OpenWindow(0, 0, 0, 230, 120, "Eventtypes example...", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ListIconGadget(1, 10, 10, 150, 100, "ListIcon", 140, #PB_ListIcon_GridLines) 
  For a = 1 To 4 
    AddGadgetItem(1, -1, "Line "+Str(a)) 
  Next
  
  Repeat
    Event = WaitWindowEvent()
    
    Select Event
        
      Case #PB_Event_Gadget
        Select EventGadget()
          Case 1 
            Select EventType()
              Case #PB_EventType_LeftClick        : Debug "Click with left mouse button"
              Case #PB_EventType_RightClick       : Debug "Click with right mouse button"
              Case #PB_EventType_LeftDoubleClick  : Debug "Double-click with left mouse button"
              Case #PB_EventType_RightDoubleClick : Debug "Double-click with right mouse button"
            EndSelect
        EndSelect
        
    EndSelect
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Window\GetWindowTitle.html%#@0 *;
If OpenWindow(2, 100, 100, 200, 100, "My cool title")
  Title$ = GetWindowTitle(2)  ; Will return "My cool title"
EndIf

;* %#@Window\HideWindow.html%#@2 *;
If OpenWindow(0, 200, 200, 220, 100, "HideWindow()", #PB_Window_SystemMenu)
  
  ButtonGadget  (1, 10, 60, 200, 30, "Hide the window")
  
  Repeat
    Event = WaitWindowEvent()
    
    Select Event
        
      Case #PB_Event_Gadget
        Select EventGadget()
          Case 1
            
            HideWindow(0, #True)  
            Debug "Window hidden."
            MessageRequester("Info", "Press OK to show the window")
            HideWindow(0, #False)  
            Debug "Window is visible."
            
        EndSelect
        
    EndSelect
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Window\PostEvent.html%#@0 *;
; All our custom events
Enumeration #PB_Event_FirstCustomValue
  #EventBeginProcessing
  #EventProcessingFinished
EndEnumeration


Procedure Thread(Value)
  PostEvent(#EventBeginProcessing)
  
  Delay(3000)
  PostEvent(#EventProcessingFinished)
EndProcedure

OpenWindow(0, 200, 200, 100, 100, "PostEvent")

CreateThread(@Thread(), 0)

Repeat
  Event = WaitWindowEvent()
  
  Select Event
    Case #EventBeginProcessing
      Debug "Thread begin processing "
      
    Case #EventProcessingFinished
      Debug "Thread processing finished"
  EndSelect
  
Until Event = #PB_Event_CloseWindow

;* %#@Window\SetWindowCallback.html%#@0 *;
Procedure MyWindowCallback(WindowID, Message, WParam, LParam)
  Result = #PB_ProcessPureBasicEvents
  ;
  ; you code here
  ;
  ProcedureReturn Result
EndProcedure

;* %#@Window\SetWindowCallback.html%#@1 *;
Procedure WinCallback(hWnd, uMsg, WParam, LParam) 
  ; Windows fills the parameter automatically, which we will use in the callback...
  
  If uMsg = #WM_SIZE 
    Select WParam 
      Case #SIZE_MINIMIZED 
        Debug "Window was minimized" 
      Case #SIZE_RESTORED 
        Debug "Window was restored" 
      Case #SIZE_MAXIMIZED 
        Debug "Window was maximized" 
    EndSelect 
  EndIf 
  
  ProcedureReturn #PB_ProcessPureBasicEvents 
EndProcedure 


If OpenWindow(0, 0, 0, 200, 100, "Messages", #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget) 
  
  SetWindowCallback(@WinCallback())    ; activate the callback
  
  Repeat 
    Select WaitWindowEvent() 
      Case #PB_Event_CloseWindow 
        End 
    EndSelect 
  ForEver 
  
EndIf 

;* %#@Window\SetWindowTitle.html%#@0 *;
If OpenWindow(2, 100, 100, 200, 100, "My cool title")
  SetWindowTitle(2, "Even cooler title !")
  
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

;* %#@Window\UnbindEvent.html%#@0 *;
Procedure SizeWindowHandler()
  Debug "Size event on window #" + EventWindow()
EndProcedure

OpenWindow(0, 100, 100, 200, 200, "Resize test", #PB_Window_SizeGadget | #PB_Window_SystemMenu)

BindEvent(#PB_Event_SizeWindow, @SizeWindowHandler())
UnbindEvent(#PB_Event_SizeWindow, @SizeWindowHandler()) ; Unbind it immediately

Repeat
  Event = WaitWindowEvent()
Until Event = #PB_Event_CloseWindow

;* %#@Window\WaitWindowEvent.html%#@0 *;
If OpenWindow(0, 0, 0, 230, 90, "Event handling example...", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  
  ButtonGadget  (1, 10, 10, 200, 20, "Click me")
  CheckBoxGadget(2, 10, 40, 200, 20, "Check me")
  
  If CreateMenu(0, WindowID(0))
    MenuTitle("Menu")
    MenuItem(1, "Item 1")
    MenuItem(2, "Item 2")
    MenuItem(3, "Item 3")
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
    
    Select Event
        
      Case #PB_Event_Gadget
        Select EventGadget()
          Case 1 : Debug "Button 1 clicked!"
          Case 2 : Debug "Button 2 clicked!"
        EndSelect
        
      Case #PB_Event_Menu
        Select EventMenu()
          Case 1 : Debug "Menu item 1 clicked!"
          Case 2 : Debug "Menu item 2 clicked!"
          Case 3 : Debug "Menu item 3 clicked!"
        EndSelect
        
    EndSelect
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Window\WaitWindowEvent.html%#@1 *;
If OpenWindow(0, 0, 0, 300, 30, "Position of the mouse on the desktop", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  TextGadget(0, 10, 6, 200, 20, "")
  
  Repeat
    Event = WaitWindowEvent(20)
    
    If Event = 0 ; No more events in the queue, so let's display the mouse coordinates
      SetGadgetText(0, "Coordinates: " + Str(DesktopMouseX()) + "," + Str(DesktopMouseY()))  
    EndIf
    
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Window\WaitWindowEvent.html%#@2 *;
If OpenWindow(0, 0, 0, 300, 30, "Position of the mouse on the desktop", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  TextGadget(0, 10, 6, 200, 20, "")
  AddWindowTimer(0, 0, 10) ; Timeout = 10 ms
  
  Repeat
    Event = WaitWindowEvent()
    If Event = #PB_Event_Timer ; Each 10 ms => Let's display the coordinates
      SetGadgetText(0, "Coordinates: " + Str(DesktopMouseX()) + "," + Str(DesktopMouseY()))  
    EndIf
    
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Window\WindowBounds.html%#@0 *;
If OpenWindow(0, 0, 0, 300, 300, "Resize me !", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_SizeGadget)
  WindowBounds(0, 200, 200, 400, 400)
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Window\WindowEvent.html%#@1 *;
Repeat 
  Event = WindowEvent()
  
  If Event    ; An event was in the queue so process it 
    .... 
  Else  
    Delay(1)  ; No event, let the others apps get some CPU time too ! 
  EndIf 
Until Event = #PB_Event_CloseWindow

;* %#@Window\WindowEvent.html%#@2 *;
If OpenWindow(0, 0, 0, 600, 100, "Position of the mouse on the window: ", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  TextGadget(0, 10, 6, 200, 20, "")
  
  Repeat
    Event = WindowEvent()
    
    If Event <> 0 ; All events are treated, so we can display the coordinates of the mouse
      SetWindowTitle(0, "Position of the mouse on the window: " + Str(WindowMouseX(0)) + "," + Str(WindowMouseX(0))) 
    Else
      
      Delay(1) ; Without a FlipBuffers(), Delay() frees the CPU for the multitasking
    EndIf
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Window\WindowEvent.html%#@3 *;
If OpenWindow(0, 0, 0, 300, 30, "Position of the mouse on the desktop", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  TextGadget(0, 10, 6, 200, 20, "")
  
  Repeat
    Event = WindowEvent()
    
    If Event = 0 ; No more events in the queue, so we can display the coordinates of the mouse
      SetGadgetText(0, "Coordinates: "+Str(DesktopMouseX())+","+Str(DesktopMouseY()))
    EndIf
    
    Delay(20) ;  Without a FlipBuffers(), Delay() frees the CPU for the multitasking
    
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Window\WindowEvent.html%#@4 *;
;Few variables
BallX = 400
BallY = 200
BallSpeedY.f = 5
Gravitation.f = 2

;Initialization 
If InitSprite()
  InitKeyboard()
  InitMouse()
EndIf

;Window
OpenWindow(0, 0, 0, 800, 600, "WindowEvent", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(0), 0, 0, 800, 600)

;Ground
Ground = CreateSprite(#PB_Any, 800, 30)
StartDrawing(SpriteOutput(Ground))
Box(0,0,800,30,RGB(128, 0, 0))
StopDrawing()

;Ball
Ball = CreateSprite(#PB_Any, 16, 16)
StartDrawing(SpriteOutput(Ball))
Box(0,0,16,16,RGB(135, 206, 235))
Circle(8,8,8,RGB(255, 255, 0))
StopDrawing()

;Gauge
Image = CreateImage(#PB_Any, 8, 8, 24, RGB(255, 255, 255))
*Buffer=EncodeImage(Image ,#PB_ImagePlugin_BMP)
Gauge = CatchSprite(#PB_Any, *Buffer)


;Main Loop
Repeat 
  
  Repeat
    ;Window events
    ;====================================
    ;Try all possibilities but only one at a time
    Event = WindowEvent()    ; Animation
                             ;Event = WaitWindowEvent()  ; Blocking animation
                             ;Event = WaitWindowEvent(1) ; Animation but a 1ms unnecessary delay and furthermore it's a 
                             ; bad way to program events because the queue is not empty
    
    Select Event   
      Case #PB_Event_CloseWindow
        End
    EndSelect 
  Until Event=0
  
  FlipBuffers() ; ==> With WindowEvent(), FlipBuffers() frees the CPU for the multitasking so Delay(1) is not necessary 
  ClearScreen(RGB(135, 206, 235))
  
  ExamineKeyboard() ;Keyboard
  
  DisplaySprite(Gauge, 50, 570-BallY) ;Display the gauge
  ZoomSprite(Gauge,  20, 570)
  
  DisplaySprite(Ground, 0, 570) ;Display the ground
  
  DisplaySprite(Ball, BallX, BallY) ;Display the ball
  
  ;Ball Movement 
  BallSpeedY = BallSpeedY + Gravitation 
  BallY = BallY + BallSpeedY
  
  ;Management of the collision of the ball with the ground
  If SpriteCollision(Ball, BallX, BallY+16, Ground, 0, 570)
    BallY= 554
    BallSpeedY = -BallSpeedY
  EndIf
  
Until KeyboardPushed(#PB_Key_Escape)

;* %#@Window\WindowMouseX.html%#@0 *;
If OpenWindow(0, 0, 0, 300, 30, "Window mouse monitor", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  TextGadget(0, 10, 6, 200, 20, "")
  
  Repeat
    Event = WaitWindowEvent(20) ; return at least every 20ms for an update
    
    SetGadgetText(0, "Window mouse position: " + Str(WindowMouseX(0)) + "," + Str(WindowMouseY(0)))       
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Window\WindowMouseY.html%#@0 *;
If OpenWindow(0, 0, 0, 300, 30, "Window mouse monitor", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  TextGadget(0, 10, 6, 200, 20, "")
  
  Repeat
    Event = WaitWindowEvent(20) ; return at least every 20ms for an update
    
    SetGadgetText(0, "Window mouse position: " + Str(WindowMouseX(0)) + "," + Str(WindowMouseY(0)))       
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Window\WindowOutput.html%#@0 *;
If OpenWindow(0, 0, 0, 220, 100, "Example...", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  
  Repeat
    Event = WaitWindowEvent()
    
    If Event = #PB_Event_Repaint ; Redraw on the window every time the window is repainted
      StartDrawing(WindowOutput(0))
      Box(10, 10, 50, 50, RGB(255, 0, 0)) 
      StopDrawing()
    EndIf
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@Window\WindowOutput.html%#@1 *;
If OpenWindow(0, 0, 0, 220, 100, "Example...", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  
  ButtonGadget  (1, 10, 60, 200, 30, "Draw on window")
  
  Repeat
    Event = WaitWindowEvent()
    
    Select Event
        
      Case #PB_Event_Gadget
        Select EventGadget()
          Case 1
            ; Draw a red box on the window
            If StartDrawing(WindowOutput(0))
              Box(10,10, 200, 30, RGB(255, 0, 0))
              StopDrawing()
            EndIf
            
        EndSelect
        
    EndSelect
  Until Event = #PB_Event_CloseWindow
EndIf

;* %#@XML\CreateXML.html%#@1 *;
; Create xml tree
xml = CreateXML(#PB_Any) 
mainNode = CreateXMLNode(RootXMLNode(xml), "Zoo") 

; Create first xml node (in main node)
item = CreateXMLNode(mainNode, "Animal") 
SetXMLAttribute(item, "id", "1") 
SetXMLNodeText(item, "Elephant") 

; Create second xml node (in main node)
item = CreateXMLNode(mainNode, "Animal") 
SetXMLAttribute(item, "id", "2") 
SetXMLNodeText(item, "Tiger") 

; Save the xml tree into a xml file
SaveXML(xml, "demo.xml")

;* %#@XML\ExtractXMLArray.html%#@0 *;
Xml$ = "<array><element>1</element><element>10</element><element>100</element></array>"

If ParseXML(0, Xml$) And XMLStatus(0) = #PB_XML_Success
  Dim MyArray(0) ; will be resized by the next call
  ExtractXMLArray(MainXMLNode(0), MyArray())
  
  For i = 0 To ArraySize(MyArray())
    Debug MyArray(i)
  Next i
Else
  Debug XMLError(0)
EndIf

;* %#@XML\ExtractXMLList.html%#@0 *;
Xml$ = "<list><element>1</element><element>10</element><ELEMENT>100</ELEMENT></list>"

If ParseXML(0, Xml$) And XMLStatus(0) = #PB_XML_Success
  NewList Values()
  ExtractXMLList(MainXMLNode(0), Values(), #PB_XML_NoCase)
  
  ForEach Values()
    Debug Values()
  Next
Else
  Debug XMLError(0)
EndIf

;* %#@XML\ExtractXMLMap.html%#@0 *;
Xml$ = "<map><element key=" + Chr(34) + "theKey" + Chr(34) + ">the value</element></map>"

If ParseXML(0, Xml$) And XMLStatus(0) = #PB_XML_Success
  NewMap Test.s()
  ExtractXMLMap(MainXMLNode(0), Test())
  
  ForEach Test()
    Debug MapKey(Test()) + " -> " + Test()
  Next
Else
  Debug XMLError(0)
EndIf

;* %#@XML\ExtractXMLStructure.html%#@0 *;
Structure Person
  Name$
  Age.l
EndStructure

Xml$ = "<Person><Name>John Smith</Name><Age>42</Age></Person>"

If ParseXML(0, Xml$) And XMLStatus(0) = #PB_XML_Success
  Define P.Person
  ExtractXMLStructure(MainXMLNode(0), @P, Person)
  
  Debug P\Name$
  Debug P\Age
Else
  Debug XMLError(0)
EndIf 

;* %#@XML\InsertXMLArray.html%#@0 *;
; This example produces the following XML tree:
;
; <array>
;   <element>red</element>
;   <element>green</element>
;   <element>blue</element>
; </array>
;
Dim Colors$(2)
Colors$(0) = "red"
Colors$(1) = "green"
Colors$(2) = "blue"

If CreateXML(0)
  InsertXMLArray(RootXMLNode(0), Colors$())
  FormatXML(0, #PB_XML_ReFormat)
  Debug ComposeXML(0)
EndIf

;* %#@XML\InsertXMLArray.html%#@1 *;
; This example produces the following XML tree:
;
; <array>
;   <element a="0" b="0">0</element>
;   <element a="0" b="1">1</element>
;   <element a="1" b="0">10</element>
;   <element a="1" b="1">11</element>
;   <element a="2" b="0">20</element>
;   <element a="2" b="1">21</element>
; </array>
;
Dim MultiArray(2, 1)
For a = 0 To 2
  For b = 0 To 1
    MultiArray(a, b) = a * 10 + b
  Next b
Next a

If CreateXML(0)
  InsertXMLArray(RootXMLNode(0), MultiArray())
  FormatXML(0, #PB_XML_ReFormat)
  Debug ComposeXML(0)
EndIf

;* %#@XML\InsertXMLList.html%#@0 *;
; This example produces the following XML tree:
;
; <list>
;   <element>square</element>
;   <element>circle</element>
;   <element>triangle</element>
; </list>
;
NewList Shapes$()
AddElement(Shapes$()): Shapes$() = "square"
AddElement(Shapes$()): Shapes$() = "circle"
AddElement(Shapes$()): Shapes$() = "triangle"

If CreateXML(0)
  InsertXMLList(RootXMLNode(0), Shapes$())
  FormatXML(0, #PB_XML_ReFormat)
  Debug ComposeXML(0)
EndIf

;* %#@XML\InsertXMLList.html%#@1 *;
; This example produces the following XML tree:
;
; <list>
;   <element>
;     <x>100</x>
;     <y>200</y>
;   </element>
;   <element>
;     <x>200</x>
;     <y>400</y>
;   </element>
; </list>
;
Structure Position
  x.l
  y.l
EndStructure

NewList Positions.Position()

For i = 1 To 2
  AddElement(Positions())
  Positions()\x = 100 * i
  Positions()\y = 200 * i
Next i

If CreateXML(0)
  InsertXMLList(RootXMLNode(0), Positions())
  FormatXML(0, #PB_XML_ReFormat)
  Debug ComposeXML(0)
EndIf

;* %#@XML\InsertXMLMap.html%#@0 *;
; This example produces the following XML tree:
;
; <map>
;   <element key="DE">Germany</element>
;   <element key="US">United States</element>
;   <element key="FR">France</element>
; </map>
;
NewMap Countries.s()
Countries("DE") = "Germany"
Countries("FR") = "France"  
Countries("US") = "United States"

If CreateXML(0)
  InsertXMLMap(RootXMLNode(0), Countries())
  FormatXML(0, #PB_XML_ReFormat)
  Debug ComposeXML(0)
EndIf

;* %#@XML\InsertXMLStructure.html%#@0 *;
; This example produces the following XML tree:
;
; <Person>
;   <Name>John Smith</Name>
;   <Age>42</Age>
;   <Books>
;     <element>Investing For Dummies</element>
;     <element>A Little Bit of Everything For Dummies</element>
;   </Books>
; </Person>  
;
Structure Person
  Name$
  Age.l
  List Books.s()
EndStructure

Define P.Person

P\Name$ = "John Smith"
P\Age   = 42
AddElement(P\Books()): P\Books() = "Investing For Dummies"
AddElement(P\Books()): P\Books() = "A Little Bit of Everything For Dummies"

If CreateXML(0)
  InsertXMLStructure(RootXMLNode(0), @P, Person)
  FormatXML(0, #PB_XML_ReFormat)
  Debug ComposeXML(0)
EndIf